1 REMark ''''SSBGEN
1000 QLC_INIT
1002 rem
1010 KCtrlA = 1
1020 KDown = 216
1030 KUp = 208
1040 KShiftDown = 220
1050 KTab = 9
1060 KShiftF5 = 250
1070 KSpace = 32
1080 KShiftUp = 212
1090 KEnter = 10
1100 KShiftEnter = 254
1110 KBackSpace = 194
1120 KCtrlUp = 210
1130 KCtrlDown = 218
1140 KCtrlD = 4
1150 KCtrlR = 18
1160 KF1 = 232
1170 KF2 = 236
1180 KF3 = 240
1190 KF4 = 244
1200 KF5 = 248
1210 KF6ShiftF1 = 234
1220 KF7ShiftF2 = 238
1230 KF8ShiftF3 = 242
1240 KF9ShiftF4 = 246
1250 KF10ShiftF5 = 250
1260 KPlus = 43
1270 KMinus = 45
1280 KEqual = 61
1290 KUnderscore = 95
1300 KCtrlI = 92
1310 KCtrlW = 23
1320 KCtrlX = 24
1330 KCtrl1 = 145
1340 KCtrl2 = 146
1350 KHome = 193
1360 KEnd = 201
1370 KPageUp = 212
1380 KPageDown = 220
1390 :
1400 :
1410 :
1420 :
1430 :
1440 REMark ''******************************************
1450 REMark ''*         Q L  C O M M A N D E R         *
1460 REMark ''*                                        *
1470 REMark ''*              version 2.0               *
1480 REMark ''*          code date 2019.05.03          *
1490 REMark ''*                                        *
1500 REMark ''*              Andrei Tenu               *
1510 REMark ''*              Martyn Hill               *
1520 REMark ''******************************************
1530 :
1540 :
1550 REMark ''*** QLiberator Directives...
1560 REMark ''$$stak=5120
1570 :
1580 :
1590 REMark ''*** TURBO Directives...   - also comment line 1370! And modify line 3010
1600 REMark ''TURBO_locstr "R"
1610 REMark ''TURBO_ref
1620 REMark ''TURBO_windo 2
1630 REMark ''TURBO_optim "B"
1640 REMark ''TURBO_model 1
1650 REMark ''TURBO_struct "S"
1660 REMark ''TURBO_diags "I"
1670 REMark ''TURBO_list "YES"
1680 REMark ''TURBO_sound "YES"
1690 REMark ''TURBO_objdat 64
1700 REMark ''TURBO_buffersz 16
1710 REMark ''TURBO_objstk 512
1720 REMark ''TURBO_taskn "QLC v2.0"
1730 REMark ''TURBO_objfil "win1_QLCommander_QLC_exe"
1740 REMark ''TURBO_repfil "win1_QLCommander_QLCv20_rpt"
1750 :
1760 :
1770 WHEN ERRor
1780   REMark ''CloseProgram
1790   PAPER# 1, 7 : INK# 1, 2 : PAPER# 0, 0 : INK# 0, 4 : CLS# 0
1800   PRINT# 1, "Error at line: "; ERLIN : REPORT : STOP
1810 END WHEN
1820 REMark ''MODE 4: PAPER#0,0:PAPER#1,0:PAPER#2,0:BORDER#1,0:CLS#1
1830 REMark ''WINDOW#1,488,220,12,0
1840 :
1850 :
1860 qlcVer$="2.0"
1870 REMark ''Make sure that guardian window covers all screen, in all resolutions
1880 IF VER$="HBA_xx" THEN     : REMark ''mixworx
1890   maxWinWid%=SCR_XLIM
1900   maxWinHgt%=SCR_YLIM
1910 ELSE
1920   maxWinWid%=512
1930   maxWinHgt%=256
1940   REMark ''make sure we are in monitor mode 4, otherwise it will crash
1950   WMON:MODE 4: PAPER#0,0:PAPER#1,0:BORDER#1,0:CLS#1:CLS#0
1960 END IF
1970 REMark ''comment next line if compiled with Turbo !
1980 PAPER#0,0:BORDER#0,0:PAPER#1,0:BORDER#1,0:PAPER#2,0:BORDER#2,0:CLS#0:CLS#1:CLS#2
1990 WINDOW#0,maxWinWid%,maxWinHgt%,0,0
2000 OUTLN #0,maxWinWid%,maxWinHgt%,0,0,0,0,0
2010 :
2020 :
2030 dbginit
2040 readConfig
2050 InitialiseVars
2060 OpenWindows
2070 DrawWindows 1
2080 MainLoop
2090 CloseProgram
2100 :
2110 STOP
2120 :
2130 :
2140 REMark ''----------------------------------------------------------
2150 DEFine PROCedure StopWithError(errorMessage$)
2160   BEEP 1390*2, 20
2170   REMark ''CLS #0
2180   PRINT #0, errorMessage$
2190   PAUSE 50*2
2200 :
2210   CloseProgram
2220   STOP
2230 END DEFine StopWithError
2240 :
2250 :
2260 REMark ''-----------------------------------------------------------
2270 DEFine PROCedure CloseProgram
2280   LOCal ch%
2290   FOR ch%=3 TO 9 : CLOSE#ch% : END FOR ch%
2300 :
2310   IF headBuff>0 THEN RECHP(headBuff)
2320   IF titleFountBase>0 THEN RECHP titleFountBase: END IF
2330   IF mainFountBase>0 THEN RECHP mainFountBase: END IF
2340   IF comFountBase>0 THEN RECHP comFountBase: END IF
2350 :
2360   DATA_USE initialDATAD$
2370   WINDOW#0,maxWinWid%,maxWinHgt%,0,0:PAPER#0,0: INK#0,White%:CLS#0
2380   WINDOW#0,512,50,0,206: BORDER#0,1,1,7,0: CLS#0
2390   WINDOW#1,256,202,256,0: BORDER#1,1,1,7,0:PAPER#1,7: INK#1,0:CLS#1
2400   WINDOW#2,256,202,0,0: BORDER#2,1,1,7,0:PAPER#2,2: INK#2,7:CLS#2
2410 END DEFine CloseProgram
2420 :
2430 :
2440 REMark ''-----------------------------------------------------------
2450 DEFine PROCedure OpenWindows
2460  LOCal ch%,titleFountFN$(36),titleFountLen%,mainFountFN$(36),mainFountLen%
2470  LOCal comFountFN$(36),comFountLen%
2480   stdFountWid%=6
2490 :
2500   FOR ch%=3 TO 9 : OPEN#ch%,con : END FOR ch%
2510 :
2520   titleFountWid%=stdFountWid%
2530   titleFountBase=0
2540   titleFountFN$=ConfigDrv$&"bold8_fnt"
2550   IF FTEST(titleFountFN$) = 0 THEN
2560     titleFountLen%=FLEN(\titleFountFN$)
2570     IF titleFountLen%>0 THEN
2580       titleFountBase = ALCHP(titleFountLen%)
2590       LBYTES titleFountFN$, titleFountBase
2600       titleFountWid%=8
2610       CHAR_USE #titleWin%,titleFountBase,0
2620       CSIZE #titleWin%,1,0
2630       CHAR_INC #titleWin%,titleFountWid%,10
2640     END IF
2650   END IF
2660 :
2670   mainFountWid%=stdFountWid%
2680   mainFountBase=0
2690   mainFountFN$=ConfigDrv$&"5Pixel_fnt"
2700   IF FTEST(mainFountFN$) = 0 THEN
2710     mainFountLen%=FLEN(\mainFountFN$)
2720     IF mainFountLen%>0 THEN
2730       mainFountBase = ALCHP(mainFountLen%)
2740       LBYTES mainFountFN$,mainFountBase
2750     END IF
2760   END IF
2770   SELect ON ClassicFont%
2780     =0 : IF mainFountBase>0 THEN
2790            mainFountWid%=5: mainFountHeight%=10
2800            CHAR_USE #leftPanelWin%,mainFountBase,0
2810            CHAR_INC #leftPanelWin%,mainFountWid%,10
2820            CHAR_USE #rightPanelWin%,mainFountBase,0
2830            CHAR_INC #rightPanelWin%,mainFountWid%,10
2840          ELSE
2850            mainFountWid%=6: mainFountHeight%=10:comFountWid%=stdFountWid%
2860          END IF
2870     =1 : CSIZE #leftPanelWin%,0,0 : CSIZE #rightPanelWin%,0,0
2880          mainFountWid%=6: mainFountHeight%=10:comFountWid%=stdFountWid%
2890     =2 : mainFountWid%=8: mainFountHeight%=20:comFountWid%=8:titleFountWid%=16
2900          CSIZE #leftPanelWin%,1,1 : CSIZE #rightPanelWin%,1,1 : CSIZE #titleWin%,3,1:CSIZE #4,1,1: CSIZE #5,1,1: CSIZE #6,1,1:CSIZE #9,1,1
2910     =3 : mainFountWid%=12: mainFountHeight%=20:titleFountWid%=16:comFountWid%=8
2920          CSIZE #leftPanelWin%,2,1 : CSIZE #rightPanelWin%,2,1 : CSIZE #titleWin%,3,1:CSIZE #4,2,1: CSIZE #5,2,1: CSIZE #6,2,1:CSIZE #9,1,1
2930   END SELect
2940   REMark ''comFountWid%=stdFountWid%
2950   comFountBase=0
2960   comFountFN$=ConfigDrv$&"qlc_fnt"
2970   IF FTEST(comFountFN$) = 0 THEN
2980     comFountLen%=FLEN(\comFountFN$)
2990     IF comFountLen%>0 THEN
3000       comFountBase = ALCHP(comFountLen%)
3010       LBYTES comFountFN$, comFountBase
3020       CHAR_USE #comWin%,comFountBase,0
3030     END IF
3040   END IF
3050 :
3060 END DEFine OpenWindows
3070 :
3080 :
3090 REMark ''-----------------------------------------------------------
3100 DEFine PROCedure DrawWindows (reload%)
3110   REMark ''reload%=1 we reload the file lists and draw the windows;
3120   REMark ''reload%==0 we do not reload the file lists, just redraw the windows
3130  LOCal left%
3140 :
3150   IF (linelen% * mainFountWid% + 2) > (maxWinWid% DIV 2) THEN
3160     linelen%=((maxWinWid% DIV 2) - 4) DIV mainFountWid%
3170   END IF
3180   panelWinWid%=linelen% * mainFountWid% + 2
3190   comWinWid%=  2 * panelWinWid%
3200   left%=(maxWinWid% - 2*panelWinWid%) DIV 2
3210 :
3220   REMark ''title line
3230   WINDOW#3, 2*panelWinWid%,mainFountHeight%+2,left%,5: BORDER#3, 1,TitleBorder%: PAPER#3, TitleBorder%,TitleBk%,1: CLS#3
3240   PAPER#3, 0: INK#3, 2
3250   IF ClassicFont%>=2 THEN CSIZE #titleWin%,3,1 :ELSE CSIZE #titleWin%,1,0
3260   CHAR_INC #titleWin%,titleFountWid%,10
3270   BLOCK#3, titleFountWid%*14,mainFountHeight%,(2*panelWinWid%-4-14*titleFountWid%)DIV 2,0,0
3280   CURSOR#3, (2*panelWinWid%-4 - 14*titleFountWid%) DIV 2,0:PRINT#3, " QL COMMANDER "
3290 :
3300   REMark ''Drive line
3310   WINDOW#4,2*panelWinWid%,mainFountHeight%+2,left%,mainFountHeight%+7:PAPER#4,brd%:INK#4,0:BORDER#4,1,brd%:CLS#4
3320   AT#4,0,0:INK#4,2:PRINT#4,"D":AT#4,0,1:INK#4,0:PRINT#4,"ir"
3330   CURSOR#4,panelWinWid%,0:PRINT#4,"Di":INK#4,2:CURSOR#4,panelWinWid%+mainFountWid%*2,0:PRINT#4,"r"
3340 :
3350   REMark ''left dir
3360   WINDOW#5,panelWinWid%-4*mainFountWid%,mainFountHeight%,left%+4*mainFountWid%-2,mainFountHeight%+8:PAPER#5,White%:INK#5,0:BORDER#5,0:CLS#5
3370   PRINT#5,leftDir$
3380 :
3390   REMark ''right dir
3400   WINDOW#6,panelWinWid%-4*mainFountWid%,mainFountHeight%,left%+panelWinWid%+4*mainFountWid%-2,mainFountHeight%+8:PAPER#6,White%:INK#6,0:BORDER#6,0:CLS#6
3410   PRINT#6,rightDir$
3420 :
3430   panelWinHeight%=rowno%*mainFountHeight%+3
3440   IF panelWinHeight%+3*mainFountHeight%+19 >maxWinHgt% THEN
3450     rowno%=(maxWinHgt%-3*mainFountHeight%- 22)DIV mainFountHeight%
3460     panelWinHeight%=rowno%*mainFountHeight%+3
3470   END IF
3480   REMark ''left file panel
3490   WINDOW#7, panelWinWid%,panelWinHeight%,left%,2*mainFountHeight%+9: PAPER#7, ppr%: INK#7, ik%:BORDER#7, 1,brd%:CLS#7
3500 :
3510   REMark ''Right file panel
3520   WINDOW#8, panelWinWid%,panelWinHeight%,panelWinWid%+left%,2*mainFountHeight%+9: PAPER#8, ppr%: INK#8, ik%:BORDER#8, 1,brd%:CLS#8
3530 :
3540   REMark ''Commands line
3550   WINDOW#9, 2*panelWinWid%,mainFountHeight%+2,left%,panelWinHeight%+3*mainFountHeight%+7:PAPER#9, brd%: INK#9, White%:BORDER#9, 1,brd%:CLS#9
3560   WriteCommands comWin%
3570 :
3580   crtPanel%=leftPanelWin%
3590   IF reload%=1 THEN
3600     LShowLeftDir
3610     LShowRightDir
3620   ELSE
3630     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
3640     ListFiles RightFiles$, RStartPos%, RIndex%, 8
3650   END IF
3660 END DEFine DrawWindows
3670 :
3680 :
3690 REMark ''-----------------------------------------------------------
3700 DEFine PROCedure readConfig
3710 LOCal a$(42), Chan%
3720 ConfigDrv$=OPTION_CMD$: REMark ''CMD$
3730 IF ConfigDrv$="" THEN ConfigDrv$="dos1_qlc_"
3740 a$=ConfigDrv$&"qlc20_cfg"
3750 Chan%=FOP_IN(a$)
3760 IF Chan%>0
3770   INPUT #Chan%, MaxFiles%
3780   INPUT #Chan%, TempDir$
3790   INPUT #Chan%, leftDir$
3800   INPUT #Chan%, rightDir$
3810   INPUT #Chan%, Qubide%
3820   INPUT #Chan%, ClassicFont%
3830   INPUT #Chan%, linelen%
3840   INPUT #Chan%, rowno%
3850   INPUT #Chan%, Xchangepath$
3860   INPUT #Chan%, Xchangeprog$
3870   INPUT #Chan%, EditPath$
3880   INPUT #Chan%, Editprog$
3890   INPUT #Chan%, QLColors%
3900   CLOSE #Chan%
3910 ELSE
3920   CLS
3930   PRINT "Config file not found - using default values ! "
3940   MaxFiles%=256
3950   TempDir$="win1_temp_"
3960   leftDir$="win1_"
3970   rightDir$="win1_"
3980   Qubide%=0
3990   ClassicFont%=1
4000   linelen%=40
4010   rowno%=20
4020   Xchangepath$=""
4030   Xchangeprog$=""
4040   EditPath$=""
4050   Editprog$=""
4060   QLColors=1
4070   PAUSE 100
4080   CLS
4090 END IF
4100 IF RMODE<=8 OR QLColors%=1 THEN
4110   IF VER$="HBA" AND RMODE>4 THEN COLOUR_QL:SetPalletteQL : END IF
4120   ppr%=0: brd%=4: ik%=7: strp%=7: White%=7:Green%=4:PPR9a%=2:ppr9b%=0:TitleBorder%=4: TitleBk%=0
4130 ELSE
4140   COLOUR_PAL: ppr%=4: brd%=13: ik%=1: strp%=13:White%=1:Green%=3:PPR9a%=72:ppr9b%=76:TitleBorder%=13:TitleBk%=4
4150 END IF
4160 IF maxWinHgt%=256 AND ClassicFont%>1 THEN ClassicFont%=1: END IF
4170 END DEFine readConfig
4180 :
4190 :
4200 REMark ''------------------------------------------------------------
4210 DEFine PROCedure InitialiseVars
4220   titleWin%=3 : leftPanelWin%=7 : rightPanelWin%=8 : comWin%=9
4230   LSizedir%=0: LSizeFile%=0: crtPanel%=leftPanelWin%
4240   RSizedir%=0: RSizeFile%=0
4250 :
4260   maxFNLen%=36
4270 :
4280   _fLen%=maxFNLen%+3 : _fTyp%=maxFNLen%+7
4290   _fDat%=maxFNLen%+9 : _fPar%=maxFNLen%+13
4300   _fFlg%=maxFNLen%+15: _fMax%=maxFNLen%+16
4310 :
4320   _dPar%=maxFNLen%+3 : _dNxt%=maxFNLen%+5
4330   _dChd%=maxFNLen%+7 : _dFlg%=maxFNLen%+9
4340   _dMax%=maxFNLen%+10
4350 :
4360   DIM cmdText$(9,9) : REMark ''Used by WriteCommands
4370   cmdText$(1)=CHR$(1)        &" Info"
4380   cmdText$(2)=CHR$(2)        &" Comp"
4390   cmdText$(3)=CHR$(3)        &" View"
4400   cmdText$(4)=CHR$(4)        &" Edit"
4410   cmdText$(5)=CHR$(5)        &" Copy"
4420   cmdText$(6)=CHR$(6)        &" Rename"
4430   cmdText$(7)=CHR$(7)        &" MkDir"
4440   cmdText$(8)=CHR$(8)        &" Delete"
4450   cmdText$(9)=CHR$(9)        &" Exit"
4460 :
4470   initialDATAD$=DATAD$
4480 :
4490   headSz%=64
4500   headBuff=ALCHP(headSz%)
4510   IF headBuff<0 THEN StopWithError("Cannot allocate memory for File-header Buffer.")
4520 :
4530 END DEFine InitialiseVars
4540 :
4550 :
4560 REMark ''-----------------------------------------------------------
4570 DEFine PROCedure LShowLeftDir
4580 LOCal i%
4590 REMark ''DIM LeftFiles$(MaxFiles%,2,36)
4600 DIM LeftFiles$(MaxFiles%,_fMax%)
4610 LoadDir leftDir$, LeftFiles$,7,LSizedir%, LSizeFile%
4620 IF LEN(leftDir$)=5 THEN
4630   LStartPos%=1
4640 ELSE
4650   LStartPos%=0
4660 END IF
4670 LIndex%=LStartPos%
4680 LMinPos%=LStartPos%
4690 ListFiles LeftFiles$, LStartPos%, LIndex%, 7
4700 END DEFine LShowLeftDir
4710 :
4720 :
4730 REMark ''-----------------------------------------------------------
4740 DEFine PROCedure LShowRightDir
4750 LOCal i%
4760 DIM RightFiles$(MaxFiles%,_fMax%)
4770 RSizedir%=0: RSizeFile%=0
4780 LoadDir rightDir$, RightFiles$,8,RSizedir%, RSizeFile%
4790 IF LEN(rightDir$)=5 THEN
4800   RStartPos%=1
4810 ELSE
4820   RStartPos%=0
4830 END IF
4840 RIndex%=RStartPos%
4850 RMinPos%=RStartPos%
4860 ListFiles RightFiles$,RStartPos%,RIndex%,8
4870 END DEFine LShowRightDir
4880 :
4890 :
4900 REMark ''-----------------------------------------------------------
4910 REMark ''REFERENCE FileList$(0,0,0)
4920 REFERENCE FileList$(0,0)
4930 DEFine PROCedure ListFiles(FileList$, StartPos%, Index%, ch%)
4940 LOCal a$(linelen%), i%, size%, EndPos%, nochars%, x%, DFlen1%, DFLen2%
4950 IF ch%=7 THEN
4960   size%=LSizedir%+LSizeFile%
4970 ELSE
4980   size%=RSizedir%+RSizeFile%
4990 END IF
5000 EndPos%=StartPos%+rowno%-1
5010 IF EndPos%>size% THEN EndPos%=size%: END IF
5020 CLS#ch%
5030 FOR i%=StartPos% TO EndPos%
5040   a$=GetFNam$(FileList$,i%)
5050   DFlen1%=LEN(a$)
5060   DFLen2%=LEN(GetFLen(FileList$,i%))
5070   IF GetFFlg%(FileList$,i%) MOD 2 = 1 THEN
5080     x%=3
5090     IF DFlen1%>linelen%-x% THEN : a$=a$( TO linelen%-x%-2): a$=a$&"..":END IF
5100     a$=a$&" ->"
5110     a$=a$&FILL$(" ",linelen%-LEN(a$) - 1)
5120   ELSE
5130     x%=9
5140     IF DFlen1%>linelen%-x% THEN : a$=a$( TO linelen%-x%-2): a$=a$&"..":END IF
5150     a$=a$&FILL$(" ",linelen%-LEN(a$)-DFLen2% - 1)& GetFLen(FileList$,i%)
5160   END IF
5170   INK#ch%, ik%
5180   IF i%=Index% THEN
5190     IF crtPanel%=ch% THEN
5200       STRIP#ch%,strp%
5210       IF GetFFlg%(FileList$,i%) > 1 THEN INK#ch%,2 : ELSE INK#ch%,ppr% : END IF
5220       PRINT#ch%,a$
5230       STRIP#ch%,ppr%
5240     ELSE
5250       PRINT#ch%,a$
5260     END IF
5270   ELSE
5280     IF GetFFlg%(FileList$,i%) > 1 THEN INK#ch%,2 : ELSE INK#ch%,ik% : END IF
5290     PRINT#ch%,a$
5300   END IF
5310 END FOR i%
5320 END DEFine ListFiles
5330 :
5340 :
5350 REMark ''-----------------------------------------------------------
5360 DEFine PROCedure MainLoop
5370  LOCal a$, x%, y$
5380   REPeat loop
5390     a$=INKEY$(-1): x%=CODE(a$) : dbg(x%)
5400     SELect ON x%
5410 :
5420       = KCtrlW:
5430           WMOV
5440 :
5450       = KCtrlA:
5460           MessageWnd 216,60,3, "        QL COMMANDER v"&qlcVer$&CHR$(10)&" Andrei Tenu & Martyn Hill - 2019"&CHR$(10)&"    GNU General Public License"
5470 :
5480       = KDown:
5490           IF crtPanel%=7 THEN
5500             MoveDown LeftFiles$, LMinPos%, LIndex%, LStartPos%, LSizeFile%, LSizedir%
5510           ELSE
5520             MoveDown RightFiles$, RMinPos%, RIndex%, RStartPos%, RSizeFile%, RSizedir%
5530           END IF
5540 :
5550       = KUp:
5560           IF crtPanel%=7 THEN
5570             MoveUp LeftFiles$, LMinPos%, LIndex%, LStartPos%, LSizeFile%, LSizedir%
5580           ELSE
5590             MoveUp RightFiles$, RMinPos%, RIndex%, RStartPos%, RSizeFile%, RSizedir%
5600           END IF
5610 :
5620       = KPageDown, KShiftDown:
5630           IF crtPanel%=7 THEN
5640             MovePageDown LeftFiles$, LStartPos%, LIndex%, 7
5650           ELSE
5660             MovePageDown RightFiles$, RStartPos%, RIndex%, 8
5670           END IF
5680 :
5690       = KTab:
5700           ChangePanel
5710 :
5720       = KCtrlX, KF10ShiftF5:
5730           RETurn
5740 :
5750       = KSpace:
5760           SelectFile
5770 :
5780       = KPageUp, KShiftUp:
5790           IF crtPanel%=7 THEN
5800             MovePageUp LeftFiles$, LStartPos%, LIndex%, 7
5810           ELSE
5820             MovePageUp RightFiles$, RStartPos%, RIndex%, 8
5830           END IF
5840 :
5850       = KEnter:
5860           OnEnter
5870 :
5880       = KShiftEnter:
5890           LRUNBasic
5900 :
5910       = KBackSpace
5920         IF crtPanel%=7 THEN
5930           MoveTop LeftFiles$, LStartPos%, LIndex%, 7
5940           IF GetFNam$(LeftFiles$,LIndex%)=".." THEN
5950             OnEnter
5960           ELSE
5970             BEEP 1390,20
5980           END IF
5990         ELSE
6000           MoveTop RightFiles$, RStartPos%, RIndex%, 8
6010           IF GetFNam$(RightFiles$,RIndex%)=".." THEN
6020             OnEnter
6030           ELSE
6040             BEEP 1390,20
6050           END IF
6060         END IF
6070 :
6080       = KHome, KCtrlUp:
6090           IF crtPanel%=7 THEN
6100             MoveTop LeftFiles$, LStartPos%, LIndex%, 7
6110           ELSE
6120             MoveTop RightFiles$, RStartPos%, RIndex%, 8
6130           END IF
6140 :
6150       = KEnd, KCtrlDown:
6160           IF crtPanel%=7 THEN
6170             MoveLast LeftFiles$, LStartPos%, LIndex%, 7
6180           ELSE
6190             MoveLast RightFiles$, RStartPos%, RIndex%, 8
6200           END IF
6210 :
6220       = KCtrl1, KCtrlD:
6230           InputDir 5
6240 :
6250       = KCtrl2, KCtrlR:
6260           InputDir 6
6270 :
6280       = KF3:
6290           ViewFile
6300 :
6310       = KF5:
6320           CopyFiles
6330 :
6340       = KF4:
6350           DoEdit
6360 :
6370       = KF6ShiftF1:
6380           RenameFile
6390 :
6400       = KF8ShiftF3:
6410           DeleteFiles
6420 :
6430       = KF1:
6440           ShowInfo
6450 :
6460       = KF7ShiftF2:
6470           CreateDir
6480 :
6490       REMark ''Find next matching File/Dir starting with a$
6500       =65  TO  90: JumpTo x%, 1
6510       =160 TO 171: JumpTo x%, 1
6520       =97  TO 122: JumpTo x%, 2
6530       =128 TO 139: JumpTo x%, 2
6540       =48  TO  57: JumpTo x%, 0
6550 :
6560       = KPlus, KEqual:
6570           SelectAll
6580 :
6590       = KMinus, KUnderscore:
6600           UnSelectAll
6610 :
6620       = KF9ShiftF4:
6630           DrawWindows 0
6640 :
6650       = KF8ShiftF3:
6660           CompareDirs
6670 :
6680       = KCtrlI:
6690           InvertSelection
6700     END SELect
6710   END REPeat loop
6720 END DEFine MainLoop
6730 :
6740 :
6750 REMark ''-----------------------------------------------------------
6760 DEFine FuNction FindFirst% (a%,what%)
6770  LOCal i%, istart%, iend%, found%
6780  REMark ''a% = code of char to find
6790  REMark ''what%=2 looking for file; =1 looking for dir; =0 looking for dir or file
6800  REMark ''search returns index of item that starts with a$, or first next item if a$ is not found, or last item in list if all existing items start with chars<a$
6810 found%=0
6820 IF crtPanel%=7 THEN
6830    IF what%<2 THEN istart%=1: ELSE istart%=LSizedir%+1: END IF
6840    IF what%=1 THEN iend%=LSizedir%: ELSE iend%=LSizedir%+LSizeFile%: END IF
6850    IF istart%>iend% THEN RETurn LIndex%: END IF
6860    IF what%>0 THEN
6870      FOR i%=istart% TO iend%
6880        IF CODE(GetFNam$(LeftFiles$,i%)) >= a% THEN found%=1: EXIT i%: END IF
6890        NEXT i%
6900      END FOR i%
6910    ELSE
6920      FOR i%=LIndex%+1 TO iend%
6930        IF CODE(GetFNam$(LeftFiles$,i%)) = a% THEN found%=1: EXIT i%: END IF
6940      NEXT i%: END FOR i%
6950      IF found%=0 THEN
6960        FOR i%=istart% TO LIndex%
6970          IF CODE(GetFNam$(LeftFiles$,i%)) = a% THEN found%=1: EXIT i%: END IF
6980        NEXT i%: END FOR i%
6990      END IF
7000      IF found%=0 THEN i%=istart%: END IF
7010    END IF
7020    IF i%<= iend% THEN RETurn i%: ELSE RETurn iend%: END IF
7030 ELSE
7040    IF what%<2 THEN istart%=1: ELSE istart%=RSizedir%+1:END IF
7050    IF what%=1 THEN iend%=RSizedir%: ELSE iend%=RSizedir%+RSizeFile%:END IF
7060    IF istart%>iend% THEN RETurn RIndex%: END IF
7070    IF what%>0 THEN
7080      FOR i%=istart% TO iend%
7090        IF CODE(GetFNam$(RightFiles$,i%)) >= a% THEN EXIT i%: END IF
7100        NEXT i%
7110      END FOR i%
7120    ELSE
7130      FOR i%=RIndex%+1 TO iend%
7140        IF CODE(GetFNam$(RightFiles$,i%)) = a% THEN found%=1: EXIT i%: END IF
7150      NEXT i%: END FOR i%
7160      IF found%=0 THEN
7170        FOR i%=istart% TO RIndex%
7180          IF CODE(GetFNam$(RightFiles$,i%)) = a% THEN found%=1: EXIT i%: END IF
7190        NEXT i%: END FOR i%
7200      END IF
7210      IF found%=0 THEN i%=istart%: END IF
7220    END IF
7230    IF i%<= iend% THEN RETurn i%: ELSE RETurn iend%: END IF
7240  END IF
7250 END DEFine FindFirst%
7260 :
7270 :
7280 REMark ''-----------------------------------------------------------
7290 DEFine PROCedure JumpTo (a%,what%)
7300 LOCal x%, start%
7310 IF crtPanel%=7 THEN
7320   IF LSizedir%+LSizeFile%=0 THEN RETurn : END IF
7330 ELSE
7340   IF RSizedir%+RSizeFile%=0 THEN RETurn : END IF
7350 END IF
7360 x%=FindFirst%(a%,what%)
7370 IF crtPanel%=7 THEN
7380   IF x%=LIndex% THEN RETurn : END IF
7390   IF (x%>=LStartPos%) AND (x%<LStartPos%+20) THEN
7400    ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 0
7410    LIndex%=x%
7420    ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 1
7430   ELSE
7440    LIndex%=x%
7450    x%=x%+(LMinPos%=0)
7460    page%=x% DIV rowno%
7470    IF x% MOD rowno% >0 THEN page%=page%+1: END IF
7480    LStartPos%=(page%-1)*rowno% +LMinPos%
7490    ListFiles LeftFiles$, LStartPos%, LIndex%, 7
7500   END IF
7510 ELSE
7520   IF x%=RIndex% THEN RETurn :END IF
7530   IF x%>=RStartPos% AND x%<RStartPos%+rowno% THEN
7540    ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 0
7550    RIndex%=x%
7560    ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 1
7570   ELSE
7580    RIndex%=x%
7590    x%=x%+(RMinPos%=0)
7600    page%=x% DIV rowno%
7610    IF x% MOD rowno% >0 THEN page%=page%+1: END IF
7620    RStartPos%=(page%-1)*rowno% +RMinPos%
7630    ListFiles RightFiles$, RStartPos%, RIndex%, 8
7640   END IF
7650 END IF
7660 END DEFine JumpTo
7670 :
7680 :
7690 REMark ''-----------------------------------------------------------
7700 REMark ''String Quick Search & Insert
7710 REMark ''(c)tcat, 2017 Tomas Kral
7720 REMark ''modified by Andrei Tenu 2018
7730 :
7740 REMark ''REFERENCE FileList$(0,0,0),id%
7750 REFERENCE FileList$(0,0),id%
7760 DEFine FuNction Find% (str$,id%,FileList$,no%,size%)
7770  REMark ''FileLis$ = name of array to load into
7780  REMark ''no% = start index
7790  REMark ''    = 0 if we add a dir to root; 1 if add a dir in a directory; SizeDir%+1 if we add a file
7800  REMark ''Quick search returns:
7810  REMark ''0=not found, 1=found, id%=position
7820  LOCal top%,bot%,mid%,nextFNam$(maxFNLen%)
7830  top%=no% : bot%=size%
7840 :
7850  REPeat find_loop
7860   mid%=(bot%+top%) DIV 2 : nextFNam$=GetFNam$(FileList$,mid%)
7870 :
7880   IF top%>bot% THEN
7890    id%=mid%+1 : RETurn 0
7900   ELSE IF str$ = nextFNam$ THEN
7910    id%=mid% : RETurn 1
7920   ELSE IF str$ > nextFNam$ THEN
7930    top%=mid%+1
7940   ELSE IF str$ < nextFNam$ THEN
7950    bot%=mid%-1
7960   END IF : END IF : END IF : END IF
7970  END REPeat find_loop
7980 END DEFine Find%
7990 :
8000 REMark ''REFERENCE FileList$(0,0,0),r_SizeDir%, r_SizeFile%
8010 REFERENCE FileList$(0,0),r_SizeDir%, r_SizeFile%
8020 DEFine FuNction Insert% (str$,id%, FileList$, DoF%, r_SizeDir%, r_SizeFile%, fLength$)
8030  REMark ''Inserts String at position id%
8040  REMark ''Returns 2=ok, -1=array full
8050  LOCal i%, size%
8060  size%=r_SizeDir%+r_SizeFile%
8070  IF size% >= MaxFiles% THEN RETurn -1
8080  FOR i%=size% TO id% STEP -1
8090    CopyRec FileList$,i% TO FileList$,i%+1
8100  END FOR i%
8110  PutFNam FileList$,id%, str$
8120  PutFLen FileList$,id%, fLength$
8130  PutFFlg FileList$,id%, DoF%
8140  IF DoF%=1 THEN
8150    r_SizeDir%=r_SizeDir%+1
8160  ELSE
8170    r_SizeFile%=r_SizeFile%+1
8180  END IF
8190 :
8200  RETurn 2
8210 END DEFine Insert%
8220 :
8230 :
8240 REMark ''End of String Quick Search & Insert -----------------------
8250 :
8260 :
8270 REMark ''-----------------------------------------------------------
8280 REMark ''REFERENCE dev$(0),FileList$(0,0,0),r_SizeDir%,r_SizeFile%
8290 REFERENCE dev$(0),FileList$(0,0),r_SizeDir%,r_SizeFile%
8300 DEFine PROCedure LoadDir (dev$, FileList$, Chan%, r_SizeDir%, r_SizeFile%)
8310  LOCal ch%, i, head_start, totrim, flength, file$, ftype, size2%, res, DirOrFile%, id%, filelen$,k$, no_files
8320  CLS#Chan%:INK#Chan%,7:PRINT#Chan%,"...Loading File List ..."
8330  IF dev$(LEN(dev$))<>"_" THEN dev$=dev$&"_"
8340  IF Chan%=7 THEN PRINT#5,dev$: ELSE PRINT#6, dev$: END IF
8350  IF DirExists%(dev$)=0 THEN
8360    BEEP 1390,100
8370    PRINT#Chan%, "Cannot open directory "&dev$
8380    RETurn
8390  END IF
8400  r_SizeDir%=0: r_SizeFile%=0
8410  totrim=LEN(dev$)-4
8420  IF totrim<=0 THEN totrim=1 : END IF
8430 :
8440  PutFNam FileList$,0, ".."
8450  PutFLen FileList$,0, 0
8460  PutFFlg FileList$,0, 1
8470 :
8480  head_start=0
8490  i=1
8500  ch%=FOP_DIR(dev$)
8510  no_files=FLEN(#ch%)/64
8520  FOR listing=1 TO no_files
8530    SET_POSITION #ch%,head_start+0
8540    flength=LONGINTEGER(INPUT$(#ch%,4))-64
8550    faccess=CODE(INKEY$(#ch%)):ftype=CODE(INKEY$(#ch%))
8560    IF flength>=0 THEN
8570      SET_POSITION #ch%,head_start+14
8580      file$=GET$(#ch%)
8590      IF LEN(file$)>0
8600       file$=file$(totrim TO)
8610       filelen$=flength
8620       SET_POSITION #ch%,head_start+52
8630       fdate=LONGINTEGER(INPUT$(#ch%,4))
8640       IF ftype<255
8650        size2%=r_SizeDir%+r_SizeFile%
8660        file$=LOWER$(file$)
8670        res=Find%(file$,id%, FileList$,r_SizeDir%+1,size2%)
8680        DirOrFile%=0
8690       ELSE
8700        file$=UPPER$(file$)
8710        res=Find%(file$,id%,FileList$,1,r_SizeDir%)
8720        DirOrFile%=1
8730       END IF
8740       i=i+1
8750    REMark ''k$="":
8760    REMark ''IF flength>1023 THEN
8770    REMark '' flength=INT(flength/1024+.5):k$="K"
8780    REMark '' IF flength>1023 THEN
8790    REMark ''   flength=INT(flength/1024+.5):k$="M"
8800    REMark '' END IF
8810    REMark ''END IF
8820    REMark ''filelen$=flength&k$
8830       IF res=0 THEN res=Insert%(file$,id%,FileList$,DirOrFile%, r_SizeDir%, r_SizeFile%, filelen$) : END IF
8840       IF res=-1 : EXIT listing : END IF
8850      END IF
8860    END IF
8870    head_start=head_start+64
8880  END FOR listing
8890  CLOSE #ch%
8900 END DEFine LoadDir
8910 :
8920 :
8930 REMark ''-----------------------------------------------------------
8940 REMark ''REFERENCE FileList$(0,0,0),r_Index%,r_StartPos%
8950 REFERENCE FileList$(0,0),r_Index%,r_StartPos%
8960 DEFine PROCedure MoveDown(FileList$, MinPos%, r_Index%, r_StartPos%, SizeFile%, SizeDir%)
8970  LOCal size%, idx%
8980  size%=SizeFile%+SizeDir%
8990  IF r_Index%>size% THEN RETurn
9000  ShowHideCursor r_Index%-r_StartPos%, r_Index%, FileList$, 0
9010  r_Index%=r_Index%+1
9020  IF r_Index%>size% THEN : r_Index%=size%: END IF
9030  IF r_Index%>r_StartPos%+rowno%-1 THEN
9040    SCROLL#crtPanel%,-mainFountHeight%
9050    r_StartPos%=r_StartPos%+1
9060  END IF
9070  ShowHideCursor r_Index%-r_StartPos%, r_Index%,  FileList$, 1
9080 END DEFine MoveDown
9090 :
9100 :
9110 REMark ''-----------------------------------------------------------
9120 REMark ''REFERENCE FileList$(0,0,0),r_Index%,r_StartPos%
9130 REFERENCE FileList$(0,0),r_Index%,r_StartPos%
9140 DEFine PROCedure MoveUp(FileList$, MinPos%, r_Index%, r_StartPos%, SizeFile%, SizeDir%)
9150  LOCal size%, idx%
9160  size%=SizeFile%+SizeDir%
9170  IF r_Index%>size%  THEN RETurn
9180  ShowHideCursor r_Index%-r_StartPos%, r_Index%, FileList$, 0
9190  r_Index%=r_Index%-1
9200  IF r_Index%<MinPos% THEN : r_Index%=MinPos%: END IF
9210  IF r_Index%<r_StartPos% THEN
9220    SCROLL#crtPanel%,mainFountHeight%
9230    r_StartPos%=r_StartPos%-1
9240  END IF
9250  ShowHideCursor r_Index%-r_StartPos%, r_Index%, FileList$, 1
9260 END DEFine MoveDown
9270 :
9280 :
9290 REMark ''-----------------------------------------------------------
9300 REMark ''REFERENCE FileList$(0,0,0)
9310 REFERENCE FileList$(0,0)
9320 DEFine PROCedure ShowHideCursor(Linepos%, Index%, FileList$, SoH%)
9330 LOCal a$, x%, DFlen1%, DFLen2%
9340 :
9350   a$=GetFNam$(FileList$,Index%)
9360   DFlen1%=LEN(a$)
9370   DFLen2%=LEN(GetFLen(FileList$,Index%))
9380 :
9390   IF GetFFlg%(FileList$,Index%) MOD 2 = 1 THEN
9400     x%=3
9410     IF DFlen1%>linelen%-x% THEN : a$=a$( TO linelen%-x%-2): a$=a$&"..":END IF
9420     a$=a$&" ->"
9430     a$=a$&FILL$(" ",linelen%-LEN(a$) - 1)
9440   ELSE
9450     x%=9
9460     IF DFlen1%>linelen%-x% THEN : a$=a$( TO linelen%-x%-2): a$=a$&"..":END IF
9470     a$=a$&FILL$(" ",linelen%-LEN(a$)-DFLen2% - 1)& GetFLen(FileList$,Index%)
9480   END IF
9490   IF SoH%=1 THEN
9500     STRIP#crtPanel%,strp%: INK#crtPanel%,0
9510     IF GetFFlg%(FileList$,Index%) > 1 THEN INK#crtPanel%,2 : ELSE INK#crtPanel%,0 : END IF
9520     AT#crtPanel%,Linepos%,0:PRINT#crtPanel%,a$;
9530     STRIP#crtPanel%,ppr%:INK#crtPanel%,ik%
9540   ELSE
9550    IF GetFFlg%(FileList$,Index%) > 1 THEN INK#crtPanel%,2 : ELSE INK#crtPanel%,ik% : END IF
9560     AT#crtPanel%,Linepos%,0:PRINT#crtPanel%,a$;
9570   END IF
9580 END DEFine ShowHideCursor
9590 :
9600 :
9610 REMark ''-----------------------------------------------------------
9620 DEFine PROCedure ChangePanel
9630 IF crtPanel%=7 THEN
9640   IF LIndex%<=LSizedir%+LSizeFile% THEN
9650     ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 0
9660   END IF
9670   crtPanel%=8
9680   IF RIndex%<=RSizedir%+RSizeFile% THEN
9690     ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 1
9700   END IF
9710   BORDER#8,1,brd%: BORDER#7, 1,brd%,1,3
9720 ELSE
9730   IF RIndex%<=RSizedir%+RSizeFile% THEN
9740     ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 0
9750   END IF
9760   crtPanel%=7
9770   IF LIndex%<=LSizedir%+LSizeFile% THEN
9780     ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 1
9790   END IF
9800   BORDER#7,1,brd%: BORDER#8,1,brd%,1,3
9810 END IF
9820 END DEFine ChangePanel
9830 :
9840 :
9850 REMark ''-----------------------------------------------------------
9860 DEFine PROCedure SelectFile
9870   IF crtPanel%=7 THEN
9880     PutFFlg LeftFiles$,LIndex%,GetFFlg%(LeftFiles$,LIndex%) ^^2
9890     ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 1
9900   ELSE
9910     PutFFlg RightFiles$,RIndex%,GetFFlg%(RightFiles$,RIndex%) ^^2
9920     ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 1
9930   END IF
9940 END DEFine SelectFile
9950 :
9960 :
9970 REMark ''-----------------------------------------------------------
9980 REMark ''REFERENCE FileList$(0,0,0),r_StartPos%,r_Index%
9990 REFERENCE FileList$(0,0),r_StartPos%,r_Index%
10000 DEFine PROCedure MovePageDown(FileList$, r_StartPos%, r_Index%, ch%)
10010 LOCal size%, x%
10020  IF ch%=7 THEN
10030   size%=LSizedir%+LSizeFile%
10040  ELSE
10050   size%=RSizedir%+RSizeFile%
10060  END IF
10070  IF r_Index%>size% THEN RETurn : END IF
10080  x%=r_StartPos%+20
10090  IF x%>size% THEN RETurn
10100  r_StartPos%=x%
10110  r_Index%=r_StartPos%
10120  ListFiles FileList$, r_StartPos%, r_Index%, ch%
10130 END DEFine MovePageDown
10140 :
10150 :
10160 REMark ''-----------------------------------------------------------
10170 REMark ''REFERENCE FileList$(0,0,0),r_StartPos%,r_Index%
10180 REFERENCE FileList$(0,0),r_StartPos%,r_Index%
10190 DEFine PROCedure MovePageUp(FileList$, r_StartPos%, r_Index%, ch%)
10200 LOCal top%, x%, size%
10210  IF ch%=7 THEN
10220   top%= LMinPos%
10230   size%=LSizeFile%+LSizedir%
10240  ELSE
10250   top%=RMinPos%
10260   size%=RSizeFile%+RSizedir%
10270  END IF
10280  IF r_Index%>size% THEN RETurn : END IF
10290  x%=r_StartPos%-20
10300  IF x%<top% THEN x%=top%:END IF
10310  r_StartPos%=x%
10320  r_Index%=r_StartPos%
10330  ListFiles FileList$, r_StartPos%, r_Index%, ch%
10340 END DEFine MovePageUp
10350 :
10360 :
10370 REMark ''-----------------------------------------------------------
10380 REMark ''REFERENCE FileList$(0,0,0)
10390 REFERENCE FileList$(0,0)
10400 DEFine PROCedure OpenSubDir(FileList$, Index%, ch%)
10410 LOCal a$, size%, d$, x%, page%
10420 IF ch%=7 THEN
10430  size%=LSizeFile%+LSizedir%
10440  d$=leftDir$
10450 ELSE
10460  size%=RSizeFile%+RSizedir%
10470  d$=rightDir$
10480 END IF
10490 IF Index%>size% THEN RETurn : END IF
10500 IF GetFFlg%(FileList$,Index%) MOD 2 <> 1 THEN RETurn : END IF
10510 IF GetFNam$(FileList$,Index%)=".." THEN
10520   a$=GetParentDir$(ch%)
10530   IF LEN(d$)>LEN(a$) THEN
10540     d$=d$(LEN(a$)+1 TO): IF d$(LEN(d$))="_" THEN d$=d$(1 TO LEN(d$)-1):END IF
10550     IF crtPanel%=7 THEN
10560       DIM LeftFiles$(MaxFiles%,_fMax%) : leftDir$=a$
10570       LoadDir leftDir$, LeftFiles$,7,LSizedir%, LSizeFile%
10580       IF LEN(leftDir$)=5 THEN
10590         LMinPos%=1
10600       ELSE
10610         LMinPos%=0
10620       END IF
10630       IF Find%(d$,id%, LeftFiles$,1,LSizedir%)=1 THEN
10640         LIndex%=id%
10650         x%=id%+(LMinPos%=0)
10660         page%=x% DIV rowno%
10670         IF x% MOD rowno% >0 THEN page%=page%+1: END IF
10680         LStartPos%=(page%-1)*rowno% +LMinPos%
10690         ListFiles LeftFiles$, LStartPos%, LIndex%, 7
10700       ELSE
10710        d$=""
10720       END IF
10730     ELSE
10740       DIM RightFiles$(MaxFiles%,_fMax%) : rightDir$=a$
10750       LoadDir rightDir$, RightFiles$,8,RSizedir%, RSizeFile%
10760       IF LEN(rightDir$)=5 THEN
10770         RMinPos%=1
10780       ELSE
10790         RMinPos%=0
10800       END IF
10810       IF Find%(d$,id%, RightFiles$,1,RSizedir%)=1 THEN
10820         RIndex%=id%
10830         x%=id%+(RMinPos%=0)
10840         page%=x% DIV rowno%
10850         IF x% MOD rowno% >0 THEN page%=page%+1: END IF
10860         RStartPos%=(page%-1)*rowno% +RMinPos%
10870         ListFiles RightFiles$, RStartPos%, RIndex%, 8
10880       ELSE
10890          d$=""
10900       END IF
10910     END IF
10920   ELSE
10930     d$=""
10940   END IF
10950 ELSE
10960   d$=""
10970   IF ch%=7 THEN
10980     a$=leftDir$& GetFNam$(FileList$,Index%)
10990   ELSE
11000     a$=rightDir$& GetFNam$(FileList$,Index%)
11010   END IF
11020 END IF
11030 IF LEN(d$)=0 THEN
11040   IF ch%=7 THEN
11050     leftDir$=a$
11060     LShowLeftDir
11070   ELSE
11080     rightDir$=a$
11090     LShowRightDir
11100   END IF
11110 END IF
11120 END DEFine OpenSubDir
11130 :
11140 :
11150 REMark ''-----------------------------------------------------------
11160 DEFine FuNction GetParentDir$(ch%)
11170 LOCal i%, dir$
11180 IF ch%=7 THEN dir$=leftDir$: ELSE dir$=rightDir$:END IF
11190 FOR i% = LEN(dir$)-1 TO 5 STEP -1
11200  IF dir$(i%) = "_" THEN
11210    IF FTEST(dir$(1 TO i%)) = 0 THEN
11220      IF FTYP(\dir$(1 TO i%)) = 255 THEN EXIT i%
11230    END IF
11240  END IF
11250 END FOR i%
11260 dir$ = dir$(1 TO i%)
11270 RETurn dir$
11280 END DEFine GetParentDir$
11290 :
11300 :
11310 REMark ''------------------------------------------------------------
11320 DEFine PROCedure InputDir(ch%)
11330  LOCal a$, olddir$
11340  PAPER#ch%,0:INK#ch%,7:CLS#ch%
11350  IF ch%=5 THEN
11360    olddir$=leftDir$
11370  ELSE
11380    olddir$=rightDir$
11390  END IF
11400  a$=EDIT$(#ch%, olddir$, 36): CLS#ch%
11410  PAPER#ch%,White%:INK#ch%,0:CLS#ch%
11420  IF a$="" THEN a$=olddir$
11430  IF a$(LEN(a$))<>"_" THEN a$=a$&"_"
11440  IF DirExists%(a$) = 0 THEN
11450    BEEP 1390,20:PRINT#ch%, olddir$
11460    RETurn
11470  END IF
11480  IF ch%=5 THEN
11490    IF crtPanel%=8 THEN ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 0: END IF
11500    leftDir$=a$
11510    crtPanel%=7
11520    LShowLeftDir
11530    BORDER#7,1,brd%: BORDER#8,1,brd%,1,3
11540  ELSE
11550    IF crtPanel%=7 THEN ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 0: END IF
11560    rightDir$=a$
11570    crtPanel%=8
11580    LShowRightDir
11590    BORDER#8,1,brd%: BORDER#7, 1,brd%,1,3
11600  END IF
11610 END DEFine InputDir
11620 :
11630 :
11640 REMark ''----------------------------------------------------------
11650 DEFine PROCedure ViewFile
11660  LOCal ext$(10), a$, x%, i%, ch%, ch1%, ch2%, ch3%, left%, windef$, wid%,hgt%,top%
11670  IF crtPanel%=7 THEN
11680    IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
11690    a$=GetFNam$(LeftFiles$,LIndex%)
11700  ELSE
11710    IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
11720    a$=GetFNam$(RightFiles$,RIndex%)
11730  END IF
11740  IF a$==".." OR a$=="<un-named>" OR IsDir%=1 THEN RETurn : END IF
11750  REMark ''now get file extension
11760  x%=LEN(a$)
11770  FOR i%=0 TO x%-1
11780    IF a$(x%-i%)=="_" OR a$(x%-i%)=="." THEN EXIT i%
11790  END FOR i%
11800  IF i%>0 THEN
11810    ext$=a$(x%-i%+1 TO x%)
11820  ELSE
11830    ext$=""
11840  END IF
11850  IF crtPanel%=7 THEN
11860    a$=leftDir$&a$
11870  ELSE
11880    a$=rightDir$&a$
11890  END IF
11900  ext$=LOWER$(ext$) : x%=0
11910  IF ext$="fnt" THEN x%=1: END IF
11920  IF ext$="fat" THEN x%=2: END IF
11930  IF ext$="scr" THEN x%=3: END IF
11940  IF ext$="doc" THEN x%=4: END IF
11950  IF ext$="zip" THEN x%=5: END IF
11960  IF x%<>3 THEN
11970    IF x%=1 OR x%=2 THEN
11980      left%=(maxWinWid%-448) DIV 2 - 2
11990      wid%=452:hgt%=230: top%=(panelWinHeight%+2*mainFountHeight%+7-hgt%) DIV 2 + 14
12000      windef$="scr_452x230a"&left%&"x"&top%
12010      ch%=FOPEN(windef$)
12020      PAPER #ch%,0:INK #ch%,White%
12030      OUTLN #ch%,452,230,left%,top%:BORDER#ch%,1,2:CLS#ch%
12040      windef$="scr_452x12a"&left%&"x"&top%
12050      ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
12060      PAPER#ch1%,0: INK#ch1%,White%: AT#ch1%,0,37-(LEN(a$)+5)/2: PRINT#ch1%, "View "&a$
12070      left%=left%+2: windef$="scr_448x204a"&left%&"x"&(top%+12)
12080      ch2%=FOPEN(windef$):PAPER#ch2%,0:INK#ch2%,Green%
12090    ELSE
12100      IF maxWinWid%>600 THEN wid%=600: ELSE wid%=452: END IF
12110      hgt%=panelWinHeight%+27
12120      left%=(maxWinWid%-wid%) DIV 2 - 2
12130      top%=mainFountHeight%+4
12140      windef$="scr_"&wid%&"x"&hgt%&"a"&left%&"x"&top%
12150      ch%=FOPEN(windef$)
12160      PAPER #ch%,0:INK #ch%,White%
12170      OUTLN #ch%,wid%,hgt%,left%,top%:BORDER#ch%,1,2:CLS#ch%
12180      windef$="scr_"&wid%&"x12a"&left%&"x"&top%
12190      ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
12200      PAPER#ch1%,0: INK#ch1%,White%: CURSOR#ch1%,(wid%-(LEN(a$)+5)*6)DIV 2,0: PRINT#ch1%, "View "&a$
12210      left%=left%+2: windef$="scr_"&(wid%-4)&"x"&(hgt%-26)&"a"&left%&"x"&(top%+12)
12220      ch2%=FOPEN(windef$):PAPER#ch2%,0:INK#ch2%,Green%
12230    END IF
12240  END IF
12250  SELect ON x%
12260    = 1: ViewFont a$, 1, ch2%
12270    = 2: ViewFont a$, 2, ch2%
12280    = 3: ViewImage a$, 4: Set78CharSet
12290    = 4: WINDOW#0,wid%-4,12,left%,hgt%+top%-14:PAPER#0,Green%: INK#0,0:CLS#0
12300        IF IsQuillDoc%(a$)=1 THEN
12310          IF FTEST(ConfigDrv$&"quill_view") =0 THEN
12320            EW ConfigDrv$&"quill_view", #ch2%; "-t "&a$&" "&TempDir$&"quill_tmp"
12330              IF FTEST(TempDir$&"quill_tmp") =0 THEN
12340              IF mainFountBase>0 AND wid%<600 THEN :CHAR_USE#ch2%,mainFountBase,0: CHAR_INC #ch2%,5,10: END IF
12350              MORE#ch2%, TempDir$&"quill_tmp"
12360              DELETE TempDir$&"quill_tmp"
12370            END IF
12380          ELSE
12390            PRINT #ch2%,"Cannot find quill_view"
12400          END IF
12410        ELSE
12420          MORE#ch2%, a$
12430        END IF
12440    =5: WINDOW#0,wid%-4,12,left%,hgt%+top%-14:PAPER#0,Green%: INK#0,0:CLS#0
12450       IF IsZipFile%(a$)=1 THEN
12460         IF FTEST(ConfigDrv$&"unzip")=0 THEN
12470           ch3%=FOP_OVER (TempDir$&"zip_tmp")
12480           IF ch3%>0 THEN
12490             EW ConfigDrv$&"unzip",#ch3%,#ch3%,#ch3%;"-lqq "&a$
12500             CLOSE#ch3%
12510             MORE#ch2%, TempDir$&"zip_tmp"
12520             DELETE TempDir$&"zip_tmp"
12530           ELSE
12540             PRINT #ch2%,"Cannot create temporary file"
12550           END IF
12560         ELSE
12570            PRINT #ch2%,"Cannot find unzip"
12580         END IF
12590       ELSE
12600         MORE#ch2%, a$
12610       END IF
12620    = REMAINDER :
12630      WINDOW#0,wid%-4,12,left%,hgt%+top%-14:PAPER#0,Green%: INK#0,0:CLS#0
12640      MORE#ch2%, a$
12650  END SELect
12660  IF x%<>3 THEN
12670    CHAR_USE#ch2%,0,0
12680    CLS#ch1%: CLS#ch2%: CLOSE#ch2%:CLOSE#ch1%
12690    WINDOW#0,488,23,12,233:PAPER#0,0:INK#0,White%
12700    OUTLN #ch%,wid%,hgt%,left%,top%
12710    CLOSE#ch%
12720  END IF
12730 END DEFine ViewFile
12740 :
12750 :
12760 REMark ''----------------------------------------------------------
12770 DEFine PROCedure ViewFont (file$, type%, ch%)
12780 LOCal lng, i, base, type$(6)
12790 lng=FLEN(\file$)
12800 IF lng>0 THEN
12810  AT#ch%,0,0:PRINT#ch%, "Font: "&file$; "      ";
12820  AT#ch%,0,44:PRINT#ch%, "Font size = ";lng;" bytes"
12830 ELSE
12840  PRINT#ch%, "Font NOT FOUND" : RETurn
12850 END IF
12860 base = ALCHP(lng)
12870 LBYTES file$,base
12880 :
12890 IF type%=1 THEN type%=TestFount%(base)
12900 IF type%=1 THEN type$="(5x9)" : ELSE type$="(8x9)"
12910 AT #ch%,0,7 + LEN(file$) : PRINT #ch%,type$;
12920 :
12930 AT#ch%,1,0:PRINT#ch%, "Lowest character code = "; PEEK(base); "        ";
12940 AT#ch%,1,44:PRINT#ch%, "Number of characters  = "; PEEK(base+1) + 1
12950 PRINT#ch%,"  "
12960 CHAR_USE#ch%,base,0
12970 CSIZE #ch%, (type%=2),0: CHAR_INC#ch%,6 + 2*(type%=2),10
12980 FOR i=0 TO 9
12990   PRINT#ch%,CHR$(i);
13000 NEXT i: END FOR i
13010 PRINT#ch%," ";
13020 FOR i=11 TO 255:PRINT#ch%,CHR$(i);:NEXT i: END FOR i
13030 PRINT#ch%,CHR$(10)
13040 PRINT#ch%, "The quick brown fox jumped over the lazy dog"
13050 CSIZE#ch%, 2+(type%=2),0 : CHAR_INC#ch%,12 + 4*(type%=2),10
13060 PRINT#ch%, "The quick brown fox jumped over the lazy dog"
13070 CSIZE#ch%, 2+(type%=2),1 : CHAR_INC#ch%,12 + 4*(type%=2),20
13080 PRINT#ch%, "The quick brown fox jumped over the lazy dog"
13090 CHAR_USE#ch%,0,0
13100 RECHP base
13110 xx$=INKEY$(-1)
13120 END DEFine ViewFont
13130 :
13140 :
13150 REMark ''----------------------------------------------------------
13160 DEFine PROCedure MessageWnd(width%, height%, type%, text$)
13170 LOCal ch%, k$, AtX%,AtY%
13180 AtX%=(maxWinWid% - width%)/2
13190 AtY%=(256-height%)/2
13200 ch% = FOPEN("con")
13210 OUTLN#ch%; width%-2, height%, AtX%, AtY%, 4, 3
13220 SELect ON type%
13230   =1:
13240   PAPER#ch%,Green%:INK#ch%,0:CLS#ch%
13250   BLOCK#ch%,width%-4, 8, 1, 1,Green%,1,1
13260   AT#ch%, 1,1: PRINT#ch%, text$
13270   =2:
13280   PAPER#ch%,2:INK#ch%,White%:CLS#ch%
13290   BLOCK#ch%,width%-4, 8, 1, 1,2,1,1
13300   CURSOR#ch%,(width%-49)/2,1:PRINT#ch%," ERROR "
13310   AT#ch%, 1,1: PRINT#ch%, text$
13320   =3:
13330   PAPER#ch%,White%:INK#ch%,0:BORDER#ch%,1,2::CLS#ch%
13340   BLOCK#ch%,width%-8, 8, 1, 1,2,0,1
13350   CURSOR#ch%,(width%-49)/2,1:PRINT#ch%," ABOUT "
13360   CURSOR#ch%,2,15:PRINT#ch%, text$
13370 END SELect
13380 CURSOR#ch%,(width%-130)/2,48:PRINT#ch%,"... press any key ..."
13390 k$=INKEY$(-1)
13400 OUTLN#ch%; width%, height%, AtX%, AtY%
13410 CLOSE#ch%
13420 END DEFine MessageWnd
13430 :
13440 :
13450 REMark ''----------------------------------------------------------
13460 DEFine FuNction IsDir%
13470 LOCal k%, lenghth, bufsize
13480 IF crtPanel%=7 THEN
13490   k%=GetFFlg%(LeftFiles$,LIndex%) MOD 2
13500 ELSE
13510   k%=GetFFlg%(RightFiles$,RIndex%) MOD 2
13520 END IF
13530 RETurn k%
13540 END DEFine IsDir%
13550 :
13560 :
13570 REMark ''----------------------------------------------------------
13580 DEFine PROCedure ViewImage(a$, mode%)
13590 LOCal ch%, ch1%,scrSz,scrBuf,maxScrSz
13600   IF maxWinHgt%>256 OR maxWinWid%>512 OR RMODE>8 THEN
13610     MessageWnd 200,60,2, CHR$(10)&" _scr images can only be viewed"&CHR$(10)&"  on classic QL configuration":RETurn
13620   END IF
13630   maxScrSz=32768
13640   scrSz=FLEN(\a$)
13650   IF scrSz > maxScrSz THEN
13660     scrBuf=ALCHP(scrSz) : IF scrBuf<0 THEN BEEP 1390,10 : RETurn
13670     LBYTES a$,scrBuf : a$=TempDir$ & "tmp_scr"
13680     SBYTES_O a$, scrBuf, maxScrSz
13690     RECHP scrBuf
13700   END IF
13710   ch% = FOPEN("con")
13720   OUTLN#ch%; 512, 256, 0, 0
13730   IF mode%=4 THEN MODE 4: ELSE MODE 8: END IF
13740   LBYTES a$, 131072 : PAUSE 10
13750   k%=CODE(INKEY$(-1))
13760   SELect ON k%
13770     = 52: OUTLN#ch%; 512, 256, 0, 0: CLOSE#ch%: ViewImage a$, 4
13780     = 56: OUTLN#ch%; 512, 256, 0, 0: CLOSE#ch%: ViewImage a$, 8
13790     = REMAINDER : MODE 4
13800       OUTLN#ch%; 512, 256, 0, 0
13810       CLOSE#ch%
13820       DELETE TempDir$ & "tmp_scr"
13830   END SELect
13840 END DEFine ViewImage
13850 :
13860 :
13870 REMark ''----------------------------------------------------------
13880 DEFine FuNction InputWnd$(width%, height%, title$, text$,default$)
13890 LOCal ch%, ch1%, k$, AtX%,AtY%
13900 AtX%=(maxWinWid% -width%)/2
13910 AtY%=(256-height%)/2
13920 ch% = FOPEN("con")
13930 OUTLN#ch%; width%, height%, AtX%, AtY%, 4, 3
13940 BORDER#ch%,1,4
13950 PAPER#ch%,White%:INK#ch%,0:CLS#ch%
13960 BLOCK#ch%,width%-4, 10, 0, 0,Green%,1,1
13970 PAPER#ch%,Green%:INK#ch%,0:CURSOR#ch%,(width%-6-LEN(title$)*6)/2,0:PRINT#ch%,title$
13980 PAPER#ch%,White%: INK#ch%,0:CURSOR#ch%, 6,16: PRINT#ch%, text$
13990 CURSOR#ch%,(width%-198)/2,48:PRINT#ch%,"... leave it empty to cancel ..."
14000 ch1% = FOPEN("con")
14010 WINDOW #ch1%, width%-18,12,AtX%+8, AtY%+28
14020 PAPER#ch1%,0:INK#ch1%,White%:CLS#ch1%
14030 k$=EDIT$(#ch1%,default$, 36)
14040 CLOSE#ch1%
14050 OUTLN#ch%; width%, height%, AtX%, AtY%
14060 CLOSE#ch%
14070 RETurn k$
14080 END DEFine InputWnd$
14090 :
14100 :
14110 REMark ''----------------------------------------------------------
14120 DEFine FuNction DirExists% (name$)
14130 LOCal er%, ch%, d$, dname$
14140 dbg name$
14150 dname$=name$
14160 IF dname$(LEN(dname$))<>"_" THEN dname$=dname$&"_": END IF
14170 IF LEN(dname$)=5 THEN
14180   d$=DATAD$: DATA_USE CHR$(0)
14190   ch%=FOP_DIR(dname$)
14200   DATA_USE d$
14210   IF ch%<0 THEN
14220     er%=0
14230   ELSE
14240     CLOSE#ch%
14250     er%=1
14260   END IF
14270 ELSE
14280   IF FTEST(dname$) = 0 THEN
14290     IF FTYP(\dname$) = 255 THEN er% = 1 : ELSE er% = 0 : END IF
14300   ELSE
14310     er% = 0
14320   END IF
14330 END IF
14340 RETurn er%
14350 END DEFine DirExists%
14360 :
14370 :
14380 REMark ''----------------------------------------------------------
14390 DEFine PROCedure CreateDir
14400 LOCal x%,DirName$, FullDirName$
14410 DirName$=InputWnd$(240,60," Create Directory ", "Directory Name:","")
14420 DirName$=UPPER$(DirName$)
14430 IF DirName$="" THEN RETurn : END IF
14440 IF crtPanel%=7 THEN
14450   FullDirName$=leftDir$&DirName$
14460 ELSE
14470   FullDirName$=rightDir$&DirName$
14480 END IF
14490 x%=Create1Dir% (DirName$, FullDirName$, crtPanel%, 1,1,1)
14500 END DEFine CreateDir
14510 :
14520 :
14530 REMark ''----------------------------------------------------------
14540 DEFine FuNction Create1Dir%(DirName$, FullDirName$, panel%, UpdateWnd%, CheckNoQ%, UpdateList%)
14550 LOCal res%, fres%, page%, msg$
14560 IF LEN(FullDirName$)>41 THEN
14570   IF UpdateWnd%=1 THEN
14580     MessageWnd 200,60,2, CHR$(10)&"          Name too long !"
14590     RETurn 0
14600   ELSE
14610     INK#0,2:PRINT#0,"Directory not created  Name too long":INK#0,White%:RETurn 0
14620   END IF
14630 END IF
14640 IF (Qubide%=1) AND (CheckNoQ%=1) THEN
14650   IF TestQubideRestriction%(DirName$, panel%)=1 THEN
14660     IF UpdateWnd%=1 THEN
14670       MessageWnd 200,60,2, "   Cannot create Directory !"&CHR$(10)&"  QUBIDE limitation: Files will"&CHR$(10)&"     fall in the directory !"
14680       RETurn 0
14690     ELSE
14700       INK#0,2:PRINT#0,"Directory not created QUBIDE limitation: Files will fall in the directory":INK#0,White%:RETurn 0
14710     END IF
14720   END IF
14730 END IF
14740 IF DirName$(LEN(DirName$))="_" THEN DirName$=DirName$(1 TO LEN(DirName$)-1):END IF
14750 IF panel%=7 THEN
14760    IF (CheckNoQ%=1) AND (LSizedir%+LSizeFile%+1>=MaxFiles%) THEN
14770      IF UpdateWnd%=1 THEN
14780        MessageWnd 200,60,2, CHR$(10)&"   Cannot create Directory !"&CHR$(10)&CHR$(10)&"     maximum number reached !"
14790        RETurn 0
14800      ELSE
14810        INK#0,2:PRINT#0,"Directory not created. You have reached the maximum number of files and directories":INK#0,White%:RETurn -1
14820      END IF
14830    ELSE
14840      fres%=FMAKE_DIR (FullDirName$)
14850      IF (UpdateList%=1) AND (fres%>=0) THEN
14860        res%=Find% (DirName$,id%,LeftFiles$,1,LSizedir%)
14870        IF res%=0 THEN res%=Insert% (DirName$,id%, LeftFiles$, 1, LSizedir%, LSizeFile%, "0"):END IF
14880        LIndex%=id%
14890        IF UpdateWnd%=1 THEN
14900          id%=id%+(LMinPos%=0)
14910          page%=id% DIV rowno%
14920          IF id% MOD rowno% >0 THEN page%=page%+1: END IF
14930          LStartPos%=(page%-1)*rowno% +LMinPos%
14940          ListFiles LeftFiles$, LStartPos%, LIndex%, 7
14950        END IF
14960        RETurn 1
14970      ELSE
14980        IF fres%>=0 THEN RETurn 1
14990      END IF
15000    END IF
15010 ELSE
15020    IF (CheckNoQ%=1) AND (RSizedir%+RSizeFile%+1>=MaxFiles%) THEN
15030      IF UpdateWnd%=1 THEN
15040        MessageWnd 200,60,2, CHR$(10)&"   Cannot create Directory !"&CHR$(10)&CHR$(10)&"     maximum number reached !"
15050        RETurn 0
15060      ELSE
15070        INK#0,2:PRINT#0,"Directory not created. You have reached the maximum number of files and directories":INK#0,White%:RETurn -1
15080      END IF
15090    ELSE
15100      fres%=FMAKE_DIR (FullDirName$)
15110      IF (UpdateList%=1) AND (fres%>=0) THEN
15120        res%=Find% (DirName$,id%,RightFiles$,1,RSizedir%)
15130        IF res%=0 THEN res%=Insert% (DirName$,id%, RightFiles$, 1, RSizedir%, RSizeFile%, "0"): END IF
15140        RIndex%=id%
15150        IF UpdateWnd%=1 THEN
15160          id%=id%+(RMinPos%=0)
15170          page%=id% DIV rowno%
15180          IF id% MOD rowno% >0 THEN page%=page%+1: END IF
15190          RStartPos%=(page%-1)*rowno% +RMinPos%
15200          ListFiles RightFiles$, RStartPos%, RIndex%, 8
15210        END IF
15220        RETurn 1
15230      ELSE
15240        IF fres%>=0 THEN RETurn 1
15250      END IF
15260    END IF
15270 END IF
15280 SELect ON fres%
15290   =-8, -9: msg$= "   Cannot create Directory !"&CHR$(10)&"    A file or a directory with"&CHR$(10)&"    same name already exists !"
15300   =-11:msg$= CHR$(10)&"    Cannot create Directory"&CHR$(10)&"            Drive full"
15310   =-15:msg$= CHR$(10)&"    Cannot create Directory"&CHR$(10)&"       Drive is not Level2"
15320   =-19:msg$= CHR$(10)&"    Cannot create Directory"&CHR$(10)&"       Not implemented yet"
15330   =-20:msg$= CHR$(10)&"    Cannot create Directory"&CHR$(10)&"        Drive is Read Only "
15340   =REMAINDER :msg$= CHR$(10)&"    Cannot create Directory"&CHR$(10)&"            Error "&fres%
15350 END SELect
15360 IF UpdateWnd%=1 THEN
15370   MessageWnd 200,60,2, msg$
15380   IF (fres%=-15) OR (fres%=-19) THEN DELETE FullDirName$: END IF
15390   RETurn 0
15400 ELSE
15410   SELect ON fres%
15420     =-8, -9: INK#0,2:PRINT#0,"Directory not created  A file or a directory with same name already exists":INK#0,White%:RETurn 0
15430     REMark ''=-9:ink#0,2:print#0,"Directory not created  A directory with same name already exists":INK#0,White%:Return 0
15440      =-11:INK#0,2:PRINT#0,"Directory not created Drive full":INK#0,White%:RETurn -1
15450      =-15:INK#0,2:PRINT#0,"Directory not created  Drive is not Level2":INK#0,White%:RETurn -1
15460      =-19:INK#0,2:PRINT#0,"Directory not created  Operation not implemented yet for this drive type":INK#0,White%:RETurn -1
15470      =-20:INK#0,2:PRINT#0,"Directory not created  Drive is Read Only ":INK#0,White%:RETurn -1
15480      =REMAINDER : INK#0,2:PRINT#0,"Directory not created  Error "&fres%:INK#0,White%:RETurn 0
15490   END SELect
15500 END IF
15510 END DEFine Create1Dir%
15520 :
15530 :
15540 REMark ''-----------------------------------------------------------
15550 DEFine FuNction CountSelected%
15560 LOCal i%, counter%
15570 counter%=0
15580 IF crtPanel%=7 THEN
15590   FOR i%=1 TO LSizedir%+LSizeFile%
15600     IF GetFFlg%(LeftFiles$,i%) > 1 THEN counter%=counter%+1 : END IF
15610   END FOR i%
15620 ELSE
15630   FOR i%=1 TO RSizedir%+RSizeFile%
15640     IF GetFFlg%(RightFiles$,i%) > 1 THEN counter%=counter%+1 : END IF
15650   END FOR i%
15660 END IF
15670 RETurn counter%
15680 END DEFine CountSelected%
15690 :
15700 :
15710 REMark ''---------------------------------------------------------
15720 DEFine FuNction DlgWnd%(width%, height%, title$, text$)
15730 LOCal ch%, a$, k%, AtX%, AtY%, loopa
15740 AtX%=(maxWinWid%-width%)/2
15750 AtY%=(256-height%)/2
15760 ch% = FOPEN("con")
15770 OUTLN#ch%; width%, height%, AtX%, AtY%, 4, 3
15780 BORDER#ch%,1,Green%
15790 PAPER#ch%,White%:INK#ch%,0:CLS#ch%
15800 BLOCK#ch%,width%-4, 10, 0, 0,Green%,1,1
15810 PAPER#ch%,Green%:INK#ch%,0:CURSOR#ch%,(width%-6-LEN(title$)*6)/2,0:PRINT#ch%,title$
15820 PAPER#ch%,White%: INK#ch%,0:CURSOR#ch%, 6,16: PRINT#ch%, text$
15830 CURSOR#ch%,(width%-198)/2,48:
15840 INK#ch%,2: PRINT#ch%,"    C";:INK#ch%,0:PRINT#ch%,"ancel                ";
15850 INK#ch%,2: PRINT#ch%,"O";:INK#ch%,0:PRINT#ch%,"k"
15860 REPeat loopa
15870    a$=INKEY$(-1)
15880    IF a$ INSTR "oO"&CHR$(10) THEN k%=1: EXIT loopa: END IF
15890    IF a$ INSTR "cC"&CHR$(27) THEN k%=0: EXIT loopa: END IF
15900 END REPeat loopa
15910 OUTLN#ch%; width%, height%, AtX%, AtY%
15920 CLOSE#ch%
15930 RETurn k%
15940 END DEFine DlgWnd%
15950 :
15960 :
15970 REMark ''----------------------------------------------------------
15980 DEFine FuNction TestQubideRestriction%(DirName$, panel%)
15990 LOCal i%, name$
16000 name$=DirName$
16010 IF name$(LEN(name$))<>"_" THEN name$=name$&"_"
16020 IF panel%=7 THEN
16030   FOR i%=LSizedir%+1 TO LSizedir%+LSizeFile%
16040     IF name$ INSTR LeftFiles$(i%) = 1 THEN RETurn 1 : END IF
16050   END FOR i%
16060 ELSE
16070   FOR i%=RSizedir%+1 TO RSizedir%+RSizeFile%
16080     IF name$ INSTR RightFiles$(i%) = 1 THEN RETurn 1 : END IF
16090   END FOR i%
16100 END IF
16110 RETurn 0
16120 END DEFine TestQubideRestriction%
16130 :
16140 :
16150 REMark ''----------------------------------------------------------
16160 DEFine FuNction IsQuillDoc%(a$)
16170 LOCal ch%, q$, i%, k%
16180 ch% = FOPEN(a$)
16190 IF ch% <= 0 THEN RETurn 0: END IF
16200 q$=""
16210 BGET #ch%\1,k%
16220 FOR i%=1 TO 8
16230  BGET #ch%,k%
16240  q$=q$&CHR$(k%)
16250 NEXT i%: END FOR i%
16260 CLOSE #ch%
16270 IF q$="vrm1qdf0" THEN RETurn 1: ELSE RETurn 0: END IF
16280 END DEFine IsQuillDoc%
16290 :
16300 :
16310 REMark ''-----------------------------------------------------------
16320 DEFine FuNction IsZipFile%(a$)
16330 LOCal ch%, q$, i%, k%
16340 ch% = FOPEN(a$)
16350 IF ch% <= 0 THEN RETurn 0: END IF
16360 q$=""
16370 FOR i%=1 TO 4
16380  BGET #ch%,k%
16390  q$=q$&CHR$(k%)
16400 NEXT i%: END FOR i%
16410 CLOSE #ch%
16420 IF q$="PK"&CHR$(3)&CHR$(4) THEN RETurn 1: ELSE RETurn 0: END IF
16430 END DEFine IsZipFile%
16440 :
16450 :
16460 REMark ''----------------------------------------------------------
16470 DEFine PROCedure RenameFile
16480 LOCal NewFileName$,filename$, sourcepath$, res%, i%, x%, filelen$, page%
16490 IF crtPanel%=7 THEN
16500  IF LIndex%>LSizeFile%+LSizedir% THEN RETurn : END IF
16510 ELSE
16520  IF RIndex%>RSizeFile%+RSizedir% THEN RETurn : END IF
16530 END IF
16540 IF crtPanel%=7 THEN
16550    filename$=GetFNam$(LeftFiles$,LIndex%)
16560    sourcepath$=leftDir$
16570 ELSE
16580    filename$=GetFNam$(RightFiles$,RIndex%)
16590    sourcepath$=rightDir$
16600 END IF
16610 IF filename$=".." THEN RETurn : END IF
16620 IF IsDir%=1 THEN
16630   MessageWnd 200,60,2, CHR$(10)&"   Cannot rename a Directory!"
16640   RETurn
16650 END IF
16660 res%=FTEST(sourcepath$&filename$)
16670 IF res%=-9 THEN
16680   MessageWnd 200,60,2, CHR$(10)&"   File in Use! Cannot rename!"
16690   RETurn
16700 END IF
16710 IF res%=-20 THEN
16720   MessageWnd 200,60,2, CHR$(10)&"       File is Read Only! "&CHR$(10)&"          Cannot rename!"
16730   RETurn
16740 END IF
16750 NewFileName$=InputWnd$(240,60," Rename File ", "Rename "&filename$&" to:",filename$)
16760 IF NewFileName$="" THEN RETurn : END IF
16770 IF LEN(sourcepath$&NewFileName$)>36 THEN
16780   MessageWnd 200,60,2, CHR$(10)&"   Full file name is too long!"
16790   RETurn
16800 END IF
16810 IF FTEST(sourcepath$&NewFileName$)<>-7 THEN
16820   MessageWnd 200,60,2, CHR$(10)&"      A file with this name"&CHR$(10)&"          already exists!"
16830   RETurn
16840 END IF
16850 RENAME sourcepath$&filename$ TO sourcepath$&NewFileName$
16860 IF crtPanel%=7 THEN
16870   filelen$=GetFLen(LeftFiles$,LIndex%)
16880   ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 0
16890   FOR i%=LIndex%+1 TO LSizedir%+LSizeFile%
16900     CopyRec LeftFiles$,i% TO LeftFiles$,i%-1
16910   END FOR i%
16920   LSizeFile%=LSizeFile%-1
16930   x%=Find%(NewFileName$,id%, LeftFiles$,LSizedir%+1,LSizedir%+LSizeFile%)
16940   x%=Insert%(NewFileName$,id%,LeftFiles$,0, LSizedir%, LSizeFile%, filelen$)
16950   LIndex%=id%
16960   x%=id%+(LMinPos%=0)
16970   page%=x% DIV rowno%
16980   IF x% MOD rowno% >0 THEN page%=page%+1: END IF
16990   LStartPos%=(page%-1)*rowno% +LMinPos%
17000   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
17010 ELSE
17020   filelen$=GetFLen(RightFiles$,RIndex%)
17030   ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 0
17040   FOR i%=RIndex%+1 TO RSizedir%+RSizeFile%
17050     CopyRec RightFiles$,i% TO RightFiles$,i%-1
17060   END FOR i%
17070   RSizeFile%=RSizeFile%-1
17080   x%=Find%(NewFileName$,id%, RightFiles$,RSizedir%+1,RSizedir%+RSizeFile%)
17090   x%=Insert%(NewFileName$,id%,RightFiles$,0, RSizedir%, RSizeFile%, filelen$)
17100   RIndex%=id%
17110   x%=id%+(RMinPos%=0)
17120   page%=x% DIV rowno%
17130   IF x% MOD rowno% >0 THEN page%=page%+1: END IF
17140   RStartPos%=(page%-1)*rowno% +RMinPos%
17150   ListFiles RightFiles$, RStartPos%, RIndex%, 8
17160 END IF
17170 END DEFine RenameFile
17180 :
17190 :
17200 REMark ''-----------------------------------------------------------
17210 DEFine PROCedure ShowInfo
17220  LOCal filename$(36), path$(36), chf%, ch%,ch1%,ch2%,x%, k$(2),windef$, left%, top%
17230 :
17240   IF crtPanel%=7 THEN
17250     IF LIndex%>LSizeFile%+LSizedir% THEN RETurn : END IF
17260   ELSE
17270     IF RIndex%>RSizeFile%+RSizedir% THEN RETurn : END IF
17280   END IF
17290 :
17300   IF crtPanel%=7 THEN
17310     filename$=GetFNam$(LeftFiles$,LIndex%)
17320     path$=leftDir$
17330   ELSE
17340     filename$=GetFNam$(RightFiles$,RIndex%)
17350     path$=rightDir$
17360   END IF
17370 :
17380   IF filename$=".." THEN RETurn : END IF
17390   left%=(maxWinWid%-452) DIV 2
17400   IF maxWinHgt%>256 THEN top%=51: ELSE top%=14: END IF
17410   windef$="scr_452x230a"&left%&"x"&top%
17420   ch%=FOPEN(windef$)
17430   PAPER #ch%,0:INK #ch%,White%
17440   OUTLN #ch%,452,230,left%,top% : BORDER #ch%,1,2: CLS #ch%
17450   windef$="scr_452x12a"&left%&"x"&top%
17460   ch1%=FOPEN(windef$): BORDER #ch1%,1,2 : PAPER #ch1%,0,2,1 : CLS #ch1%
17470   PAPER #ch1%,0 : INK #ch1%,White% : AT #ch1%,0,34 : PRINT#ch1%, " Info "
17480   windef$="scr_448x204a"&(left%+2)&"x"&(top%+12)
17490   ch2%=FOPEN(windef$):PAPER#ch2%,0:INK#ch2%,Green%
17500   PRINT #ch2%, "Full name: ";path$&filename$;CHR$(10);
17510 :
17520   chf%=FOPEN(path$&filename$)
17530   IF chf%<0 THEN
17540     INK#ch2%, 2
17550     SELect ON chf%
17560       =-7: PRINT#ch2%, "File Not Found !"
17570       =-9: PRINT#ch2%, "File in use"
17580       = REMAINDER : PRINT#ch2%, "Error ";chf%
17590     END SELect
17600     INK 4
17610   ELSE
17620     GetHEAD #chf%,headBuff
17630     PRINT#ch2%, "File Length:"; : PRINT_USING#ch2%, "##,###,###. bytes\", PEEK_L(headBuff)
17640     x%=PEEK(headBuff+5)
17650     PRINT#ch2%, "File Type:   ";x%;" - ";
17660     SELect ON x%
17670       =0  : PRINT#ch2%, "BASIC, CALLable machine code, extensions or DATA file"
17680       =1  : PRINT#ch2%, "EXECable file"
17690       =2  : PRINT#ch2%, "SROFF file used by linkers etc, a C68 Library file etc"
17700       =3  : PRINT#ch2%, "THOR hard disc directory file. (I think!)"
17710       =4  : PRINT#ch2%, "A font file for The Painter"
17720       =5  : PRINT#ch2%, "A pattern file for The Painter"
17730       =6  : PRINT#ch2%, "A compressed MODE 4 screen in The Painter"
17740       =11 : PRINT#ch2%, "A compressed MODE 8 screen in The Painter"
17750       =255: PRINT#ch2%, "Level 2 driver directory or sub-directory file"
17760       =REMAINDER : PRINT#ch2%," "
17770     END SELect
17780     PRINT#ch2%, "Data-space: ";
17790     IF x%=1 THEN PRINT_USING#ch2%, "##,###,###. bytes\", PEEK_L(headBuff+6) : ELSE : PRINT#ch2%, "   n/a"
17800     PRINT#ch2%, "File Version:  ";PEEK_W(headBuff+56)
17810     PRINT#ch2%, "Last modified: ";
17820     d=PEEK_L(headBuff+52) : IF d THEN PRINT#ch2%, DATE$(d) : ELSE : PRINT#ch2%, "<not-set>"
17830     PRINT#ch2%, "Backup date:   ";
17840     d=PEEK_L(headBuff+60) : IF d THEN PRINT#ch2%, DATE$(d) : ELSE : PRINT#ch2%, "<not-set>"
17850     CLOSE #chf%
17860   END IF
17870 :
17880   PRINT#ch2%, CHR$(10);"------------------------------------------------------------------------";CHR$(10)
17890   PRINT#ch2%, "ROM Version:  "; VER$
17900   PRINT#ch2%, "QDOS Version: "; VER$(1)
17910   PRINT#ch2%, "Current RAMTOP: "; : PRINT_USING#ch2%, "##,###.#",RESPR(0)/1024-128 : PRINT#ch2%, " Kb"
17920   PRINT#ch2%, "Free memory:    "; : PRINT_USING#ch2%, "##,###.#",FREE_MEM/1024     : PRINT#ch2%, " Kb"
17930   PRINT#ch2%
17940   PRINT#ch2%, "DataD$: ";DATAD$
17950   PRINT#ch2%, "ProgD$: ";PROGD$
17960   PRINT#ch2%, "DestD$: ";DESTD$
17970 :
17980   k$=INKEY$(-1)
17990   CLS #ch1% : CLS #ch2% : CLOSE #ch2% : CLOSE #ch1%
18000   OUTLN #ch%,452,230,left%,top%
18010   CLOSE #ch%
18020 :
18030 END DEFine ShowInfo
18040 :
18050 :
18060 REMark ''----------------------------------------------------------
18070 DEFine PROCedure WriteCommands(ch%)
18080  LOCal lat, px%, px1%, i%, x%, lat%(9)
18090   lat=(comWinWid% - 4) DIV 9: rest=(comWinWid% - 4) MOD 9:FOR i%=1 TO 9:lat%(i%)=lat:NEXT i%
18100   IF rest>=0 THEN lat%(4)=lat+1
18110   IF rest>=1 THEN lat%(3)=lat+1
18120   IF rest>=2 THEN lat%(5)=lat+1
18130   IF rest>=3 THEN lat%(1)=lat+1
18140   IF rest>=4 THEN lat%(2)=lat+1
18150   IF rest>=5 THEN lat%(6)=lat+1
18160   IF rest>=6 THEN lat%(7)=lat+1
18170   IF rest>=7 THEN lat%(8)=lat+1
18180   IF rest>=8 THEN lat%(9)=lat+1
18190   px%=0
18200   PAPER#ch%, PPR9a%,ppr9b%,3
18210 :
18220   FOR i%=1 TO 9
18230     BLOCK#ch%, lat%(i%)-1,mainFountHeight%, px%,0, PPR9a%,ppr9b%,3
18240     x%=px% + (lat%(i%) - 1 - LEN(cmdText$(i%)) * comFountWid%) DIV 2
18250     CURSOR#ch%, x%,0 : PRINT#ch%, cmdText$(i%);
18260     px%=px%+lat%(i%)
18270   END FOR i%
18280 END DEFine WriteCommands
18290 :
18300 :
18310 REMark ''----------------------------------------------------------
18320 DEFine FuNction IsReadOnly% (a$)
18330 LOCal res%
18340 res%=FOPEN(a$&CHR$(0))
18350 IF res%=-20 THEN RETurn 1: END IF
18360 IF res%>0 THEN DELETE a$&CHR$(0): END IF
18370 RETurn 0
18380 END DEFine IsReadOnly%
18390 :
18400 :
18410 REMark ''----------------------------------------------------------
18420 DEFine PROCedure CopyFiles
18430 LOCal k%, x%, name$, source$, dest$, filelen$, panel%
18440 x%=CountSelected%
18450 IF crtPanel%=7 THEN
18460   source$=leftDir$ : dest$=rightDir$
18470   name$=GetFNam$(LeftFiles$,LIndex%)
18480   filelen$=GetFLen(LeftFiles$,LIndex%)
18490   panel%=8
18500 ELSE
18510   dest$=leftDir$ : source$=rightDir$
18520   name$=GetFNam$(RightFiles$,RIndex%)
18530   filelen$=GetFLen(RightFiles$,RIndex%)
18540   panel%=7
18550 END IF
18560 IF IsReadOnly%(dest$) THEN
18570  MessageWnd 200,60,2, CHR$(10)&"    Destination is Read Only! "&CHR$(10)&"           Cannot copy!"
18580  RETurn
18590 END IF
18600 IF x%>0 THEN
18610  k%=DlgWnd%(240,60," Copy Files ", "    Are you sure you want to copy"&CHR$(10)&"     "&x%&" files and directories ?")
18620  IF k%=1 THEN CopyMultipleFiles x%
18630 ELSE
18640  IF IsDir%=1 THEN
18650      CopySingleDir name$, source$, dest$, panel%
18660  ELSE
18670    IF LEN(dest$&name$)>41 THEN
18680      MessageWnd 200,60,2, CHR$(10)&"        Cannot copy file"&CHR$(10)&"          Name too long !"
18690      RETurn
18700    END IF
18710    k%=FTEST(dest$&name$)
18720    IF k%=-7 THEN
18730     IF crtPanel%=7 THEN
18740       IF RSizedir%+RSizeFile%+1>=MaxFiles% THEN
18750         MessageWnd 200,60,2, CHR$(10)&"        Cannot copy file"&CHR$(10)&"      maximum number reached !"
18760         RETurn
18770       END IF
18780      ELSE
18790       IF LSizedir%+LSizeFile%+1>=MaxFiles% THEN
18800         MessageWnd 200,60,2, CHR$(10)&"        Cannot copy file"&CHR$(10)&"      maximum number reached !"
18810         RETurn
18820       END IF
18830      END IF
18840      Copy1File name$, source$, dest$, filelen$, 1: RETurn
18850    ELSE
18860      IF k%=0 THEN
18870        x%=DlgWnd%(240,60," Copy Files ", "   Destination file already exists"&CHR$(10)&"              Overwrite ?")
18880        IF x%=1 THEN Copy1File name$, source$, dest$, filelen$, 1: RETurn :END IF
18890      ELSE
18900        SELect ON k%
18910          =-9: MessageWnd 200,60,2, CHR$(10)&"      Destination is in use "&CHR$(10)&"           Cannot copy!":RETurn
18920          =-11:MessageWnd 200,60,2, CHR$(10)&"    Destination drive is full"&CHR$(10)&"           Cannot copy!":RETurn
18930          =-16:MessageWnd 200,60,2, CHR$(10)&"      Bad or Changed Medium"&CHR$(10)&"           Cannot copy!":RETurn
18940          =-20:MessageWnd 200,60,2, CHR$(10)&"    Destination is Read Only! "&CHR$(10)&"           Cannot copy!": RETurn
18950          =REMAINDER : MessageWnd 200,60,2, CHR$(10)&"     Error copying file : "&k%:RETurn
18960        END SELect
18970      END IF
18980    END IF
18990  END IF
19000  IF crtPanel%=7 THEN
19010    id%=RIndex%+(RMinPos%=0)
19020    page%=id% DIV rowno%
19030    IF id% MOD rowno% >0 THEN page%=page%+1: END IF
19040    RStartPos%=(page%-1)*rowno% +RMinPos%
19050    ListFiles RightFiles$, RStartPos%, RIndex%, 8
19060  ELSE
19070    id%=LIndex%+(LMinPos%=0)
19080    page%=id% DIV rowno%
19090    IF id% MOD rowno% >0 THEN page%=page%+1: END IF
19100    LStartPos%=(page%-1)*rowno% +LMinPos%
19110    ListFiles LeftFiles$, LStartPos%, LIndex%, 7
19120  END IF
19130 END IF
19140 END DEFine CopyFiles
19150 :
19160 :
19170 REMark ''-----------------------------------------------------------
19180 DEFine PROCedure Copy1File (name$, source$, dest$, filelen$, UpdateList%)
19190 LOCal x%, page%
19200 COPY_O source$&name$ TO dest$&name$
19210 IF crtPanel%=8 THEN
19220   x%=Find%(name$,id%, LeftFiles$,LSizedir%+1,LSizedir%+LSizeFile%)
19230   IF x%=0 THEN
19240     x%=Insert%(name$,id%,LeftFiles$,0, LSizedir%, LSizeFile%, filelen$)
19250   ELSE
19260     PutFLen LeftFiles$,id%,filelen$
19270   END IF
19280   LIndex%=id%
19290   IF UpdateList%=1 THEN
19300     id%=id%+(LMinPos%=0)
19310     page%=id% DIV rowno%
19320     IF id% MOD rowno% >0 THEN page%=page%+1: END IF
19330     LStartPos%=(page%-1)*rowno% +LMinPos%
19340     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
19350   END IF
19360 ELSE
19370   x%=Find%(name$,id%, RightFiles$,RSizedir%+1,RSizedir%+RSizeFile%)
19380   IF x%=0 THEN
19390     x%=Insert%(name$,id%,RightFiles$,0, RSizedir%, RSizeFile%, filelen$):
19400   ELSE
19410     PutFLen RightFiles$,id%,filelen$
19420   END IF
19430   RIndex%=id%
19440   IF UpdateList%=1 THEN
19450     id%=id%+(RMinPos%=0)
19460     page%=id% DIV rowno%
19470     IF id% MOD rowno% >0 THEN page%=page%+1: END IF
19480     RStartPos%=(page%-1)*rowno% +RMinPos%
19490     ListFiles RightFiles$, RStartPos%, RIndex%, 8
19500   END IF
19510 END IF
19520 END DEFine Copy1File
19530 :
19540 :
19550 REMark ''----------------------------------------------------------
19560 DEFine PROCedure CopyDirFiles(name$, source$, dest$, CreateWnd%)
19570 LOCal ch%, ch1%
19580 IF CreateWnd%=1 THEN
19590   ch%=FOPEN("scr_400x156a56x50")
19600   PAPER #ch%,0:INK #ch%,7
19610   OUTLN #ch%,400,156,56,50:BORDER#ch%,1,2:CLS#ch%
19620   ch1%=FOPEN("scr_398x12a57x51"): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
19630   PAPER#ch1%,0: INK#ch1%,7: AT#ch1%,0,25: PRINT#ch1%, " Copy Directory "
19640   WINDOW#0,396, 140, 58, 63:PAPER#0,0: INK#0,White%:CLS#0
19650 END IF
19660 PRINT#0, "Copy "&source$&name$&" to "&dest$&name$
19670 WCOPY source$&name$ TO dest$&name$
19680 IF CreateWnd%=1 THEN
19690   INK#0,Green%:PRINT#0, "Copy process ended - press any key to close window":INK#0,White%
19700   x%=KEYROW(0):a$=INKEY$(-1)
19710   WINDOW#0,448,12,32,231:
19720   CLOSE#ch1%
19730   OUTLN #ch%,400,156,56,50
19740   CLOSE#ch%
19750 END IF
19760 END DEFine CopyDirFiles
19770 :
19780 :
19790 REMark ''----------------------------------------------------------
19800 DEFine PROCedure CopyMultipleFiles(k%)
19810 LOCal ch%, ch1%, i%, x%, a$, Index%, panel%, page%, id%, left%,windef$, hgt%, wid%
19820 IF panelWinWid%*2>602 THEN wid%=600: ELSE wid%=400:END IF
19830 hgt%=panelWinHeight%*8 DIV  10
19840 left%=(maxWinWid%-wid%) DIV 2
19850 windef$="scr_"&wid%&"x"&hgt%&"a"&left%&"x50"
19860 ch%=FOPEN(windef$)
19870 PAPER #ch%,0:INK #ch%,White%
19880 OUTLN #ch%,wid%,hgt%,left%,50:BORDER#ch%,1,2:CLS#ch%
19890 left%=left%+1
19900 windef$="scr_"&(wid%-2)&"x12a"&left%&"x51"
19910 ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
19920 PAPER#ch1%,0: INK#ch1%,White%: CURSOR#ch1%,(wid%-90) DIV 2,0: PRINT#ch1%, " Copy Selected "
19930 WINDOW#0,wid%-4, hgt%-16, left%+1, 63:PAPER#0,0: INK#0,White%:CLS#0
19940 PRINT#0, "Copy Selected list: "&k%&" files and/or directories"
19950 IF crtPanel%=7 THEN
19960  source$=leftDir$:dest$=rightDir$: Index%=LIndex%: panel%=8
19970  FOR i%=1 TO LSizedir%+LSizeFile%
19980    LIndex%=i%
19990    IF GetFFlg%(LeftFiles$,i%) > 1 THEN
20000      IF GetFFlg%(LeftFiles$,i%) = 2 THEN
20010        PRINT#0, "Copying file "&GetFNam$(LeftFiles$,i%)&" ..."
20020        x%=CopyAListFile%(GetFNam$(LeftFiles$,i%), source$, dest$, GetFLen(LeftFiles$,i%), 8)
20030      ELSE
20040        PRINT#0, "Copying directory "&GetFNam$(LeftFiles$,i%)&" ..."
20050        x%=CopyFullDir%(GetFNam$(LeftFiles$,i%), source$, dest$, 8, 0, 1, 1)
20060      END IF
20070      IF x%=-1 THEN EXIT i%
20080      PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
20090    END IF
20100  NEXT i%: END FOR i%
20110  LIndex%=Index%
20120 ELSE
20130  source$=rightDir$:dest$=leftDir$:Index%=RIndex%
20140  FOR i%=1 TO RSizedir%+RSizeFile%
20150    RIndex%=i%
20160    IF GetFFlg%(RightFiles$,i%) > 1 THEN
20170      IF GetFFlg%(RightFiles$,i%)=2 THEN
20180        PRINT#0, "Copying file "&GetFNam$(RightFiles$,i%)&" ..."
20190        x%=CopyAListFile%(GetFNam$(RightFiles$,i%), source$, dest$, GetFLen(RightFiles$,i%), 7)
20200      ELSE
20210        PRINT#0, "Copying directory "&GetFNam$(RightFiles$,i%)&" ..."
20220        x%=CopyFullDir% (GetFNam$(RightFiles$,i%), source$, dest$, 7, 0, 1, 1)
20230      END IF
20240      IF x%=-1 THEN EXIT i%
20250      PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
20260    END IF
20270  NEXT i%: END FOR i%
20280  RIndex%=Index%
20290 END IF
20300 INK#0,Green%:PRINT#0, "Copy process ended - press any key to close window":INK#0,White%
20310 x%=KEYROW(0):a$=INKEY$(-1)
20320 WINDOW#0,448,12,32,231:
20330 CLOSE#ch1%
20340 OUTLN #ch%,wid%,hgt%,left%-1,50
20350 CLOSE#ch%
20360 id%=RIndex%+(RMinPos%=0)
20370 page%=id% DIV rowno%
20380 IF id% MOD rowno% >0 THEN page%=page%+1: END IF
20390 RStartPos%=(page%-1)*rowno% +RMinPos%
20400 ListFiles RightFiles$, RStartPos%, RIndex%, 8
20410 id%=LIndex%+(LMinPos%=0)
20420 page%=id% DIV rowno%
20430 IF id% MOD rowno% >0 THEN page%=page%+1: END IF
20440 LStartPos%=(page%-1)*rowno% +LMinPos%
20450 ListFiles LeftFiles$, LStartPos%, LIndex%, 7
20460 END DEFine CopyMultipleFiles
20470 :
20480 :
20490 REMark ''----------------------------------------------------------
20500 DEFine FuNction CopyAListFile%(name$, source$, dest$, filelen$, panel%)
20510 LOCal k%
20520  IF LEN(dest$&name$)>41 THEN
20530    INK#0,2: PRINT#0,name$&" not copied. Name too long":INK#0,White%
20540    RETurn 0
20550  END IF
20560  k%=FTEST(dest$&name$)
20570  IF k%=-7 THEN
20580   IF panel%=8 THEN
20590     IF RSizedir%+RSizeFile%+1>=MaxFiles% THEN
20600       INK#0,2: PRINT#0,"Maximum number reached on destination directory!":INK#0,White%
20610       RETurn -1
20620     END IF
20630   ELSE
20640     IF LSizedir%+LSizeFile%+1>=MaxFiles% THEN
20650       INK#0,2: PRINT#0,"Maximum number reached on destination directory!":INK#0,White%
20660       RETurn -1
20670     END IF
20680   END IF
20690   Copy1File name$, source$, dest$, filelen$, 0: RETurn 1
20700  ELSE
20710    IF k%=0 THEN
20720      PRINT#0,"File already exists Overwrite (Y/N) ?"
20730      REPeat loopa
20740        a$=INKEY$(-1)
20750        IF a$ INSTR "yYnN" THEN EXIT loopa: END IF
20760      END REPeat loopa
20770      IF a$="y" OR a$="Y" THEN
20780        Copy1File name$, source$, dest$, filelen$, 0: RETurn 1
20790      ELSE
20800        RETurn 0
20810      END IF
20820    ELSE
20830      SELect ON k%
20840        =-9: INK#0,2: PRINT#0,name$&"not copied. Destination is in use":INK#0,White%:RETurn 0
20850        =-11:INK#0,2: PRINT#0,name$&"not copied. Destination drive is full":INK#0,White%:RETurn -1
20860        =-16:INK#0,2: PRINT#0,name$&"not copied. Destination Bad or Changed Medium":INK#0,White%:RETurn -1
20870        =-20:INK#0,2: PRINT#0,name$&"not copied. Destination is Read Only! ":INK#0,White%: RETurn 0
20880        =REMAINDER : INK#0,2: PRINT#0,name$&"not copied. Error "&k%:INK#0,White%:RETurn 0
20890      END SELect
20900    END IF
20910  END IF
20920 END DEFine CopyAListFile%
20930 :
20940 :
20950 REMark ''-----------------------------------------------------------
20960 DEFine PROCedure DeleteFiles
20970 LOCal source$, name$, panel%, x%, k%, a$, ch%,ch1%, Index%,left%,windef$,hgt%, wid%
20980 IF crtPanel%=7 THEN
20990  source$=leftDir$: name$=GetFNam$(LeftFiles$,LIndex%):panel%=7: Index%=LIndex%
21000 ELSE
21010  source$=rightDir$: name$=GetFNam$(RightFiles$,RIndex%):panel%=8: Index%=RIndex%
21020 END IF
21030 IF IsReadOnly%(source$) THEN
21040  MessageWnd 200,60,2, CHR$(10)&"       Drive is Read Only! "
21050  RETurn
21060 END IF
21070 x%=CountSelected%
21080 IF x%>0 THEN
21090  k%=DlgWnd%(240,60," Delete Files ", "   Are you sure you want to delete"&CHR$(10)&"     "&x%&" files and directories ?")
21100 ELSE
21110  IF IsDir%=1 THEN
21120    a$="directory "&name$
21130  ELSE
21140    a$="file "&name$
21150  END IF
21160  k%=(39-LEN(a$))DIV 2: IF k%<0 THEN k%=0
21170  a$="   Are you sure you want to delete"&CHR$(10)&FILL$(" ",k%)&a$
21180  k%=DlgWnd%(240,60," Delete File ",a$)
21190 END IF
21200 IF k%=0 THEN RETurn
21210 IF panelWinWid%*2>602 THEN wid%=600: ELSE wid%=400:END IF
21220 hgt%=panelWinHeight%*8 DIV  10
21230 left%=(maxWinWid%-wid%) DIV 2
21240 windef$="scr_"&wid%&"x"&hgt%&"a"&left%&"x50"
21250 ch%=FOPEN(windef$)
21260 PAPER #ch%,0:INK #ch%,White%
21270 OUTLN #ch%,wid%,hgt%,left%,50:BORDER#ch%,1,2:CLS#ch%
21280 left%=left%+1
21290 windef$="scr_"&(wid%-2)&"x12a"&left%&"x51"
21300 ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
21310 PAPER#ch1%,0: INK#ch1%,White%: CURSOR#ch1%,(wid%-84) DIV 2,0: PRINT#ch1%, " Delete Files "
21320 WINDOW#0,wid%-4, hgt%-16, left%+1, 63:PAPER#0,0: INK#0,White%:CLS#0
21330 IF x%=0 THEN
21340   IF IsDir%=0
21350     PRINT#0, "Deleting file "&source$&name$
21360     DELETE source$&name$
21370   ELSE
21380     IF DeleteDirectory (source$, name$)=0 THEN INK#0,2:PRINT#0, "Could not delete all of "&source$&name$&"_": INK#0,White%
21390   END IF
21400 ELSE
21410   PRINT#0, "Delete Selected list: "&x%&" files and/or directories"
21420   IF crtPanel%=7 THEN
21430     FOR k%=1 TO LSizedir%+LSizeFile%
21440       IF GetFFlg%(LeftFiles$,k%) > 1 THEN
21450         IF GetFFlg%(LeftFiles$,k%)=2 THEN
21460           PRINT#0, "Deleting file "&GetFNam$(LeftFiles$,k%)&" ..."
21470           DELETE source$&GetFNam$(LeftFiles$,k%)
21480         ELSE
21490           IF DeleteDirectory (source$, GetFNam$(LeftFiles$,k%)) =0 THEN INK#0,2:PRINT#0, "Could not delete all of "&source$&GetFNam$(LeftFiles$,k%)&"_": INK#0,White%
21500         END IF
21510       END IF
21520     NEXT k%: END FOR k%
21530   ELSE
21540     FOR k%=1 TO RSizedir%+RSizeFile%
21550       IF GetFFlg%(RightFiles$,k%) > 1 THEN
21560         IF GetFFlg%(RightFiles$,k%)=2 THEN
21570           PRINT#0, "Deleting file "&GetFNam$(RightFiles$,k%)&" ..."
21580           DELETE source$&GetFNam$(RightFiles$,k%)
21590         ELSE
21600           IF DeleteDirectory (source$, GetFNam$(RightFiles$,k%)) THEN INK#0,2:PRINT#0, "Could not delete all of "&source$&GetFNam$(RightFiles$,k%)&"_": INK#0,White%
21610         END IF
21620       END IF
21630     NEXT k%: END FOR k%
21640   END IF
21650 END IF
21660 INK#0,Green%:PRINT#0, "Delete process ended - press any key to close window":INK#0,White%
21670 x%=KEYROW(0):a$=INKEY$(-1)
21680 WINDOW#0,448,12,32,231:
21690 CLOSE#ch1%
21700 OUTLN #ch%,wid%,hgt%,left%-1,50
21710 CLOSE#ch%
21720 IF crtPanel%=7 THEN
21730   ReloadPanel 7, Index%
21740 ELSE
21750   ReloadPanel 8, Index%
21760 END IF
21770 END DEFine DeleteFiles
21780 :
21790 :
21800 REMark ''-----------------------------------------------------------
21810 DEFine PROCedure EXecFile
21820 LOCal filename$, path$, chf%, x%
21830 IF crtPanel%=7 THEN
21840  IF LIndex%>LSizeFile%+LSizedir% THEN RETurn : END IF
21850  filename$=GetFNam$(LeftFiles$,LIndex%)
21860  path$=leftDir$
21870 ELSE
21880  IF RIndex%>RSizeFile%+RSizedir% THEN RETurn : END IF
21890  filename$=GetFNam$(RightFiles$,RIndex%)
21900  path$=rightDir$
21910 END IF
21920 chf%=FOPEN(path$&filename$)
21930 IF chf%<0 THEN
21940   SELect ON chf%
21950    =-7:  MessageWnd 200,60,2, CHR$(10)&"         File Not Found !"
21960    =-9:  MessageWnd 200,60,2, CHR$(10)&"           File in use"
21970    = REMAINDER :  MessageWnd 200,60,2, CHR$(10)& "             Error "&chf%
21980  END SELect
21990  ELSE
22000   CLOSE#chf%
22010   x%=FTYP(\path$&filename$)
22020   IF x%<>1 THEN
22030     MessageWnd 200,60,2, CHR$(10)&"   This is not a EXECable file"
22040   ELSE
22050     EX path$&filename$
22060   END IF
22070 END IF
22080 END DEFine EXecFile
22090 :
22100 :
22110 REMark ''----------------------------------------------------------
22120 DEFine FuNction getKey$(c%)
22130  LOCal k$(2)
22140   CURSEN #c%
22150   k$=INKEY$(c%,-1)
22160   CURDIS #c%
22170   RETurn k$
22180 END DEFine getKey$
22190 :
22200 :
22210 REMark ''----------------------------------------------------------
22220 DEFine PROCedure OnEnter
22230   LOCal ext$(10), path$, a$, x%, i%
22240 :
22250   IF crtPanel%=7 THEN
22260     IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
22270     a$=GetFNam$(LeftFiles$,LIndex%)
22280     path$=leftDir$
22290   ELSE
22300     IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
22310     a$=GetFNam$(RightFiles$,RIndex%)
22320     path$=rightDir$
22330   END IF
22340   IF a$==".." OR IsDir%=1 THEN
22350     IF crtPanel%=7 THEN
22360       OpenSubDir LeftFiles$, LIndex%, 7
22370     ELSE
22380       OpenSubDir RightFiles$, RIndex%, 8
22390     END IF
22400     RETurn
22410   END IF
22420 :
22430   IF FTYP(\path$&a$) =1 THEN
22440     EXecFile
22450     RETurn
22460   END IF
22470 :
22480   REMark ''now get file extension
22490   x% = LEN(a$)
22500   FOR i% = 0 TO x% - 1
22510     IF a$(x% - i%) == "_" THEN EXIT i%
22520   NEXT i%: END FOR i%
22530   IF i%>0 THEN
22540     ext$ = a$(x% - i% TO x%)
22550   ELSE
22560     ext$=""
22570   END IF
22580   ext$ = LOWER$(ext$) : x% = 0
22590 :
22600   IF ext$ = "_bas" THEN x% = 1
22610   IF ext$ = "_cde" OR ext$ = "_code" OR ext$ = "_rext" THEN x% = 2
22620   IF ext$ = "_zip" THEN x% = 3
22630   IF ext$ = "_doc" THEN x% = 4
22640   IF ext$ = "_aba" THEN x% = 5
22650   IF ext$ = "_grf" THEN x% = 6
22660   IF ext$ = "_dbf" THEN x% = 7
22670   IF ext$ = "_ssb" THEN x% = 9
22680   IF a$ = "boot" THEN x% = 1
22690 :
22700   SELect ON x%
22710     = 1:
22720         dbg(path$ & a$) : LoadBasFile(path$ & a$)
22730     = 2:
22740         DoLrespr path$ & a$
22750     = 3:
22760         IF IsZipFile%(path$ & a$) = 1 THEN UnzipFile path$ & a$
22770     = 4:
22780         IF IsQuillDoc%(path$ & a$) = 1 THEN
22790           IF Xchangeprog$ <> ""
22800             ExecXchange path$, path$ & a$
22810           END IF
22820         END IF
22830     = 5:
22840         IF IsAbacusDoc%(path$ & a$) = 1
22850           IF Xchangeprog$ <> ""
22860             ExecXchange path$, path$ & a$
22870           END IF
22880         END IF
22890     = 6:
22900         IF Xchangeprog$ <> ""
22910           ExecXchange path$, path$ & a$
22920         END IF
22930     = 7:
22940         IF IsArchiveDoc%(path$ & a$) = 1
22950           IF Xchangeprog$ <> ""
22960             ExecXchange path$, path$ & a$
22970           END IF
22980         END IF
22990     = 8:
23000         x% = DlgWnd%(240,60," Archive Prg ", "     "&a$&CHR$(10)&"      Open with Xchange Archive ?")
23010         IF x% = 0 THEN RETurn
23020         ExecXchange path$, path$ & a$
23030     = 9:
23040         dbg(path$ & a$) : LoadSsbFile(path$ & a$)
23050   END SELect
23060 END DEFine OnEnter
23070 :
23080 :
23090 REMark ''----------------------------------------------------------
23100 DEFine PROCedure UnzipFile (filename$)
23110 LOCal path$, ch%, ch1%, ch2%
23120 IF crtPanel%=7 THEN
23130   IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
23140   path$=rightDir$
23150 ELSE
23160   IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
23170   path$=leftDir$
23180 END IF
23190 ch%=DlgWnd%(240,60," Unzip File ", "    Are you sure you want to unzip"&CHR$(10)&"     "&filename$&" ?")
23200 IF ch%=0 THEN RETurn
23210 ch%=FOPEN("scr_452x230a30x14")
23220 PAPER #ch%,0:INK #ch%,7
23230 OUTLN #ch%,452,230,30,14:BORDER#ch%,1,2:CLS#ch%
23240 ch1%=FOPEN("scr_452x12a31x14"): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
23250 PAPER#ch1%,0: INK#ch1%,7: AT#ch1%,0,37-(LEN(a$)+5)/2: PRINT#ch1%, "Unzip"&a$
23260 ch2%=FOPEN("scr_448x204a32x26"):PAPER#ch2%,0:INK#ch2%,4
23270 EW ConfigDrv$&"unzip", #ch2%;"-D"&path$&" -o "&filename$
23280 PRINT #ch2%, "Press any key ..."
23290 path$=INKEY$(-1)
23300 CLS#ch1%: CLS#ch2%: CLOSE#ch2%:CLOSE#ch1%
23310 WINDOW#0,488,23,12,233:PAPER#0,0:INK#0,White%
23320 OUTLN #ch%,452,230,30,14
23330 CLOSE#ch%
23340  IF crtPanel%=7 THEN
23350     ReloadPanel 8,RIndex%
23360  ELSE
23370     ReloadPanel 7,LIndex%
23380  END IF
23390 END DEFine UnzipFile
23400 :
23410 :
23420 REMark ''----------------------------------------------------------
23430 DEFine PROCedure ExecXchange(path$, filename$)
23440  LOCal savedDATAD$(36), savedPROGD$(36)
23450   savedDATAD$=DATAD$ : savedPROGD$=PROGD$
23460   DATA_USE path$
23470   PROG_USE Xchangepath$
23480   EX Xchangepath$&Xchangeprog$; filename$
23490   DATA_USE savedDATAD$
23500   PROG_USE savedPROGD$
23510 END DEFine ExecXchange
23520 :
23530 :
23540 REMark ''-----------------------------------------------------------
23550 DEFine PROCedure EditFile(path$, filename$)
23560   LOCal savedDATAD$(36), savedPROGD$(36)
23570   savedDATAD$=DATAD$ : savedPROGD$=PROGD$
23580   DATA_USE path$
23590   PROG_USE EditPath$
23600   EX EditPath$&Editprog$; path$&filename$
23610   DATA_USE savedDATAD$
23620   PROG_USE savedPROGD$
23630 END DEFine EditFile
23640 :
23650 :
23660 REMark ''-----------------------------------------------------------
23670 DEFine PROCedure LoadBasFile(filename$)
23680   LOCal x%
23690   REMark ''QLC_GlobalFilename$ = filename$
23700   SBASIC
23710   COMMAND_LINE
23720   PAUSE 5
23730   TYPE_IN "LOAD " & filename$ & CHR$(10)
23740   TYPE_IN "DLINE 32600 TO" & CHR$(10)
23750   TYPE_IN "MERGE " & "dos1_qlc_cmd_bas" & CHR$(10)
23760   TYPE_IN "32607   QLC_GlobalFilename$ = '" & filename$ & "'" & CHR$(10) : REMark '' odd '
23770   TYPE_IN "1 REMark @SSBGEN" & CHR$(10)
23780   TYPE_IN "QLC_INIT" & CHR$(10)
23790   TYPE_IN "WTV" & CHR$(10)
23800   AT 2,0 : TYPE_IN "rem CMD: h/W/r/e/x/q/s/l/u" & CHR$(10)
23810   TYPE_IN "ED" & CHR$(10)
23820 END DEFine
23830 :
23840 :
23850 REMark ''-----------------------------------------------------------
23860 DEFine PROCedure LoadSsbFile(filename$)
23870   LOCal ssb_filename$, bas_filename$, i
23880   REMark ''""simplified SSB to BAS conversion - missing support for @Lables and #include, now !!!
23890 :
23900   ssb_filename$ = filename$
23910   bas_filename$ = ssb_filename$(1 TO LEN(ssb_filename$) - 4) & "_bas"
23920 :
23930   ierr = FOP_IN(#10, ssb_filename$)
23940   oerr = FOP_OVER(#11, bas_filename$)
23950   linenum = 10
23960   REPeat linenum
23970     INPUT #10, in$
23980     IF EOF(#10) THEN EXIT
23984     if (chr$(64) & "QLCGEN") INSTR in$ then exit
23990     out$ = in$
24000     IF in$ = "" THEN out$ = ":"
24010     pos = ("''" INSTR in$) : REMark ''or ("##" INSTR in$) or ("//" INSTR in$) + odd '
24020     IF pos > 0
24030       IF pos > 1
24040         FOR i = 1 TO pos : IF in$(i) <> " " THEN EXIT : NEXT i
24050         IF i < pos THEN comment$ = ": rem" : ELSE comment$ = "rem " : END IF
24060         out$ = in$(1 TO pos - 1) & comment$
24070       ELSE out$ = "rem "
24080       END IF
24090       out$ = out$ & in$(pos TO)
24100     END IF
24110     PRINT #11, linenum & " " & out$
24120     linenum = linenum + 2
24130   END REPeat
24140   CLOSE #10
24150   CLOSE #11
24160   LoadBasFile(bas_filename$)
24170 END DEFine
24180 :
24190 :
24200 REMark ''----------------------------------------------------------
24210 DEFine PROCedure DoEdit
24220 LOCal path$, a$
24230 IF crtPanel%=7 THEN
24240   IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
24250   a$=GetFNam$(LeftFiles$,LIndex%)
24260   path$=leftDir$
24270 ELSE
24280   IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
24290   a$=GetFNam$(RightFiles$,RIndex%)
24300   path$=rightDir$
24310 END IF
24320 IF IsDir%(path$&a$)=1 THEN RETurn
24330 IF IsQuillDoc%(path$&a$)=1 THEN
24340   IF Xchangeprog$<>"" THEN
24350     ExecXchange path$, path$&a$
24360     RETurn
24370   END IF
24380 ELSE
24390   EditFile path$, a$
24400 END IF
24410 END DEFine DoEdit
24420 :
24430 :
24440 REMark ''-----------------------------------------------------------
24450 DEFine PROCedure DoLrespr (filename$)
24460 LOCal x%
24470 x%=DlgWnd%(240,60," LRESPR File ", "    Are you sure you want to LRESPR"&CHR$(10)&"     "&filename$&" ?")
24480 IF x%=0 THEN RETurn
24490 COMMAND_LINE
24500 PAUSE 5
24510 TYPE_IN "LRESPR "&filename$&CHR$(10)
24520 END DEFine DoLrespr
24530 :
24540 :
24550 REMark ''----------------------------------------------------------
24560 DEFine FuNction IsAbacusDoc%(a$)
24570 LOCal ch%, q$, i%, k%
24580 ch% = FOPEN(a$)
24590 IF ch% <= 0 THEN RETurn 0: END IF
24600 q$=""
24610 FOR i%=1 TO 4
24620  BGET #ch%,k%
24630  q$=q$&CHR$(k%)
24640 NEXT i%: END FOR i%
24650 CLOSE #ch%
24660 IF q$="ABM1" THEN RETurn 1: ELSE RETurn 0: END IF
24670 END DEFine IsAbacusDoc%
24680 :
24690 :
24700 REMark ''-----------------------------------------------------------
24710 DEFine FuNction IsArchiveDoc%(a$)
24720 LOCal ch%, q$, i%, k%
24730 ch% = FOPEN(a$)
24740 IF ch% <= 0 THEN RETurn 0: END IF
24750 q$=""
24760 BGET #ch%\1,k%
24770 FOR i%=1 TO 8
24780  BGET #ch%,k%
24790  q$=q$&CHR$(k%)
24800 NEXT i%: END FOR i%
24810 CLOSE #ch%
24820 IF q$="vrm1dbf0" THEN RETurn 1: ELSE RETurn 0: END IF
24830 END DEFine IsArchiveDoc%
24840 :
24850 :
24860 REMark ''-----------------------------------------------------------
24870 DEFine PROCedure ReloadPanel(panel%, Index%)
24880 LOCal page%, x%
24890 IF panel%=7 THEN
24900   DIM LeftFiles$(MaxFiles%,_fMax%)
24910   LoadDir leftDir$, LeftFiles$,7,LSizedir%, LSizeFile%
24920   IF LEN(leftDir$)=5 THEN
24930     LMinPos%=1
24940   ELSE
24950     LMinPos%=0
24960   END IF
24970   IF Index%<LMinPos% THEN Index%=LMinPos%
24980   IF Index%>LSizedir%+LSizeFile% THEN Index%=LMinPos%
24990   LIndex%=Index%
25000   x%=Index%+(LMinPos%=0)
25010   page%=x% DIV rowno%
25020   IF x% MOD rowno% >0 THEN page%=page%+1: END IF
25030   LStartPos%=(page%-1)*rowno% +LMinPos%
25040   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
25050 ELSE
25060   DIM RightFiles$(MaxFiles%,_fMax%)
25070   LoadDir rightDir$, RightFiles$,8,RSizedir%, RSizeFile%
25080   IF LEN(rightDir$)=5 THEN
25090     RMinPos%=1
25100   ELSE
25110     RMinPos%=0
25120   END IF
25130   IF Index%<RMinPos% THEN Index%=RMinPos%
25140   IF Index%>RSizedir%+RSizeFile% THEN Index%=RMinPos%
25150   RIndex%=Index%
25160   x%=Index%+(RMinPos%=0)
25170   page%=x% DIV rowno%
25180   IF x% MOD rowno% >0 THEN page%=page%+1: END IF
25190   RStartPos%=(page%-1)*rowno% +RMinPos%
25200   ListFiles RightFiles$, RStartPos%, RIndex%, 8
25210 END IF
25220 END DEFine ReloadPanel
25230 :
25240 :
25250 REMark ''-----------------------------------------------------------
25260 DEFine PROCedure SelectAll
25270 LOCal i%
25280 IF crtPanel%=7 THEN
25290   FOR i%=1 TO LSizedir%+LSizeFile%
25300     IF GetFFlg%(LeftFiles$,i%) < 2 THEN PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
25310   END FOR i%
25320   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
25330 ELSE
25340   FOR i%=1 TO RSizedir%+RSizeFile%
25350     IF GetFFlg%(RightFiles$,i%) < 2 THEN PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
25360   END FOR i%
25370   ListFiles RightFiles$, RStartPos%, RIndex%, 8
25380 END IF
25390 END DEFine SelectAll
25400 :
25410 :
25420 REMark ''-----------------------------------------------------------
25430 DEFine PROCedure UnSelectAll
25440 LOCal i%
25450 IF crtPanel%=7 THEN
25460   FOR i%=1 TO LSizedir%+LSizeFile%
25470     IF GetFFlg%(LeftFiles$,i%) > 1 THEN PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
25480   END FOR i%
25490   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
25500 ELSE
25510   FOR i%=1 TO RSizedir%+RSizeFile%
25520     IF GetFFlg%(RightFiles$,i%) > 1 THEN PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
25530   END FOR i%
25540   ListFiles RightFiles$, RStartPos%, RIndex%, 8
25550 END IF
25560 END DEFine UnSelectAll
25570 :
25580 :
25590 REMark ''-----------------------------------------------------------
25600 DEFine PROCedure Set78CharSet
25610 REMark ''On QPC2 the char width gets reset so we have to set it again
25620 IF mainFountBase>0 THEN
25630   IF ClassicFont%=0 THEN
25640     CHAR_USE #leftPanelWin%,mainFountBase,0
25650     CHAR_INC #leftPanelWin%,5,10
25660     CHAR_USE #rightPanelWin%,mainFountBase,0
25670     CHAR_INC #rightPanelWin%,5,10
25680   END IF
25690 END IF
25700 END DEFine Set78CharSet
25710 :
25720 :
25730 REMark ''----------------------------------------------------------
25740 DEFine FuNction TestFount%(fountBase)
25750  LOCal fountMask%,fountMax%,char%,row%
25760   fountMask%=3 : REMark ''*** ------XX
25770   fountMax%=PEEK(fountBase+1)
25780   FOR char%=0 TO fountMax%
25790     FOR row%=0 TO 8
25800       IF PEEK(fountBase+2 + char%*9 + row%) && fountMask% THEN RETurn 2 : REMark ''*** appears to be a FAT fount
25810     END FOR row%
25820   END FOR char%
25830 :
25840   RETurn 1 : REMark ''*** Does not appear to be a FAT fount
25850 :
25860 END DEFine TestFount%
25870 :
25880 :
25890 REMark ''----------------------------------------------------------
25900 REFERENCE fList$(0,0)
25910 DEFine FuNction GetFNam$(fList$,fIndex%)
25920   RETurn fList$(fIndex%,3 TO 2 + STRING%(fList$(fIndex%,1 TO 2)))
25930 END DEFine GetFNam$
25940 :
25950 :
25960 REMark ''----------------------------------------------------------
25970 REFERENCE fList$(0,0)
25980 DEFine FuNction GetFLen(fList$,fIndex%)
25990   RETurn LONGINTEGER(fList$(fIndex%,_fLen% TO _fTyp%-1))
26000 END DEFine GetFLen
26010 :
26020 :
26030 REMark ''-----------------------------------------------------------
26040 REFERENCE fList$(0,0)
26050 DEFine FuNction GetFTyp%(fList$)
26060   RETurn STRING%(fList$(fIndex%,_fTyp% TO _fDat%-1))
26070 END DEFine GetFTyp%
26080 :
26090 :
26100 REMark ''-----------------------------------------------------------
26110 REFERENCE fList$(0,0)
26120 DEFine FuNction GetFDat(fList$,fIndex%)
26130   RETurn LONGINTEGER(fList$(fIndex%,_fDat% TO _fPar%-1))
26140 END DEFine GetFDat
26150 :
26160 :
26170 REMark ''-----------------------------------------------------------
26180 REFERENCE fList$(0,0)
26190 DEFine FuNction GetFPar%(fList$,fIndex%)
26200   RETurn STRING%(fList$(fIndex%,_fPar% TO _fFlg%-1))
26210 END DEFine GetFPar%
26220 :
26230 :
26240 REMark ''-----------------------------------------------------------
26250 REFERENCE fList$(0,0)
26260 DEFine FuNction GetFFlg%(fList$,fIndex%)
26270   RETurn STRING%(fList$(fIndex%,_fFlg% TO _fMax%))
26280 END DEFine GetFFlg%
26290 :
26300 :
26310 REMark ''-----------------------------------------------------------
26320 REFERENCE fList$(0,0)
26330 DEFine PROCedure PutFNam(fList$,fIndex%,newVal$)
26340  LOCal nVLen%
26350   nVLen%=LEN(newVal$)
26360   IF nVLen%>maxFNLen% THEN nVLen%=maxFNLen%
26370   fList$(fIndex%,1 TO 2+nVLen%)=STRING$(newVal$(1 TO nVLen%))
26380 END DEFine PutFNam
26390 :
26400 :
26410 REMark ''-----------------------------------------------------------
26420 REFERENCE fList$(0,0)
26430 DEFine PROCedure PutFLen(fList$,fIndex%,newVal)
26440   fList$(fIndex%,_fLen% TO _fTyp%-1)=LONGINTEGER$(newVal)
26450 END DEFine PutFLen
26460 :
26470 :
26480 REMark ''-----------------------------------------------------------
26490 REFERENCE fList$(0,0)
26500 DEFine PROCedure PutFTyp(fList$,fIndex%,newVal%)
26510   fList$(fIndex%,_fTyp% TO _fDat%-1)=INTEGER$(newVal%)
26520 END DEFine PutFTyp
26530 :
26540 :
26550 REMark ''-----------------------------------------------------------
26560 REFERENCE fList$(0,0)
26570 DEFine PROCedure PutFDat(fList$,fIndex%,newVal)
26580   fList$(fIndex%,_fDat% TO _fPar%-1)=LONGINTEGER$(newVal)
26590 END DEFine PutFDat
26600 :
26610 :
26620 REMark ''-----------------------------------------------------------
26630 REFERENCE fList$(0,0)
26640 DEFine PROCedure PutFPar(fList$,fIndex%,newVal%)
26650   fList$(fIndex%,_fPar% TO _fFlg%-1)=INTEGER$(newVal%)
26660 END DEFine PutFPar
26670 :
26680 :
26690 REMark ''-----------------------------------------------------------
26700 REFERENCE fList$(0,0)
26710 DEFine PROCedure PutFFlg(fList$,fIndex%,newVal%)
26720   fList$(fIndex%,_fFlg% TO _fMax%)=INTEGER$(newVal%)
26730 END DEFine PutFFlg
26740 :
26750 :
26760 REMark ''-----------------------------------------------------------
26770 REFERENCE fList$(0,0),fListDest$(0,0)
26780 DEFine PROCedure CopyRec(fList$,fIndex%,fListDest$,fDestIndex%)
26790   fListDest$(fDestIndex%, 1 TO _fMax%)=fList$(fIndex%, 1 TO _fMax%)
26800 END DEFine CopyRec
26810 :
26820 :
26830 REMark ''-----------------------------------------------------------
26840 DEFine FuNction isBasicRunning
26850   IF BASIC_B%(111)<> 0 THEN
26860     RETurn 0
26870   ELSE
26880     IF BASIC_B%(143) = 0 : RETurn 0 : REMark ''break - Ctrl-Space pressed
26890     IF BASIC_W%(104) = BASIC_W%(146) : RETurn 0 : REMark ''STOP occurred
26900     RETurn 1 : REMark ''Program is running
26910   END IF
26920 END DEFine isBasicRunning
26930 :
26940 :
26950 REMark ''-----------------------------------------------------------
26960 DEFine FuNction isBasicProgramLoaded
26970 RETurn BASIC_W%(BASIC_L(16))
26980 END DEFine isBasicProgramLoaded
26990 :
27000 :
27010 REMark ''-----------------------------------------------------------
27020 REFERENCE fList$(0,0),r_StartPos%,r_Index%
27030 DEFine PROCedure MoveTop(fList$, r_StartPos%, r_Index%, ch%)
27040 LOCal top%, x%, size%
27050 IF ch%=7 THEN
27060   r_StartPos%= LMinPos%
27070 ELSE
27080   r_StartPos%=RMinPos%
27090 END IF
27100 r_Index%=r_StartPos%
27110 ListFiles fList$, r_StartPos%, r_Index%, ch%
27120 END DEFine MovePageUp
27130 :
27140 :
27150 REMark ''----------------------------------------------------------
27160 REFERENCE fList$(0,0),r_StartPos%,r_Index%
27170 DEFine PROCedure MoveLast(fList$, r_StartPos%, r_Index%, ch%)
27180 LOCal top%
27190 IF ch%=7 THEN
27200   top%= LMinPos%
27210   r_Index%=LSizeFile%+LSizedir%
27220 ELSE
27230   top%=RMinPos%
27240   r_Index%=RSizeFile%+RSizedir%
27250 END IF
27260 r_StartPos%=r_Index%-19
27270 IF r_StartPos%<top% THEN r_StartPos%=top%
27280 ListFiles fList$, r_StartPos%, r_Index%, ch%
27290 END DEFine MoveLast
27300 :
27310 :
27320 REMark ''-----------------------------------------------------------
27330 DEFine PROCedure LRUNBasic
27340 LOCal i%, a$, path$, ext$
27350 IF crtPanel%=7 THEN
27360   IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
27370   a$=GetFNam$(LeftFiles$,LIndex%)
27380   path$=leftDir$
27390 ELSE
27400   IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
27410   a$=GetFNam$(RightFiles$,RIndex%)
27420   path$=rightDir$
27430 END IF
27440 IF a$==".." OR IsDir%=1 THEN RETurn
27450 REMark ''now get file extension
27460 x%=LEN(a$)
27470 FOR i%=0 TO x%-1
27480 IF a$(x%-i%)=="_" THEN EXIT i%
27490 NEXT i%: END FOR i%
27500 IF i%>0 THEN
27510   ext$=a$(x%-i% TO x%)
27520 ELSE
27530   ext$=""
27540 END IF
27550 ext$=LOWER$(ext$)
27560 IF ext$<>"_bas" AND a$<>"boot" THEN RETurn
27570 IF isBasicRunning=1 THEN
27580   MessageWnd 200,60,2, CHR$(10)&"        BASIC is running"&CHR$(10)&"       Cannot run _bas now!"
27590   RETurn
27600 END IF
27610 IF (isBasicProgramLoaded>0) AND (isBasicProgramEdited=1) THEN
27620   i%=DlgWnd%(240,60," Basic program loaded ", "       A Basic program is loaded"&CHR$(10)&"         Loose any changes made?")
27630   IF i%=0 THEN RETurn
27640 END IF
27650 COMMAND_LINE
27660 PAUSE 5
27670 TYPE_IN CHR$(27)&CHR$(27)&CHR$(27):PAUSE 5
27680 TYPE_IN "LRUN "&path$&a$ & CHR$(10)
27690 END DEFine LRUNBasic
27700 :
27710 :
27720 REMark ''-----------------------------------------------------------
27730 DEFine PROCedure SetPalletteQL
27740 PALETTE_QL 0,0,0,255*256*256,255*256*256,255*256,255*256,255*256*256+255*256+255,255*256*256+255*256+255
27750 END DEFine SetPalletteQL
27760 :
27770 :
27780 REMark ''-----------------------------------------------------------
27790 DEFine FuNction isBasicProgramEdited
27800 IF BASIC_B%(142)=255 THEN
27810    RETurn 1
27820 ELSE
27830    RETurn 0
27840 END IF
27850 END DEFine isBasicProgramEdited
27860 :
27870 :
27880 REMark ''-----------------------------------------------------------
27890 DEFine FuNction CopyFullDir%(name$, source$, dest$, panel%, UpdateWnd%, CheckNoQ%, UpdateList%)
27900 LOCal x%, ch%, loop, d$, fp, newname$, newsource$, newdest$, totrim
27910 IF DirExists%(dest$&name$)=0 THEN
27920   x%=Create1Dir%(name$, dest$&name$,panel%,0,CheckNoQ%, UpdateList%)
27930   IF x%=0 THEN RETurn 0
27940 END IF
27950 PRINT#0, "Copy "&source$&name$&" to "&dest$&name$
27960 WCOPY source$&name$ TO dest$&name$
27970 ch% = FOP_DIR (source$&name$) : REMark ''open channel to directory
27980 IF ch% < 0 THEN RETurn : REMark ''unable to open directory
27990 fp = 14 : REMark ''file position in directory for filename
28000 newsource$=source$&name$: IF newsource$(LEN(newsource$))<>"_" THEN newsource$=newsource$&"_"
28010 newdest$=dest$&name$: IF newdest$(LEN(newdest$))<>"_" THEN newdest$=newdest$&"_"
28020 REPeat loop
28030   BGET #ch%\fp : IF EOF(#ch%) THEN CLOSE #ch% : EXIT loop
28040   GET #ch%,d$ : REMark ''get a directory entry name
28050   IF LEN(d$) > 0 THEN
28060     REMark ''a directory length of 0 may be a deleted file
28070     BGET #ch%\fp-9 : REMark ''file type byte
28080     IF CODE(INKEY$(#ch%)) = 255 THEN
28090       REMark ''this is a subdirectory, so we need to copy this
28100       REMark ''Extract file name and check length
28110       totrim=LEN(newsource$)-4
28120       newname$=d$(totrim TO)
28130       IF LEN(newdest$&newname$)>36 THEN
28140         INK#0,2:PRINT#0,"Directory "&newdest$&newname$&" not created  Name too long":INK#0,White%
28150       ELSE
28160         x%=CopyFullDir%(newname$, newsource$, newdest$, panel%, 0,0,0)
28170       END IF
28180     END IF
28190   END IF
28200   fp = fp + 64
28210 END REPeat loop
28220 RETurn 1
28230 END DEFine CopyFullDir%
28240 :
28250 :
28260 REMark ''-----------------------------------------------------------
28270 DEFine PROCedure CopySingleDir(name$, source$, dest$, panel%)
28280 LOCal ch%, ch1%, i%, x%, a$, Index%,page%, id%, left%,windef$, hgt%, wid%
28290 IF panelWinWid%*2>602 THEN wid%=600: ELSE wid%=400:END IF
28300 hgt%=panelWinHeight%*8 DIV  10
28310 left%=(maxWinWid%-wid%) DIV 2
28320 windef$="scr_"&wid%&"x"&hgt%&"a"&left%&"x50"
28330 ch%=FOPEN(windef$)
28340 PAPER #ch%,0:INK #ch%,White%
28350 OUTLN #ch%,wid%,hgt%,left%,50:BORDER#ch%,1,2:CLS#ch%
28360 left%=left%+1
28370 windef$="scr_"&(wid%-2)&"x12a"&left%&"x51"
28380 ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
28390 PAPER#ch1%,0: INK#ch1%,White%: CURSOR#ch1%,(wid%-90) DIV 2,0: PRINT#ch1%, " Copy Directory "
28400 WINDOW#0,wid%-4, hgt%-16, left%+1, 63:PAPER#0,0: INK#0,White%:CLS#0
28410 PRINT#0, "Copy Directory "&source$&name$&" to "&dest$
28420 res%=CopyFullDir% (name$, source$, dest$, panel%,0,1,0)
28430 INK#0,Green%:PRINT#0, "Copy process ended - press any key to close window":INK#0,White%
28440 x%=KEYROW(0):a$=INKEY$(-1)
28450 WINDOW#0,448,12,32,231:
28460 CLOSE#ch1%
28470 OUTLN #ch%,wid%,hgt%,left%-1,50
28480 CLOSE#ch%
28490 REMark ''If copy OK then Add the dir name to the list in the destination panel and refresh screen
28500 IF res%=1 THEN
28510   IF panel%=8 THEN
28520     res%=Find% (name$,id%,RightFiles$,1,RSizedir%)
28530     IF res%=0 THEN
28540       res%=Insert% (name$,id%, RightFiles$, 1, RSizedir%, RSizeFile%, "0")
28550       RIndex%=id%
28560       id%=id%+(RMinPos%=0)
28570       page%=id% DIV rowno%
28580       IF id% MOD rowno% >0 THEN page%=page%+1: END IF
28590       RStartPos%=(page%-1)*rowno% +RMinPos%
28600       ListFiles RightFiles$, RStartPos%, RIndex%, 8
28610     END IF
28620   ELSE
28630     res%=Find% (name$,id%,LeftFiles$,1,LSizedir%)
28640     IF res%=0 THEN
28650       res%=Insert% (name$,id%, LeftFiles$, 1, LSizedir%, LSizeFile%, "0")
28660       LIndex%=id%
28670       id%=id%+(LMinPos%=0)
28680       page%=id% DIV rowno%
28690       IF id% MOD rowno% >0 THEN page%=page%+1: END IF
28700       LStartPos%=(page%-1)*rowno% +LMinPos%
28710       ListFiles LeftFiles$, LStartPos%, LIndex%, 7
28720     END IF
28730   END IF
28740 END IF
28750 END DEFine CopySingleDir
28760 :
28770 :
28780 REMark ''----------------------------------------------------------
28790 DEFine FuNction DeleteDirectory(source$, name$)
28800 LOCal ch%, loop, d$, newsource$, newname$, fp, totrim, x%
28810 IF name$(LEN(name$))<>"_" THEN name$=name$&"_"
28820 PRINT#0, "Deleting directory "&source$&name$&"..."
28830 WDEL source$&name$
28840 ch% = FOP_DIR (source$&name$) : REMark ''open channel to directory
28850 IF ch% < 0 THEN RETurn : REMark ''unable to open directory
28860 fp = 14 : REMark ''file position in directory for filename
28870 newsource$=source$&name$: IF newsource$(LEN(newsource$))<>"_" THEN newsource$=newsource$&"_"
28880 REPeat loop
28890   BGET #ch%\fp : IF EOF(#ch%) THEN CLOSE #ch% : EXIT loop
28900   GET #ch%,d$ : REMark ''get a directory entry name
28910   IF LEN(d$) > 0 THEN
28920     REMark ''a directory length of 0 may be a deleted file
28930     BGET #ch%\fp-9 : REMark ''file type byte
28940     IF CODE(INKEY$(#ch%)) = 255 THEN
28950       REMark ''this is a subdirectory, so we need to delete this
28960       REMark ''Extract file name and check length
28970       totrim=LEN(newsource$)-4
28980       newname$=d$(totrim TO)
28990       x%=DeleteDirectory (newsource$, newname$)
29000     END IF
29010   END IF
29020   fp = fp + 64
29030 END REPeat loop
29040 REMark ''Now check that directory is empty
29050 IF isDirEmpty(source$&name$)=1 THEN
29060   DELETE source$&name$
29070   RETurn 1
29080 ELSE
29090   RETurn 0
29100 END IF
29110 END DEFine DeleteDirectory
29120 :
29130 :
29140 REMark ''----------------------------------------------------------
29150 DEFine FuNction isDirEmpty(DirName$)
29160 LOCal ch%, fp, d$, loop, res%
29170 ch% = FOP_DIR (DirName$) : REMark ''open channel to directory
29180 IF ch% < 0 THEN RETurn 0: REMark ''unable to open directory
29190 res%=1
29200 fp = 14 : REMark ''file position in directory for filename
29210 REPeat loop
29220   BGET #ch%\fp : IF EOF(#ch%) THEN : EXIT loop
29230   GET #ch%,d$ : REMark ''get a directory entry name
29240   IF LEN(d$) > 0 THEN res%=0: EXIT loop: REMark ''if file name >0 then we found a file and we set result to 1
29250   fp = fp + 64
29260 END REPeat loop
29270 CLOSE#ch%
29280 RETurn res%
29290 END DEFine isDirEmpty
29300 :
29310 :
29320 REMark ''----------------------------------------------------------
29330 DEFine PROCedure CompareDirs
29340 LOCal i%, res%
29350 REMark ''Unselect all left files
29360 FOR i%=1 TO LSizedir%+LSizeFile%
29370   IF GetFFlg%(LeftFiles$,i%) > 1 THEN PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
29380 END FOR i%
29390 REMark ''Select all right files
29400 FOR i%=1 TO RSizedir%+RSizeFile%
29410   IF GetFFlg%(RightFiles$,i%) < 2 THEN PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
29420 END FOR i%
29430 REMark ''Parse left directory list and compare it to right
29440 FOR i%= 1 TO LSizedir%
29450   res%=Find% (GetFNam$(LeftFiles$,i%),id%,RightFiles$,1,RSizedir%)
29460   IF res%=0 THEN
29470     PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
29480   ELSE
29490     PutFFlg RightFiles$,id%, GetFFlg%(RightFiles$,id%) ^^2
29500   END IF
29510 NEXT i%: END FOR i%
29520 REMark ''Parse left file list and compare it to right
29530 FOR i%= LSizedir%+1 TO LSizedir%+LSizeFile%
29540   res%=Find% (GetFNam$(LeftFiles$,i%),id%,RightFiles$,RSizedir%+1,RSizedir%+RSizeFile%)
29550   IF res%=0 THEN
29560     PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
29570   ELSE
29580     IF GetFLen(LeftFiles$,i%)=GetFLen(RightFiles$,id%) THEN
29590       PutFFlg RightFiles$,id%, GetFFlg%(RightFiles$,id%) ^^2
29600     ELSE
29610       PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
29620     END IF
29630   END IF
29640 NEXT i%: END FOR i%
29650 REMark ''refresh screen
29660 ListFiles LeftFiles$, LStartPos%, LIndex%, 7
29670 ListFiles RightFiles$, RStartPos%, RIndex%, 8
29680 END DEFine CompareDirs
29690 :
29700 :
29710 REMark ''----------------------------------------------------------
29720 DEFine PROCedure InvertSelection
29730 LOCal i%
29740 IF crtPanel%=7 THEN
29750   FOR i%=1 TO LSizedir%+LSizeFile%
29760     PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
29770   END FOR i%
29780   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
29790 ELSE
29800   FOR i%=1 TO RSizedir%+RSizeFile%
29810     PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
29820   END FOR i%
29830   ListFiles RightFiles$, RStartPos%, RIndex%, 8
29840 END IF
29850 END DEFine InvertSelection
29860 :
29870 :
29880 :
32600 REMark @QLCGEN ShellCommands
32602 DEFine PROCedure QLC_INIT
32604   QLC_GlobalFilename$ = 'dos1_QLC_qlc20_bas'
32616   XX=RESPR(1024) : LBYTES "dos1_tk_MORE_CODE", XX : CALL XX
32618   XX=RESPR(1538) : LBYTES "dos1_qlc_QLC_CODE", XX : CALL XX
32620   LRESPR "dos1_tk_TURBO_SMS_CODE"
32622 END DEFine
32624 :
32626 DEFine PROCedure r
32628   RUN
32630 END DEFine
32632 DEFine PROCedure e
32634   WTV
32636   PAPER #2,0 : INK #2,4
32638 END DEFine
32640 DEFine PROCedure x
32642   s : QUIT
32644 END DEFine
32646 DEFine PROCedure q
32648   s : QUIT
32650 END DEFine
32652 DEFine PROCedure s
32654   SAVE QLC_GlobalFilename$
32656   PRINT #2, QLC_GlobalFilename$ & " SAVED"
32658 END DEFine
32660 DEFine PROCedure l
32662   LOAD QLC_GlobalFilename$
32664   PRINT #2, QLC_GlobalFilename$ & " LOADED"
32666 END DEFine
32668 DEFine PROCedure w
32670   WMOV
32672 END DEFine
32674 DEFine PROCedure u
32676   REMark DLINE 32600 TO
32678   TYPE_IN "MERGE dos1_qlc_cmd_bas" & CHR$(10)
32680 END DEFine
32682 DEFine PROCedure h
32684   PRINT #0, "CMD: h/W/n/r/e/x/q/s/l/u"
32686 END DEFine
32688 DEFine PROCedure n(i)
32690   IF i = 0 THEN i = 1
32692   TYPE_IN "RENUM 10 TO 32599; 1000, " & i & CHR$(10)
32694 END DEFine
32696 DEFine PROCedure dbginit
32698   OPEN #99, "scr_"
32700   WINDOW #99, 120,16,0,0 : PAPER #99,0 : INK #99,7
32702 END DEFine
32704 DEFine PROCedure dbg(s$)
32706   PAPER #99,7 : INK #99,2 : PRINT #99, s$
32708 END DEFine
32710 DEFine PROCedure dbgstop
32712   STOP
32714 END DEFine
