1 REMark &&SSBGEN &&SAVE
10 :
12 QLC_INIT
14 :
16 KCtrlA = 1
18 KDown = 216
20 KUp = 208
22 KShiftDown = 220
24 KTab = 9
26 KShiftF5 = 250
28 KSpace = 32
30 KShiftUp = 212
32 KEnter = 10
34 KShiftEnter = 254
36 KBackSpace = 194
38 KCtrlUp = 210
40 KCtrlDown = 218
42 KCtrlD = 4
44 KCtrlR = 18
46 KF1 = 232
48 KF2 = 236
50 KF3 = 240
52 KF4 = 244
54 KF5 = 248
56 KF6ShiftF1 = 234
58 KF7ShiftF2 = 238
60 KF8ShiftF3 = 242
62 KF9ShiftF4 = 246
64 KF10ShiftF5 = 250
66 KPlus = 43
68 KMinus = 45
70 KEqual = 61
72 KUnderscore = 95
74 KCtrlI = 92
76 KCtrlW = 23
78 KCtrlX = 24
80 KCtrl1 = 145
82 KCtrl2 = 146
84 KHome = 193
86 KEnd = 201
88 KPageUp = 212
90 KPageDown = 220
92 :
94 :
96 :
98 :
100 :
102 REMark ''******************************************
104 REMark ''*        QLX   C O M M A N D E R         *
106 REMark ''*                                        *
108 REMark ''*              version 2.1               *
110 REMark ''*          code date 2023.11.13          *
112 REMark ''*                                        *
114 REMark ''*              Andrei Tenu               *
116 REMark ''*              Martyn Hill               *
118 REMark ''*                7alken                  *
120 REMark ''******************************************
122 :
124 :
126 REMark ''*** QLiberator Directives...
128 REMark ''$$stak=5120
130 :
132 :
134 REMark ''*** TURBO Directives...
136 REMark '' - also comment line 1370! And modify line 3010
138 REMark ''TURBO_locstr "R"
140 REMark ''TURBO_ref
142 REMark ''TURBO_windo 2
144 REMark ''TURBO_optim "B"
146 REMark ''TURBO_model 1
148 REMark ''TURBO_struct "S"
150 REMark ''TURBO_diags "I"
152 REMark ''TURBO_list "YES"
154 REMark ''TURBO_sound "YES"
156 REMark ''TURBO_objdat 64
158 REMark ''TURBO_buffersz 16
160 REMark ''TURBO_objstk 512
162 REMark ''TURBO_taskn "QLC v2.0"
164 REMark ''TURBO_objfil "win1_QLCommander_QLC_exe"
166 REMark ''TURBO_repfil "win1_QLCommander_QLCv20_rpt"
168 :
170 :
172 WHEN ERRor
174   REMark ''CloseProgram
176   PAPER# 1, 7 : INK# 1, 2 : PAPER# 0, 0 : INK# 0, 4 : CLS# 0
178   PRINT# 1, "Error at line: "; ERLIN : REPORT : STOP
180 END WHEN
182 :
184 REMark ''mode 4: paper#0,0:paper#1,0:paper#2,0:border#1,0:cls#1
186 REMark ''window#1,488,220,12,0
188 :
190 xc
192 :
194 REMark ''----------------------------------------------------------
196 DEFine PROCedure xc
198 :
200     qlcVer$ = "2.1"
202     REMark ''Make sure that guardian window covers all screen,
204     REMark ''in all resolutions
206     IF VER$="HBA_xx" THEN  : REMark ''FIXME mixworx
208       maxWinWid% = SCR_XLIM
210       maxWinHgt% = SCR_YLIM
212     ELSE
214       maxWinWid%=512
216       maxWinHgt%=256
218       REMark ''make sure we are in monitor mode 4,
220       REMark ''otherwise it will crash
222       WMON
224       MODE 4
226       PAPER# 0, 0 : PAPER# 1, 0 : BORDER# 1, 0
228       CLS# 1 : CLS# 0
230     END IF
232     REMark ''comment next line if compiled with Turbo !
234     PAPER#0,0:BORDER#0,0:PAPER#1,0:BORDER#1,0
236     PAPER#2,0:BORDER#2,0:CLS#0:CLS#1:CLS#2
238     WINDOW#0,maxWinWid%,maxWinHgt%,0,0
240     OUTLN #0,maxWinWid%,maxWinHgt%,0,0,0,0,0
242 :
244 :
246     dbginit
248     readConfig
250     InitialiseVars
252     OpenWindows
254     DrawWindows 1
256     MainLoop
258     CloseProgram
260 :
262     STOP
264 END DEFine
266 :
268 REMark ''----------------------------------------------------------
270 DEFine PROCedure StopWithError(errorMessage$)
272 :
274   BEEP 1390 * 2, 20
276   REMark ''cls #0
278   PRINT #0, errorMessage$
280   PAUSE 50 * 2
282   CloseProgram
284   STOP
286 END DEFine StopWithError
288 :
290 :
292 REMark ''-----------------------------------------------------------
294 DEFine PROCedure CloseProgram
296   LOCal ch%
298 :
300   FOR ch% = 3 TO 9 : CLOSE# ch% : END FOR ch%
302 :
304   IF headBuff > 0 THEN RECHP(headBuff)
306   IF titleFountBase > 0 THEN RECHP titleFountBase: END IF
308   IF mainFountBase > 0 THEN RECHP mainFountBase: END IF
310   IF comFountBase > 0 THEN RECHP comFountBase: END IF
312 :
314   DATA_USE initialDATAD$
316 :
318   WINDOW# 0, maxWinWid%, maxWinHgt%, 0, 0
320   PAPER# 0,0: INK# 0, White% : CLS# 0
322 :
324   WINDOW# 0, 512, 50, 0, 206
326   BORDER# 0, 1, 1, 7, 0 : CLS# 0
328 :
330   WINDOW# 1, 256, 202, 256, 0
332   BORDER# 1, 1, 1, 7, 0
334   PAPER# 1, 7 : INK# 1, 0 : CLS# 1
336 :
338   WINDOW# 2, 256, 202, 0, 0
340   BORDER# 2, 1, 1, 7, 0
342   PAPER# 2, 2 : INK# 2, 7 : CLS# 2
344 :
346 END DEFine CloseProgram
348 :
350 :
352 REMark ''-----------------------------------------------------------
354 DEFine PROCedure OpenWindows
356   LOCal ch%, titleFountFN$(36), titleFountLen%
358   LOCal mainFountFN$(36), mainFountLen%
360   LOCal comFountFN$(36), comFountLen%
362 :
364   stdFountWid%=6
366 :
368   FOR ch% = 3 TO 9 : OPEN# ch%, con : END FOR ch%
370 :
372   titleFountWid% = stdFountWid%
374   titleFountBase = 0
376   titleFountFN$ = ConfigDrv$ & "bold8_fnt"
378 :
380   IF FTEST(titleFountFN$) = 0
382     titleFountLen% = FLEN(\titleFountFN$)
384     IF titleFountLen% > 0
386       titleFountBase = ALCHP(titleFountLen%)
388       LBYTES titleFountFN$, titleFountBase
390       titleFountWid% = 8
392       CHAR_USE# titleWin%, titleFountBase, 0
394       CSIZE# titleWin%,1,0
396       CHAR_INC# titleWin%, titleFountWid%, 10
398     END IF
400   END IF
402 :
404   mainFountWid% = stdFountWid%
406   mainFountBase = 0
408   mainFountFN$ = ConfigDrv$ & "5Pixel_fnt"
410   IF FTEST(mainFountFN$) = 0
412     mainFountLen% = FLEN(\mainFountFN$)
414     IF mainFountLen% > 0
416       mainFountBase = ALCHP(mainFountLen%)
418       LBYTES mainFountFN$, mainFountBase
420     END IF
422   END IF
424 :
426   SELect ON ClassicFont%
428     = 0:
430       IF mainFountBase>0 THEN
432         mainFountWid% = 5 : mainFountHeight% = 10
434         CHAR_USE# leftPanelWin%, mainFountBase, 0
436         CHAR_INC# leftPanelWin%, mainFountWid%, 10
438         CHAR_USE# rightPanelWin%, mainFountBase, 0
440         CHAR_INC# rightPanelWin%, mainFountWid%, 10
442       ELSE
444         mainFountWid% = 6
446         mainFountHeight% = 10
448         comFountWid% = stdFountWid%
450       END IF
452 :
454     = 1:
456       CSIZE# leftPanelWin%, 0, 0 : CSIZE# rightPanelWin%, 0, 0
458       mainFountWid% = 6
460       mainFountHeight% = 10
462       comFountWid% = stdFountWid%
464 :
466     = 2:
468       mainFountWid% = 8
470       mainFountHeight% = 20
472       comFountWid% = 8
474       titleFountWid% = 16
476       CSIZE# leftPanelWin%, 1, 1 : CSIZE# rightPanelWin%, 1, 1
478       CSIZE# titleWin%, 3, 1
480       CSIZE# 4, 1, 1 : CSIZE# 5, 1, 1
482       CSIZE# 6, 1, 1 : CSIZE# 9, 1, 1
484 :
486     = 3:
488       mainFountWid% = 12
490       mainFountHeight% = 20
492       titleFountWid% = 16
494       comFountWid% = 8
496       CSIZE# leftPanelWin%, 2, 1 : CSIZE# rightPanelWin%, 2, 1
498       CSIZE# titleWin%, 3, 1
500       CSIZE# 4, 2, 1 : CSIZE# 5, 2, 1
502       CSIZE# 6, 2, 1 : CSIZE# 9, 1, 1
504   END SELect
506 :
508   REMark ''comFountWid%=stdFountWid%
510   comFountBase = 0
512   comFountFN$=ConfigDrv$ & "qlc_fnt"
514 :
516   IF FTEST(comFountFN$) = 0
518     comFountLen% = FLEN(\comFountFN$)
520     IF comFountLen% > 0
522       comFountBase = ALCHP(comFountLen%)
524       LBYTES comFountFN$, comFountBase
526       CHAR_USE# comWin%, comFountBase, 0
528     END IF
530   END IF
532 :
534 END DEFine OpenWindows
536 :
538 :
540 REMark ''-----------------------------------------------------------
542 REMark ''reload% = 1 we reload the file lists and draw the windows;
544 REMark ''reload%==0 we do not reload the file lists,
546 REMark ''just redraw the windows
548 DEFine PROCedure DrawWindows (reload%)
550   LOCal left%
552 :
554   IF (linelen% * mainFountWid% + 2) > (maxWinWid% DIV 2)
556     linelen%=((maxWinWid% DIV 2) - 4) DIV mainFountWid%
558   END IF
560   panelWinWid% = linelen% * mainFountWid% + 2
562   comWinWid% = 2 * panelWinWid%
564   left% = (maxWinWid% - 2 * panelWinWid%) DIV 2
566 :
568   REMark ''title line
570   WINDOW# 3, 2 * panelWinWid%, mainFountHeight% + 2, left%, 5
572   BORDER# 3, 1, TitleBorder%
574   PAPER# 3, TitleBorder%, TitleBk%, 1 : CLS#3
576 :
578   PAPER# 3, 0 : INK# 3, 2
580   IF ClassicFont% >= 2
582     CSIZE# titleWin%, 3, 1
584   ELSE
586     CSIZE# titleWin%, 1, 0
588   END IF
590   CHAR_INC# titleWin%, titleFountWid%, 10
592   BLOCK# 3, titleFountWid% * 14, mainFountHeight%, (2 * panelWinWid% - 4 - 14 * titleFountWid%) DIV 2, 0, 0
594   CURSOR# 3, (2 * panelWinWid% - 4 - 14 * titleFountWid%) DIV 2, 0
596   PRINT# 3, " QLX COMMANDER "
598 :
600   REMark ''Drive line
602   WINDOW#4,2*panelWinWid%,mainFountHeight%+2,left%,mainFountHeight%+7:PAPER#4,brd%:INK#4,0:BORDER#4,1,brd%:CLS#4
604   AT#4,0,0:INK#4,2:PRINT#4,"D":AT#4,0,1:INK#4,0:PRINT#4,"ir"
606   CURSOR#4,panelWinWid%,0:PRINT#4,"Di":INK#4,2:CURSOR#4,panelWinWid%+mainFountWid%*2,0:PRINT#4,"r"
608 :
610   REMark ''left dir
612   WINDOW#5,panelWinWid%-4*mainFountWid%,mainFountHeight%,left%+4*mainFountWid%-2,mainFountHeight%+8:PAPER#5,White%:INK#5,0:BORDER#5,0:CLS#5
614   PRINT#5,leftDir$
616 :
618   REMark ''right dir
620   WINDOW#6,panelWinWid%-4*mainFountWid%,mainFountHeight%,left%+panelWinWid%+4*mainFountWid%-2,mainFountHeight%+8:PAPER#6,White%:INK#6,0:BORDER#6,0:CLS#6
622   PRINT#6,rightDir$
624 :
626   panelWinHeight%=rowno%*mainFountHeight%+3
628   IF panelWinHeight%+3*mainFountHeight%+19 >maxWinHgt% THEN
630     rowno%=(maxWinHgt%-3*mainFountHeight%- 22) DIV mainFountHeight%
632     panelWinHeight%=rowno%*mainFountHeight%+3
634   END IF
636   REMark ''left file panel
638   WINDOW#7, panelWinWid%,panelWinHeight%,left%,2*mainFountHeight%+9: PAPER#7, ppr%: INK#7, ik%:BORDER#7, 1,brd%:CLS#7
640 :
642   REMark ''Right file panel
644   WINDOW#8, panelWinWid%,panelWinHeight%,panelWinWid%+left%,2*mainFountHeight%+9: PAPER#8, ppr%: INK#8, ik%:BORDER#8, 1,brd%:CLS#8
646 :
648   REMark ''Commands line
650   WINDOW#9, 2*panelWinWid%,mainFountHeight%+2,left%,panelWinHeight%+3*mainFountHeight%+7:PAPER#9, brd%: INK#9, White%:BORDER#9, 1,brd%:CLS#9
652   WriteCommands comWin%
654 :
656   crtPanel%=leftPanelWin%
658   IF reload%=1 THEN
660     LShowLeftDir
662     LShowRightDir
664   ELSE
666     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
668     ListFiles RightFiles$, RStartPos%, RIndex%, 8
670   END IF
672 END DEFine DrawWindows
674 :
676 :
678 REMark ''-----------------------------------------------------------
680 DEFine PROCedure readConfig
682 LOCal a$(42), Chan%
684 ConfigDrv$=OPTION_CMD$: REMark ''CMD$
686 IF ConfigDrv$="" THEN ConfigDrv$="dos1_qlc_"
688 a$=ConfigDrv$&"qlc20_cfg"
690 Chan%=FOP_IN(a$)
692 IF Chan%>0
694   INPUT #Chan%, MaxFiles%
696   INPUT #Chan%, TempDir$
698   INPUT #Chan%, leftDir$
700   INPUT #Chan%, rightDir$
702   INPUT #Chan%, Qubide%
704   INPUT #Chan%, ClassicFont%
706   INPUT #Chan%, linelen%
708   INPUT #Chan%, rowno%
710   INPUT #Chan%, Xchangepath$
712   INPUT #Chan%, Xchangeprog$
714   INPUT #Chan%, EditPath$
716   INPUT #Chan%, Editprog$
718   INPUT #Chan%, QLColors%
720   CLOSE #Chan%
722 ELSE
724   CLS
726   PRINT "Config file not found - using default values ! "
728   MaxFiles%=256
730   TempDir$="win1_temp_"
732   leftDir$="win1_"
734   rightDir$="win1_"
736   Qubide%=0
738   ClassicFont%=1
740   linelen%=40
742   rowno%=20
744   Xchangepath$=""
746   Xchangeprog$=""
748   EditPath$=""
750   Editprog$=""
752   QLColors=1
754   PAUSE 100
756   CLS
758 END IF
760 IF RMODE<=8 OR QLColors%=1 THEN
762   IF VER$="HBA" AND RMODE>4 THEN COLOUR_QL:SetPalletteQL : END IF
764   ppr%=0: brd%=4: ik%=7: strp%=7: White%=7:Green%=4:PPR9a%=2:ppr9b%=0:TitleBorder%=4: TitleBk%=0
766 ELSE
768   COLOUR_PAL: ppr%=4: brd%=13: ik%=1: strp%=13:White%=1:Green%=3:PPR9a%=72:ppr9b%=76:TitleBorder%=13:TitleBk%=4
770 END IF
772 IF maxWinHgt%=256 AND ClassicFont%>1 THEN ClassicFont%=1: END IF
774 END DEFine readConfig
776 :
778 :
780 REMark ''------------------------------------------------------------
782 DEFine PROCedure InitialiseVars
784   titleWin%=3 : leftPanelWin%=7 : rightPanelWin%=8 : comWin%=9
786   LSizedir%=0: LSizeFile%=0: crtPanel%=leftPanelWin%
788   RSizedir%=0: RSizeFile%=0
790 :
792   maxFNLen%=36
794 :
796   _fLen%=maxFNLen%+3 : _fTyp%=maxFNLen%+7
798   _fDat%=maxFNLen%+9 : _fPar%=maxFNLen%+13
800   _fFlg%=maxFNLen%+15: _fMax%=maxFNLen%+16
802 :
804   _dPar%=maxFNLen%+3 : _dNxt%=maxFNLen%+5
806   _dChd%=maxFNLen%+7 : _dFlg%=maxFNLen%+9
808   _dMax%=maxFNLen%+10
810 :
812   DIM cmdText$(9,9) : REMark ''Used by WriteCommands
814   cmdText$(1)=CHR$(1)        &" Info"
816   cmdText$(2)=CHR$(2)        &" Comp"
818   cmdText$(3)=CHR$(3)        &" View"
820   cmdText$(4)=CHR$(4)        &" Edit"
822   cmdText$(5)=CHR$(5)        &" Copy"
824   cmdText$(6)=CHR$(6)        &" Rename"
826   cmdText$(7)=CHR$(7)        &" MkDir"
828   cmdText$(8)=CHR$(8)        &" Delete"
830   cmdText$(9)=CHR$(9)        &" Exit"
832 :
834   initialDATAD$=DATAD$
836 :
838   headSz%=64
840   headBuff=ALCHP(headSz%)
842   IF headBuff<0 THEN StopWithError("Cannot allocate memory for File-header Buffer.")
844 :
846 END DEFine InitialiseVars
848 :
850 :
852 REMark ''-----------------------------------------------------------
854 DEFine PROCedure LShowLeftDir
856 LOCal i%
858 REMark ''dim LeftFiles$(MaxFiles%,2,36)
860 DIM LeftFiles$(MaxFiles%,_fMax%)
862 LoadDir leftDir$, LeftFiles$,7,LSizedir%, LSizeFile%
864 IF LEN(leftDir$)=5 THEN
866   LStartPos%=1
868 ELSE
870   LStartPos%=0
872 END IF
874 LIndex%=LStartPos%
876 LMinPos%=LStartPos%
878 ListFiles LeftFiles$, LStartPos%, LIndex%, 7
880 END DEFine LShowLeftDir
882 :
884 :
886 REMark ''-----------------------------------------------------------
888 DEFine PROCedure LShowRightDir
890 LOCal i%
892 DIM RightFiles$(MaxFiles%,_fMax%)
894 RSizedir%=0: RSizeFile%=0
896 LoadDir rightDir$, RightFiles$,8,RSizedir%, RSizeFile%
898 IF LEN(rightDir$)=5 THEN
900   RStartPos%=1
902 ELSE
904   RStartPos%=0
906 END IF
908 RIndex%=RStartPos%
910 RMinPos%=RStartPos%
912 ListFiles RightFiles$,RStartPos%,RIndex%,8
914 END DEFine LShowRightDir
916 :
918 :
920 REMark ''-----------------------------------------------------------
922 REMark ''reference FileList$(0,0,0)
924 REFERENCE FileList$(0,0)
926 DEFine PROCedure ListFiles(FileList$, StartPos%, Index%, ch%)
928 LOCal a$(linelen%), i%, size%, EndPos%, nochars%, x%, DFlen1%, DFLen2%
930 IF ch%=7 THEN
932   size%=LSizedir%+LSizeFile%
934 ELSE
936   size%=RSizedir%+RSizeFile%
938 END IF
940 EndPos%=StartPos%+rowno%-1
942 IF EndPos%>size% THEN EndPos%=size%: END IF
944 CLS#ch%
946 FOR i%=StartPos% TO EndPos%
948   a$=GetFNam$(FileList$,i%)
950   DFlen1%=LEN(a$)
952   DFLen2%=LEN(GetFLen(FileList$,i%))
954   IF GetFFlg%(FileList$,i%) MOD 2 = 1 THEN
956     x%=3
958     IF DFlen1%>linelen%-x% THEN : a$=a$( TO linelen%-x%-2): a$=a$&"..":END IF
960     a$=a$&" ->"
962     a$=a$&FILL$(" ",linelen%-LEN(a$) - 1)
964   ELSE
966     x%=9
968     IF DFlen1%>linelen%-x% THEN : a$=a$( TO linelen%-x%-2): a$=a$&"..":END IF
970     a$=a$&FILL$(" ",linelen%-LEN(a$)-DFLen2% - 1)& GetFLen(FileList$,i%)
972   END IF
974   INK#ch%, ik%
976   IF i%=Index% THEN
978     IF crtPanel%=ch% THEN
980       STRIP#ch%,strp%
982       IF GetFFlg%(FileList$,i%) > 1 THEN INK#ch%,2 : ELSE INK#ch%,ppr% : END IF
984       PRINT#ch%,a$
986       STRIP#ch%,ppr%
988     ELSE
990       PRINT#ch%,a$
992     END IF
994   ELSE
996     IF GetFFlg%(FileList$,i%) > 1 THEN INK#ch%,2 : ELSE INK#ch%,ik% : END IF
998     PRINT#ch%,a$
1000   END IF
1002 END FOR i%
1004 END DEFine ListFiles
1006 :
1008 :
1010 REMark ''-----------------------------------------------------------
1012 DEFine PROCedure MainLoop
1014  LOCal a$, x%, y$
1016   REPeat loop
1018     a$=INKEY$(-1): x%=CODE(a$) : dbg(x%)
1020     SELect ON x%
1022 :
1024       = KCtrlW:
1026           WMOV
1028 :
1030       = KCtrlA:
1032           MessageWnd 216,60,3, "        QL COMMANDER v"&qlcVer$&CHR$(10)&" Andrei Tenu & Martyn Hill - 2019"&CHR$(10)&"    GNU General Public License"
1034 :
1036       = KDown:
1038           IF crtPanel%=7 THEN
1040             MoveDown LeftFiles$, LMinPos%, LIndex%, LStartPos%, LSizeFile%, LSizedir%
1042           ELSE
1044             MoveDown RightFiles$, RMinPos%, RIndex%, RStartPos%, RSizeFile%, RSizedir%
1046           END IF
1048 :
1050       = KUp:
1052           IF crtPanel%=7 THEN
1054             MoveUp LeftFiles$, LMinPos%, LIndex%, LStartPos%, LSizeFile%, LSizedir%
1056           ELSE
1058             MoveUp RightFiles$, RMinPos%, RIndex%, RStartPos%, RSizeFile%, RSizedir%
1060           END IF
1062 :
1064       = KPageDown, KShiftDown:
1066           IF crtPanel%=7 THEN
1068             MovePageDown LeftFiles$, LStartPos%, LIndex%, 7
1070           ELSE
1072             MovePageDown RightFiles$, RStartPos%, RIndex%, 8
1074           END IF
1076 :
1078       = KTab:
1080           ChangePanel
1082 :
1084       = KCtrlX, KF10ShiftF5:
1086           RETurn
1088 :
1090       = KSpace:
1092           SelectFile
1094 :
1096       = KPageUp, KShiftUp:
1098           IF crtPanel%=7 THEN
1100             MovePageUp LeftFiles$, LStartPos%, LIndex%, 7
1102           ELSE
1104             MovePageUp RightFiles$, RStartPos%, RIndex%, 8
1106           END IF
1108 :
1110       = KEnter:
1112           OnEnter
1114 :
1116       = KShiftEnter:
1118           LRUNBasic
1120 :
1122       = KBackSpace
1124         IF crtPanel%=7 THEN
1126           MoveTop LeftFiles$, LStartPos%, LIndex%, 7
1128           IF GetFNam$(LeftFiles$,LIndex%)=".." THEN
1130             OnEnter
1132           ELSE
1134             BEEP 1390,20
1136           END IF
1138         ELSE
1140           MoveTop RightFiles$, RStartPos%, RIndex%, 8
1142           IF GetFNam$(RightFiles$,RIndex%)=".." THEN
1144             OnEnter
1146           ELSE
1148             BEEP 1390,20
1150           END IF
1152         END IF
1154 :
1156       = KHome, KCtrlUp:
1158           IF crtPanel%=7 THEN
1160             MoveTop LeftFiles$, LStartPos%, LIndex%, 7
1162           ELSE
1164             MoveTop RightFiles$, RStartPos%, RIndex%, 8
1166           END IF
1168 :
1170       = KEnd, KCtrlDown:
1172           IF crtPanel%=7 THEN
1174             MoveLast LeftFiles$, LStartPos%, LIndex%, 7
1176           ELSE
1178             MoveLast RightFiles$, RStartPos%, RIndex%, 8
1180           END IF
1182 :
1184       = KCtrl1, KCtrlD:
1186           InputDir 5
1188 :
1190       = KCtrl2, KCtrlR:
1192           InputDir 6
1194 :
1196       = KF3:
1198           ViewFile
1200 :
1202       = KF5:
1204           CopyFiles
1206 :
1208       = KF4:
1210           DoEdit
1212 :
1214       = KF6ShiftF1:
1216           RenameFile
1218 :
1220       = KF8ShiftF3:
1222           DeleteFiles
1224 :
1226       = KF1:
1228           ShowInfo
1230 :
1232       = KF7ShiftF2:
1234           CreateDir
1236 :
1238       REMark ''Find next matching File/Dir starting with a$
1240       =65  TO  90: JumpTo x%, 1
1242       =160 TO 171: JumpTo x%, 1
1244       =97  TO 122: JumpTo x%, 2
1246       =128 TO 139: JumpTo x%, 2
1248       =48  TO  57: JumpTo x%, 0
1250 :
1252       = KPlus, KEqual:
1254           SelectAll
1256 :
1258       = KMinus, KUnderscore:
1260           UnSelectAll
1262 :
1264       = KF9ShiftF4:
1266           DrawWindows 0
1268 :
1270       = KF8ShiftF3:
1272           CompareDirs
1274 :
1276       = KCtrlI:
1278           InvertSelection
1280     END SELect
1282   END REPeat loop
1284 END DEFine MainLoop
1286 :
1288 :
1290 REMark ''-----------------------------------------------------------
1292 DEFine FuNction FindFirst% (a%,what%)
1294  LOCal i%, istart%, iend%, found%
1296  REMark ''a% = code of char to find
1298  REMark ''what%=2 looking for file; =1 looking for dir; =0 looking for dir or file
1300  REMark ''search returns index of item that starts with a$, or first next item if a$ is not found, or last item in list if all existing items start with chars<a$
1302 found%=0
1304 IF crtPanel%=7 THEN
1306    IF what%<2 THEN istart%=1: ELSE istart%=LSizedir%+1: END IF
1308    IF what%=1 THEN iend%=LSizedir%: ELSE iend%=LSizedir%+LSizeFile%: END IF
1310    IF istart%>iend% THEN RETurn LIndex%: END IF
1312    IF what%>0 THEN
1314      FOR i%=istart% TO iend%
1316        IF CODE(GetFNam$(LeftFiles$,i%)) >= a% THEN found%=1: EXIT i%: END IF
1318        NEXT i%
1320      END FOR i%
1322    ELSE
1324      FOR i%=LIndex%+1 TO iend%
1326        IF CODE(GetFNam$(LeftFiles$,i%)) = a% THEN found%=1: EXIT i%: END IF
1328      NEXT i%: END FOR i%
1330      IF found%=0 THEN
1332        FOR i%=istart% TO LIndex%
1334          IF CODE(GetFNam$(LeftFiles$,i%)) = a% THEN found%=1: EXIT i%: END IF
1336        NEXT i%: END FOR i%
1338      END IF
1340      IF found%=0 THEN i%=istart%: END IF
1342    END IF
1344    IF i%<= iend% THEN RETurn i%: ELSE RETurn iend%: END IF
1346 ELSE
1348    IF what%<2 THEN istart%=1: ELSE istart%=RSizedir%+1:END IF
1350    IF what%=1 THEN iend%=RSizedir%: ELSE iend%=RSizedir%+RSizeFile%:END IF
1352    IF istart%>iend% THEN RETurn RIndex%: END IF
1354    IF what%>0 THEN
1356      FOR i%=istart% TO iend%
1358        IF CODE(GetFNam$(RightFiles$,i%)) >= a% THEN EXIT i%: END IF
1360        NEXT i%
1362      END FOR i%
1364    ELSE
1366      FOR i%=RIndex%+1 TO iend%
1368        IF CODE(GetFNam$(RightFiles$,i%)) = a% THEN found%=1: EXIT i%: END IF
1370      NEXT i%: END FOR i%
1372      IF found%=0 THEN
1374        FOR i%=istart% TO RIndex%
1376          IF CODE(GetFNam$(RightFiles$,i%)) = a% THEN found%=1: EXIT i%: END IF
1378        NEXT i%: END FOR i%
1380      END IF
1382      IF found%=0 THEN i%=istart%: END IF
1384    END IF
1386    IF i%<= iend% THEN RETurn i%: ELSE RETurn iend%: END IF
1388  END IF
1390 END DEFine FindFirst%
1392 :
1394 :
1396 REMark ''-----------------------------------------------------------
1398 DEFine PROCedure JumpTo (a%,what%)
1400 LOCal x%, start%
1402 IF crtPanel%=7 THEN
1404   IF LSizedir%+LSizeFile%=0 THEN RETurn : END IF
1406 ELSE
1408   IF RSizedir%+RSizeFile%=0 THEN RETurn : END IF
1410 END IF
1412 x%=FindFirst%(a%,what%)
1414 IF crtPanel%=7 THEN
1416   IF x%=LIndex% THEN RETurn : END IF
1418   IF (x%>=LStartPos%) AND (x%<LStartPos%+20) THEN
1420    ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 0
1422    LIndex%=x%
1424    ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 1
1426   ELSE
1428    LIndex%=x%
1430    x%=x%+(LMinPos%=0)
1432    page%=x% DIV rowno%
1434    IF x% MOD rowno% >0 THEN page%=page%+1: END IF
1436    LStartPos%=(page%-1)*rowno% +LMinPos%
1438    ListFiles LeftFiles$, LStartPos%, LIndex%, 7
1440   END IF
1442 ELSE
1444   IF x%=RIndex% THEN RETurn :END IF
1446   IF x%>=RStartPos% AND x%<RStartPos%+rowno% THEN
1448    ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 0
1450    RIndex%=x%
1452    ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 1
1454   ELSE
1456    RIndex%=x%
1458    x%=x%+(RMinPos%=0)
1460    page%=x% DIV rowno%
1462    IF x% MOD rowno% >0 THEN page%=page%+1: END IF
1464    RStartPos%=(page%-1)*rowno% +RMinPos%
1466    ListFiles RightFiles$, RStartPos%, RIndex%, 8
1468   END IF
1470 END IF
1472 END DEFine JumpTo
1474 :
1476 :
1478 REMark ''-----------------------------------------------------------
1480 REMark ''String Quick Search & Insert
1482 REMark ''(c)tcat, 2017 Tomas Kral
1484 REMark ''modified by Andrei Tenu 2018
1486 :
1488 REMark ''reference FileList$(0,0,0),id%
1490 REFERENCE FileList$(0,0),id%
1492 DEFine FuNction Find% (str$,id%,FileList$,no%,size%)
1494  REMark ''FileLis$ = name of array to load into
1496  REMark ''no% = start index
1498  REMark ''    = 0 if we add a dir to root; 1 if add a dir in a directory; SizeDir%+1 if we add a file
1500  REMark ''Quick search returns:
1502  REMark ''0=not found, 1=found, id%=position
1504  LOCal top%,bot%,mid%,nextFNam$(maxFNLen%)
1506  top%=no% : bot%=size%
1508 :
1510  REPeat find_loop
1512   mid%=(bot%+top%) DIV 2 : nextFNam$=GetFNam$(FileList$,mid%)
1514 :
1516   IF top%>bot% THEN
1518    id%=mid%+1 : RETurn 0
1520   ELSE IF str$ = nextFNam$ THEN
1522    id%=mid% : RETurn 1
1524   ELSE IF str$ > nextFNam$ THEN
1526    top%=mid%+1
1528   ELSE IF str$ < nextFNam$ THEN
1530    bot%=mid%-1
1532   END IF : END IF : END IF : END IF
1534  END REPeat find_loop
1536 END DEFine Find%
1538 :
1540 REMark ''reference FileList$(0,0,0),r_SizeDir%, r_SizeFile%
1542 REFERENCE FileList$(0,0),r_SizeDir%, r_SizeFile%
1544 DEFine FuNction Insert% (str$,id%, FileList$, DoF%, r_SizeDir%, r_SizeFile%, fLength$)
1546  REMark ''Inserts String at position id%
1548  REMark ''Returns 2=ok, -1=array full
1550  LOCal i%, size%
1552  size%=r_SizeDir%+r_SizeFile%
1554  IF size% >= MaxFiles% THEN RETurn -1
1556  FOR i%=size% TO id% STEP -1
1558    CopyRec FileList$,i% TO FileList$,i%+1
1560  END FOR i%
1562  PutFNam FileList$,id%, str$
1564  PutFLen FileList$,id%, fLength$
1566  PutFFlg FileList$,id%, DoF%
1568  IF DoF%=1 THEN
1570    r_SizeDir%=r_SizeDir%+1
1572  ELSE
1574    r_SizeFile%=r_SizeFile%+1
1576  END IF
1578 :
1580  RETurn 2
1582 END DEFine Insert%
1584 :
1586 :
1588 REMark ''End of String Quick Search & Insert -----------------------
1590 :
1592 :
1594 REMark ''-----------------------------------------------------------
1596 REMark ''reference dev$(0),FileList$(0,0,0),r_SizeDir%,r_SizeFile%
1598 REFERENCE dev$(0),FileList$(0,0),r_SizeDir%,r_SizeFile%
1600 DEFine PROCedure LoadDir (dev$, FileList$, Chan%, r_SizeDir%, r_SizeFile%)
1602  LOCal ch%, i, head_start, totrim, flength, file$, ftype, size2%, res, DirOrFile%, id%, filelen$,k$, no_files
1604  CLS#Chan%:INK#Chan%,7:PRINT#Chan%,"...Loading File List ..."
1606  IF dev$(LEN(dev$))<>"_" THEN dev$=dev$&"_"
1608  IF Chan%=7 THEN PRINT#5,dev$: ELSE PRINT#6, dev$: END IF
1610  IF DirExists%(dev$)=0 THEN
1612    BEEP 1390,100
1614    PRINT#Chan%, "Cannot open directory "&dev$
1616    RETurn
1618  END IF
1620  r_SizeDir%=0: r_SizeFile%=0
1622  totrim=LEN(dev$)-4
1624  IF totrim<=0 THEN totrim=1 : END IF
1626 :
1628  PutFNam FileList$,0, ".."
1630  PutFLen FileList$,0, 0
1632  PutFFlg FileList$,0, 1
1634 :
1636  head_start=0
1638  i=1
1640  ch%=FOP_DIR(dev$)
1642  no_files=FLEN(#ch%)/64
1644  FOR listing=1 TO no_files
1646    SET_POSITION #ch%,head_start+0
1648    flength=LONGINTEGER(INPUT$(#ch%,4))-64
1650    faccess=CODE(INKEY$(#ch%)):ftype=CODE(INKEY$(#ch%))
1652    IF flength>=0 THEN
1654      SET_POSITION #ch%,head_start+14
1656      file$=GET$(#ch%)
1658      IF LEN(file$)>0
1660       file$=file$(totrim TO)
1662       filelen$=flength
1664       SET_POSITION #ch%,head_start+52
1666       fdate=LONGINTEGER(INPUT$(#ch%,4))
1668       IF ftype<255
1670        size2%=r_SizeDir%+r_SizeFile%
1672        file$=LOWER$(file$)
1674        res=Find%(file$,id%, FileList$,r_SizeDir%+1,size2%)
1676        DirOrFile%=0
1678       ELSE
1680        file$=UPPER$(file$)
1682        res=Find%(file$,id%,FileList$,1,r_SizeDir%)
1684        DirOrFile%=1
1686       END IF
1688       i=i+1
1690    REMark ''k$="":
1692    REMark ''if flength>1023 then
1694    REMark '' flength=INT(flength/1024+.5):k$="K"
1696    REMark '' if flength>1023 then
1698    REMark ''   flength=INT(flength/1024+.5):k$="M"
1700    REMark '' endif
1702    REMark ''endif
1704    REMark ''filelen$=flength&k$
1706       IF res=0 THEN res=Insert%(file$,id%,FileList$,DirOrFile%, r_SizeDir%, r_SizeFile%, filelen$) : END IF
1708       IF res=-1 : EXIT listing : END IF
1710      END IF
1712    END IF
1714    head_start=head_start+64
1716  END FOR listing
1718  CLOSE #ch%
1720 END DEFine LoadDir
1722 :
1724 :
1726 REMark ''-----------------------------------------------------------
1728 REMark ''reference FileList$(0,0,0),r_Index%,r_StartPos%
1730 REFERENCE FileList$(0,0),r_Index%,r_StartPos%
1732 DEFine PROCedure MoveDown(FileList$, MinPos%, r_Index%, r_StartPos%, SizeFile%, SizeDir%)
1734  LOCal size%, idx%
1736  size%=SizeFile%+SizeDir%
1738  IF r_Index%>size% THEN RETurn
1740  ShowHideCursor r_Index%-r_StartPos%, r_Index%, FileList$, 0
1742  r_Index%=r_Index%+1
1744  IF r_Index%>size% THEN : r_Index%=size%: END IF
1746  IF r_Index%>r_StartPos%+rowno%-1 THEN
1748    SCROLL#crtPanel%,-mainFountHeight%
1750    r_StartPos%=r_StartPos%+1
1752  END IF
1754  ShowHideCursor r_Index%-r_StartPos%, r_Index%,  FileList$, 1
1756 END DEFine MoveDown
1758 :
1760 :
1762 REMark ''-----------------------------------------------------------
1764 REMark ''reference FileList$(0,0,0),r_Index%,r_StartPos%
1766 REFERENCE FileList$(0,0),r_Index%,r_StartPos%
1768 DEFine PROCedure MoveUp(FileList$, MinPos%, r_Index%, r_StartPos%, SizeFile%, SizeDir%)
1770  LOCal size%, idx%
1772  size%=SizeFile%+SizeDir%
1774  IF r_Index%>size%  THEN RETurn
1776  ShowHideCursor r_Index%-r_StartPos%, r_Index%, FileList$, 0
1778  r_Index%=r_Index%-1
1780  IF r_Index%<MinPos% THEN : r_Index%=MinPos%: END IF
1782  IF r_Index%<r_StartPos% THEN
1784    SCROLL#crtPanel%,mainFountHeight%
1786    r_StartPos%=r_StartPos%-1
1788  END IF
1790  ShowHideCursor r_Index%-r_StartPos%, r_Index%, FileList$, 1
1792 END DEFine MoveDown
1794 :
1796 :
1798 REMark ''-----------------------------------------------------------
1800 REMark ''reference FileList$(0,0,0)
1802 REFERENCE FileList$(0,0)
1804 DEFine PROCedure ShowHideCursor(Linepos%, Index%, FileList$, SoH%)
1806 LOCal a$, x%, DFlen1%, DFLen2%
1808 :
1810   a$=GetFNam$(FileList$,Index%)
1812   DFlen1%=LEN(a$)
1814   DFLen2%=LEN(GetFLen(FileList$,Index%))
1816 :
1818   IF GetFFlg%(FileList$,Index%) MOD 2 = 1 THEN
1820     x%=3
1822     IF DFlen1%>linelen%-x% THEN : a$=a$(TO linelen%-x%-2): a$=a$&"..":END IF
1824     a$=a$&" ->"
1826     a$=a$&FILL$(" ",linelen%-LEN(a$) - 1)
1828   ELSE
1830     x%=9
1832     IF DFlen1%>linelen%-x% THEN : a$=a$(TO linelen%-x%-2): a$=a$&"..":END IF
1834     a$=a$&FILL$(" ",linelen%-LEN(a$)-DFLen2% - 1)& GetFLen(FileList$,Index%)
1836   END IF
1838   IF SoH%=1 THEN
1840     STRIP#crtPanel%,strp%: INK#crtPanel%,0
1842     IF GetFFlg%(FileList$,Index%) > 1 THEN INK#crtPanel%,2 : ELSE INK#crtPanel%,0 : END IF
1844     AT#crtPanel%,Linepos%,0:PRINT#crtPanel%,a$;
1846     STRIP#crtPanel%,ppr%:INK#crtPanel%,ik%
1848   ELSE
1850    IF GetFFlg%(FileList$,Index%) > 1 THEN INK#crtPanel%,2 : ELSE INK#crtPanel%,ik% : END IF
1852     AT#crtPanel%,Linepos%,0:PRINT#crtPanel%,a$;
1854   END IF
1856 END DEFine ShowHideCursor
1858 :
1860 :
1862 REMark ''-----------------------------------------------------------
1864 DEFine PROCedure ChangePanel
1866 IF crtPanel%=7 THEN
1868   IF LIndex%<=LSizedir%+LSizeFile% THEN
1870     ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 0
1872   END IF
1874   crtPanel%=8
1876   IF RIndex%<=RSizedir%+RSizeFile% THEN
1878     ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 1
1880   END IF
1882   BORDER#8,1,brd%: BORDER#7, 1,brd%,1,3
1884 ELSE
1886   IF RIndex%<=RSizedir%+RSizeFile% THEN
1888     ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 0
1890   END IF
1892   crtPanel%=7
1894   IF LIndex%<=LSizedir%+LSizeFile% THEN
1896     ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 1
1898   END IF
1900   BORDER#7,1,brd%: BORDER#8,1,brd%,1,3
1902 END IF
1904 END DEFine ChangePanel
1906 :
1908 :
1910 REMark ''-----------------------------------------------------------
1912 DEFine PROCedure SelectFile
1914   IF crtPanel%=7 THEN
1916     PutFFlg LeftFiles$,LIndex%,GetFFlg%(LeftFiles$,LIndex%) ^^2
1918     ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 1
1920   ELSE
1922     PutFFlg RightFiles$,RIndex%,GetFFlg%(RightFiles$,RIndex%) ^^2
1924     ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 1
1926   END IF
1928 END DEFine SelectFile
1930 :
1932 :
1934 REMark ''-----------------------------------------------------------
1936 REMark ''reference FileList$(0,0,0),r_StartPos%,r_Index%
1938 REFERENCE FileList$(0,0),r_StartPos%,r_Index%
1940 DEFine PROCedure MovePageDown(FileList$, r_StartPos%, r_Index%, ch%)
1942 LOCal size%, x%
1944  IF ch%=7 THEN
1946   size%=LSizedir%+LSizeFile%
1948  ELSE
1950   size%=RSizedir%+RSizeFile%
1952  END IF
1954  IF r_Index%>size% THEN RETurn : END IF
1956  x%=r_StartPos%+20
1958  IF x%>size% THEN RETurn
1960  r_StartPos%=x%
1962  r_Index%=r_StartPos%
1964  ListFiles FileList$, r_StartPos%, r_Index%, ch%
1966 END DEFine MovePageDown
1968 :
1970 :
1972 REMark ''-----------------------------------------------------------
1974 REMark ''reference FileList$(0,0,0),r_StartPos%,r_Index%
1976 REFERENCE FileList$(0,0),r_StartPos%,r_Index%
1978 DEFine PROCedure MovePageUp(FileList$, r_StartPos%, r_Index%, ch%)
1980 LOCal top%, x%, size%
1982  IF ch%=7 THEN
1984   top%= LMinPos%
1986   size%=LSizeFile%+LSizedir%
1988  ELSE
1990   top%=RMinPos%
1992   size%=RSizeFile%+RSizedir%
1994  END IF
1996  IF r_Index%>size% THEN RETurn : END IF
1998  x%=r_StartPos%-20
2000  IF x%<top% THEN x%=top%:END IF
2002  r_StartPos%=x%
2004  r_Index%=r_StartPos%
2006  ListFiles FileList$, r_StartPos%, r_Index%, ch%
2008 END DEFine MovePageUp
2010 :
2012 :
2014 REMark ''-----------------------------------------------------------
2016 REMark ''reference FileList$(0,0,0)
2018 REFERENCE FileList$(0,0)
2020 DEFine PROCedure OpenSubDir(FileList$, Index%, ch%)
2022 LOCal a$, size%, d$, x%, page%
2024 IF ch%=7 THEN
2026  size%=LSizeFile%+LSizedir%
2028  d$=leftDir$
2030 ELSE
2032  size%=RSizeFile%+RSizedir%
2034  d$=rightDir$
2036 END IF
2038 IF Index%>size% THEN RETurn : END IF
2040 IF GetFFlg%(FileList$,Index%) MOD 2 <> 1 THEN RETurn : END IF
2042 IF GetFNam$(FileList$,Index%)=".." THEN
2044   a$=GetParentDir$(ch%)
2046   IF LEN(d$)>LEN(a$) THEN
2048     d$=d$(LEN(a$)+1 TO): IF d$(LEN(d$))="_" THEN d$=d$(1 TO LEN(d$)-1):END IF
2050     IF crtPanel%=7 THEN
2052       DIM LeftFiles$(MaxFiles%,_fMax%) : leftDir$=a$
2054       LoadDir leftDir$, LeftFiles$,7,LSizedir%, LSizeFile%
2056       IF LEN(leftDir$)=5 THEN
2058         LMinPos%=1
2060       ELSE
2062         LMinPos%=0
2064       END IF
2066       IF Find%(d$,id%, LeftFiles$,1,LSizedir%)=1 THEN
2068         LIndex%=id%
2070         x%=id%+(LMinPos%=0)
2072         page%=x% DIV rowno%
2074         IF x% MOD rowno% >0 THEN page%=page%+1: END IF
2076         LStartPos%=(page%-1)*rowno% +LMinPos%
2078         ListFiles LeftFiles$, LStartPos%, LIndex%, 7
2080       ELSE
2082        d$=""
2084       END IF
2086     ELSE
2088       DIM RightFiles$(MaxFiles%,_fMax%) : rightDir$=a$
2090       LoadDir rightDir$, RightFiles$,8,RSizedir%, RSizeFile%
2092       IF LEN(rightDir$)=5 THEN
2094         RMinPos%=1
2096       ELSE
2098         RMinPos%=0
2100       END IF
2102       IF Find%(d$,id%, RightFiles$,1,RSizedir%)=1 THEN
2104         RIndex%=id%
2106         x%=id%+(RMinPos%=0)
2108         page%=x% DIV rowno%
2110         IF x% MOD rowno% >0 THEN page%=page%+1: END IF
2112         RStartPos%=(page%-1)*rowno% +RMinPos%
2114         ListFiles RightFiles$, RStartPos%, RIndex%, 8
2116       ELSE
2118          d$=""
2120       END IF
2122     END IF
2124   ELSE
2126     d$=""
2128   END IF
2130 ELSE
2132   d$=""
2134   IF ch%=7 THEN
2136     a$=leftDir$& GetFNam$(FileList$,Index%)
2138   ELSE
2140     a$=rightDir$& GetFNam$(FileList$,Index%)
2142   END IF
2144 END IF
2146 IF LEN(d$)=0 THEN
2148   IF ch%=7 THEN
2150     leftDir$=a$
2152     LShowLeftDir
2154   ELSE
2156     rightDir$=a$
2158     LShowRightDir
2160   END IF
2162 END IF
2164 END DEFine OpenSubDir
2166 :
2168 :
2170 REMark ''-----------------------------------------------------------
2172 DEFine FuNction GetParentDir$(ch%)
2174 LOCal i%, dir$
2176 IF ch%=7 THEN dir$=leftDir$: ELSE dir$=rightDir$:END IF
2178 FOR i% = LEN(dir$)-1 TO 5 STEP -1
2180  IF dir$(i%) = "_" THEN
2182    IF FTEST(dir$(1 TO i%)) = 0 THEN
2184      IF FTYP(\dir$(1 TO i%)) = 255 THEN EXIT i%
2186    END IF
2188  END IF
2190 END FOR i%
2192 dir$ = dir$(1 TO i%)
2194 RETurn dir$
2196 END DEFine GetParentDir$
2198 :
2200 :
2202 REMark ''------------------------------------------------------------
2204 DEFine PROCedure InputDir(ch%)
2206  LOCal a$, olddir$
2208  PAPER#ch%,0:INK#ch%,7:CLS#ch%
2210  IF ch%=5 THEN
2212    olddir$=leftDir$
2214  ELSE
2216    olddir$=rightDir$
2218  END IF
2220  a$=EDIT$(#ch%, olddir$, 36): CLS#ch%
2222  PAPER#ch%,White%:INK#ch%,0:CLS#ch%
2224  IF a$="" THEN a$=olddir$
2226  IF a$(LEN(a$))<>"_" THEN a$=a$&"_"
2228  IF DirExists%(a$) = 0 THEN
2230    BEEP 1390,20:PRINT#ch%, olddir$
2232    RETurn
2234  END IF
2236  IF ch%=5 THEN
2238    IF crtPanel%=8 THEN ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 0: END IF
2240    leftDir$=a$
2242    crtPanel%=7
2244    LShowLeftDir
2246    BORDER#7,1,brd%: BORDER#8,1,brd%,1,3
2248  ELSE
2250    IF crtPanel%=7 THEN ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 0: END IF
2252    rightDir$=a$
2254    crtPanel%=8
2256    LShowRightDir
2258    BORDER#8,1,brd%: BORDER#7, 1,brd%,1,3
2260  END IF
2262 END DEFine InputDir
2264 :
2266 :
2268 REMark ''----------------------------------------------------------
2270 DEFine PROCedure ViewFile
2272  LOCal ext$(10), a$, x%, i%, ch%, ch1%, ch2%, ch3%, left%, windef$, wid%,hgt%,top%
2274  IF crtPanel%=7 THEN
2276    IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
2278    a$=GetFNam$(LeftFiles$,LIndex%)
2280  ELSE
2282    IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
2284    a$=GetFNam$(RightFiles$,RIndex%)
2286  END IF
2288  IF a$==".." OR a$=="<un-named>" OR IsDir%=1 THEN RETurn : END IF
2290  REMark ''now get file extension
2292  x%=LEN(a$)
2294  FOR i%=0 TO x%-1
2296    IF a$(x%-i%)=="_" OR a$(x%-i%)=="." THEN EXIT i%
2298  END FOR i%
2300  IF i%>0 THEN
2302    ext$=a$(x%-i%+1 TO x%)
2304  ELSE
2306    ext$=""
2308  END IF
2310  IF crtPanel%=7 THEN
2312    a$=leftDir$&a$
2314  ELSE
2316    a$=rightDir$&a$
2318  END IF
2320  ext$=LOWER$(ext$) : x%=0
2322  IF ext$="fnt" THEN x%=1: END IF
2324  IF ext$="fat" THEN x%=2: END IF
2326  IF ext$="scr" THEN x%=3: END IF
2328  IF ext$="doc" THEN x%=4: END IF
2330  IF ext$="zip" THEN x%=5: END IF
2332  IF x%<>3 THEN
2334    IF x%=1 OR x%=2 THEN
2336      left%=(maxWinWid%-448) DIV 2 - 2
2338      wid%=452:hgt%=230: top%=(panelWinHeight%+2*mainFountHeight%+7-hgt%) DIV 2 + 14
2340      windef$="scr_452x230a"&left%&"x"&top%
2342      ch%=FOPEN(windef$)
2344      PAPER #ch%,0:INK #ch%,White%
2346      OUTLN #ch%,452,230,left%,top%:BORDER#ch%,1,2:CLS#ch%
2348      windef$="scr_452x12a"&left%&"x"&top%
2350      ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
2352      PAPER#ch1%,0: INK#ch1%,White%: AT#ch1%,0,37-(LEN(a$)+5)/2: PRINT#ch1%, "View "&a$
2354      left%=left%+2: windef$="scr_448x204a"&left%&"x"&(top%+12)
2356      ch2%=FOPEN(windef$):PAPER#ch2%,0:INK#ch2%,Green%
2358    ELSE
2360      IF maxWinWid%>600 THEN wid%=600: ELSE wid%=452: END IF
2362      hgt%=panelWinHeight%+27
2364      left%=(maxWinWid%-wid%) DIV 2 - 2
2366      top%=mainFountHeight%+4
2368      windef$="scr_"&wid%&"x"&hgt%&"a"&left%&"x"&top%
2370      ch%=FOPEN(windef$)
2372      PAPER #ch%,0:INK #ch%,White%
2374      OUTLN #ch%,wid%,hgt%,left%,top%:BORDER#ch%,1,2:CLS#ch%
2376      windef$="scr_"&wid%&"x12a"&left%&"x"&top%
2378      ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
2380      PAPER#ch1%,0: INK#ch1%,White%: CURSOR#ch1%,(wid%-(LEN(a$)+5)*6) DIV 2,0: PRINT#ch1%, "View "&a$
2382      left%=left%+2: windef$="scr_"&(wid%-4)&"x"&(hgt%-26)&"a"&left%&"x"&(top%+12)
2384      ch2%=FOPEN(windef$):PAPER#ch2%,0:INK#ch2%,Green%
2386    END IF
2388  END IF
2390  SELect ON x%
2392    = 1: ViewFont a$, 1, ch2%
2394    = 2: ViewFont a$, 2, ch2%
2396    = 3: ViewImage a$, 4: Set78CharSet
2398    = 4: WINDOW#0,wid%-4,12,left%,hgt%+top%-14:PAPER#0,Green%: INK#0,0:CLS#0
2400        IF IsQuillDoc%(a$)=1 THEN
2402          IF FTEST(ConfigDrv$&"quill_view") =0 THEN
2404            EW ConfigDrv$&"quill_view", #ch2%; "-t "&a$&" "&TempDir$&"quill_tmp"
2406              IF FTEST(TempDir$&"quill_tmp") =0 THEN
2408              IF mainFountBase>0 AND wid%<600 THEN :CHAR_USE#ch2%,mainFountBase,0: CHAR_INC #ch2%,5,10: END IF
2410              MORE#ch2%, TempDir$&"quill_tmp"
2412              DELETE TempDir$&"quill_tmp"
2414            END IF
2416          ELSE
2418            PRINT #ch2%,"Cannot find quill_view"
2420          END IF
2422        ELSE
2424          MORE#ch2%, a$
2426        END IF
2428    =5: WINDOW#0,wid%-4,12,left%,hgt%+top%-14:PAPER#0,Green%: INK#0,0:CLS#0
2430       IF IsZipFile%(a$)=1 THEN
2432         IF FTEST(ConfigDrv$&"unzip")=0 THEN
2434           ch3%=FOP_OVER(TempDir$&"zip_tmp")
2436           IF ch3%>0 THEN
2438             EW ConfigDrv$&"unzip",#ch3%,#ch3%,#ch3%;"-lqq "&a$
2440             CLOSE#ch3%
2442             MORE#ch2%, TempDir$&"zip_tmp"
2444             DELETE TempDir$&"zip_tmp"
2446           ELSE
2448             PRINT #ch2%,"Cannot create temporary file"
2450           END IF
2452         ELSE
2454            PRINT #ch2%,"Cannot find unzip"
2456         END IF
2458       ELSE
2460         MORE#ch2%, a$
2462       END IF
2464    = REMAINDER :
2466      WINDOW#0,wid%-4,12,left%,hgt%+top%-14:PAPER#0,Green%: INK#0,0:CLS#0
2468      MORE#ch2%, a$
2470  END SELect
2472  IF x%<>3 THEN
2474    CHAR_USE#ch2%,0,0
2476    CLS#ch1%: CLS#ch2%: CLOSE#ch2%:CLOSE#ch1%
2478    WINDOW#0,488,23,12,233:PAPER#0,0:INK#0,White%
2480    OUTLN #ch%,wid%,hgt%,left%,top%
2482    CLOSE#ch%
2484  END IF
2486 END DEFine ViewFile
2488 :
2490 :
2492 REMark ''----------------------------------------------------------
2494 DEFine PROCedure ViewFont (file$, type%, ch%)
2496 LOCal lng, i, base, type$(6)
2498 lng=FLEN(\file$)
2500 IF lng>0 THEN
2502  AT#ch%,0,0:PRINT#ch%, "Font: "&file$; "      ";
2504  AT#ch%,0,44:PRINT#ch%, "Font size = ";lng;" bytes"
2506 ELSE
2508  PRINT#ch%, "Font NOT FOUND" : RETurn
2510 END IF
2512 base = ALCHP(lng)
2514 LBYTES file$,base
2516 :
2518 IF type%=1 THEN type%=TestFount%(base)
2520 IF type%=1 THEN type$="(5x9)" : ELSE type$="(8x9)"
2522 AT #ch%,0,7 + LEN(file$) : PRINT #ch%,type$;
2524 :
2526 AT#ch%,1,0:PRINT#ch%, "Lowest character code = "; PEEK(base); "        ";
2528 AT#ch%,1,44:PRINT#ch%, "Number of characters  = "; PEEK(base+1) + 1
2530 PRINT#ch%,"  "
2532 CHAR_USE#ch%,base,0
2534 CSIZE #ch%, (type%=2),0: CHAR_INC#ch%,6 + 2*(type%=2),10
2536 FOR i=0 TO 9
2538   PRINT#ch%,CHR$(i);
2540 NEXT i: END FOR i
2542 PRINT#ch%," ";
2544 FOR i=11 TO 255:PRINT#ch%,CHR$(i);:NEXT i: END FOR i
2546 PRINT#ch%,CHR$(10)
2548 PRINT#ch%, "The quick brown fox jumped over the lazy dog"
2550 CSIZE#ch%, 2+(type%=2),0 : CHAR_INC#ch%,12 + 4*(type%=2),10
2552 PRINT#ch%, "The quick brown fox jumped over the lazy dog"
2554 CSIZE#ch%, 2+(type%=2),1 : CHAR_INC#ch%,12 + 4*(type%=2),20
2556 PRINT#ch%, "The quick brown fox jumped over the lazy dog"
2558 CHAR_USE#ch%,0,0
2560 RECHP base
2562 xx$=INKEY$(-1)
2564 END DEFine ViewFont
2566 :
2568 :
2570 REMark ''----------------------------------------------------------
2572 DEFine PROCedure MessageWnd(width%, height%, type%, text$)
2574 LOCal ch%, k$, AtX%,AtY%
2576 AtX%=(maxWinWid% - width%)/2
2578 AtY%=(256-height%)/2
2580 ch% = FOPEN("con")
2582 OUTLN#ch%; width%-2, height%, AtX%, AtY%, 4, 3
2584 SELect ON type%
2586   =1:
2588   PAPER#ch%,Green%:INK#ch%,0:CLS#ch%
2590   BLOCK#ch%,width%-4, 8, 1, 1,Green%,1,1
2592   AT#ch%, 1,1: PRINT#ch%, text$
2594   =2:
2596   PAPER#ch%,2:INK#ch%,White%:CLS#ch%
2598   BLOCK#ch%,width%-4, 8, 1, 1,2,1,1
2600   CURSOR#ch%,(width%-49)/2,1:PRINT#ch%," ERROR "
2602   AT#ch%, 1,1: PRINT#ch%, text$
2604   =3:
2606   PAPER#ch%,White%:INK#ch%,0:BORDER#ch%,1,2::CLS#ch%
2608   BLOCK#ch%,width%-8, 8, 1, 1,2,0,1
2610   CURSOR#ch%,(width%-49)/2,1:PRINT#ch%," ABOUT "
2612   CURSOR#ch%,2,15:PRINT#ch%, text$
2614 END SELect
2616 CURSOR#ch%,(width%-130)/2,48:PRINT#ch%,"... press any key ..."
2618 k$=INKEY$(-1)
2620 OUTLN#ch%; width%, height%, AtX%, AtY%
2622 CLOSE#ch%
2624 END DEFine MessageWnd
2626 :
2628 :
2630 REMark ''----------------------------------------------------------
2632 DEFine FuNction IsDir%
2634 LOCal k%, lenghth, bufsize
2636 IF crtPanel%=7 THEN
2638   k%=GetFFlg%(LeftFiles$,LIndex%) MOD 2
2640 ELSE
2642   k%=GetFFlg%(RightFiles$,RIndex%) MOD 2
2644 END IF
2646 RETurn k%
2648 END DEFine IsDir%
2650 :
2652 :
2654 REMark ''----------------------------------------------------------
2656 DEFine PROCedure ViewImage(a$, m%)
2658 LOCal ch%, ch1%,scrSz,scrBuf,maxScrSz
2660   IF maxWinHgt%>256 OR maxWinWid%>512 OR RMODE>8 THEN
2662     MessageWnd 200,60,2, CHR$(10)&" _scr images can only be viewed"&CHR$(10)&"  on classic QL configuration":RETurn
2664   END IF
2666   maxScrSz=32768
2668   scrSz=FLEN(\a$)
2670   IF scrSz > maxScrSz THEN
2672     scrBuf=ALCHP(scrSz) : IF scrBuf<0 THEN BEEP 1390,10 : RETurn
2674     LBYTES a$,scrBuf : a$=TempDir$ & "tmp_scr"
2676     SBYTES_O a$, scrBuf, maxScrSz
2678     RECHP scrBuf
2680   END IF
2682   ch% = FOPEN("con")
2684   OUTLN#ch%; 512, 256, 0, 0
2686   IF m%=4 THEN MODE 4: ELSE MODE 8: END IF
2688   LBYTES a$, 131072 : PAUSE 10
2690   k%=CODE(INKEY$(-1))
2692   SELect ON k%
2694     = 52: OUTLN#ch%; 512, 256, 0, 0: CLOSE#ch%: ViewImage a$, 4
2696     = 56: OUTLN#ch%; 512, 256, 0, 0: CLOSE#ch%: ViewImage a$, 8
2698     = REMAINDER : MODE 4
2700       OUTLN#ch%; 512, 256, 0, 0
2702       CLOSE#ch%
2704       DELETE TempDir$ & "tmp_scr"
2706   END SELect
2708 END DEFine ViewImage
2710 :
2712 :
2714 REMark ''----------------------------------------------------------
2716 DEFine FuNction InputWnd$(width%, height%, title$, text$,default$)
2718 LOCal ch%, ch1%, k$, AtX%,AtY%
2720 AtX%=(maxWinWid% -width%)/2
2722 AtY%=(256-height%)/2
2724 ch% = FOPEN("con")
2726 OUTLN#ch%; width%, height%, AtX%, AtY%, 4, 3
2728 BORDER#ch%,1,4
2730 PAPER#ch%,White%:INK#ch%,0:CLS#ch%
2732 BLOCK#ch%,width%-4, 10, 0, 0,Green%,1,1
2734 PAPER#ch%,Green%:INK#ch%,0:CURSOR#ch%,(width%-6-LEN(title$)*6)/2,0:PRINT#ch%,title$
2736 PAPER#ch%,White%: INK#ch%,0:CURSOR#ch%, 6,16: PRINT#ch%, text$
2738 CURSOR#ch%,(width%-198)/2,48:PRINT#ch%,"... leave it empty to cancel ..."
2740 ch1% = FOPEN("con")
2742 WINDOW #ch1%, width%-18,12,AtX%+8, AtY%+28
2744 PAPER#ch1%,0:INK#ch1%,White%:CLS#ch1%
2746 k$=EDIT$(#ch1%,default$, 36)
2748 CLOSE#ch1%
2750 OUTLN#ch%; width%, height%, AtX%, AtY%
2752 CLOSE#ch%
2754 RETurn k$
2756 END DEFine InputWnd$
2758 :
2760 :
2762 REMark ''----------------------------------------------------------
2764 DEFine FuNction DirExists% (name$)
2766 LOCal er%, ch%, d$, dname$
2768 dbg name$
2770 dname$=name$
2772 IF dname$(LEN(dname$))<>"_" THEN dname$=dname$&"_": END IF
2774 IF LEN(dname$)=5 THEN
2776   d$=DATAD$: DATA_USE CHR$(0)
2778   ch%=FOP_DIR(dname$)
2780   DATA_USE d$
2782   IF ch%<0 THEN
2784     er%=0
2786   ELSE
2788     CLOSE#ch%
2790     er%=1
2792   END IF
2794 ELSE
2796   IF FTEST(dname$) = 0 THEN
2798     IF FTYP(\dname$) = 255 THEN er% = 1 : ELSE er% = 0 : END IF
2800   ELSE
2802     er% = 0
2804   END IF
2806 END IF
2808 RETurn er%
2810 END DEFine DirExists%
2812 :
2814 :
2816 REMark ''----------------------------------------------------------
2818 DEFine PROCedure CreateDir
2820 LOCal x%,DirName$, FullDirName$
2822 DirName$=InputWnd$(240,60," Create Directory ", "Directory Name:","")
2824 DirName$=UPPER$(DirName$)
2826 IF DirName$="" THEN RETurn : END IF
2828 IF crtPanel%=7 THEN
2830   FullDirName$=leftDir$&DirName$
2832 ELSE
2834   FullDirName$=rightDir$&DirName$
2836 END IF
2838 x%=Create1Dir% (DirName$, FullDirName$, crtPanel%, 1,1,1)
2840 END DEFine CreateDir
2842 :
2844 :
2846 REMark ''----------------------------------------------------------
2848 DEFine FuNction Create1Dir%(DirName$, FullDirName$, panel%, UpdateWnd%, CheckNoQ%, UpdateList%)
2850 LOCal res%, fres%, page%, msg$
2852 IF LEN(FullDirName$)>41 THEN
2854   IF UpdateWnd%=1 THEN
2856     MessageWnd 200,60,2, CHR$(10)&"          Name too long !"
2858     RETurn 0
2860   ELSE
2862     INK#0,2:PRINT#0,"Directory not created  Name too long":INK#0,White%:RETurn 0
2864   END IF
2866 END IF
2868 IF (Qubide%=1) AND (CheckNoQ%=1) THEN
2870   IF TestQubideRestriction%(DirName$, panel%)=1 THEN
2872     IF UpdateWnd%=1 THEN
2874       MessageWnd 200,60,2, "   Cannot create Directory !"&CHR$(10)&"  QUBIDE limitation: Files will"&CHR$(10)&"     fall in the directory !"
2876       RETurn 0
2878     ELSE
2880       INK#0,2:PRINT#0,"Directory not created QUBIDE limitation: Files will fall in the directory":INK#0,White%:RETurn 0
2882     END IF
2884   END IF
2886 END IF
2888 IF DirName$(LEN(DirName$))="_" THEN DirName$=DirName$(1 TO LEN(DirName$)-1):END IF
2890 IF panel%=7 THEN
2892    IF (CheckNoQ%=1) AND (LSizedir%+LSizeFile%+1>=MaxFiles%) THEN
2894      IF UpdateWnd%=1 THEN
2896        MessageWnd 200,60,2, CHR$(10)&"   Cannot create Directory !"&CHR$(10)&CHR$(10)&"     maximum number reached !"
2898        RETurn 0
2900      ELSE
2902        INK#0,2:PRINT#0,"Directory not created. You have reached the maximum number of files and directories":INK#0,White%:RETurn -1
2904      END IF
2906    ELSE
2908      fres%=FMAKE_DIR (FullDirName$)
2910      IF (UpdateList%=1) AND (fres%>=0) THEN
2912        res%=Find% (DirName$,id%,LeftFiles$,1,LSizedir%)
2914        IF res%=0 THEN res%=Insert% (DirName$,id%, LeftFiles$, 1, LSizedir%, LSizeFile%, "0"):END IF
2916        LIndex%=id%
2918        IF UpdateWnd%=1 THEN
2920          id%=id%+(LMinPos%=0)
2922          page%=id% DIV rowno%
2924          IF id% MOD rowno% >0 THEN page%=page%+1: END IF
2926          LStartPos%=(page%-1)*rowno% +LMinPos%
2928          ListFiles LeftFiles$, LStartPos%, LIndex%, 7
2930        END IF
2932        RETurn 1
2934      ELSE
2936        IF fres%>=0 THEN RETurn 1
2938      END IF
2940    END IF
2942 ELSE
2944    IF (CheckNoQ%=1) AND (RSizedir%+RSizeFile%+1>=MaxFiles%) THEN
2946      IF UpdateWnd%=1 THEN
2948        MessageWnd 200,60,2, CHR$(10)&"   Cannot create Directory !"&CHR$(10)&CHR$(10)&"     maximum number reached !"
2950        RETurn 0
2952      ELSE
2954        INK#0,2:PRINT#0,"Directory not created. You have reached the maximum number of files and directories":INK#0,White%:RETurn -1
2956      END IF
2958    ELSE
2960      fres%=FMAKE_DIR (FullDirName$)
2962      IF (UpdateList%=1) AND (fres%>=0) THEN
2964        res%=Find% (DirName$,id%,RightFiles$,1,RSizedir%)
2966        IF res%=0 THEN res%=Insert% (DirName$,id%, RightFiles$, 1, RSizedir%, RSizeFile%, "0"): END IF
2968        RIndex%=id%
2970        IF UpdateWnd%=1 THEN
2972          id%=id%+(RMinPos%=0)
2974          page%=id% DIV rowno%
2976          IF id% MOD rowno% >0 THEN page%=page%+1: END IF
2978          RStartPos%=(page%-1)*rowno% +RMinPos%
2980          ListFiles RightFiles$, RStartPos%, RIndex%, 8
2982        END IF
2984        RETurn 1
2986      ELSE
2988        IF fres%>=0 THEN RETurn 1
2990      END IF
2992    END IF
2994 END IF
2996 SELect ON fres%
2998   =-8, -9: msg$= "   Cannot create Directory !"&CHR$(10)&"    A file or a directory with"&CHR$(10)&"    same name already exists !"
3000   =-11:msg$= CHR$(10)&"    Cannot create Directory"&CHR$(10)&"            Drive full"
3002   =-15:msg$= CHR$(10)&"    Cannot create Directory"&CHR$(10)&"       Drive is not Level2"
3004   =-19:msg$= CHR$(10)&"    Cannot create Directory"&CHR$(10)&"       Not implemented yet"
3006   =-20:msg$= CHR$(10)&"    Cannot create Directory"&CHR$(10)&"        Drive is Read Only "
3008   =REMAINDER :msg$= CHR$(10)&"    Cannot create Directory"&CHR$(10)&"            Error "&fres%
3010 END SELect
3012 IF UpdateWnd%=1 THEN
3014   MessageWnd 200,60,2, msg$
3016   IF (fres%=-15) OR (fres%=-19) THEN DELETE FullDirName$: END IF
3018   RETurn 0
3020 ELSE
3022   SELect ON fres%
3024     =-8, -9: INK#0,2:PRINT#0,"Directory not created  A file or a directory with same name already exists":INK#0,White%:RETurn 0
3026     REMark ''=-9:ink#0,2:print#0,"Directory not created  A directory with same name already exists":ink#0,White%:Return 0
3028      =-11:INK#0,2:PRINT#0,"Directory not created Drive full":INK#0,White%:RETurn -1
3030      =-15:INK#0,2:PRINT#0,"Directory not created  Drive is not Level2":INK#0,White%:RETurn -1
3032      =-19:INK#0,2:PRINT#0,"Directory not created  Operation not implemented yet for this drive type":INK#0,White%:RETurn -1
3034      =-20:INK#0,2:PRINT#0,"Directory not created  Drive is Read Only ":INK#0,White%:RETurn -1
3036      =REMAINDER : INK#0,2:PRINT#0,"Directory not created  Error "&fres%:INK#0,White%:RETurn 0
3038   END SELect
3040 END IF
3042 END DEFine Create1Dir%
3044 :
3046 :
3048 REMark ''-----------------------------------------------------------
3050 DEFine FuNction CountSelected%
3052 LOCal i%, counter%
3054 counter%=0
3056 IF crtPanel%=7 THEN
3058   FOR i%=1 TO LSizedir%+LSizeFile%
3060     IF GetFFlg%(LeftFiles$,i%) > 1 THEN counter%=counter%+1 : END IF
3062   END FOR i%
3064 ELSE
3066   FOR i%=1 TO RSizedir%+RSizeFile%
3068     IF GetFFlg%(RightFiles$,i%) > 1 THEN counter%=counter%+1 : END IF
3070   END FOR i%
3072 END IF
3074 RETurn counter%
3076 END DEFine CountSelected%
3078 :
3080 :
3082 REMark ''---------------------------------------------------------
3084 DEFine FuNction DlgWnd%(width%, height%, title$, text$)
3086 LOCal ch%, a$, k%, AtX%, AtY%, loopa
3088 AtX%=(maxWinWid%-width%)/2
3090 AtY%=(256-height%)/2
3092 ch% = FOPEN("con")
3094 OUTLN#ch%; width%, height%, AtX%, AtY%, 4, 3
3096 BORDER#ch%,1,Green%
3098 PAPER#ch%,White%:INK#ch%,0:CLS#ch%
3100 BLOCK#ch%,width%-4, 10, 0, 0,Green%,1,1
3102 PAPER#ch%,Green%:INK#ch%,0:CURSOR#ch%,(width%-6-LEN(title$)*6)/2,0:PRINT#ch%,title$
3104 PAPER#ch%,White%: INK#ch%,0:CURSOR#ch%, 6,16: PRINT#ch%, text$
3106 CURSOR#ch%,(width%-198)/2,48:
3108 INK#ch%,2: PRINT#ch%,"    C";:INK#ch%,0:PRINT#ch%,"ancel                ";
3110 INK#ch%,2: PRINT#ch%,"O";:INK#ch%,0:PRINT#ch%,"k"
3112 REPeat loopa
3114    a$=INKEY$(-1)
3116    IF a$ INSTR "oO"&CHR$(10) THEN k%=1: EXIT loopa: END IF
3118    IF a$ INSTR "cC"&CHR$(27) THEN k%=0: EXIT loopa: END IF
3120 END REPeat loopa
3122 OUTLN#ch%; width%, height%, AtX%, AtY%
3124 CLOSE#ch%
3126 RETurn k%
3128 END DEFine DlgWnd%
3130 :
3132 :
3134 REMark ''----------------------------------------------------------
3136 DEFine FuNction TestQubideRestriction%(DirName$, panel%)
3138 LOCal i%, name$
3140 name$=DirName$
3142 IF name$(LEN(name$))<>"_" THEN name$=name$&"_"
3144 IF panel%=7 THEN
3146   FOR i%=LSizedir%+1 TO LSizedir%+LSizeFile%
3148     IF name$ INSTR LeftFiles$(i%) = 1 THEN RETurn 1 : END IF
3150   END FOR i%
3152 ELSE
3154   FOR i%=RSizedir%+1 TO RSizedir%+RSizeFile%
3156     IF name$ INSTR RightFiles$(i%) = 1 THEN RETurn 1 : END IF
3158   END FOR i%
3160 END IF
3162 RETurn 0
3164 END DEFine TestQubideRestriction%
3166 :
3168 :
3170 REMark ''----------------------------------------------------------
3172 DEFine FuNction IsQuillDoc%(a$)
3174 LOCal ch%, q$, i%, k%
3176 ch% = FOPEN(a$)
3178 IF ch% <= 0 THEN RETurn 0: END IF
3180 q$=""
3182 BGET #ch%\1,k%
3184 FOR i%=1 TO 8
3186  BGET #ch%,k%
3188  q$=q$&CHR$(k%)
3190 NEXT i%: END FOR i%
3192 CLOSE #ch%
3194 IF q$="vrm1qdf0" THEN RETurn 1: ELSE RETurn 0: END IF
3196 END DEFine IsQuillDoc%
3198 :
3200 :
3202 REMark ''-----------------------------------------------------------
3204 DEFine FuNction IsZipFile%(a$)
3206 LOCal ch%, q$, i%, k%
3208 ch% = FOPEN(a$)
3210 IF ch% <= 0 THEN RETurn 0: END IF
3212 q$=""
3214 FOR i%=1 TO 4
3216  BGET #ch%,k%
3218  q$=q$&CHR$(k%)
3220 NEXT i%: END FOR i%
3222 CLOSE #ch%
3224 IF q$="PK"&CHR$(3)&CHR$(4) THEN RETurn 1: ELSE RETurn 0: END IF
3226 END DEFine IsZipFile%
3228 :
3230 :
3232 REMark ''----------------------------------------------------------
3234 DEFine PROCedure RenameFile
3236 LOCal NewFileName$,filename$, sourcepath$, res%, i%, x%, filelen$, page%
3238 IF crtPanel%=7 THEN
3240  IF LIndex%>LSizeFile%+LSizedir% THEN RETurn : END IF
3242 ELSE
3244  IF RIndex%>RSizeFile%+RSizedir% THEN RETurn : END IF
3246 END IF
3248 IF crtPanel%=7 THEN
3250    filename$=GetFNam$(LeftFiles$,LIndex%)
3252    sourcepath$=leftDir$
3254 ELSE
3256    filename$=GetFNam$(RightFiles$,RIndex%)
3258    sourcepath$=rightDir$
3260 END IF
3262 IF filename$=".." THEN RETurn : END IF
3264 IF IsDir%=1 THEN
3266   MessageWnd 200,60,2, CHR$(10)&"   Cannot rename a Directory!"
3268   RETurn
3270 END IF
3272 res%=FTEST(sourcepath$&filename$)
3274 IF res%=-9 THEN
3276   MessageWnd 200,60,2, CHR$(10)&"   File in Use! Cannot rename!"
3278   RETurn
3280 END IF
3282 IF res%=-20 THEN
3284   MessageWnd 200,60,2, CHR$(10)&"       File is Read Only! "&CHR$(10)&"          Cannot rename!"
3286   RETurn
3288 END IF
3290 NewFileName$=InputWnd$(240,60," Rename File ", "Rename "&filename$&" to:",filename$)
3292 IF NewFileName$="" THEN RETurn : END IF
3294 IF LEN(sourcepath$&NewFileName$)>36 THEN
3296   MessageWnd 200,60,2, CHR$(10)&"   Full file name is too long!"
3298   RETurn
3300 END IF
3302 IF FTEST(sourcepath$&NewFileName$)<>-7 THEN
3304   MessageWnd 200,60,2, CHR$(10)&"      A file with this name"&CHR$(10)&"          already exists!"
3306   RETurn
3308 END IF
3310 RENAME sourcepath$&filename$ TO sourcepath$&NewFileName$
3312 IF crtPanel%=7 THEN
3314   filelen$=GetFLen(LeftFiles$,LIndex%)
3316   ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 0
3318   FOR i%=LIndex%+1 TO LSizedir%+LSizeFile%
3320     CopyRec LeftFiles$,i% TO LeftFiles$,i%-1
3322   END FOR i%
3324   LSizeFile%=LSizeFile%-1
3326   x%=Find%(NewFileName$,id%, LeftFiles$,LSizedir%+1,LSizedir%+LSizeFile%)
3328   x%=Insert%(NewFileName$,id%,LeftFiles$,0, LSizedir%, LSizeFile%, filelen$)
3330   LIndex%=id%
3332   x%=id%+(LMinPos%=0)
3334   page%=x% DIV rowno%
3336   IF x% MOD rowno% >0 THEN page%=page%+1: END IF
3338   LStartPos%=(page%-1)*rowno% +LMinPos%
3340   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
3342 ELSE
3344   filelen$=GetFLen(RightFiles$,RIndex%)
3346   ShowHideCursor RIndex%-RStartPos%, RIndex%, RightFiles$, 0
3348   FOR i%=RIndex%+1 TO RSizedir%+RSizeFile%
3350     CopyRec RightFiles$,i% TO RightFiles$,i%-1
3352   END FOR i%
3354   RSizeFile%=RSizeFile%-1
3356   x%=Find%(NewFileName$,id%, RightFiles$,RSizedir%+1,RSizedir%+RSizeFile%)
3358   x%=Insert%(NewFileName$,id%,RightFiles$,0, RSizedir%, RSizeFile%, filelen$)
3360   RIndex%=id%
3362   x%=id%+(RMinPos%=0)
3364   page%=x% DIV rowno%
3366   IF x% MOD rowno% >0 THEN page%=page%+1: END IF
3368   RStartPos%=(page%-1)*rowno% +RMinPos%
3370   ListFiles RightFiles$, RStartPos%, RIndex%, 8
3372 END IF
3374 END DEFine RenameFile
3376 :
3378 :
3380 REMark ''-----------------------------------------------------------
3382 DEFine PROCedure ShowInfo
3384  LOCal filename$(36), path$(36), chf%, ch%,ch1%,ch2%,x%, k$(2),windef$, left%, top%
3386 :
3388   IF crtPanel%=7 THEN
3390     IF LIndex%>LSizeFile%+LSizedir% THEN RETurn : END IF
3392   ELSE
3394     IF RIndex%>RSizeFile%+RSizedir% THEN RETurn : END IF
3396   END IF
3398 :
3400   IF crtPanel%=7 THEN
3402     filename$=GetFNam$(LeftFiles$,LIndex%)
3404     path$=leftDir$
3406   ELSE
3408     filename$=GetFNam$(RightFiles$,RIndex%)
3410     path$=rightDir$
3412   END IF
3414 :
3416   IF filename$=".." THEN RETurn : END IF
3418   left%=(maxWinWid%-452) DIV 2
3420   IF maxWinHgt%>256 THEN top%=51: ELSE top%=14: END IF
3422   windef$="scr_452x230a"&left%&"x"&top%
3424   ch%=FOPEN(windef$)
3426   PAPER #ch%,0:INK #ch%,White%
3428   OUTLN #ch%,452,230,left%,top% : BORDER #ch%,1,2: CLS #ch%
3430   windef$="scr_452x12a"&left%&"x"&top%
3432   ch1%=FOPEN(windef$): BORDER #ch1%,1,2 : PAPER #ch1%,0,2,1 : CLS #ch1%
3434   PAPER #ch1%,0 : INK #ch1%,White% : AT #ch1%,0,34 : PRINT#ch1%, " Info "
3436   windef$="scr_448x204a"&(left%+2)&"x"&(top%+12)
3438   ch2%=FOPEN(windef$):PAPER#ch2%,0:INK#ch2%,Green%
3440   PRINT #ch2%, "Full name: ";path$&filename$;CHR$(10);
3442 :
3444   chf%=FOPEN(path$&filename$)
3446   IF chf%<0 THEN
3448     INK#ch2%, 2
3450     SELect ON chf%
3452       =-7: PRINT#ch2%, "File Not Found !"
3454       =-9: PRINT#ch2%, "File in use"
3456       = REMAINDER : PRINT#ch2%, "Error ";chf%
3458     END SELect
3460     INK 4
3462   ELSE
3464     GetHEAD #chf%,headBuff
3466     PRINT#ch2%, "File Length:"; : PRINT_USING#ch2%, "##,###,###. bytes\", PEEK_L(headBuff)
3468     x%=PEEK(headBuff+5)
3470     PRINT#ch2%, "File Type:   ";x%;" - ";
3472     SELect ON x%
3474       =0  : PRINT#ch2%, "BASIC, CALLable machine code, extensions or DATA file"
3476       =1  : PRINT#ch2%, "EXECable file"
3478       =2  : PRINT#ch2%, "SROFF file used by linkers etc, a C68 Library file etc"
3480       =3  : PRINT#ch2%, "THOR hard disc directory file. (I think!)"
3482       =4  : PRINT#ch2%, "A font file for The Painter"
3484       =5  : PRINT#ch2%, "A pattern file for The Painter"
3486       =6  : PRINT#ch2%, "A compressed mode 4 screen in The Painter"
3488       =11 : PRINT#ch2%, "A compressed mode 8 screen in The Painter"
3490       =255: PRINT#ch2%, "Level 2 driver directory or sub-directory file"
3492       =REMAINDER : PRINT#ch2%," "
3494     END SELect
3496     PRINT#ch2%, "Data-space: ";
3498     IF x%=1 THEN PRINT_USING#ch2%, "##,###,###. bytes\", PEEK_L(headBuff+6) : ELSE : PRINT#ch2%, "   n/a"
3500     PRINT#ch2%, "File Version:  ";PEEK_W(headBuff+56)
3502     PRINT#ch2%, "Last modified: ";
3504     d=PEEK_L(headBuff+52) : IF d THEN PRINT#ch2%, DATE$(d) : ELSE : PRINT#ch2%, "<not-set>"
3506     PRINT#ch2%, "Backup date:   ";
3508     d=PEEK_L(headBuff+60) : IF d THEN PRINT#ch2%, DATE$(d) : ELSE : PRINT#ch2%, "<not-set>"
3510     CLOSE #chf%
3512   END IF
3514 :
3516   PRINT#ch2%, CHR$(10);"------------------------------------------------------------------------";CHR$(10)
3518   PRINT#ch2%, "ROM Version:  "; VER$
3520   PRINT#ch2%, "QDOS Version: "; VER$(1)
3522   PRINT#ch2%, "Current RAMTOP: "; : PRINT_USING#ch2%, "##,###.#",RESPR(0)/1024-128 : PRINT#ch2%, " Kb"
3524   PRINT#ch2%, "Free memory:    "; : PRINT_USING#ch2%, "##,###.#",FREE_MEM/1024     : PRINT#ch2%, " Kb"
3526   PRINT#ch2%
3528   PRINT#ch2%, "DataD$: ";DATAD$
3530   PRINT#ch2%, "ProgD$: ";PROGD$
3532   PRINT#ch2%, "DestD$: ";DESTD$
3534 :
3536   k$=INKEY$(-1)
3538   CLS #ch1% : CLS #ch2% : CLOSE #ch2% : CLOSE #ch1%
3540   OUTLN #ch%,452,230,left%,top%
3542   CLOSE #ch%
3544 :
3546 END DEFine ShowInfo
3548 :
3550 :
3552 REMark ''----------------------------------------------------------
3554 DEFine PROCedure WriteCommands(ch%)
3556  LOCal lat, px%, px1%, i%, x%, lat%(9)
3558   lat=(comWinWid% - 4) DIV 9: rest=(comWinWid% - 4) MOD 9:FOR i%=1 TO 9:lat%(i%)=lat:NEXT i%
3560   IF rest>=0 THEN lat%(4)=lat+1
3562   IF rest>=1 THEN lat%(3)=lat+1
3564   IF rest>=2 THEN lat%(5)=lat+1
3566   IF rest>=3 THEN lat%(1)=lat+1
3568   IF rest>=4 THEN lat%(2)=lat+1
3570   IF rest>=5 THEN lat%(6)=lat+1
3572   IF rest>=6 THEN lat%(7)=lat+1
3574   IF rest>=7 THEN lat%(8)=lat+1
3576   IF rest>=8 THEN lat%(9)=lat+1
3578   px%=0
3580   PAPER#ch%, PPR9a%,ppr9b%,3
3582 :
3584   FOR i%=1 TO 9
3586     BLOCK#ch%, lat%(i%)-1,mainFountHeight%, px%,0, PPR9a%,ppr9b%,3
3588     x%=px% + (lat%(i%) - 1 - LEN(cmdText$(i%)) * comFountWid%) DIV 2
3590     CURSOR#ch%, x%,0 : PRINT#ch%, cmdText$(i%);
3592     px%=px%+lat%(i%)
3594   END FOR i%
3596 END DEFine WriteCommands
3598 :
3600 :
3602 REMark ''----------------------------------------------------------
3604 DEFine FuNction IsReadOnly% (a$)
3606 LOCal res%
3608 res%=FOPEN(a$&CHR$(0))
3610 IF res%=-20 THEN RETurn 1: END IF
3612 IF res%>0 THEN DELETE a$&CHR$(0): END IF
3614 RETurn 0
3616 END DEFine IsReadOnly%
3618 :
3620 :
3622 REMark ''----------------------------------------------------------
3624 DEFine PROCedure CopyFiles
3626 LOCal k%, x%, name$, source$, dest$, filelen$, panel%
3628 x%=CountSelected%
3630 IF crtPanel%=7 THEN
3632   source$=leftDir$ : dest$=rightDir$
3634   name$=GetFNam$(LeftFiles$,LIndex%)
3636   filelen$=GetFLen(LeftFiles$,LIndex%)
3638   panel%=8
3640 ELSE
3642   dest$=leftDir$ : source$=rightDir$
3644   name$=GetFNam$(RightFiles$,RIndex%)
3646   filelen$=GetFLen(RightFiles$,RIndex%)
3648   panel%=7
3650 END IF
3652 IF IsReadOnly%(dest$) THEN
3654  MessageWnd 200,60,2, CHR$(10)&"    Destination is Read Only! "&CHR$(10)&"           Cannot copy!"
3656  RETurn
3658 END IF
3660 IF x%>0 THEN
3662  k%=DlgWnd%(240,60," Copy Files ", "    Are you sure you want to copy"&CHR$(10)&"     "&x%&" files and directories ?")
3664  IF k%=1 THEN CopyMultipleFiles x%
3666 ELSE
3668  IF IsDir%=1 THEN
3670      CopySingleDir name$, source$, dest$, panel%
3672  ELSE
3674    IF LEN(dest$&name$)>41 THEN
3676      MessageWnd 200,60,2, CHR$(10)&"        Cannot copy file"&CHR$(10)&"          Name too long !"
3678      RETurn
3680    END IF
3682    k%=FTEST(dest$&name$)
3684    IF k%=-7 THEN
3686     IF crtPanel%=7 THEN
3688       IF RSizedir%+RSizeFile%+1>=MaxFiles% THEN
3690         MessageWnd 200,60,2, CHR$(10)&"        Cannot copy file"&CHR$(10)&"      maximum number reached !"
3692         RETurn
3694       END IF
3696      ELSE
3698       IF LSizedir%+LSizeFile%+1>=MaxFiles% THEN
3700         MessageWnd 200,60,2, CHR$(10)&"        Cannot copy file"&CHR$(10)&"      maximum number reached !"
3702         RETurn
3704       END IF
3706      END IF
3708      Copy1File name$, source$, dest$, filelen$, 1: RETurn
3710    ELSE
3712      IF k%=0 THEN
3714        x%=DlgWnd%(240,60," Copy Files ", "   Destination file already exists"&CHR$(10)&"              Overwrite ?")
3716        IF x%=1 THEN Copy1File name$, source$, dest$, filelen$, 1: RETurn :END IF
3718      ELSE
3720        SELect ON k%
3722          =-9: MessageWnd 200,60,2, CHR$(10)&"      Destination is in use "&CHR$(10)&"           Cannot copy!":RETurn
3724          =-11:MessageWnd 200,60,2, CHR$(10)&"    Destination drive is full"&CHR$(10)&"           Cannot copy!":RETurn
3726          =-16:MessageWnd 200,60,2, CHR$(10)&"      Bad or Changed Medium"&CHR$(10)&"           Cannot copy!":RETurn
3728          =-20:MessageWnd 200,60,2, CHR$(10)&"    Destination is Read Only! "&CHR$(10)&"           Cannot copy!": RETurn
3730          =REMAINDER : MessageWnd 200,60,2, CHR$(10)&"     Error copying file : "&k%:RETurn
3732        END SELect
3734      END IF
3736    END IF
3738  END IF
3740  IF crtPanel%=7 THEN
3742    id%=RIndex%+(RMinPos%=0)
3744    page%=id% DIV rowno%
3746    IF id% MOD rowno% >0 THEN page%=page%+1: END IF
3748    RStartPos%=(page%-1)*rowno% +RMinPos%
3750    ListFiles RightFiles$, RStartPos%, RIndex%, 8
3752  ELSE
3754    id%=LIndex%+(LMinPos%=0)
3756    page%=id% DIV rowno%
3758    IF id% MOD rowno% >0 THEN page%=page%+1: END IF
3760    LStartPos%=(page%-1)*rowno% +LMinPos%
3762    ListFiles LeftFiles$, LStartPos%, LIndex%, 7
3764  END IF
3766 END IF
3768 END DEFine CopyFiles
3770 :
3772 :
3774 REMark ''-----------------------------------------------------------
3776 DEFine PROCedure Copy1File (name$, source$, dest$, filelen$, UpdateList%)
3778 LOCal x%, page%
3780 COPY_O source$&name$ TO dest$&name$
3782 IF crtPanel%=8 THEN
3784   x%=Find%(name$,id%, LeftFiles$,LSizedir%+1,LSizedir%+LSizeFile%)
3786   IF x%=0 THEN
3788     x%=Insert%(name$,id%,LeftFiles$,0, LSizedir%, LSizeFile%, filelen$)
3790   ELSE
3792     PutFLen LeftFiles$,id%,filelen$
3794   END IF
3796   LIndex%=id%
3798   IF UpdateList%=1 THEN
3800     id%=id%+(LMinPos%=0)
3802     page%=id% DIV rowno%
3804     IF id% MOD rowno% >0 THEN page%=page%+1: END IF
3806     LStartPos%=(page%-1)*rowno% +LMinPos%
3808     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
3810   END IF
3812 ELSE
3814   x%=Find%(name$,id%, RightFiles$,RSizedir%+1,RSizedir%+RSizeFile%)
3816   IF x%=0 THEN
3818     x%=Insert%(name$,id%,RightFiles$,0, RSizedir%, RSizeFile%, filelen$):
3820   ELSE
3822     PutFLen RightFiles$,id%,filelen$
3824   END IF
3826   RIndex%=id%
3828   IF UpdateList%=1 THEN
3830     id%=id%+(RMinPos%=0)
3832     page%=id% DIV rowno%
3834     IF id% MOD rowno% >0 THEN page%=page%+1: END IF
3836     RStartPos%=(page%-1)*rowno% +RMinPos%
3838     ListFiles RightFiles$, RStartPos%, RIndex%, 8
3840   END IF
3842 END IF
3844 END DEFine Copy1File
3846 :
3848 :
3850 REMark ''----------------------------------------------------------
3852 DEFine PROCedure CopyDirFiles(name$, source$, dest$, CreateWnd%)
3854 LOCal ch%, ch1%
3856 IF CreateWnd%=1 THEN
3858   ch%=FOPEN("scr_400x156a56x50")
3860   PAPER #ch%,0:INK #ch%,7
3862   OUTLN #ch%,400,156,56,50:BORDER#ch%,1,2:CLS#ch%
3864   ch1%=FOPEN("scr_398x12a57x51"): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
3866   PAPER#ch1%,0: INK#ch1%,7: AT#ch1%,0,25: PRINT#ch1%, " Copy Directory "
3868   WINDOW#0,396, 140, 58, 63:PAPER#0,0: INK#0,White%:CLS#0
3870 END IF
3872 PRINT#0, "Copy "&source$&name$&" to "&dest$&name$
3874 WCOPY source$&name$ TO dest$&name$
3876 IF CreateWnd%=1 THEN
3878   INK#0,Green%:PRINT#0, "Copy process ended - press any key to close window":INK#0,White%
3880   x%=KEYROW(0):a$=INKEY$(-1)
3882   WINDOW#0,448,12,32,231:
3884   CLOSE#ch1%
3886   OUTLN #ch%,400,156,56,50
3888   CLOSE#ch%
3890 END IF
3892 END DEFine CopyDirFiles
3894 :
3896 :
3898 REMark ''----------------------------------------------------------
3900 DEFine PROCedure CopyMultipleFiles(k%)
3902 LOCal ch%, ch1%, i%, x%, a$, Index%, panel%, page%, id%, left%,windef$, hgt%, wid%
3904 IF panelWinWid%*2>602 THEN wid%=600: ELSE wid%=400:END IF
3906 hgt%=panelWinHeight%*8 DIV  10
3908 left%=(maxWinWid%-wid%) DIV 2
3910 windef$="scr_"&wid%&"x"&hgt%&"a"&left%&"x50"
3912 ch%=FOPEN(windef$)
3914 PAPER #ch%,0:INK #ch%,White%
3916 OUTLN #ch%,wid%,hgt%,left%,50:BORDER#ch%,1,2:CLS#ch%
3918 left%=left%+1
3920 windef$="scr_"&(wid%-2)&"x12a"&left%&"x51"
3922 ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
3924 PAPER#ch1%,0: INK#ch1%,White%: CURSOR#ch1%,(wid%-90) DIV 2,0: PRINT#ch1%, " Copy Selected "
3926 WINDOW#0,wid%-4, hgt%-16, left%+1, 63:PAPER#0,0: INK#0,White%:CLS#0
3928 PRINT#0, "Copy Selected list: "&k%&" files and/or directories"
3930 IF crtPanel%=7 THEN
3932  source$=leftDir$:dest$=rightDir$: Index%=LIndex%: panel%=8
3934  FOR i%=1 TO LSizedir%+LSizeFile%
3936    LIndex%=i%
3938    IF GetFFlg%(LeftFiles$,i%) > 1 THEN
3940      IF GetFFlg%(LeftFiles$,i%) = 2 THEN
3942        PRINT#0, "Copying file "&GetFNam$(LeftFiles$,i%)&" ..."
3944        x%=CopyAListFile%(GetFNam$(LeftFiles$,i%), source$, dest$, GetFLen(LeftFiles$,i%), 8)
3946      ELSE
3948        PRINT#0, "Copying directory "&GetFNam$(LeftFiles$,i%)&" ..."
3950        x%=CopyFullDir%(GetFNam$(LeftFiles$,i%), source$, dest$, 8, 0, 1, 1)
3952      END IF
3954      IF x%=-1 THEN EXIT i%
3956      PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
3958    END IF
3960  NEXT i%: END FOR i%
3962  LIndex%=Index%
3964 ELSE
3966  source$=rightDir$:dest$=leftDir$:Index%=RIndex%
3968  FOR i%=1 TO RSizedir%+RSizeFile%
3970    RIndex%=i%
3972    IF GetFFlg%(RightFiles$,i%) > 1 THEN
3974      IF GetFFlg%(RightFiles$,i%)=2 THEN
3976        PRINT#0, "Copying file "&GetFNam$(RightFiles$,i%)&" ..."
3978        x%=CopyAListFile%(GetFNam$(RightFiles$,i%), source$, dest$, GetFLen(RightFiles$,i%), 7)
3980      ELSE
3982        PRINT#0, "Copying directory "&GetFNam$(RightFiles$,i%)&" ..."
3984        x%=CopyFullDir% (GetFNam$(RightFiles$,i%), source$, dest$, 7, 0, 1, 1)
3986      END IF
3988      IF x%=-1 THEN EXIT i%
3990      PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
3992    END IF
3994  NEXT i%: END FOR i%
3996  RIndex%=Index%
3998 END IF
4000 INK#0,Green%:PRINT#0, "Copy process ended - press any key to close window":INK#0,White%
4002 x%=KEYROW(0):a$=INKEY$(-1)
4004 WINDOW#0,448,12,32,231:
4006 CLOSE#ch1%
4008 OUTLN #ch%,wid%,hgt%,left%-1,50
4010 CLOSE#ch%
4012 id%=RIndex%+(RMinPos%=0)
4014 page%=id% DIV rowno%
4016 IF id% MOD rowno% >0 THEN page%=page%+1: END IF
4018 RStartPos%=(page%-1)*rowno% +RMinPos%
4020 ListFiles RightFiles$, RStartPos%, RIndex%, 8
4022 id%=LIndex%+(LMinPos%=0)
4024 page%=id% DIV rowno%
4026 IF id% MOD rowno% >0 THEN page%=page%+1: END IF
4028 LStartPos%=(page%-1)*rowno% +LMinPos%
4030 ListFiles LeftFiles$, LStartPos%, LIndex%, 7
4032 END DEFine CopyMultipleFiles
4034 :
4036 :
4038 REMark ''----------------------------------------------------------
4040 DEFine FuNction CopyAListFile%(name$, source$, dest$, filelen$, panel%)
4042 LOCal k%
4044  IF LEN(dest$&name$)>41 THEN
4046    INK#0,2: PRINT#0,name$&" not copied. Name too long":INK#0,White%
4048    RETurn 0
4050  END IF
4052  k%=FTEST(dest$&name$)
4054  IF k%=-7 THEN
4056   IF panel%=8 THEN
4058     IF RSizedir%+RSizeFile%+1>=MaxFiles% THEN
4060       INK#0,2: PRINT#0,"Maximum number reached on destination directory!":INK#0,White%
4062       RETurn -1
4064     END IF
4066   ELSE
4068     IF LSizedir%+LSizeFile%+1>=MaxFiles% THEN
4070       INK#0,2: PRINT#0,"Maximum number reached on destination directory!":INK#0,White%
4072       RETurn -1
4074     END IF
4076   END IF
4078   Copy1File name$, source$, dest$, filelen$, 0: RETurn 1
4080  ELSE
4082    IF k%=0 THEN
4084      PRINT#0,"File already exists Overwrite (Y/N) ?"
4086      REPeat loopa
4088        a$=INKEY$(-1)
4090        IF a$ INSTR "yYnN" THEN EXIT loopa: END IF
4092      END REPeat loopa
4094      IF a$="y" OR a$="Y" THEN
4096        Copy1File name$, source$, dest$, filelen$, 0: RETurn 1
4098      ELSE
4100        RETurn 0
4102      END IF
4104    ELSE
4106      SELect ON k%
4108        =-9: INK#0,2: PRINT#0,name$&"not copied. Destination is in use":INK#0,White%:RETurn 0
4110        =-11:INK#0,2: PRINT#0,name$&"not copied. Destination drive is full":INK#0,White%:RETurn -1
4112        =-16:INK#0,2: PRINT#0,name$&"not copied. Destination Bad or Changed Medium":INK#0,White%:RETurn -1
4114        =-20:INK#0,2: PRINT#0,name$&"not copied. Destination is Read Only! ":INK#0,White%: RETurn 0
4116        =REMAINDER : INK#0,2: PRINT#0,name$&"not copied. Error "&k%:INK#0,White%:RETurn 0
4118      END SELect
4120    END IF
4122  END IF
4124 END DEFine CopyAListFile%
4126 :
4128 :
4130 REMark ''-----------------------------------------------------------
4132 DEFine PROCedure DeleteFiles
4134 LOCal source$, name$, panel%, x%, k%, a$, ch%,ch1%, Index%,left%,windef$,hgt%, wid%
4136 IF crtPanel%=7 THEN
4138  source$=leftDir$: name$=GetFNam$(LeftFiles$,LIndex%):panel%=7: Index%=LIndex%
4140 ELSE
4142  source$=rightDir$: name$=GetFNam$(RightFiles$,RIndex%):panel%=8: Index%=RIndex%
4144 END IF
4146 IF IsReadOnly%(source$) THEN
4148  MessageWnd 200,60,2, CHR$(10)&"       Drive is Read Only! "
4150  RETurn
4152 END IF
4154 x%=CountSelected%
4156 IF x%>0 THEN
4158  k%=DlgWnd%(240,60," Delete Files ", "   Are you sure you want to delete"&CHR$(10)&"     "&x%&" files and directories ?")
4160 ELSE
4162  IF IsDir%=1 THEN
4164    a$="directory "&name$
4166  ELSE
4168    a$="file "&name$
4170  END IF
4172  k%=(39-LEN(a$)) DIV 2: IF k%<0 THEN k%=0
4174  a$="   Are you sure you want to delete"&CHR$(10)&FILL$(" ",k%)&a$
4176  k%=DlgWnd%(240,60," Delete File ",a$)
4178 END IF
4180 IF k%=0 THEN RETurn
4182 IF panelWinWid%*2>602 THEN wid%=600: ELSE wid%=400:END IF
4184 hgt%=panelWinHeight%*8 DIV  10
4186 left%=(maxWinWid%-wid%) DIV 2
4188 windef$="scr_"&wid%&"x"&hgt%&"a"&left%&"x50"
4190 ch%=FOPEN(windef$)
4192 PAPER #ch%,0:INK #ch%,White%
4194 OUTLN #ch%,wid%,hgt%,left%,50:BORDER#ch%,1,2:CLS#ch%
4196 left%=left%+1
4198 windef$="scr_"&(wid%-2)&"x12a"&left%&"x51"
4200 ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
4202 PAPER#ch1%,0: INK#ch1%,White%: CURSOR#ch1%,(wid%-84) DIV 2,0: PRINT#ch1%, " Delete Files "
4204 WINDOW#0,wid%-4, hgt%-16, left%+1, 63:PAPER#0,0: INK#0,White%:CLS#0
4206 IF x%=0 THEN
4208   IF IsDir%=0
4210     PRINT#0, "Deleting file "&source$&name$
4212     DELETE source$&name$
4214   ELSE
4216     IF DeleteDirectory (source$, name$)=0 THEN INK#0,2:PRINT#0, "Could not delete all of "&source$&name$&"_": INK#0,White%
4218   END IF
4220 ELSE
4222   PRINT#0, "Delete Selected list: "&x%&" files and/or directories"
4224   IF crtPanel%=7 THEN
4226     FOR k%=1 TO LSizedir%+LSizeFile%
4228       IF GetFFlg%(LeftFiles$,k%) > 1 THEN
4230         IF GetFFlg%(LeftFiles$,k%)=2 THEN
4232           PRINT#0, "Deleting file "&GetFNam$(LeftFiles$,k%)&" ..."
4234           DELETE source$&GetFNam$(LeftFiles$,k%)
4236         ELSE
4238           IF DeleteDirectory (source$, GetFNam$(LeftFiles$,k%)) =0 THEN INK#0,2:PRINT#0, "Could not delete all of "&source$&GetFNam$(LeftFiles$,k%)&"_": INK#0,White%
4240         END IF
4242       END IF
4244     NEXT k%: END FOR k%
4246   ELSE
4248     FOR k%=1 TO RSizedir%+RSizeFile%
4250       IF GetFFlg%(RightFiles$,k%) > 1 THEN
4252         IF GetFFlg%(RightFiles$,k%)=2 THEN
4254           PRINT#0, "Deleting file "&GetFNam$(RightFiles$,k%)&" ..."
4256           DELETE source$&GetFNam$(RightFiles$,k%)
4258         ELSE
4260           IF DeleteDirectory (source$, GetFNam$(RightFiles$,k%)) THEN INK#0,2:PRINT#0, "Could not delete all of "&source$&GetFNam$(RightFiles$,k%)&"_": INK#0,White%
4262         END IF
4264       END IF
4266     NEXT k%: END FOR k%
4268   END IF
4270 END IF
4272 INK#0,Green%:PRINT#0, "Delete process ended - press any key to close window":INK#0,White%
4274 x%=KEYROW(0):a$=INKEY$(-1)
4276 WINDOW#0,448,12,32,231:
4278 CLOSE#ch1%
4280 OUTLN #ch%,wid%,hgt%,left%-1,50
4282 CLOSE#ch%
4284 IF crtPanel%=7 THEN
4286   ReloadPanel 7, Index%
4288 ELSE
4290   ReloadPanel 8, Index%
4292 END IF
4294 END DEFine DeleteFiles
4296 :
4298 :
4300 REMark ''-----------------------------------------------------------
4302 DEFine PROCedure EXecFile
4304 LOCal filename$, path$, chf%, x%
4306 IF crtPanel%=7 THEN
4308  IF LIndex%>LSizeFile%+LSizedir% THEN RETurn : END IF
4310  filename$=GetFNam$(LeftFiles$,LIndex%)
4312  path$=leftDir$
4314 ELSE
4316  IF RIndex%>RSizeFile%+RSizedir% THEN RETurn : END IF
4318  filename$=GetFNam$(RightFiles$,RIndex%)
4320  path$=rightDir$
4322 END IF
4324 chf%=FOPEN(path$&filename$)
4326 IF chf%<0 THEN
4328   SELect ON chf%
4330    =-7:  MessageWnd 200,60,2, CHR$(10)&"         File Not Found !"
4332    =-9:  MessageWnd 200,60,2, CHR$(10)&"           File in use"
4334    = REMAINDER :  MessageWnd 200,60,2, CHR$(10)& "             Error "&chf%
4336  END SELect
4338  ELSE
4340   CLOSE#chf%
4342   x%=FTYP(\path$&filename$)
4344   IF x%<>1 THEN
4346     MessageWnd 200,60,2, CHR$(10)&"   This is not a EXECable file"
4348   ELSE
4350     EX path$&filename$
4352   END IF
4354 END IF
4356 END DEFine EXecFile
4358 :
4360 :
4362 REMark ''----------------------------------------------------------
4364 DEFine FuNction getKey$(c%)
4366  LOCal k$(2)
4368   CURSEN #c%
4370   k$=INKEY$(c%,-1)
4372   CURDIS #c%
4374   RETurn k$
4376 END DEFine getKey$
4378 :
4380 :
4382 REMark ''----------------------------------------------------------
4384 DEFine PROCedure OnEnter
4386   LOCal ext$(10), path$, a$, x%, i%
4388 :
4390   IF crtPanel%=7 THEN
4392     IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
4394     a$=GetFNam$(LeftFiles$,LIndex%)
4396     path$=leftDir$
4398   ELSE
4400     IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
4402     a$=GetFNam$(RightFiles$,RIndex%)
4404     path$=rightDir$
4406   END IF
4408   IF a$==".." OR IsDir%=1 THEN
4410     IF crtPanel%=7 THEN
4412       OpenSubDir LeftFiles$, LIndex%, 7
4414     ELSE
4416       OpenSubDir RightFiles$, RIndex%, 8
4418     END IF
4420     RETurn
4422   END IF
4424 :
4426   IF FTYP(\path$&a$) =1 THEN
4428     EXecFile
4430     RETurn
4432   END IF
4434 :
4436   REMark ''now get file extension
4438   x% = LEN(a$)
4440   FOR i% = 0 TO x% - 1
4442     IF a$(x% - i%) == "_" THEN EXIT i%
4444   NEXT i%: END FOR i%
4446   IF i%>0 THEN
4448     ext$ = a$(x% - i% TO x%)
4450   ELSE
4452     ext$=""
4454   END IF
4456   ext$ = LOWER$(ext$) : x% = 0
4458 :
4460   IF ext$ = "_bas" THEN x% = 1
4462   IF ext$ = "_cde" OR ext$ = "_code" OR ext$ = "_rext" THEN x% = 2
4464   IF ext$ = "_zip" THEN x% = 3
4466   IF ext$ = "_doc" THEN x% = 4
4468   IF ext$ = "_aba" THEN x% = 5
4470   IF ext$ = "_grf" THEN x% = 6
4472   IF ext$ = "_dbf" THEN x% = 7
4474   IF ext$ = "_ssb" THEN x% = 9
4476   IF a$ = "boot" THEN x% = 1
4478 :
4480   SELect ON x%
4482     = 1:
4484         dbg(path$ & a$) : LoadBasFile(path$ & a$)
4486     = 2:
4488         DoLrespr path$ & a$
4490     = 3:
4492         IF IsZipFile%(path$ & a$) = 1 THEN UnzipFile path$ & a$
4494     = 4:
4496         IF IsQuillDoc%(path$ & a$) = 1 THEN
4498           IF Xchangeprog$ <> ""
4500             ExecXchange path$, path$ & a$
4502           END IF
4504         END IF
4506     = 5:
4508         IF IsAbacusDoc%(path$ & a$) = 1
4510           IF Xchangeprog$ <> ""
4512             ExecXchange path$, path$ & a$
4514           END IF
4516         END IF
4518     = 6:
4520         IF Xchangeprog$ <> ""
4522           ExecXchange path$, path$ & a$
4524         END IF
4526     = 7:
4528         IF IsArchiveDoc%(path$ & a$) = 1
4530           IF Xchangeprog$ <> ""
4532             ExecXchange path$, path$ & a$
4534           END IF
4536         END IF
4538     = 8:
4540         x% = DlgWnd%(240,60," Archive Prg ", "     "&a$&CHR$(10)&"      Open with Xchange Archive ?")
4542         IF x% = 0 THEN RETurn
4544         ExecXchange path$, path$ & a$
4546     = 9:
4548         dbg(path$ & a$) : LoadSsbFile(path$ & a$)
4550   END SELect
4552 END DEFine OnEnter
4554 :
4556 :
4558 REMark ''----------------------------------------------------------
4560 DEFine PROCedure UnzipFile (filename$)
4562 LOCal path$, ch%, ch1%, ch2%
4564 IF crtPanel%=7 THEN
4566   IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
4568   path$=rightDir$
4570 ELSE
4572   IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
4574   path$=leftDir$
4576 END IF
4578 ch%=DlgWnd%(240,60," Unzip File ", "    Are you sure you want to unzip"&CHR$(10)&"     "&filename$&" ?")
4580 IF ch%=0 THEN RETurn
4582 ch%=FOPEN("scr_452x230a30x14")
4584 PAPER #ch%,0:INK #ch%,7
4586 OUTLN #ch%,452,230,30,14:BORDER#ch%,1,2:CLS#ch%
4588 ch1%=FOPEN("scr_452x12a31x14"): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
4590 PAPER#ch1%,0: INK#ch1%,7: AT#ch1%,0,37-(LEN(a$)+5)/2: PRINT#ch1%, "Unzip"&a$
4592 ch2%=FOPEN("scr_448x204a32x26"):PAPER#ch2%,0:INK#ch2%,4
4594 EW ConfigDrv$&"unzip", #ch2%;"-D"&path$&" -o "&filename$
4596 PRINT #ch2%, "Press any key ..."
4598 path$=INKEY$(-1)
4600 CLS#ch1%: CLS#ch2%: CLOSE#ch2%:CLOSE#ch1%
4602 WINDOW#0,488,23,12,233:PAPER#0,0:INK#0,White%
4604 OUTLN #ch%,452,230,30,14
4606 CLOSE#ch%
4608  IF crtPanel%=7 THEN
4610     ReloadPanel 8,RIndex%
4612  ELSE
4614     ReloadPanel 7,LIndex%
4616  END IF
4618 END DEFine UnzipFile
4620 :
4622 :
4624 REMark ''----------------------------------------------------------
4626 DEFine PROCedure ExecXchange(path$, filename$)
4628  LOCal savedDATAD$(36), savedPROGD$(36)
4630   savedDATAD$=DATAD$ : savedPROGD$=PROGD$
4632   DATA_USE path$
4634   PROG_USE Xchangepath$
4636   EX Xchangepath$&Xchangeprog$; filename$
4638   DATA_USE savedDATAD$
4640   PROG_USE savedPROGD$
4642 END DEFine ExecXchange
4644 :
4646 :
4648 REMark ''-----------------------------------------------------------
4650 DEFine PROCedure EditFile(path$, filename$)
4652   LOCal savedDATAD$(36), savedPROGD$(36)
4654   savedDATAD$=DATAD$ : savedPROGD$=PROGD$
4656   DATA_USE path$
4658   PROG_USE EditPath$
4660   EX EditPath$&Editprog$; path$&filename$
4662   DATA_USE savedDATAD$
4664   PROG_USE savedPROGD$
4666 END DEFine EditFile
4668 :
4670 :
4672 REMark ''-----------------------------------------------------------
4674 DEFine PROCedure LoadBasFile(filename$)
4676   LOCal x%
4678   REMark ''QLC_GlobalFilename$ = filename$
4680   SBASIC
4682   COMMAND_LINE
4684   PAUSE 5
4686   TYPE_IN "load " & filename$ & CHR$(10)
4688   TYPE_IN "DLINE 32600to" & CHR$(10)
4690   TYPE_IN "MERGE " & "dos1_qlc_cmd_bas" & CHR$(10)
4692   TYPE_IN "32604   QLC_GlobalFilename$ = '" & filename$ & "'" & CHR$(10) : REMark '' odd '
4694   TYPE_IN "1 REMark &&SSBGEN &&SAVE" & CHR$(10)
4696   TYPE_IN "QLC_INIT" & CHR$(10)
4698   REMark ''type_in "SAVE_O " & filename$ & chr$(10)
4700   TYPE_IN "wtv" & CHR$(10)
4702   AT 2,0 : TYPE_IN "rem CMD: h/W/r/e/x/q/s/l/u" & CHR$(10)
4704   TYPE_IN "ED" & CHR$(10)
4706 END DEFine
4708 :
4710 :
4712 REMark ''-----------------------------------------------------------
4714 DEFine PROCedure LoadSsbFile(filename$)
4716   LOCal ssb_filename$, bas_filename$, i, x$
4718   REMark ''""simplified SSB to BAS conversion - missing support for @Lables and #include, now !!!
4720 :
4722   ssb_filename$ = filename$
4724   bas_filename$ = ssb_filename$(1 TO LEN(ssb_filename$) - 4) & "_bas"
4726 :
4728   ierr = FOP_IN(#10, ssb_filename$)
4730   oerr = FOP_OVER(#11, bas_filename$)
4732   PRINT #11, "1 rem &&SSBGEN"
4734   linenum = 10
4736   REPeat linenum
4738     INPUT #10, in$
4740     IF EOF(#10) THEN EXIT
4742     IF (CHR$(38) & CHR$(38) & "QLCGEN") INSTR in$ THEN EXIT
4744     out$ = in$
4746     IF in$ = "" THEN out$ = ":"
4748     pos = (CHR$(39) & CHR$(39) INSTR in$) : REMark ''or ("##" instr in$) or ("//" instr in$) + odd '
4750     IF pos > 0
4752       IF pos > 1
4754         FOR i = 1 TO pos : IF in$(i) <> " " THEN EXIT : NEXT i
4756         IF i < pos THEN comment$ = ": rem" : ELSE comment$ = "rem " : END IF
4758         out$ = in$(1 TO pos - 1) & comment$
4760       ELSE out$ = "rem "
4762       END IF
4764       out$ = out$ & in$(pos TO)
4766     END IF
4768     PRINT #11, linenum & " " & out$
4770     linenum = linenum + 2
4772   END REPeat
4774   CLOSE #10
4776   CLOSE #11
4778   LoadBasFile(bas_filename$)
4780 END DEFine
4782 :
4784 :
4786 REMark ''----------------------------------------------------------
4788 DEFine PROCedure DoEdit
4790 LOCal path$, a$
4792 IF crtPanel%=7 THEN
4794   IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
4796   a$=GetFNam$(LeftFiles$,LIndex%)
4798   path$=leftDir$
4800 ELSE
4802   IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
4804   a$=GetFNam$(RightFiles$,RIndex%)
4806   path$=rightDir$
4808 END IF
4810 IF IsDir%(path$&a$)=1 THEN RETurn
4812 IF IsQuillDoc%(path$&a$)=1 THEN
4814   IF Xchangeprog$<>"" THEN
4816     ExecXchange path$, path$&a$
4818     RETurn
4820   END IF
4822 ELSE
4824   EditFile path$, a$
4826 END IF
4828 END DEFine DoEdit
4830 :
4832 :
4834 REMark ''-----------------------------------------------------------
4836 DEFine PROCedure DoLrespr (filename$)
4838 LOCal x%
4840 x%=DlgWnd%(240,60," lrespr File ", "    Are you sure you want to lrespr"&CHR$(10)&"     "&filename$&" ?")
4842 IF x%=0 THEN RETurn
4844 COMMAND_LINE
4846 PAUSE 5
4848 TYPE_IN "lrespr "&filename$&CHR$(10)
4850 END DEFine DoLrespr
4852 :
4854 :
4856 REMark ''----------------------------------------------------------
4858 DEFine FuNction IsAbacusDoc%(a$)
4860 LOCal ch%, q$, i%, k%
4862 ch% = FOPEN(a$)
4864 IF ch% <= 0 THEN RETurn 0: END IF
4866 q$=""
4868 FOR i%=1 TO 4
4870  BGET #ch%,k%
4872  q$=q$&CHR$(k%)
4874 NEXT i%: END FOR i%
4876 CLOSE #ch%
4878 IF q$="ABM1" THEN RETurn 1: ELSE RETurn 0: END IF
4880 END DEFine IsAbacusDoc%
4882 :
4884 :
4886 REMark ''-----------------------------------------------------------
4888 DEFine FuNction IsArchiveDoc%(a$)
4890 LOCal ch%, q$, i%, k%
4892 ch% = FOPEN(a$)
4894 IF ch% <= 0 THEN RETurn 0: END IF
4896 q$=""
4898 BGET #ch%\1,k%
4900 FOR i%=1 TO 8
4902  BGET #ch%,k%
4904  q$=q$&CHR$(k%)
4906 NEXT i%: END FOR i%
4908 CLOSE #ch%
4910 IF q$="vrm1dbf0" THEN RETurn 1: ELSE RETurn 0: END IF
4912 END DEFine IsArchiveDoc%
4914 :
4916 :
4918 REMark ''-----------------------------------------------------------
4920 DEFine PROCedure ReloadPanel(panel%, Index%)
4922 LOCal page%, x%
4924 IF panel%=7 THEN
4926   DIM LeftFiles$(MaxFiles%,_fMax%)
4928   LoadDir leftDir$, LeftFiles$,7,LSizedir%, LSizeFile%
4930   IF LEN(leftDir$)=5 THEN
4932     LMinPos%=1
4934   ELSE
4936     LMinPos%=0
4938   END IF
4940   IF Index%<LMinPos% THEN Index%=LMinPos%
4942   IF Index%>LSizedir%+LSizeFile% THEN Index%=LMinPos%
4944   LIndex%=Index%
4946   x%=Index%+(LMinPos%=0)
4948   page%=x% DIV rowno%
4950   IF x% MOD rowno% >0 THEN page%=page%+1: END IF
4952   LStartPos%=(page%-1)*rowno% +LMinPos%
4954   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
4956 ELSE
4958   DIM RightFiles$(MaxFiles%,_fMax%)
4960   LoadDir rightDir$, RightFiles$,8,RSizedir%, RSizeFile%
4962   IF LEN(rightDir$)=5 THEN
4964     RMinPos%=1
4966   ELSE
4968     RMinPos%=0
4970   END IF
4972   IF Index%<RMinPos% THEN Index%=RMinPos%
4974   IF Index%>RSizedir%+RSizeFile% THEN Index%=RMinPos%
4976   RIndex%=Index%
4978   x%=Index%+(RMinPos%=0)
4980   page%=x% DIV rowno%
4982   IF x% MOD rowno% >0 THEN page%=page%+1: END IF
4984   RStartPos%=(page%-1)*rowno% +RMinPos%
4986   ListFiles RightFiles$, RStartPos%, RIndex%, 8
4988 END IF
4990 END DEFine ReloadPanel
4992 :
4994 :
4996 REMark ''-----------------------------------------------------------
4998 DEFine PROCedure SelectAll
5000 LOCal i%
5002 IF crtPanel%=7 THEN
5004   FOR i%=1 TO LSizedir%+LSizeFile%
5006     IF GetFFlg%(LeftFiles$,i%) < 2 THEN PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
5008   END FOR i%
5010   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
5012 ELSE
5014   FOR i%=1 TO RSizedir%+RSizeFile%
5016     IF GetFFlg%(RightFiles$,i%) < 2 THEN PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
5018   END FOR i%
5020   ListFiles RightFiles$, RStartPos%, RIndex%, 8
5022 END IF
5024 END DEFine SelectAll
5026 :
5028 :
5030 REMark ''-----------------------------------------------------------
5032 DEFine PROCedure UnSelectAll
5034 LOCal i%
5036 IF crtPanel%=7 THEN
5038   FOR i%=1 TO LSizedir%+LSizeFile%
5040     IF GetFFlg%(LeftFiles$,i%) > 1 THEN PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
5042   END FOR i%
5044   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
5046 ELSE
5048   FOR i%=1 TO RSizedir%+RSizeFile%
5050     IF GetFFlg%(RightFiles$,i%) > 1 THEN PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
5052   END FOR i%
5054   ListFiles RightFiles$, RStartPos%, RIndex%, 8
5056 END IF
5058 END DEFine UnSelectAll
5060 :
5062 :
5064 REMark ''-----------------------------------------------------------
5066 DEFine PROCedure Set78CharSet
5068 REMark ''On QPC2 the char width gets reset so we have to set it again
5070 IF mainFountBase>0 THEN
5072   IF ClassicFont%=0 THEN
5074     CHAR_USE #leftPanelWin%,mainFountBase,0
5076     CHAR_INC #leftPanelWin%,5,10
5078     CHAR_USE #rightPanelWin%,mainFountBase,0
5080     CHAR_INC #rightPanelWin%,5,10
5082   END IF
5084 END IF
5086 END DEFine Set78CharSet
5088 :
5090 :
5092 REMark ''----------------------------------------------------------
5094 DEFine FuNction TestFount%(fountBase)
5096  LOCal fountMask%,fountMax%,char%,row%
5098   fountMask%=3 : REMark ''*** ------XX
5100   fountMax%=PEEK(fountBase+1)
5102   FOR char%=0 TO fountMax%
5104     FOR row%=0 TO 8
5106       IF PEEK(fountBase+2 + char%*9 + row%) && fountMask% THEN RETurn 2 : REMark ''*** appears to be a FAT fount
5108     END FOR row%
5110   END FOR char%
5112 :
5114   RETurn 1 : REMark ''*** Does not appear to be a FAT fount
5116 :
5118 END DEFine TestFount%
5120 :
5122 :
5124 REMark ''----------------------------------------------------------
5126 REFERENCE fList$(0,0)
5128 DEFine FuNction GetFNam$(fList$,fIndex%)
5130   RETurn fList$(fIndex%,3 TO 2 + STRING%(fList$(fIndex%,1 TO 2)))
5132 END DEFine GetFNam$
5134 :
5136 :
5138 REMark ''----------------------------------------------------------
5140 REFERENCE fList$(0,0)
5142 DEFine FuNction GetFLen(fList$,fIndex%)
5144   RETurn LONGINTEGER(fList$(fIndex%,_fLen% TO _fTyp%-1))
5146 END DEFine GetFLen
5148 :
5150 :
5152 REMark ''-----------------------------------------------------------
5154 REFERENCE fList$(0,0)
5156 DEFine FuNction GetFTyp%(fList$)
5158   RETurn STRING%(fList$(fIndex%,_fTyp% TO _fDat%-1))
5160 END DEFine GetFTyp%
5162 :
5164 :
5166 REMark ''-----------------------------------------------------------
5168 REFERENCE fList$(0,0)
5170 DEFine FuNction GetFDat(fList$,fIndex%)
5172   RETurn LONGINTEGER(fList$(fIndex%,_fDat% TO _fPar%-1))
5174 END DEFine GetFDat
5176 :
5178 :
5180 REMark ''-----------------------------------------------------------
5182 REFERENCE fList$(0,0)
5184 DEFine FuNction GetFPar%(fList$,fIndex%)
5186   RETurn STRING%(fList$(fIndex%,_fPar% TO _fFlg%-1))
5188 END DEFine GetFPar%
5190 :
5192 :
5194 REMark ''-----------------------------------------------------------
5196 REFERENCE fList$(0,0)
5198 DEFine FuNction GetFFlg%(fList$,fIndex%)
5200   RETurn STRING%(fList$(fIndex%,_fFlg% TO _fMax%))
5202 END DEFine GetFFlg%
5204 :
5206 :
5208 REMark ''-----------------------------------------------------------
5210 REFERENCE fList$(0,0)
5212 DEFine PROCedure PutFNam(fList$,fIndex%,newVal$)
5214  LOCal nVLen%
5216   nVLen%=LEN(newVal$)
5218   IF nVLen%>maxFNLen% THEN nVLen%=maxFNLen%
5220   fList$(fIndex%,1 TO 2+nVLen%)=STRING$(newVal$(1 TO nVLen%))
5222 END DEFine PutFNam
5224 :
5226 :
5228 REMark ''-----------------------------------------------------------
5230 REFERENCE fList$(0,0)
5232 DEFine PROCedure PutFLen(fList$,fIndex%,newVal)
5234   fList$(fIndex%,_fLen% TO _fTyp%-1)=LONGINTEGER$(newVal)
5236 END DEFine PutFLen
5238 :
5240 :
5242 REMark ''-----------------------------------------------------------
5244 REFERENCE fList$(0,0)
5246 DEFine PROCedure PutFTyp(fList$,fIndex%,newVal%)
5248   fList$(fIndex%,_fTyp% TO _fDat%-1)=INTEGER$(newVal%)
5250 END DEFine PutFTyp
5252 :
5254 :
5256 REMark ''-----------------------------------------------------------
5258 REFERENCE fList$(0,0)
5260 DEFine PROCedure PutFDat(fList$,fIndex%,newVal)
5262   fList$(fIndex%,_fDat% TO _fPar%-1)=LONGINTEGER$(newVal)
5264 END DEFine PutFDat
5266 :
5268 :
5270 REMark ''-----------------------------------------------------------
5272 REFERENCE fList$(0,0)
5274 DEFine PROCedure PutFPar(fList$,fIndex%,newVal%)
5276   fList$(fIndex%,_fPar% TO _fFlg%-1)=INTEGER$(newVal%)
5278 END DEFine PutFPar
5280 :
5282 :
5284 REMark ''-----------------------------------------------------------
5286 REFERENCE fList$(0,0)
5288 DEFine PROCedure PutFFlg(fList$,fIndex%,newVal%)
5290   fList$(fIndex%,_fFlg% TO _fMax%)=INTEGER$(newVal%)
5292 END DEFine PutFFlg
5294 :
5296 :
5298 REMark ''-----------------------------------------------------------
5300 REFERENCE fList$(0,0),fListDest$(0,0)
5302 DEFine PROCedure CopyRec(fList$,fIndex%,fListDest$,fDestIndex%)
5304   fListDest$(fDestIndex%, 1 TO _fMax%)=fList$(fIndex%, 1 TO _fMax%)
5306 END DEFine CopyRec
5308 :
5310 :
5312 REMark ''-----------------------------------------------------------
5314 DEFine FuNction isBasicRunning
5316   IF BASIC_B%(111)<> 0 THEN
5318     RETurn 0
5320   ELSE
5322     IF BASIC_B%(143) = 0 : RETurn 0 : REMark ''break - Ctrl-Space pressed
5324     IF BASIC_W%(104) = BASIC_W%(146) : RETurn 0 : REMark ''stop occurred
5326     RETurn 1 : REMark ''Program is running
5328   END IF
5330 END DEFine isBasicRunning
5332 :
5334 :
5336 REMark ''-----------------------------------------------------------
5338 DEFine FuNction isBasicProgramLoaded
5340 RETurn BASIC_W%(BASIC_L(16))
5342 END DEFine isBasicProgramLoaded
5344 :
5346 :
5348 REMark ''-----------------------------------------------------------
5350 REFERENCE fList$(0,0),r_StartPos%,r_Index%
5352 DEFine PROCedure MoveTop(fList$, r_StartPos%, r_Index%, ch%)
5354 LOCal top%, x%, size%
5356 IF ch%=7 THEN
5358   r_StartPos%= LMinPos%
5360 ELSE
5362   r_StartPos%=RMinPos%
5364 END IF
5366 r_Index%=r_StartPos%
5368 ListFiles fList$, r_StartPos%, r_Index%, ch%
5370 END DEFine MovePageUp
5372 :
5374 :
5376 REMark ''----------------------------------------------------------
5378 REFERENCE fList$(0,0),r_StartPos%,r_Index%
5380 DEFine PROCedure MoveLast(fList$, r_StartPos%, r_Index%, ch%)
5382 LOCal top%
5384 IF ch%=7 THEN
5386   top%= LMinPos%
5388   r_Index%=LSizeFile%+LSizedir%
5390 ELSE
5392   top%=RMinPos%
5394   r_Index%=RSizeFile%+RSizedir%
5396 END IF
5398 r_StartPos%=r_Index%-19
5400 IF r_StartPos%<top% THEN r_StartPos%=top%
5402 ListFiles fList$, r_StartPos%, r_Index%, ch%
5404 END DEFine MoveLast
5406 :
5408 :
5410 REMark ''-----------------------------------------------------------
5412 DEFine PROCedure LRUNBasic
5414 LOCal i%, a$, path$, ext$
5416 IF crtPanel%=7 THEN
5418   IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
5420   a$=GetFNam$(LeftFiles$,LIndex%)
5422   path$=leftDir$
5424 ELSE
5426   IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
5428   a$=GetFNam$(RightFiles$,RIndex%)
5430   path$=rightDir$
5432 END IF
5434 IF a$==".." OR IsDir%=1 THEN RETurn
5436 REMark ''now get file extension
5438 x%=LEN(a$)
5440 FOR i%=0 TO x%-1
5442 IF a$(x%-i%)=="_" THEN EXIT i%
5444 NEXT i%: END FOR i%
5446 IF i%>0 THEN
5448   ext$=a$(x%-i% TO x%)
5450 ELSE
5452   ext$=""
5454 END IF
5456 ext$=LOWER$(ext$)
5458 IF ext$<>"_bas" AND a$<>"boot" THEN RETurn
5460 IF isBasicRunning=1 THEN
5462   MessageWnd 200,60,2, CHR$(10)&"        BASIC is running"&CHR$(10)&"       Cannot run _bas now!"
5464   RETurn
5466 END IF
5468 IF (isBasicProgramLoaded>0) AND (isBasicProgramEdited=1) THEN
5470   i%=DlgWnd%(240,60," Basic program loaded ", "       A Basic program is loaded"&CHR$(10)&"         Loose any changes made?")
5472   IF i%=0 THEN RETurn
5474 END IF
5476 COMMAND_LINE
5478 PAUSE 5
5480 TYPE_IN CHR$(27)&CHR$(27)&CHR$(27):PAUSE 5
5482 TYPE_IN "LRUN "&path$&a$ & CHR$(10)
5484 END DEFine LRUNBasic
5486 :
5488 :
5490 REMark ''-----------------------------------------------------------
5492 DEFine PROCedure SetPalletteQL
5494 PALETTE_QL 0,0,0,255*256*256,255*256*256,255*256,255*256,255*256*256+255*256+255,255*256*256+255*256+255
5496 END DEFine SetPalletteQL
5498 :
5500 :
5502 REMark ''-----------------------------------------------------------
5504 DEFine FuNction isBasicProgramEdited
5506 IF BASIC_B%(142)=255 THEN
5508    RETurn 1
5510 ELSE
5512    RETurn 0
5514 END IF
5516 END DEFine isBasicProgramEdited
5518 :
5520 :
5522 REMark ''-----------------------------------------------------------
5524 DEFine FuNction CopyFullDir%(name$, source$, dest$, panel%, UpdateWnd%, CheckNoQ%, UpdateList%)
5526 LOCal x%, ch%, loop, d$, fp, newname$, newsource$, newdest$, totrim
5528 IF DirExists%(dest$&name$)=0 THEN
5530   x%=Create1Dir%(name$, dest$&name$,panel%,0,CheckNoQ%, UpdateList%)
5532   IF x%=0 THEN RETurn 0
5534 END IF
5536 PRINT#0, "Copy "&source$&name$&" to "&dest$&name$
5538 WCOPY source$&name$ TO dest$&name$
5540 ch% = FOP_DIR (source$&name$) : REMark ''open channel to directory
5542 IF ch% < 0 THEN RETurn : REMark ''unable to open directory
5544 fp = 14 : REMark ''file position in directory for filename
5546 newsource$=source$&name$: IF newsource$(LEN(newsource$))<>"_" THEN newsource$=newsource$&"_"
5548 newdest$=dest$&name$: IF newdest$(LEN(newdest$))<>"_" THEN newdest$=newdest$&"_"
5550 REPeat loop
5552   BGET #ch%\fp : IF EOF(#ch%) THEN CLOSE #ch% : EXIT loop
5554   GET #ch%,d$ : REMark ''get a directory entry name
5556   IF LEN(d$) > 0 THEN
5558     REMark ''a directory length of 0 may be a deleted file
5560     BGET #ch%\fp-9 : REMark ''file type byte
5562     IF CODE(INKEY$(#ch%)) = 255 THEN
5564       REMark ''this is a subdirectory, so we need to copy this
5566       REMark ''Extract file name and check length
5568       totrim=LEN(newsource$)-4
5570       newname$=d$(totrim TO)
5572       IF LEN(newdest$&newname$)>36 THEN
5574         INK#0,2:PRINT#0,"Directory "&newdest$&newname$&" not created  Name too long":INK#0,White%
5576       ELSE
5578         x%=CopyFullDir%(newname$, newsource$, newdest$, panel%, 0,0,0)
5580       END IF
5582     END IF
5584   END IF
5586   fp = fp + 64
5588 END REPeat loop
5590 RETurn 1
5592 END DEFine CopyFullDir%
5594 :
5596 :
5598 REMark ''-----------------------------------------------------------
5600 DEFine PROCedure CopySingleDir(name$, source$, dest$, panel%)
5602 LOCal ch%, ch1%, i%, x%, a$, Index%,page%, id%, left%,windef$, hgt%, wid%
5604 IF panelWinWid%*2>602 THEN wid%=600: ELSE wid%=400:END IF
5606 hgt%=panelWinHeight%*8 DIV  10
5608 left%=(maxWinWid%-wid%) DIV 2
5610 windef$="scr_"&wid%&"x"&hgt%&"a"&left%&"x50"
5612 ch%=FOPEN(windef$)
5614 PAPER #ch%,0:INK #ch%,White%
5616 OUTLN #ch%,wid%,hgt%,left%,50:BORDER#ch%,1,2:CLS#ch%
5618 left%=left%+1
5620 windef$="scr_"&(wid%-2)&"x12a"&left%&"x51"
5622 ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
5624 PAPER#ch1%,0: INK#ch1%,White%: CURSOR#ch1%,(wid%-90) DIV 2,0: PRINT#ch1%, " Copy Directory "
5626 WINDOW#0,wid%-4, hgt%-16, left%+1, 63:PAPER#0,0: INK#0,White%:CLS#0
5628 PRINT#0, "Copy Directory "&source$&name$&" to "&dest$
5630 res%=CopyFullDir% (name$, source$, dest$, panel%,0,1,0)
5632 INK#0,Green%:PRINT#0, "Copy process ended - press any key to close window":INK#0,White%
5634 x%=KEYROW(0):a$=INKEY$(-1)
5636 WINDOW#0,448,12,32,231:
5638 CLOSE#ch1%
5640 OUTLN #ch%,wid%,hgt%,left%-1,50
5642 CLOSE#ch%
5644 REMark ''if copy OK then Add the dir name to the list in the destination panel and refresh screen
5646 IF res%=1 THEN
5648   IF panel%=8 THEN
5650     res%=Find% (name$,id%,RightFiles$,1,RSizedir%)
5652     IF res%=0 THEN
5654       res%=Insert% (name$,id%, RightFiles$, 1, RSizedir%, RSizeFile%, "0")
5656       RIndex%=id%
5658       id%=id%+(RMinPos%=0)
5660       page%=id% DIV rowno%
5662       IF id% MOD rowno% >0 THEN page%=page%+1: END IF
5664       RStartPos%=(page%-1)*rowno% +RMinPos%
5666       ListFiles RightFiles$, RStartPos%, RIndex%, 8
5668     END IF
5670   ELSE
5672     res%=Find% (name$,id%,LeftFiles$,1,LSizedir%)
5674     IF res%=0 THEN
5676       res%=Insert% (name$,id%, LeftFiles$, 1, LSizedir%, LSizeFile%, "0")
5678       LIndex%=id%
5680       id%=id%+(LMinPos%=0)
5682       page%=id% DIV rowno%
5684       IF id% MOD rowno% >0 THEN page%=page%+1: END IF
5686       LStartPos%=(page%-1)*rowno% +LMinPos%
5688       ListFiles LeftFiles$, LStartPos%, LIndex%, 7
5690     END IF
5692   END IF
5694 END IF
5696 END DEFine CopySingleDir
5698 :
5700 :
5702 REMark ''----------------------------------------------------------
5704 DEFine FuNction DeleteDirectory(source$, name$)
5706 LOCal ch%, loop, d$, newsource$, newname$, fp, totrim, x%
5708 IF name$(LEN(name$))<>"_" THEN name$=name$&"_"
5710 PRINT#0, "Deleting directory "&source$&name$&"..."
5712 WDEL source$&name$
5714 ch% = FOP_DIR (source$&name$) : REMark ''open channel to directory
5716 IF ch% < 0 THEN RETurn : REMark ''unable to open directory
5718 fp = 14 : REMark ''file position in directory for filename
5720 newsource$=source$&name$: IF newsource$(LEN(newsource$))<>"_" THEN newsource$=newsource$&"_"
5722 REPeat loop
5724   BGET #ch%\fp : IF EOF(#ch%) THEN CLOSE #ch% : EXIT loop
5726   GET #ch%,d$ : REMark ''get a directory entry name
5728   IF LEN(d$) > 0 THEN
5730     REMark ''a directory length of 0 may be a deleted file
5732     BGET #ch%\fp-9 : REMark ''file type byte
5734     IF CODE(INKEY$(#ch%)) = 255 THEN
5736       REMark ''this is a subdirectory, so we need to delete this
5738       REMark ''Extract file name and check length
5740       totrim=LEN(newsource$)-4
5742       newname$=d$(totrimto)
5744       x%=DeleteDirectory (newsource$, newname$)
5746     END IF
5748   END IF
5750   fp = fp + 64
5752 END REPeat loop
5754 REMark ''Now check that directory is empty
5756 IF isDirEmpty(source$&name$)=1 THEN
5758   DELETE source$&name$
5760   RETurn 1
5762 ELSE
5764   RETurn 0
5766 END IF
5768 END DEFine DeleteDirectory
5770 :
5772 :
5774 REMark ''----------------------------------------------------------
5776 DEFine FuNction isDirEmpty(DirName$)
5778 LOCal ch%, fp, d$, loop, res%
5780 ch% = FOP_DIR (DirName$) : REMark ''open channel to directory
5782 IF ch% < 0 THEN RETurn 0: REMark ''unable to open directory
5784 res%=1
5786 fp = 14 : REMark ''file position in directory for filename
5788 REPeat loop
5790   BGET #ch%\fp : IF EOF(#ch%) THEN : EXIT loop
5792   GET #ch%,d$ : REMark ''get a directory entry name
5794   IF LEN(d$) > 0 THEN res%=0: EXIT loop: REMark ''if file name >0 then we found a file and we set result to 1
5796   fp = fp + 64
5798 END REPeat loop
5800 CLOSE#ch%
5802 RETurn res%
5804 END DEFine isDirEmpty
5806 :
5808 :
5810 REMark ''----------------------------------------------------------
5812 DEFine PROCedure CompareDirs
5814 LOCal i%, res%
5816 REMark ''Unselect all left files
5818 FOR i%=1 TO LSizedir%+LSizeFile%
5820   IF GetFFlg%(LeftFiles$,i%) > 1 THEN PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
5822 END FOR i%
5824 REMark ''Select all right files
5826 FOR i%=1 TO RSizedir%+RSizeFile%
5828   IF GetFFlg%(RightFiles$,i%) < 2 THEN PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
5830 END FOR i%
5832 REMark ''Parse left directory list and compare it to right
5834 FOR i%= 1 TO LSizedir%
5836   res%=Find% (GetFNam$(LeftFiles$,i%),id%,RightFiles$,1,RSizedir%)
5838   IF res%=0 THEN
5840     PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
5842   ELSE
5844     PutFFlg RightFiles$,id%, GetFFlg%(RightFiles$,id%) ^^2
5846   END IF
5848 NEXT i%: END FOR i%
5850 REMark ''Parse left file list and compare it to right
5852 FOR i%= LSizedir%+1 TO LSizedir%+LSizeFile%
5854   res%=Find% (GetFNam$(LeftFiles$,i%),id%,RightFiles$,RSizedir%+1,RSizedir%+RSizeFile%)
5856   IF res%=0 THEN
5858     PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
5860   ELSE
5862     IF GetFLen(LeftFiles$,i%)=GetFLen(RightFiles$,id%) THEN
5864       PutFFlg RightFiles$,id%, GetFFlg%(RightFiles$,id%) ^^2
5866     ELSE
5868       PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
5870     END IF
5872   END IF
5874 NEXT i%: END FOR i%
5876 REMark ''refresh screen
5878 ListFiles LeftFiles$, LStartPos%, LIndex%, 7
5880 ListFiles RightFiles$, RStartPos%, RIndex%, 8
5882 END DEFine CompareDirs
5884 :
5886 :
5888 REMark ''----------------------------------------------------------
5890 DEFine PROCedure InvertSelection
5892 LOCal i%
5894 IF crtPanel%=7 THEN
5896   FOR i%=1 TO LSizedir%+LSizeFile%
5898     PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
5900   END FOR i%
5902   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
5904 ELSE
5906   FOR i%=1 TO RSizedir%+RSizeFile%
5908     PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
5910   END FOR i%
5912   ListFiles RightFiles$, RStartPos%, RIndex%, 8
5914 END IF
5916 END DEFine InvertSelection
5918 :
5920 :
5922 :
5924 :
32600 REMark &&QLCGEN ShellCommands
32602 DEFine PROCedure QLC_INIT
32604   QLC_GlobalFilename$ = 'dos1_QLC_qlc20x_bas'
32616   XX=RESPR(1024) : LBYTES "dos1_tk_MORE_CODE", XX : CALL XX
32618   XX=RESPR(1538) : LBYTES "dos1_qlc_QLC_CODE", XX : CALL XX
32620   LRESPR "dos1_tk_TURBO_SMS_CODE"
32622 END DEFine
32624 :
32626 DEFine PROCedure r
32628   RUN
32630 END DEFine
32632 DEFine PROCedure e
32634   WTV
32636   PAPER #2,0 : INK #2,4
32638 END DEFine
32640 DEFine PROCedure x
32642   s : QUIT
32644 END DEFine
32646 DEFine PROCedure q
32648   s : QUIT
32650 END DEFine
32652 DEFine PROCedure s
32654   SAVE QLC_GlobalFilename$
32656   PRINT #2, QLC_GlobalFilename$ & " SAVED"
32658 END DEFine
32660 DEFine PROCedure l
32662   LOAD QLC_GlobalFilename$
32664   PRINT #2, QLC_GlobalFilename$ & " LOADED"
32666 END DEFine
32668 DEFine PROCedure w
32670   WMOV
32672 END DEFine
32674 DEFine PROCedure u
32676   REMark DLINE 32600 TO
32678   TYPE_IN "MERGE dos1_qlc_cmd_bas" & CHR$(10)
32680 END DEFine
32682 DEFine PROCedure h
32684   PRINT #0, "CMD: h/W/n/r/e/x/q/s/l/u"
32686 END DEFine
32688 DEFine PROCedure n(i)
32690   IF i = 0 THEN i = 1
32692   TYPE_IN "RENUM 10 TO 32599; 1000, " & i & CHR$(10)
32694 END DEFine
32696 DEFine PROCedure dbginit
32698   OPEN #99, "scr_"
32700   WINDOW #99, 120,16,0,0 : PAPER #99,0 : INK #99,7
32702 END DEFine
32704 DEFine PROCedure dbg(s$)
32706   PAPER #99,7 : INK #99,2 : PRINT #99, s$
32708 END DEFine
32710 DEFine PROCedure dbgstop
32712   STOP
32714 END DEFine
