1 REMark &&SSBGEN &&SAVE
10 :
12 QLC_INIT
14 :
16 KCtrlA = 1
18 KDown = 216
20 KUp = 208
22 KShiftDown = 220
24 KTab = 9
26 KShiftF5 = 250
28 KSpace = 32
30 KShiftUp = 212
32 KEnter = 10
34 KShiftEnter = 254
36 KBackSpace = 194
38 KCtrlUp = 210
40 KCtrlDown = 218
42 KCtrlD = 4
44 KCtrlR = 18
46 KF1 = 232
48 KF2 = 236
50 KF3 = 240
52 KF4 = 244
54 KF5 = 248
56 KF6ShiftF1 = 234
58 KF7ShiftF2 = 238
60 KF8ShiftF3 = 242
62 KF9ShiftF4 = 246
64 KF10ShiftF5 = 250
66 KPlus = 43
68 KMinus = 45
70 KEqual = 61
72 KUnderscore = 95
74 KCtrlI = 92
76 KCtrlW = 23
78 KCtrlX = 24
80 KCtrl1 = 145
82 KCtrl2 = 146
84 KHome = 193
86 KEnd = 201
88 KPageUp = 212
90 KPageDown = 220
92 :
94 :
96 :
98 :
100 REMark ''******************************************
102 REMark ''*        QLX   C O M M A N D E R         *
104 REMark ''*                                        *
106 REMark ''*              version 2.1               *
108 REMark ''*          code date 2023.11.13          *
110 REMark ''*                                        *
112 REMark ''*              Andrei Tenu               *
114 REMark ''*              Martyn Hill               *
116 REMark ''*                7alken                  *
118 REMark ''******************************************
120 :
122 :
124 REMark ''*** QLiberator Directives...
126 REMark ''$$stak=5120
128 :
130 :
132 REMark ''*** TURBO Directives...
134 REMark '' - also comment line 1370! And modify line 3010
136 REMark ''TURBO_locstr "R"
138 REMark ''TURBO_ref
140 REMark ''TURBO_windo 2
142 REMark ''TURBO_optim "B"
144 REMark ''TURBO_model 1
146 REMark ''TURBO_struct "S"
148 REMark ''TURBO_diags "I"
150 REMark ''TURBO_list "YES"
152 REMark ''TURBO_sound "YES"
154 REMark ''TURBO_objdat 64
156 REMark ''TURBO_buffersz 16
158 REMark ''TURBO_objstk 512
160 REMark ''TURBO_taskn "QLC v2.0"
162 REMark ''TURBO_objfil "win1_QLCommander_QLC_exe"
164 REMark ''TURBO_repfil "win1_QLCommander_QLCv20_rpt"
166 :
168 :
170 WHEN ERRor
172   REMark ''CloseProgram
174   PAPER# 1, 7 : INK# 1, 2 : PAPER# 0, 0 : INK# 0, 4 : CLS# 0
176   PRINT# 1, "Error at line: "; ERLIN : REPORT : STOP
178 END WHEN
180 :
182 REMark ''mode 4: paper#0,0:paper#1,0:paper#2,0:border#1,0:cls#1
184 REMark ''window#1,488,220,12,0
186 :
188 REMark ''----------------------------------------------------------
190 REMark ''recompilation QLXC from ssb source
192 DEFine PROCedure c
194   LOCal ssb_fn$, test_fn$
196 :
198   ssb_fn$ = "dos1_QLC_qlc20x_ssb"
200   bas_fn$ = ssb_fn$(1 TO LEN(ssb_fn$) - 4) & "_bas"
202 :
204   PRINT #0, "Compiling SSB to BAS ..."
206   CompileSsb2Bas ssb_fn$, bas_fn$
208 :
210 :
212   TYPE_IN "l" & CHR$(10) : REMark ''reload bas
214   AttachBasFileShell bas_fn$
216   REMark ''print #0, "Attaching QLXC Shell ..."
218   TYPE_IN "r" & CHR$(10) : REMark ''run
220   REMark ''print #0, "Test ..."
222 END DEFine
224 :
226 xc
228 :
230 REMark ''----------------------------------------------------------
232 DEFine PROCedure xc
234 :
236     qlcVer$ = "2.1"
238     REMark ''Make sure that guardian window covers all screen,
240     REMark ''in all resolutions
242     IF VER$="HBA_xx" THEN  : REMark ''FIXME mixworx
244       maxWinWid% = SCR_XLIM
246       maxWinHgt% = SCR_YLIM
248     ELSE
250       maxWinWid%=512
252       maxWinHgt%=256
254       REMark ''make sure we are in monitor mode 4,
256       REMark ''otherwise it will crash
258       WMON
260       MODE 4
262       PAPER# 0, 0 : PAPER# 1, 0 : BORDER# 1, 0
264       CLS# 1 : CLS# 0
266     END IF
268     REMark ''comment next line if compiled with Turbo !
270     PAPER#0,0:BORDER#0,0:PAPER#1,0:BORDER#1,0
272     PAPER#2,0:BORDER#2,0:CLS#0:CLS#1:CLS#2
274     WINDOW#0,maxWinWid%,maxWinHgt%,0,0
276     OUTLN #0,maxWinWid%,maxWinHgt%,0,0,0,0,0
278 :
280 :
282     dbginit
284     readConfig
286     InitialiseVars
288     OpenWindows
290     DrawWindows 1
292     MainLoop
294     CloseProgram
296 :
298     STOP
300 END DEFine
302 :
304 REMark ''----------------------------------------------------------
306 DEFine PROCedure StopWithError(errorMessage$)
308 :
310   BEEP 1390 * 2, 20
312   REMark ''cls #0
314   PRINT #0, errorMessage$
316   PAUSE 50 * 2
318   CloseProgram
320   STOP
322 END DEFine
324 :
326 :
328 REMark ''-----------------------------------------------------------
330 DEFine PROCedure CloseProgram
332   LOCal ch%
334 :
336   FOR ch% = 3 TO 9 : CLOSE# ch% : END FOR ch%
338 :
340   IF headBuff > 0 THEN RECHP(headBuff)
342   IF titleFountBase > 0 THEN RECHP titleFountBase: END IF
344   IF mainFountBase > 0 THEN RECHP mainFountBase: END IF
346   IF comFountBase > 0 THEN RECHP comFountBase: END IF
348 :
350   DATA_USE initialDATAD$
352 :
354   WINDOW# 0, maxWinWid%, maxWinHgt%, 0, 0
356   PAPER# 0,0: INK# 0, White% : CLS# 0
358 :
360   WINDOW# 0, 512, 50, 0, 206
362   BORDER# 0, 1, 1, 7, 0 : CLS# 0
364 :
366   WINDOW# 1, 256, 202, 256, 0
368   BORDER# 1, 1, 1, 7, 0
370   PAPER# 1, 7 : INK# 1, 0 : CLS# 1
372 :
374   WINDOW# 2, 256, 202, 0, 0
376   BORDER# 2, 1, 1, 7, 0
378   PAPER# 2, 2 : INK# 2, 7 : CLS# 2
380 :
382 END DEFine
384 :
386 :
388 REMark ''-----------------------------------------------------------
390 DEFine PROCedure OpenWindows
392   LOCal ch%, titleFountFN$(36), titleFountLen%
394   LOCal mainFountFN$(36), mainFountLen%
396   LOCal comFountFN$(36), comFountLen%
398 :
400   stdFountWid%=6
402 :
404   FOR ch% = 3 TO 9 : OPEN# ch%, con : END FOR ch%
406 :
408   titleFountWid% = stdFountWid%
410   titleFountBase = 0
412   titleFountFN$ = ConfigDrv$ & "bold8_fnt"
414 :
416   IF FTEST(titleFountFN$) = 0
418     titleFountLen% = FLEN(\titleFountFN$)
420     IF titleFountLen% > 0
422       titleFountBase = ALCHP(titleFountLen%)
424       LBYTES titleFountFN$, titleFountBase
426       titleFountWid% = 8
428       CHAR_USE# titleWin%, titleFountBase, 0
430       CSIZE# titleWin%,1,0
432       CHAR_INC# titleWin%, titleFountWid%, 10
434     END IF
436   END IF
438 :
440   mainFountWid% = stdFountWid%
442   mainFountBase = 0
444   mainFountFN$ = ConfigDrv$ & "5Pixel_fnt"
446   IF FTEST(mainFountFN$) = 0
448     mainFountLen% = FLEN(\mainFountFN$)
450     IF mainFountLen% > 0
452       mainFountBase = ALCHP(mainFountLen%)
454       LBYTES mainFountFN$, mainFountBase
456     END IF
458   END IF
460 :
462   SELect ON ClassicFont%
464     = 0:
466       IF mainFountBase>0 THEN
468         mainFountWid% = 5 : mainFountHeight% = 10
470         CHAR_USE# leftPanelWin%, mainFountBase, 0
472         CHAR_INC# leftPanelWin%, mainFountWid%, 10
474         CHAR_USE# rightPanelWin%, mainFountBase, 0
476         CHAR_INC# rightPanelWin%, mainFountWid%, 10
478       ELSE
480         mainFountWid% = 6
482         mainFountHeight% = 10
484         comFountWid% = stdFountWid%
486       END IF
488 :
490     = 1:
492       CSIZE# leftPanelWin%, 0, 0
494       CSIZE# rightPanelWin%, 0, 0
496       mainFountWid% = 6
498       mainFountHeight% = 10
500       comFountWid% = stdFountWid%
502 :
504     = 2:
506       mainFountWid% = 8
508       mainFountHeight% = 20
510       comFountWid% = 8
512       titleFountWid% = 16
514       CSIZE# leftPanelWin%, 1, 1
516       CSIZE# rightPanelWin%, 1, 1
518       CSIZE# titleWin%, 3, 1
520       CSIZE# 4, 1, 1 : CSIZE# 5, 1, 1
522       CSIZE# 6, 1, 1 : CSIZE# 9, 1, 1
524 :
526     = 3:
528       mainFountWid% = 12
530       mainFountHeight% = 20
532       titleFountWid% = 16
534       comFountWid% = 8
536       CSIZE# leftPanelWin%, 2, 1
538       CSIZE# rightPanelWin%, 2, 1
540       CSIZE# titleWin%, 3, 1
542       CSIZE# 4, 2, 1 : CSIZE# 5, 2, 1
544       CSIZE# 6, 2, 1 : CSIZE# 9, 1, 1
546   END SELect
548 :
550   REMark ''comFountWid%=stdFountWid%
552   comFountBase = 0
554   comFountFN$=ConfigDrv$ & "qlc_fnt"
556 :
558   IF FTEST(comFountFN$) = 0
560     comFountLen% = FLEN(\comFountFN$)
562     IF comFountLen% > 0
564       comFountBase = ALCHP(comFountLen%)
566       LBYTES comFountFN$, comFountBase
568       CHAR_USE# comWin%, comFountBase, 0
570     END IF
572   END IF
574 :
576 END DEFine
578 :
580 :
582 REMark ''-----------------------------------------------------------
584 REMark ''reload% = 1 we reload the file lists and draw the windows;
586 REMark ''reload%==0 we do not reload the file lists,
588 REMark ''just redraw the windows
590 DEFine PROCedure DrawWindows (reload%)
592   LOCal left%
594 :
596   IF (linelen% * mainFountWid% + 2) > (maxWinWid% DIV 2)
598     linelen%=((maxWinWid% DIV 2) - 4) DIV mainFountWid%
600   END IF
602   panelWinWid% = linelen% * mainFountWid% + 2
604   comWinWid% = 2 * panelWinWid%
606   left% = (maxWinWid% - 2 * panelWinWid%) DIV 2
608 :
610   REMark ''title line
612   WINDOW# 3, 2 * panelWinWid%, mainFountHeight% + 2, left%, 5
614   BORDER# 3, 1, TitleBorder%
616   PAPER# 3, TitleBorder%, TitleBk%, 1 : CLS#3
618 :
620   PAPER# 3, 0 : INK# 3, 2
622   IF ClassicFont% >= 2
624     CSIZE# titleWin%, 3, 1
626   ELSE
628     CSIZE# titleWin%, 1, 0
630   END IF
632   CHAR_INC# titleWin%, titleFountWid%, 10
634 :
636 :
638   REMark ''FIXME long lines, use vars here !!!!!!
640   BLOCK# 3, titleFountWid% * 14, mainFountHeight%, (2 * panelWinWid% - 4 - 14 * titleFountWid%) DIV 2, 0, 0
642   CURSOR# 3, (2 * panelWinWid% - 4 - 14 * titleFountWid%) DIV 2, 0
644   PRINT# 3, " QLX COMMANDER "
646 :
648   REMark ''Drive line
650   WINDOW# 4, 2 * panelWinWid%, mainFountHeight% + 2, left%,mainFountHeight% + 7
652   PAPER# 4, brd% : INK# 4, 0 : BORDER# 4, 1, brd% : CLS# 4
654   AT# 4, 0, 0 : INK# 4, 2 : PRINT# 4, "D"
656   AT# 4, 0, 1 : INK# 4, 0 : PRINT# 4,"ir"
658   CURSOR# 4, panelWinWid%, 0 : PRINT# 4, "Di"
660   INK# 4, 2 : CURSOR# 4, panelWinWid% + mainFountWid% * 2, 0 : PRINT#4,"r"
662 :
664   REMark ''left dir
666   WINDOW# 5, panelWinWid% - 4 * mainFountWid%, mainFountHeight%, left% + 4 * mainFountWid% - 2, mainFountHeight% + 8
668   PAPER# 5, White% : INK# 5, 0 : BORDER# 5, 0 : CLS# 5
670   PRINT# 5, leftDir$
672 :
674   REMark ''right dir
676   WINDOW# 6, panelWinWid% - 4 * mainFountWid%, mainFountHeight%, left% + panelWinWid% + 4 * mainFountWid% - 2, mainFountHeight% + 8
678   PAPER# 6, White% : INK# 6, 0 : BORDER# 6, 0 : CLS# 6
680   PRINT# 6, rightDir$
682 :
684   panelWinHeight% = rowno% * mainFountHeight% + 3
686   IF panelWinHeight% + 3 * mainFountHeight% + 19 > maxWinHgt%
688     rowno% = (maxWinHgt% - 3 * mainFountHeight% - 22) DIV mainFountHeight%
690     panelWinHeight% = rowno% * mainFountHeight% + 3
692   END IF
694 :
696   REMark ''left file panel
698   WINDOW# 7, panelWinWid%, panelWinHeight%, left%, 2 * mainFountHeight% + 9
700   PAPER# 7, ppr% : INK# 7, ik% : BORDER# 7, 1, brd% : CLS# 7
702 :
704   REMark ''Right file panel
706   WINDOW# 8, panelWinWid%, panelWinHeight%, panelWinWid% + left%, 2 * mainFountHeight% + 9
708   PAPER# 8, ppr% : INK# 8, ik% : BORDER# 8, 1, brd% : CLS# 8
710 :
712   REMark ''Commands line
714   WINDOW# 9, 2 * panelWinWid%, mainFountHeight% + 2, left%, panelWinHeight% + 3 * mainFountHeight% + 7
716   PAPER# 9, brd% : INK# 9, White% : BORDER# 9, 1, brd% : CLS# 9
718 :
720   WriteCommands comWin%
722 :
724   crtPanel% = leftPanelWin%
726   IF reload% = 1
728     LShowLeftDir
730     LShowRightDir
732   ELSE
734     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
736     ListFiles RightFiles$, RStartPos%, RIndex%, 8
738   END IF
740 END DEFine
742 :
744 :
746 REMark ''-----------------------------------------------------------
748 DEFine PROCedure readConfig
750   LOCal a$(42), Chan%
752 :
754   ConfigDrv$ = OPTION_CMD$ : REMark ''CMD$
756   IF ConfigDrv$ = "" THEN ConfigDrv$ = "dos1_qlc_"
758   a$ = ConfigDrv$ & "qlc20_cfg"
760   Chan% = FOP_IN(a$)
762   IF Chan% > 0
764     INPUT# Chan%, MaxFiles%
766     INPUT# Chan%, TempDir$
768     INPUT# Chan%, leftDir$
770     INPUT# Chan%, rightDir$
772     INPUT# Chan%, Qubide%
774     INPUT# Chan%, ClassicFont%
776     INPUT# Chan%, linelen%
778     INPUT# Chan%, rowno%
780     INPUT# Chan%, Xchangepath$
782     INPUT# Chan%, Xchangeprog$
784     INPUT# Chan%, EditPath$
786     INPUT# Chan%, Editprog$
788     INPUT# Chan%, QLColors%
790     CLOSE# Chan%
792   ELSE
794     CLS
796     PRINT "Config file not found - using default values ! "
798     MaxFiles% = 256
800     TempDir$ = "win1_temp_"
802     leftDir$ = "win1_"
804     rightDir$ = "win1_"
806     Qubide% = 0
808     ClassicFont% = 1
810     linelen% = 40
812     rowno% = 20
814     Xchangepath$ = ""
816     Xchangeprog$ = ""
818     EditPath$ = ""
820     Editprog$ = ""
822     QLColors = 1
824     PAUSE 100
826     CLS
828   END IF
830   IF RMODE <= 8 OR QLColors% = 1
832     IF VER$ = "HBA" AND RMODE > 4
834       COLOUR_QL:SetPalletteQL
836     END IF
838     ppr% = 0 : brd% = 4 : ik% = 7 : strp% = 7 : White% = 7
840     Green% = 4 : PPR9a% = 2 : ppr9b% = 0 : TitleBorder% = 4
842     TitleBk% = 0
844   ELSE
846     COLOUR_PAL
848     ppr% = 4 : brd% = 13 : ik% = 1 : strp% = 13 : White% = 1
850     Green% = 3 : PPR9a% = 72 : ppr9b% = 76
852     TitleBorder% = 13 : TitleBk% = 4
854   END IF
856   IF maxWinHgt% = 256 AND ClassicFont% > 1
858     ClassicFont% = 1
860   END IF
862 END DEFine
864 :
866 :
868 REMark ''------------------------------------------------------------
870 DEFine PROCedure InitialiseVars
872   titleWin% = 3 : leftPanelWin% = 7 : rightPanelWin% = 8
874   comWin% = 9
876   LSizedir% = 0 : LSizeFile% = 0
878   crtPanel% = leftPanelWin%
880   RSizedir% = 0 : RSizeFile% = 0
882 :
884   maxFNLen%=36
886 :
888   _fLen% = maxFNLen% + 3 : _fTyp% = maxFNLen% + 7
890   _fDat% = maxFNLen% + 9 : _fPar% = maxFNLen% + 13
892   _fFlg% = maxFNLen% + 15 : _fMax% = maxFNLen% + 16
894 :
896   _dPar% = maxFNLen% + 3 : _dNxt% = maxFNLen% + 5
898   _dChd% = maxFNLen% + 7 : _dFlg% = maxFNLen% + 9
900   _dMax% = maxFNLen% + 10
902 :
904   DIM cmdText$(9,9) : REMark ''Used by WriteCommands
906   cmdText$(1) = CHR$(1) & " Info"
908   cmdText$(2) = CHR$(2) & " Comp"
910   cmdText$(3) = CHR$(3) & " View"
912   cmdText$(4) = CHR$(4) & " Edit"
914   cmdText$(5) = CHR$(5) & " Copy"
916   cmdText$(6) = CHR$(6) & " Rename"
918   cmdText$(7) = CHR$(7) & " MkDir"
920   cmdText$(8) = CHR$(8) & " Delete"
922   cmdText$(9) = CHR$(9) & " Exit"
924 :
926   initialDATAD$=DATAD$
928 :
930   headSz% = 64
932   headBuff = ALCHP(headSz%)
934   IF headBuff < 0
936     StopWithError("Cannot allocate memory for File-header Buffer.")
938   END IF
940 :
942 END DEFine
944 :
946 :
948 REMark ''-----------------------------------------------------------
950 DEFine PROCedure LShowLeftDir
952   LOCal i%
954 :
956   REMark ''dim LeftFiles$(MaxFiles%,2,36)
958   DIM LeftFiles$(MaxFiles%, _fMax%)
960 :
962   LoadDir leftDir$, LeftFiles$, 7, LSizedir%, LSizeFile%
964 :
966   IF LEN(leftDir$) = 5
968     LStartPos% = 1
970   ELSE
972     LStartPos% = 0
974   END IF
976   LIndex% = LStartPos%
978   LMinPos% = LStartPos%
980   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
982 END DEFine
984 :
986 :
988 REMark ''-----------------------------------------------------------
990 DEFine PROCedure LShowRightDir
992   LOCal i%
994 :
996   DIM RightFiles$(MaxFiles%, _fMax%)
998 :
1000   RSizedir% = 0 : RSizeFile% = 0
1002   LoadDir rightDir$, RightFiles$, 8, RSizedir%, RSizeFile%
1004   IF LEN(rightDir$) = 5
1006     RStartPos% = 1
1008   ELSE
1010     RStartPos% = 0
1012   END IF
1014   RIndex% = RStartPos%
1016   RMinPos% = RStartPos%
1018   ListFiles RightFiles$, RStartPos%, RIndex%, 8
1020 END DEFine
1022 :
1024 REMark ''-----------------------------------------------------------
1026 REMark ''reference FileList$(0,0,0)
1028 REFERENCE FileList$(0,0)
1030 DEFine PROCedure ListFiles(FileList$, StartPos%, Index%, ch%)
1032   LOCal a$(linelen%), i%, size%, EndPos%
1034   LOCal nochars%, x%, DFlen1%, DFLen2%
1036 :
1038   IF ch% = 7
1040     size% = LSizedir% + LSizeFile%
1042   ELSE
1044     size% = RSizedir% + RSizeFile%
1046   END IF
1048   EndPos% = StartPos% + rowno% - 1
1050   IF EndPos% > size% THEN EndPos% = size% : END IF
1052 :
1054   CLS# ch%
1056   FOR i% = StartPos% TO EndPos%
1058     a$ = GetFNam$(FileList$, i%)
1060     DFlen1% = LEN(a$)
1062     DFLen2% = LEN(GetFLen(FileList$, i%))
1064     IF GetFFlg%(FileList$,i%) MOD 2 = 1
1066       x% = 3
1068       IF DFlen1% > linelen% - x%
1070         a$ = a$(TO linelen% - x% - 2)
1072         a$ = a$ & ".."
1074       END IF
1076       a$ = a$ & " ->"
1078       a$ = a$ & FILL$(" ", linelen% - LEN(a$) - 1)
1080     ELSE
1082       x% = 9
1084       IF DFlen1% > linelen% - x%
1086         a$ = a$(TO linelen% - x% - 2)
1088         a$ = a$ & ".."
1090       END IF
1092       REMark ''FIXME long line
1094       a$ = a$ & FILL$(" ", linelen% - LEN(a$) - DFLen2% - 1) & GetFLen(FileList$,i%)
1096     END IF
1098 :
1100     INK# ch%, ik%
1102     IF i% = Index%
1104       IF crtPanel% = ch%
1106         STRIP# ch%, strp%
1108         IF GetFFlg%(FileList$, i%) > 1
1110           INK# ch%, 2
1112         ELSE
1114           INK# ch%, ppr%
1116         END IF
1118         PRINT# ch%, a$
1120         STRIP# ch%, ppr%
1122       ELSE
1124         PRINT# ch%, a$
1126       END IF
1128     ELSE
1130       IF GetFFlg%(FileList$, i%) > 1
1132         INK# ch%, 2
1134       ELSE
1136         INK# ch%, ik%
1138       END IF
1140       PRINT# ch%, a$
1142     END IF
1144   END FOR i%
1146 END DEFine
1148 :
1150 :
1152 REMark ''-----------------------------------------------------------
1154 DEFine PROCedure MainLoop
1156   LOCal a$, x%, y$
1158 :
1160   REPeat loop
1162     a$ = INKEY$(-1) : x% = CODE(a$) : dbg(x%)
1164 :
1166     SELect ON x%
1168 :
1170       = KCtrlW:
1172           WMOV
1174 :
1176       = KCtrlA:
1178           MessageWnd 216, 60, 3, "        QL COMMANDER v" & qlcVer$ & CHR$(10) & " Andrei Tenu & Martyn Hill - 2019" & CHR$(10) & "    GNU General Public License"
1180 :
1182       = KDown:
1184           IF crtPanel% = 7
1186             MoveDown LeftFiles$, LMinPos%, LIndex%, LStartPos%, LSizeFile%, LSizedir%
1188           ELSE
1190             MoveDown RightFiles$, RMinPos%, RIndex%, RStartPos%, RSizeFile%, RSizedir%
1192           END IF
1194 :
1196       = KUp:
1198           IF crtPanel% = 7
1200             MoveUp LeftFiles$, LMinPos%, LIndex%, LStartPos%, LSizeFile%, LSizedir%
1202           ELSE
1204             MoveUp RightFiles$, RMinPos%, RIndex%, RStartPos%, RSizeFile%, RSizedir%
1206           END IF
1208 :
1210       = KPageDown, KShiftDown:
1212           IF crtPanel% = 7
1214             MovePageDown LeftFiles$, LStartPos%, LIndex%, 7
1216           ELSE
1218             MovePageDown RightFiles$, RStartPos%, RIndex%, 8
1220           END IF
1222 :
1224       = KTab:
1226           ChangePanel
1228 :
1230       = KCtrlX, KF10ShiftF5:
1232           RETurn
1234 :
1236       = KSpace:
1238           SelectFile
1240 :
1242       = KPageUp, KShiftUp:
1244           IF crtPanel% = 7
1246             MovePageUp LeftFiles$, LStartPos%, LIndex%, 7
1248           ELSE
1250             MovePageUp RightFiles$, RStartPos%, RIndex%, 8
1252           END IF
1254 :
1256       = KEnter:
1258           OnEnter
1260 :
1262       = KShiftEnter:
1264           LRUNBasic
1266 :
1268       = KBackSpace
1270         IF crtPanel% = 7
1272           MoveTop LeftFiles$, LStartPos%, LIndex%, 7
1274           IF GetFNam$(LeftFiles$, LIndex%) = ".."
1276             OnEnter
1278           ELSE
1280             BEEP 1390, 20
1282           END IF
1284         ELSE
1286           MoveTop RightFiles$, RStartPos%, RIndex%, 8
1288           IF GetFNam$(RightFiles$,RIndex%) = ".."
1290             OnEnter
1292           ELSE
1294             BEEP 1390, 20
1296           END IF
1298         END IF
1300 :
1302       = KHome, KCtrlUp:
1304           IF crtPanel% = 7
1306             MoveTop LeftFiles$, LStartPos%, LIndex%, 7
1308           ELSE
1310             MoveTop RightFiles$, RStartPos%, RIndex%, 8
1312           END IF
1314 :
1316       = KEnd, KCtrlDown:
1318           IF crtPanel% = 7
1320             MoveLast LeftFiles$, LStartPos%, LIndex%, 7
1322           ELSE
1324             MoveLast RightFiles$, RStartPos%, RIndex%, 8
1326           END IF
1328 :
1330       = KCtrl1, KCtrlD:
1332           InputDir 5
1334 :
1336       = KCtrl2, KCtrlR:
1338           InputDir 6
1340 :
1342       = KF3:
1344           ViewFile
1346 :
1348       = KF5:
1350           CopyFiles
1352 :
1354       = KF4:
1356           DoEdit
1358 :
1360       = KF6ShiftF1:
1362           RenameFile
1364 :
1366       = KF8ShiftF3:
1368           DeleteFiles
1370 :
1372       = KF1:
1374           ShowInfo
1376 :
1378       = KF7ShiftF2:
1380           CreateDir
1382 :
1384       REMark ''Find next matching File/Dir starting with a$
1386       =65  TO  90: JumpTo x%, 1
1388       =160 TO 171: JumpTo x%, 1
1390       =97  TO 122: JumpTo x%, 2
1392       =128 TO 139: JumpTo x%, 2
1394       =48  TO  57: JumpTo x%, 0
1396 :
1398       = KPlus, KEqual:
1400           SelectAll
1402 :
1404       = KMinus, KUnderscore:
1406           UnSelectAll
1408 :
1410       = KF9ShiftF4:
1412           DrawWindows 0
1414 :
1416       = KF8ShiftF3:
1418           CompareDirs
1420 :
1422       = KCtrlI:
1424           InvertSelection
1426     END SELect
1428   END REPeat loop
1430 END DEFine
1432 :
1434 :
1436 REMark ''-----------------------------------------------------------
1438 REMark ''a% = code of char to find
1440 REMark ''what%=2 looking for file; =1 looking for dir; =0 looking for dir or file
1442 REMark ''search returns index of item that starts with a$, or first next item if a$ is not found, or last item in list if all existing items start with chars<a$
1444 DEFine FuNction FindFirst% (a%,what%)
1446   LOCal i%, istart%, iend%, found%
1448 :
1450   found%=0
1452 :
1454   IF crtPanel% = 7
1456 :
1458     IF what% < 2
1460       istart% = 1
1462     ELSE
1464       istart% = LSizedir% + 1
1466     END IF
1468 :
1470     IF what% = 1
1472       iend% = LSizedir%
1474     ELSE
1476       iend% = LSizedir% + LSizeFile%
1478     END IF
1480 :
1482     IF istart% > iend% THEN RETurn LIndex% : END IF
1484 :
1486     IF what% > 0
1488       FOR i% = istart% TO iend%
1490         IF CODE(GetFNam$(LeftFiles$, i%)) >= a%
1492           found% = 1 : EXIT i%
1494         END IF
1496         NEXT i%
1498       END FOR i%
1500     ELSE
1502       FOR i% = LIndex% + 1 TO iend%
1504         IF CODE(GetFNam$(LeftFiles$, i%)) = a%
1506           found% = 1 : EXIT i%
1508         END IF
1510         NEXT i%
1512       END FOR i%
1514       IF found% = 0
1516         FOR i% = istart% TO LIndex%
1518           IF CODE(GetFNam$(LeftFiles$, i%)) = a%
1520             found% = 1 : EXIT i%
1522           END IF
1524           NEXT i%
1526         END FOR i%
1528       END IF
1530       IF found% = 0 THEN i% = istart% : END IF
1532     END IF
1534 :
1536     IF i% <= iend% THEN RETurn i% : ELSE RETurn iend% : END IF
1538 :
1540   ELSE
1542 :
1544     IF what% < 2
1546       istart% = 1
1548     ELSE
1550       istart% = RSizedir% + 1
1552     END IF
1554 :
1556     IF what% = 1
1558       iend% = RSizedir%
1560     ELSE
1562       iend% = RSizedir% + RSizeFile%
1564     END IF
1566 :
1568     IF istart% > iend% THEN RETurn RIndex% : END IF
1570 :
1572     IF what% > 0
1574       FOR i% = istart% TO iend%
1576         IF CODE(GetFNam$(RightFiles$, i%)) >= a%
1578           EXIT i%
1580         END IF
1582         NEXT i%
1584       END FOR i%
1586     ELSE
1588       FOR i% = RIndex% + 1 TO iend%
1590         IF CODE(GetFNam$(RightFiles$, i%)) = a%
1592           found%=1 : EXIT i%
1594         END IF
1596         NEXT i%
1598       END FOR i%
1600       IF found% = 0
1602         FOR i% = istart% TO RIndex%
1604           IF CODE(GetFNam$(RightFiles$, i%)) = a%
1606             found% = 1: EXIT i%
1608           END IF
1610           NEXT i%
1612         END FOR i%
1614       END IF
1616       IF found% = 0 THEN i% = istart% : END IF
1618     END IF
1620 :
1622     IF i% <= iend% THEN RETurn i% : ELSE RETurn iend% : END IF
1624 :
1626   END IF
1628 :
1630 END DEFine
1632 :
1634 :
1636 REMark ''-----------------------------------------------------------
1638 DEFine PROCedure JumpTo (a%,what%)
1640   LOCal x%, start%
1642 :
1644   IF crtPanel% = 7 THEN
1646     IF LSizedir% + LSizeFile% = 0 THEN RETurn : END IF
1648   ELSE
1650     IF RSizedir% + RSizeFile% = 0 THEN RETurn : END IF
1652   END IF
1654 :
1656   x% = FindFirst%(a%, what%)
1658 :
1660   IF crtPanel% = 7 THEN
1662     IF x% = LIndex% THEN RETurn : END IF
1664     IF (x% >= LStartPos%) AND (x% < LStartPos% + 20)
1666       ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 0
1668       LIndex% = x%
1670       ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 1
1672     ELSE
1674       LIndex% = x%
1676       x% = x% + (LMinPos% = 0)
1678       page% = x% DIV rowno%
1680       IF x% MOD rowno% > 0 THEN page% = page% + 1 : END IF
1682       LStartPos% = (page% - 1) * rowno% + LMinPos%
1684       ListFiles LeftFiles$, LStartPos%, LIndex%, 7
1686     END IF
1688   ELSE
1690     IF x% = RIndex% THEN RETurn : END IF
1692     IF x% >= RStartPos% AND x% < RStartPos% + rowno%
1694       ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 0
1696       RIndex% = x%
1698       ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 1
1700     ELSE
1702       RIndex% = x%
1704       x% = x% + (RMinPos% = 0)
1706       page% = x% DIV rowno%
1708       IF x% MOD rowno% > 0 THEN page% = page% + 1 : END IF
1710       RStartPos% = (page% - 1) * rowno% + RMinPos%
1712       ListFiles RightFiles$, RStartPos%, RIndex%, 8
1714     END IF
1716   END IF
1718 END DEFine
1720 :
1722 :
1724 REMark ''-----------------------------------------------------------
1726 REMark ''String Quick Search & Insert
1728 REMark ''(c)tcat, 2017 Tomas Kral
1730 REMark ''modified by Andrei Tenu 2018
1732 :
1734  REMark ''FileLis$ = name of array to load into
1736  REMark ''no% = start index
1738  REMark ''    = 0 if we add a dir to root; 1 if add a dir in a directory; SizeDir%+1 if we add a file
1740  REMark ''Quick search returns:
1742  REMark ''0=not found, 1=found, id%=position
1744 :
1746 REMark ''reference FileList$(0,0,0),id%
1748 REFERENCE FileList$(0, 0), id%
1750 DEFine FuNction Find%(str$, id%, FileList$, no%, size%)
1752   LOCal top%, bot%, mid%, nextFNam$(maxFNLen%)
1754 :
1756   top% = no% : bot% = size%
1758 :
1760   REPeat find_loop
1762     mid% = (bot% + top%) DIV 2 : nextFNam$ = GetFNam$(FileList$, mid%)
1764 :
1766     IF top% > bot% THEN
1768      id% = mid% + 1 : RETurn 0
1770     ELSE IF str$ = nextFNam$ THEN
1772      id% = mid% : RETurn 1
1774     ELSE IF str$ > nextFNam$ THEN
1776      top% = mid% + 1
1778     ELSE IF str$ < nextFNam$ THEN
1780      bot% = mid% - 1
1782     END IF : END IF : END IF : END IF
1784   END REPeat find_loop
1786 END DEFine
1788 :
1790 :
1792 REMark ''-----------------------------------------------------------
1794  REMark ''Inserts String at position id%
1796  REMark ''Returns 2=ok, -1=array full
1798 :
1800 REMark ''reference FileList$(0,0,0),r_SizeDir%, r_SizeFile%
1802 REFERENCE FileList$(0,0), r_SizeDir%, r_SizeFile%
1804 DEFine FuNction Insert% (str$, id%, FileList$, DoF%, r_SizeDir%, r_SizeFile%, fLength$)
1806   LOCal i%, size%
1808 :
1810   size% = r_SizeDir% + r_SizeFile%
1812   IF size% >= MaxFiles% THEN RETurn -1
1814   FOR i% = size% TO id% STEP -1
1816     CopyRec FileList$, i% TO FileList$, i%+1
1818   END FOR i%
1820 :
1822   PutFNam FileList$, id%, str$
1824   PutFLen FileList$, id%, fLength$
1826   PutFFlg FileList$, id%, DoF%
1828 :
1830   IF DoF% = 1
1832     r_SizeDir% = r_SizeDir% + 1
1834   ELSE
1836     r_SizeFile% = r_SizeFile% + 1
1838   END IF
1840 :
1842   RETurn 2
1844 END DEFine
1846 :
1848 :
1850 REMark ''End of String Quick Search & Insert -----------------------
1852 :
1854 :
1856 REMark ''-----------------------------------------------------------
1858 REMark ''reference dev$(0),FileList$(0,0,0),r_SizeDir%,r_SizeFile%
1860 REFERENCE dev$(0), FileList$(0,0), r_SizeDir%, r_SizeFile%
1862 DEFine PROCedure LoadDir (dev$, FileList$, Chan%, r_SizeDir%, r_SizeFile%)
1864   LOCal ch%, i, head_start, totrim, flength, file$, ftype
1866   LOCal size2%, res, DirOrFile%, id%, filelen$,k$, no_files
1868 :
1870  CLS# Chan% : INK# Chan%, 7
1872  PRINT# Chan%, "...Loading File List ..."
1874 :
1876  IF dev$(LEN(dev$)) <> "_" THEN dev$ = dev$ & "_"
1878 :
1880  IF Chan% = 7 THEN PRINT# 5, dev$ : ELSE PRINT# 6, dev$: END IF
1882 :
1884  IF DirExists%(dev$) = 0
1886    BEEP 1390, 100
1888    PRINT# Chan%, "Cannot open directory " & dev$
1890    RETurn
1892  END IF
1894 :
1896  r_SizeDir% = 0 : r_SizeFile% = 0
1898  totrim = LEN(dev$) - 4
1900  IF totrim <= 0 THEN totrim = 1 : END IF
1902 :
1904  PutFNam FileList$, 0, ".."
1906  PutFLen FileList$, 0, 0
1908  PutFFlg FileList$, 0, 1
1910 :
1912  head_start = 0
1914  i = 1
1916  ch% = FOP_DIR(dev$)
1918  no_files = FLEN(#ch%) / 64
1920  FOR listing = 1 TO no_files
1922    SET_POSITION #ch%, head_start + 0
1924    flength = LONGINTEGER(INPUT$(#ch%, 4)) - 64
1926    faccess = CODE(INKEY$(#ch%)) : ftype = CODE(INKEY$(#ch%))
1928    IF flength >= 0 THEN
1930      SET_POSITION #ch%, head_start + 14
1932      file$ = GET$(#ch%)
1934      IF LEN(file$) > 0
1936        file$ = file$(totrim TO)
1938        filelen$ = flength
1940        SET_POSITION #ch%, head_start + 52
1942        fdate = LONGINTEGER(INPUT$(#ch%, 4))
1944        IF ftype < 255
1946          size2% = r_SizeDir% + r_SizeFile%
1948          file$ = LOWER$(file$)
1950          res = Find%(file$,id%, FileList$, r_SizeDir% + 1, size2%)
1952          DirOrFile% = 0
1954        ELSE
1956          file$ = UPPER$(file$)
1958          res = Find%(file$, id%, FileList$, 1, r_SizeDir%)
1960          DirOrFile% = 1
1962        END IF
1964        i = i + 1
1966    REMark ''k$="":
1968    REMark ''if flength>1023 then
1970    REMark '' flength=INT(flength/1024+.5):k$="K"
1972    REMark '' if flength>1023 then
1974    REMark ''   flength=INT(flength/1024+.5):k$="M"
1976    REMark '' endif
1978    REMark ''endif
1980    REMark ''filelen$=flength&k$
1982        IF res = 0
1984          res = Insert%(file$, id%, FileList$, DirOrFile%, r_SizeDir%, r_SizeFile%, filelen$)
1986        END IF
1988        IF res = -1 : EXIT listing : END IF
1990      END IF
1992    END IF
1994    head_start = head_start + 64
1996  END FOR listing
1998  CLOSE# ch%
2000 END DEFine
2002 :
2004 :
2006 REMark ''-----------------------------------------------------------
2008 REMark ''reference FileList$(0,0,0),r_Index%,r_StartPos%
2010 REFERENCE FileList$(0, 0), r_Index%, r_StartPos%
2012 DEFine PROCedure MoveDown(FileList$, MinPos%, r_Index%, r_StartPos%, SizeFile%, SizeDir%)
2014   LOCal size%, idx%
2016 :
2018   size% = SizeFile% + SizeDir%
2020   IF r_Index% > size% THEN RETurn
2022   ShowHideCursor r_Index% - r_StartPos%, r_Index%, FileList$, 0
2024   r_Index% = r_Index% + 1
2026   IF r_Index%>size% THEN : r_Index% = size% : END IF
2028   IF r_Index% > r_StartPos% + rowno% - 1 THEN
2030     SCROLL# crtPanel%, - mainFountHeight%
2032     r_StartPos% = r_StartPos% + 1
2034   END IF
2036   ShowHideCursor r_Index%-r_StartPos%, r_Index%,  FileList$, 1
2038 END DEFine MoveDown
2040 :
2042 :
2044 REMark ''-----------------------------------------------------------
2046 REMark ''reference FileList$(0,0,0),r_Index%,r_StartPos%
2048 REFERENCE FileList$(0, 0), r_Index%, r_StartPos%
2050 DEFine PROCedure MoveUp(FileList$, MinPos%, r_Index%, r_StartPos%, SizeFile%, SizeDir%)
2052   LOCal size%, idx%
2054 :
2056   size% = SizeFile% + SizeDir%
2058   IF r_Index% > size%  THEN RETurn
2060   ShowHideCursor r_Index% - r_StartPos%, r_Index%, FileList$, 0
2062   r_Index% = r_Index% - 1
2064   IF r_Index%<MinPos% THEN : r_Index% = MinPos% : END IF
2066   IF r_Index% < r_StartPos%
2068     SCROLL# crtPanel%, mainFountHeight%
2070     r_StartPos% = r_StartPos% - 1
2072   END IF
2074   ShowHideCursor r_Index% - r_StartPos%, r_Index%, FileList$, 1
2076 END DEFine MoveDown
2078 :
2080 :
2082 REMark ''-----------------------------------------------------------
2084 REMark ''reference FileList$(0,0,0)
2086 REFERENCE FileList$(0, 0)
2088 DEFine PROCedure ShowHideCursor(Linepos%, Index%, FileList$, SoH%)
2090   LOCal a$, x%, DFlen1%, DFLen2%
2092 :
2094   a$ = GetFNam$(FileList$, Index%)
2096   DFlen1% = LEN(a$)
2098   DFLen2% = LEN(GetFLen(FileList$, Index%))
2100 :
2102   IF GetFFlg%(FileList$,Index%) MOD 2 = 1 THEN
2104     x% = 3
2106     IF DFlen1%>linelen% - x%
2108       a$ = a$(TO linelen% - x% - 2) : a$ = a$ & ".."
2110     END IF
2112     a$ = a$ & " ->"
2114     a$ = a$ & FILL$(" ", linelen% - LEN(a$) - 1)
2116   ELSE
2118     x% = 9
2120     IF DFlen1% > linelen% - x%
2122       a$ = a$(TO linelen% - x% - 2) : a$ = a$ & ".."
2124     END IF
2126     a$ = a$ & FILL$(" ", linelen% - LEN(a$) - DFLen2% - 1) & GetFLen(FileList$, Index%)
2128   END IF
2130   IF SoH% = 1
2132     STRIP# crtPanel%, strp% : INK# crtPanel%, 0
2134     IF GetFFlg%(FileList$, Index%) > 1
2136       INK# crtPanel%, 2 : ELSE INK# crtPanel%, 0
2138     END IF
2140     AT# crtPanel%, Linepos%, 0 : PRINT# crtPanel%, a$;
2142     STRIP# crtPanel%, ppr% : INK# crtPanel%, ik%
2144   ELSE
2146     IF GetFFlg%(FileList$, Index%) > 1
2148       INK# crtPanel%, 2
2150     ELSE
2152       INK# crtPanel%, ik%
2154     END IF
2156     AT# crtPanel%, Linepos%, 0 : PRINT# crtPanel%, a$;
2158   END IF
2160 END DEFine
2162 :
2164 :
2166 REMark ''-----------------------------------------------------------
2168 DEFine PROCedure ChangePanel
2170 IF crtPanel% = 7
2172   IF LIndex% <= LSizedir% + LSizeFile%
2174     ShowHideCursor LIndex% - LStartPos%, LIndex%, LeftFiles$, 0
2176   END IF
2178   crtPanel% = 8
2180   IF RIndex% <= RSizedir% + RSizeFile%
2182     ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 1
2184   END IF
2186   BORDER# 8, 1, brd% : BORDER# 7, 1, brd%, 1 ,3
2188 ELSE
2190   IF RIndex% <= RSizedir% + RSizeFile%
2192     ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 0
2194   END IF
2196   crtPanel% = 7
2198   IF LIndex% <= LSizedir% + LSizeFile%
2200     ShowHideCursor LIndex% - LStartPos%, LIndex%, LeftFiles$, 1
2202   END IF
2204   BORDER# 7, 1, brd% : BORDER# 8, 1, brd%, 1, 3
2206 END IF
2208 END DEFine
2210 :
2212 :
2214 REMark ''-----------------------------------------------------------
2216 DEFine PROCedure SelectFile
2218   IF crtPanel% = 7
2220     PutFFlg LeftFiles$, LIndex%, GetFFlg%(LeftFiles$, LIndex%) ^^ 2
2222     ShowHideCursor LIndex%-LStartPos%, LIndex%, LeftFiles$, 1
2224   ELSE
2226     PutFFlg RightFiles$, RIndex%, GetFFlg%(RightFiles$, RIndex%) ^^ 2
2228     ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 1
2230   END IF
2232 END DEFine SelectFile
2234 :
2236 :
2238 REMark ''-----------------------------------------------------------
2240 REMark ''reference FileList$(0,0,0),r_StartPos%,r_Index%
2242 REFERENCE FileList$(0, 0), r_StartPos%, r_Index%
2244 DEFine PROCedure MovePageDown(FileList$, r_StartPos%, r_Index%, ch%)
2246   LOCal size%, x%
2248 :
2250   IF ch% = 7
2252     size% = LSizedir% + LSizeFile%
2254   ELSE
2256     size% = RSizedir% + RSizeFile%
2258   END IF
2260   IF r_Index%>size% THEN RETurn : END IF
2262   x% = r_StartPos% + 20
2264   IF x% > size% THEN RETurn
2266   r_StartPos% = x%
2268   r_Index% = r_StartPos%
2270   ListFiles FileList$, r_StartPos%, r_Index%, ch%
2272 END DEFine
2274 :
2276 :
2278 REMark ''-----------------------------------------------------------
2280 REMark ''reference FileList$(0,0,0),r_StartPos%,r_Index%
2282 REFERENCE FileList$(0, 0), r_StartPos%, r_Index%
2284 DEFine PROCedure MovePageUp(FileList$, r_StartPos%, r_Index%, ch%)
2286   LOCal top%, x%, size%
2288   IF ch% = 7
2290     top% = LMinPos%
2292     size% = LSizeFile% + LSizedir%
2294   ELSE
2296     top% = RMinPos%
2298     size% = RSizeFile% + RSizedir%
2300   END IF
2302   IF r_Index%>size% THEN RETurn : END IF
2304   x% = r_StartPos% - 20
2306   IF x% < top% THEN x% = top% : END IF
2308   r_StartPos% = x%
2310   r_Index% = r_StartPos%
2312   ListFiles FileList$, r_StartPos%, r_Index%, ch%
2314 END DEFine
2316 :
2318 :
2320 REMark ''-----------------------------------------------------------
2322 REMark ''reference FileList$(0,0,0)
2324 REFERENCE FileList$(0, 0)
2326 DEFine PROCedure OpenSubDir(FileList$, Index%, ch%)
2328   LOCal a$, size%, d$, x%, page%
2330 :
2332   IF ch% = 7
2334     size% = LSizeFile% + LSizedir%
2336     d$ = leftDir$
2338   ELSE
2340     size% = RSizeFile% + RSizedir%
2342     d$ = rightDir$
2344   END IF
2346   IF Index% > size% THEN RETurn : END IF
2348   IF GetFFlg%(FileList$, Index%) MOD 2 <> 1 THEN RETurn : END IF
2350   IF GetFNam$(FileList$, Index%) = ".."
2352     a$ = GetParentDir$(ch%)
2354     IF LEN(d$) > LEN(a$)
2356       d$ = d$(LEN(a$) + 1 TO)
2358       IF d$(LEN(d$)) = "_" THEN d$ = d$(1 TO LEN(d$) - 1):END IF
2360       IF crtPanel% = 7
2362         DIM LeftFiles$(MaxFiles%, _fMax%) : leftDir$ = a$
2364         LoadDir leftDir$, LeftFiles$, 7, LSizedir%, LSizeFile%
2366         IF LEN(leftDir$) = 5 THEN
2368           LMinPos% = 1
2370         ELSE
2372           LMinPos% = 0
2374         END IF
2376         IF Find%(d$, id%, LeftFiles$, 1, LSizedir%) = 1 THEN
2378           LIndex% = id%
2380           x% = id% + (LMinPos% = 0)
2382           page% = x% DIV rowno%
2384           IF x% MOD rowno% > 0 THEN page% = page% + 1 : END IF
2386           LStartPos% = (page% - 1) * rowno% + LMinPos%
2388           ListFiles LeftFiles$, LStartPos%, LIndex%, 7
2390         ELSE
2392          d$ = ""
2394         END IF
2396       ELSE
2398         DIM RightFiles$(MaxFiles%, _fMax%) : rightDir$ = a$
2400         LoadDir rightDir$, RightFiles$, 8, RSizedir%, RSizeFile%
2402         IF LEN(rightDir$) = 5
2404           RMinPos% = 1
2406         ELSE
2408           RMinPos% = 0
2410         END IF
2412         IF Find%(d$, id%, RightFiles$, 1, RSizedir%) = 1
2414           RIndex% = id%
2416           x% = id% + (RMinPos% = 0)
2418           page% = x% DIV rowno%
2420           IF x% MOD rowno% > 0 THEN page% = page% + 1 : END IF
2422           RStartPos% = (page% - 1) * rowno% + RMinPos%
2424           ListFiles RightFiles$, RStartPos%, RIndex%, 8
2426         ELSE
2428           d$ = ""
2430         END IF
2432       END IF
2434     ELSE
2436       d$ = ""
2438     END IF
2440   ELSE
2442     d$ = ""
2444     IF ch% = 7
2446       a$ = leftDir$ & GetFNam$(FileList$, Index%)
2448     ELSE
2450       a$ = rightDir$ & GetFNam$(FileList$, Index%)
2452     END IF
2454   END IF
2456   IF LEN(d$) = 0 THEN
2458     IF ch% = 7 THEN
2460       leftDir$ = a$
2462       LShowLeftDir
2464     ELSE
2466       rightDir$ = a$
2468       LShowRightDir
2470     END IF
2472   END IF
2474 END DEFine
2476 :
2478 :
2480 REMark ''-----------------------------------------------------------
2482 DEFine FuNction GetParentDir$(ch%)
2484   LOCal i%, dir$
2486 :
2488   IF ch% = 7 THEN dir$ = leftDir$ : ELSE dir$ = rightDir$ : END IF
2490   FOR i% = LEN(dir$) - 1 TO 5 STEP -1
2492     IF dir$(i%) = "_"
2494       IF FTEST(dir$(1 TO i%)) = 0
2496         IF FTYP(\dir$(1 TO i%)) = 255 THEN EXIT i%
2498       END IF
2500     END IF
2502   END FOR i%
2504   dir$ = dir$(1 TO i%)
2506   RETurn dir$
2508 END DEFine
2510 :
2512 :
2514 REMark ''------------------------------------------------------------
2516 DEFine PROCedure InputDir(ch%)
2518   LOCal a$, olddir$
2520 :
2522   PAPER# ch%, 0 : INK# ch%, 7 : CLS# ch%
2524 :
2526   IF ch% = 5
2528     olddir$ = leftDir$
2530   ELSE
2532     olddir$ = rightDir$
2534   END IF
2536 :
2538   a$ = EDIT$(#ch%, olddir$, 36) : CLS# ch%
2540   PAPER# ch%, White% : INK# ch%, 0 : CLS# ch%
2542 :
2544   IF a$ = "" THEN a$ = olddir$
2546   IF a$(LEN(a$)) <> "_" THEN a$ = a$ & "_"
2548   IF DirExists%(a$) = 0
2550     BEEP 1390, 20 : PRINT# ch%, olddir$
2552     RETurn
2554   END IF
2556   IF ch% = 5
2558     IF crtPanel% = 8
2560       ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 0
2562     END IF
2564     leftDir$ = a$
2566     crtPanel% = 7
2568     LShowLeftDir
2570     BORDER# 7, 1, brd% : BORDER# 8, 1, brd%, 1, 3
2572   ELSE
2574     IF crtPanel% = 7
2576       ShowHideCursor LIndex% - LStartPos%, LIndex%, LeftFiles$, 0
2578     END IF
2580     rightDir$ = a$
2582     crtPanel% = 8
2584     LShowRightDir
2586     BORDER# 8, 1, brd% : BORDER# 7, 1, brd%, 1, 3
2588   END IF
2590 END DEFine
2592 :
2594 :
2596 REMark ''----------------------------------------------------------
2598 DEFine PROCedure ViewFile
2600     LOCal ext$(10), a$, x%, i%, ch%, ch1%, ch2%, ch3%
2602     LOCal left%, windef$, wid%,hgt%,top%
2604 :
2606     IF crtPanel% = 7
2608         IF LIndex%>LSizedir% + LSizeFile% THEN RETurn : END IF
2610         a$ = GetFNam$(LeftFiles$, LIndex%)
2612     ELSE
2614         IF RIndex%>RSizedir% + RSizeFile% THEN RETurn : END IF
2616         a$ = GetFNam$(RightFiles$, RIndex%)
2618     END IF
2620     IF a$ == ".." OR a$ == "<un-named>" OR IsDir% = 1
2622         RETurn
2624     END IF
2626     REMark ''now get file extension
2628     x% = LEN(a$)
2630     FOR i% = 0 TO x% - 1
2632         IF a$(x% - i%) == "_" OR a$(x% - i%) == "."
2634             EXIT i%
2636         END IF
2638     END FOR i%
2640     IF i% > 0 THEN
2642         ext$ = a$(x% - i% + 1 TO x%)
2644     ELSE
2646         ext$ = ""
2648     END IF
2650     IF crtPanel% = 7 THEN
2652         a$ = leftDir$ & a$
2654     ELSE
2656         a$=rightDir$ & a$
2658     END IF
2660     ext$ = LOWER$(ext$) : x%=0
2662     IF ext$ = "fnt" THEN x% = 1 : END IF
2664     IF ext$ = "fat" THEN x% = 2 : END IF
2666     IF ext$ = "scr" THEN x% = 3 : END IF
2668     IF ext$ = "doc" THEN x% = 4 : END IF
2670     IF ext$ = "zip" THEN x% = 5 : END IF
2672     IF x% <> 3
2674         IF x% = 1 OR x% = 2
2676             left% = (maxWinWid% - 448) DIV 2 - 2
2678             wid% = 452 : hgt% = 230
2680             top% = (panelWinHeight% + 2 * mainFountHeight% + 7 - hgt%) DIV 2 + 14
2682             windef$ = "scr_452x230a" & left% & "x" & top%
2684             ch% = FOPEN(windef$)
2686             PAPER# ch%, 0 :INK #ch%,White%
2688             OUTLN# ch%, 452, 230, left%, top%
2690             BORDER# ch%, 1, 2 : CLS# ch%
2692             windef$ = "scr_452x12a" & left% & "x" & top%
2694             ch1% = FOPEN(windef$) : BORDER# ch1%, 1, 2
2696             PAPER# ch1%, 0, 2, 1 : CLS#ch1%
2698             PAPER# ch1%,0 : INK# ch1%, White%
2700             AT# ch1%, 0, 37 - (LEN(a$) + 5) / 2
2702             PRINT# ch1%, "View " & a$
2704             left% = left% + 2
2706             windef$ = "scr_448x204a" & left% & "x" & (top% + 12)
2708             ch2% = FOPEN(windef$)
2710             PAPER# ch2%, 0 : INK# ch2%, Green%
2712         ELSE
2714             IF maxWinWid% > 600 THEN wid% = 600 : ELSE wid% = 452 : END IF
2716             hgt% = panelWinHeight% + 27
2718             left% = (maxWinWid% - wid%) DIV 2 - 2
2720             top% = mainFountHeight% + 4
2722             windef$ = "scr_" & wid% & "x" & hgt% & "a" & left% & "x" & top%
2724             ch% = FOPEN(windef$)
2726             PAPER# ch%, 0 : INK# ch%, White%
2728             OUTLN# ch%, wid%, hgt%, left%, top%
2730             BORDER# ch%, 1, 2 : CLS# ch%
2732             windef$ = "scr_" & wid% & "x12a" & left% & "x" & top%
2734             ch1% = FOPEN(windef$)
2736             BORDER# ch1%, 1, 2
2738             PAPER# ch1%, 0, 2, 1 : CLS# ch1%
2740             PAPER# ch1%, 0 : INK# ch1%, White%
2742             CURSOR# ch1%,(wid% - (LEN(a$) + 5) * 6) DIV 2, 0
2744             PRINT# ch1%, "View " & a$
2746             left% = left% + 2
2748             windef$ = "scr_" & (wid% - 4) & "x" & (hgt% - 26) & "a" & left% & "x" & (top% + 12)
2750             ch2% = FOPEN(windef$) : PAPER# ch2%, 0 : INK# ch2%, Green%
2752         END IF
2754 :
2756     END IF
2758     SELect ON x%
2760         = 1:
2762             ViewFont a$, 1, ch2%
2764 :
2766         = 2:
2768             ViewFont a$, 2, ch2%
2770 :
2772         = 3:
2774             ViewImage a$, 4 : Set78CharSet
2776 :
2778         = 4:
2780             WINDOW# 0, wid% - 4, 12, left%, hgt% + top% - 14
2782             PAPER# 0, Green%: INK# 0,0 : CLS# 0
2784 :
2786             IF IsQuillDoc%(a$) = 1
2788                 IF FTEST(ConfigDrv$ & "quill_view") = 0
2790                     EW ConfigDrv$ & "quill_view", #ch2%; "-t " & a$ & " " & TempDir$ & "quill_tmp"
2792                     IF FTEST(TempDir$ & "quill_tmp") = 0
2794                         IF mainFountBase > 0 AND wid% < 600
2796                             CHAR_USE# ch2%, mainFountBase, 0
2798                             CHAR_INC# ch2%, 5, 10
2800                         END IF
2802                         MORE# ch2%, TempDir$ & "quill_tmp"
2804                         DELETE TempDir$ & "quill_tmp"
2806                     END IF
2808                 ELSE
2810                     PRINT #ch2%, "Cannot find quill_view"
2812                 END IF
2814             ELSE
2816                 MORE#ch2%, a$
2818             END IF
2820 :
2822         =5:
2824             WINDOW#0,wid%-4,12,left%,hgt%+top%-14:PAPER#0,Green%: INK#0,0:CLS#0
2826             IF IsZipFile%(a$)=1 THEN
2828                 IF FTEST(ConfigDrv$&"unzip")=0 THEN
2830                     ch3%=FOP_OVER(TempDir$&"zip_tmp")
2832                     IF ch3%>0 THEN
2834                         EW ConfigDrv$&"unzip",#ch3%,#ch3%,#ch3%;"-lqq "&a$
2836                         CLOSE#ch3%
2838                         MORE#ch2%, TempDir$&"zip_tmp"
2840                         DELETE TempDir$&"zip_tmp"
2842                     ELSE
2844                         PRINT #ch2%,"Cannot create temporary file"
2846                     END IF
2848                 ELSE
2850                     PRINT #ch2%,"Cannot find unzip"
2852                 END IF
2854             ELSE
2856                 MORE#ch2%, a$
2858             END IF
2860 :
2862         = REMAINDER :
2864             WINDOW#0,wid%-4,12,left%,hgt%+top%-14:PAPER#0,Green%: INK#0,0:CLS#0
2866             MORE#ch2%, a$
2868     END SELect
2870 :
2872     IF x% <> 3
2874         CHAR_USE# ch2%, 0, 0
2876         CLS# ch1% : CLS# ch2% : CLOSE# ch2% : CLOSE# ch1%
2878         WINDOW# 0, 488, 23, 12, 233 : PAPER# 0, 0 : INK# 0, White%
2880         OUTLN #ch%, wid%, hgt%, left%, top%
2882         CLOSE# ch%
2884     END IF
2886 END DEFine
2888 :
2890 :
2892 REMark ''----------------------------------------------------------
2894 DEFine PROCedure ViewFont (file$, type%, ch%)
2896     LOCal lng, i, base, type$(6)
2898 :
2900     lng = FLEN(\file$)
2902     IF lng > 0
2904         AT# ch%, 0, 0 : PRINT# ch%, "Font: " & file$; "      ";
2906         AT# ch%, 0, 44 : PRINT# ch%, "Font size = "; lng; " bytes"
2908     ELSE
2910         PRINT# ch%, "Font NOT FOUND" : RETurn
2912     END IF
2914     base = ALCHP(lng)
2916     LBYTES file$, base
2918 :
2920     IF type% = 1 THEN type% = TestFount%(base)
2922     IF type% = 1 THEN type$ = "(5x9)" : ELSE type$ = "(8x9)"
2924     AT# ch%, 0, 7 + LEN(file$) : PRINT #ch%, type$;
2926 :
2928     AT# ch%, 1, 0 : PRINT# ch%, "Lowest character code = "; PEEK(base); "        ";
2930     AT# ch%, 1, 44 : PRINT# ch%, "Number of characters  = "; PEEK(base+1) + 1
2932     PRINT# ch%,"  "
2934     CHAR_USE# ch%, base, 0
2936     CSIZE# ch%, (type% = 2), 0 : CHAR_INC# ch%, 6 + 2 * (type% = 2), 10
2938     FOR i = 0 TO 9
2940         PRINT# ch%, CHR$(i);
2942         NEXT i
2944     END FOR i
2946     PRINT# ch%, " ";
2948     FOR i = 11 TO 255 : PRINT# ch%, CHR$(i); :NEXT i: END FOR i
2950     PRINT# ch%, CHR$(10)
2952     PRINT# ch%, "The quick brown fox jumped over the lazy dog"
2954     CSIZE# ch%, 2 + (type% = 2), 0 : CHAR_INC# ch%, 12 + 4 * (type% = 2), 10
2956     PRINT# ch%, "The quick brown fox jumped over the lazy dog"
2958     CSIZE# ch%, 2 + (type% = 2), 1 : CHAR_INC# ch%, 12 + 4 * (type% = 2), 20
2960     PRINT# ch%, "The quick brown fox jumped over the lazy dog"
2962     CHAR_USE# ch%, 0, 0
2964     RECHP base
2966     xx$ = INKEY$(-1)
2968 END DEFine
2970 :
2972 :
2974 REMark ''----------------------------------------------------------
2976 DEFine PROCedure MessageWnd(width%, height%, type%, text$)
2978     LOCal ch%, k$, AtX%,AtY%
2980 :
2982     AtX% = (maxWinWid% - width%) / 2
2984     AtY% = (256 - height%) / 2
2986     ch% = FOPEN("con")
2988     OUTLN# ch%; width% - 2, height%, AtX%, AtY%, 4, 3
2990     SELect ON type%
2992       = 1:
2994           PAPER# ch%, Green% : INK# ch%, 0 : CLS# ch%
2996           BLOCK# ch%, width% - 4, 8, 1, 1, Green%, 1, 1
2998           AT# ch%, 1, 1 : PRINT# ch%, text$
3000       =2:
3002           PAPER# ch%, 2 : INK# ch%, White% : CLS# ch%
3004           BLOCK# ch%, width% - 4, 8, 1, 1, 2, 1, 1
3006           CURSOR# ch%, (width% - 49) / 2, 1 : PRINT# ch%, " ERROR "
3008           AT# ch%, 1, 1 : PRINT# ch%, text$
3010       =3:
3012           PAPER# ch%, White% : INK# ch%, 0 : BORDER# ch%, 1, 2 : CLS# ch%
3014           BLOCK# ch%, width% - 8, 8, 1, 1, 2 ,0 , 1
3016           CURSOR# ch%, (width% - 49) / 2, 1 : PRINT# ch%, " ABOUT "
3018           CURSOR#ch%, 2, 15 : PRINT# ch%, text$
3020     END SELect
3022     CURSOR# ch%, (width% - 130) / 2, 48 : PRINT# ch%, "... press any key ..."
3024     k$ = INKEY$(-1)
3026     OUTLN# ch%; width%, height%, AtX%, AtY%
3028     CLOSE# ch%
3030 END DEFine
3032 :
3034 :
3036 REMark ''----------------------------------------------------------
3038 DEFine FuNction IsDir%
3040     LOCal k%, lenghth, bufsize
3042 :
3044     IF crtPanel% = 7
3046         k% = GetFFlg%(LeftFiles$, LIndex%) MOD 2
3048     ELSE
3050         k% = GetFFlg%(RightFiles$, RIndex%) MOD 2
3052     END IF
3054     RETurn k%
3056 END DEFine IsDir%
3058 :
3060 :
3062 REMark ''----------------------------------------------------------
3064 DEFine PROCedure ViewImage(a$, m%)
3066     LOCal ch%, ch1%,scrSz,scrBuf,maxScrSz
3068     IF maxWinHgt%>256 OR maxWinWid%>512 OR RMODE>8 THEN
3070         MessageWnd 200,60,2, CHR$(10)&" _scr images can only be viewed"&CHR$(10)&"  on classic QL configuration":RETurn
3072     END IF
3074     maxScrSz=32768
3076     scrSz=FLEN(\a$)
3078     IF scrSz > maxScrSz THEN
3080         scrBuf=ALCHP(scrSz) : IF scrBuf<0 THEN BEEP 1390,10 : RETurn
3082         LBYTES a$,scrBuf : a$=TempDir$ & "tmp_scr"
3084         SBYTES_O a$, scrBuf, maxScrSz
3086         RECHP scrBuf
3088     END IF
3090     ch% = FOPEN("con")
3092     OUTLN#ch%; 512, 256, 0, 0
3094     IF m%=4 THEN MODE 4: ELSE MODE 8: END IF
3096     LBYTES a$, 131072 : PAUSE 10
3098     k%=CODE(INKEY$(-1))
3100     SELect ON k%
3102       = 52:
3104         OUTLN# ch%; 512, 256, 0, 0: CLOSE# ch% : ViewImage a$, 4
3106 :
3108       = 56:
3110         OUTLN# ch%; 512, 256, 0, 0: CLOSE# ch% : ViewImage a$, 8
3112 :
3114       = REMAINDER :
3116         MODE 4
3118         OUTLN#ch%; 512, 256, 0, 0
3120         CLOSE# ch%
3122         DELETE TempDir$ & "tmp_scr"
3124     END SELect
3126 END DEFine
3128 :
3130 :
3132 REMark ''----------------------------------------------------------
3134 DEFine FuNction InputWnd$(width%, height%, title$, text$, start$)
3136     LOCal ch%, ch1%, k$, AtX%,AtY%
3138 :
3140     AtX% = (maxWinWid% - width%) / 2
3142     AtY% = (256 - height%) / 2
3144     ch% = FOPEN("con")
3146     OUTLN# ch%; width%, height%, AtX%, AtY%, 4, 3
3148     BORDER# ch%, 1, 4
3150     PAPER# ch%, White% : INK# ch%, 0 : CLS# ch%
3152     BLOCK# ch%, width% - 4, 10, 0, 0, Green%, 1, 1
3154     PAPER# ch%, Green% : INK# ch%, 0
3156     CURSOR# ch%,(width% - 6 - LEN(title$) * 6) / 2, 0
3158     PRINT# ch%, title$
3160     PAPER# ch%, White% : INK# ch%, 0
3162     CURSOR# ch%, 6, 16 : PRINT# ch%, text$
3164     CURSOR# ch%, (width% - 198) / 2, 48
3166     PRINT# ch%, "... leave it empty to cancel ..."
3168     ch1% = FOPEN("con")
3170     WINDOW# ch1%, width% - 18, 12, AtX% + 8, AtY% + 28
3172     PAPER# ch1%, 0 : INK# ch1%, White% : CLS# ch1%
3174     k$ = EDIT$(#ch1%, start$, 36)
3176     CLOSE# ch1%
3178     OUTLN# ch%; width%, height%, AtX%, AtY%
3180     CLOSE# ch%
3182     RETurn k$
3184 END DEFine InputWnd$
3186 :
3188 :
3190 REMark ''----------------------------------------------------------
3192 DEFine FuNction DirExists% (name$)
3194     LOCal er%, ch%, d$, dname$
3196 :
3198     dbg name$
3200     dname$ = name$
3202     IF dname$(LEN(dname$)) <> "_"
3204         dname$ = dname$ & "_"
3206     END IF
3208     IF LEN(dname$) = 5
3210         d$ = DATAD$
3212         DATA_USE CHR$(0)
3214         ch% = FOP_DIR(dname$)
3216         DATA_USE d$
3218         IF ch% < 0
3220             er% = 0
3222         ELSE
3224             CLOSE#ch%
3226             er% = 1
3228         END IF
3230     ELSE
3232         IF FTEST(dname$) = 0
3234             IF FTYP(\dname$) = 255
3236                 er% = 1
3238             ELSE
3240                 er% = 0
3242             END IF
3244         ELSE
3246             er% = 0
3248         END IF
3250     END IF
3252     RETurn er%
3254 END DEFine
3256 :
3258 :
3260 REMark ''----------------------------------------------------------
3262 DEFine PROCedure CreateDir
3264     LOCal x%,DirName$, FullDirName$
3266 :
3268     DirName$ = InputWnd$(240, 60, " Create Directory ", "Directory Name:", "")
3270     DirName$ = UPPER$(DirName$)
3272     IF DirName$ = "" THEN RETurn : END IF
3274     IF crtPanel% = 7
3276         FullDirName$ = leftDir$ & DirName$
3278     ELSE
3280         FullDirName$ = rightDir$ & DirName$
3282     END IF
3284     x% = Create1Dir%(DirName$, FullDirName$, crtPanel%, 1, 1, 1)
3286 END DEFine CreateDir
3288 :
3290 :
3292 REMark ''----------------------------------------------------------
3294 DEFine FuNction Create1Dir%(DirName$, FullDirName$, panel%, UpdateWnd%, CheckNoQ%, UpdateList%)
3296     LOCal res%, fres%, page%, msg$
3298 :
3300     IF LEN(FullDirName$) > 41
3302         IF UpdateWnd% = 1
3304             MessageWnd 200, 60, 2, CHR$(10) & "          Name too long !"
3306             RETurn 0
3308         ELSE
3310           INK# 0, 2
3312           PRINT# 0, "Directory not created  Name too long"
3314           INK# 0, White%
3316           RETurn 0
3318         END IF
3320     END IF
3322     IF (Qubide% = 1) AND (CheckNoQ% = 1)
3324         IF TestQubideRestriction%(DirName$, panel%) = 1
3326             IF UpdateWnd% = 1
3328                 MessageWnd 200, 60, 2, "   Cannot create Directory !" & CHR$(10) & "  QUBIDE limitation: Files will" & CHR$(10) & "     fall in the directory !"
3330                 RETurn 0
3332             ELSE
3334                 INK# 0, 2 : PRINT# 0, "Directory not created QUBIDE limitation: Files will fall in the directory" : INK# 0, White% : RETurn 0
3336             END IF
3338         END IF
3340     END IF
3342     IF DirName$(LEN(DirName$)) = "_"
3344         DirName$ = DirName$(1 TO LEN(DirName$) - 1)
3346     END IF
3348     IF panel% = 7
3350         IF (CheckNoQ% = 1) AND (LSizedir% + LSizeFile% + 1 >= MaxFiles%)
3352             IF UpdateWnd% = 1
3354               MessageWnd 200,60,2, CHR$(10) & "   Cannot create Directory !" & CHR$(10) & CHR$(10) & "     maximum number reached !"
3356               RETurn 0
3358             ELSE
3360               INK# 0, 2
3362               PRINT# 0,"Directory not created. You have reached the maximum number of files and directories"
3364               INK# 0, White%
3366               RETurn -1
3368             END IF
3370         ELSE
3372             fres% = FMAKE_DIR(FullDirName$)
3374             IF (UpdateList% = 1) AND (fres% >= 0)
3376                 res% = Find%(DirName$, id%, LeftFiles$, 1, LSizedir%)
3378                 IF res% = 0
3380                     res% = Insert%(DirName$, id%, LeftFiles$, 1, LSizedir%, LSizeFile%, "0")
3382                 END IF
3384                 LIndex% = id%
3386                 IF UpdateWnd% = 1
3388                     id% = id% + (LMinPos% = 0)
3390                     page% = id% DIV rowno%
3392                     IF id% MOD rowno% > 0 THEN page% = page% + 1 : END IF
3394                     LStartPos% = (page% - 1) * rowno% + LMinPos%
3396                     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
3398                 END IF
3400                 RETurn 1
3402             ELSE
3404                 IF fres% >= 0 THEN RETurn 1
3406             END IF
3408         END IF
3410     ELSE
3412         IF (CheckNoQ% = 1) AND (RSizedir% + RSizeFile% + 1 >= MaxFiles%)
3414             IF UpdateWnd% = 1
3416               MessageWnd 200, 60, 2, CHR$(10) & "   Cannot create Directory !" & CHR$(10) & CHR$(10) & "     maximum number reached !"
3418               RETurn 0
3420             ELSE
3422               INK# 0, 2
3424               PRINT# 0, "Directory not created. You have reached the maximum number of files and directories"
3426               INK# 0, White%
3428               RETurn -1
3430             END IF
3432         ELSE
3434             fres% = FMAKE_DIR(FullDirName$)
3436             IF (UpdateList% = 1) AND (fres% >= 0)
3438                 res% = Find%(DirName$, id%, RightFiles$, 1, RSizedir%)
3440                 IF res% = 0
3442                     res% = Insert%(DirName$, id%, RightFiles$, 1, RSizedir%, RSizeFile%, "0")
3444                 END IF
3446                 RIndex% = id%
3448                 IF UpdateWnd% = 1
3450                     id% = id% + (RMinPos% = 0)
3452                     page% = id% DIV rowno%
3454                     IF id% MOD rowno% > 0 THEN page% = page% + 1 : END IF
3456                     RStartPos% = (page% - 1) * rowno% + RMinPos%
3458                     ListFiles RightFiles$, RStartPos%, RIndex%, 8
3460                 END IF
3462                 RETurn 1
3464             ELSE
3466                 IF fres% >= 0 THEN RETurn 1
3468             END IF
3470         END IF
3472     END IF
3474 :
3476     SELect ON fres%
3478       = -8, -9:
3480         msg$ = "   Cannot create Directory !" & CHR$(10) & "    A file or a directory with" & CHR$(10) & "    same name already exists !"
3482 :
3484       = -11:
3486         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "            Drive full"
3488 :
3490       = -15:
3492         msg$ = CHR$(10)&"    Cannot create Directory"&CHR$(10)&"       Drive is not Level2"
3494 :
3496       = -19:
3498         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "       Not implemented yet"
3500 :
3502       = -20:
3504         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "        Drive is Read Only "
3506 :
3508       = REMAINDER :
3510         msg$ = CHR$(10) & "    Cannot create Directory" & CHR$(10) & "            Error " & fres%
3512     END SELect
3514 :
3516     IF UpdateWnd% = 1
3518         MessageWnd 200, 60, 2, msg$
3520         IF (fres% = -15) OR (fres% = -19)
3522             DELETE FullDirName$
3524         END IF
3526         RETurn 0
3528     ELSE
3530         SELect ON fres%
3532           = -8, -9:
3534             INK# 0,2
3536             PRINT# 0, "Directory not created  A file or a directory with same name already exists"
3538             INK# 0,White%
3540             RETurn 0
3542 :
3544           REMark ''= -9:
3546           REMark ''  ink# 0, 2
3548           REMark ''  print# 0, "Directory not created  A directory with same name already exists"
3550           REMark ''  ink# 0, White%
3552           REMark ''  Return 0
3554 :
3556           = -11:
3558             INK# 0,2
3560             PRINT# 0, "Directory not created Drive full"
3562             INK# 0, White%
3564             RETurn -1
3566 :
3568           = -15:
3570             INK# 0, 2
3572             PRINT# 0, "Directory not created  Drive is not Level2"
3574             INK# 0, White%
3576             RETurn -1
3578 :
3580           = -19:
3582             INK# 0, 2
3584             PRINT# 0, "Directory not created  Operation not implemented yet for this drive type"
3586             INK# 0, White%
3588             RETurn -1
3590 :
3592           = -20:
3594             INK# 0, 2
3596             PRINT# 0, "Directory not created  Drive is Read Only "
3598             INK# 0, White%
3600             RETurn -1
3602 :
3604           = REMAINDER :
3606             INK# 0, 2
3608             PRINT# 0, "Directory not created  Error " & fres%
3610             INK# 0, White%
3612             RETurn 0
3614         END SELect
3616     END IF
3618 :
3620 END DEFine
3622 :
3624 :
3626 REMark ''-----------------------------------------------------------
3628 DEFine FuNction CountSelected%
3630     LOCal i%, counter%
3632 :
3634     counter% = 0
3636 :
3638     IF crtPanel% = 7
3640         FOR i% = 1 TO LSizedir% + LSizeFile%
3642             IF GetFFlg%(LeftFiles$, i%) > 1
3644                 counter% = counter% + 1
3646             END IF
3648         END FOR i%
3650     ELSE
3652         FOR i% = 1 TO RSizedir%+RSizeFile%
3654             IF GetFFlg%(RightFiles$,i%) > 1
3656                 counter% = counter% + 1
3658             END IF
3660         END FOR i%
3662     END IF
3664     RETurn counter%
3666 END DEFine
3668 :
3670 :
3672 REMark ''---------------------------------------------------------
3674 DEFine FuNction DlgWnd%(width%, height%, title$, text$)
3676     LOCal ch%, a$, k%, AtX%, AtY%, loopa
3678 :
3680     AtX% = (maxWinWid% - width%) / 2
3682     AtY% = (256 - height%) / 2
3684     ch% = FOPEN("con")
3686     OUTLN# ch%; width%, height%, AtX%, AtY%, 4, 3
3688     BORDER# ch%, 1, Green%
3690     PAPER# ch%, White% : INK# ch%, 0 : CLS# ch%
3692     BLOCK# ch%, width% - 4, 10, 0, 0, Green%, 1, 1
3694     PAPER# ch%, Green% : INK# ch%, 0
3696     CURSOR# ch%, (width% - 6 - LEN(title$) * 6) / 2, 0
3698     PRINT# ch%, title$
3700     PAPER# ch%, White% : INK# ch%, 0
3702     CURSOR# ch%, 6, 16 : PRINT# ch%, text$
3704     CURSOR# ch%, (width% - 198) / 2, 48:
3706     INK# ch%, 2 : PRINT# ch%, "    C";
3708     INK# ch%, 0 : PRINT# ch%, "ancel                ";
3710     INK# ch%, 2 : PRINT# ch%, "O";
3712     INK# ch%, 0 : PRINT# ch%, "k"
3714     REPeat loopa
3716        a$ = INKEY$(-1)
3718        IF a$ INSTR "oO" & CHR$(10) THEN k% = 1: EXIT loopa: END IF
3720        IF a$ INSTR "cC" & CHR$(27) THEN k% = 0: EXIT loopa: END IF
3722     END REPeat loopa
3724     OUTLN# ch%; width%, height%, AtX%, AtY%
3726     CLOSE# ch%
3728     RETurn k%
3730 END DEFine
3732 :
3734 :
3736 REMark ''----------------------------------------------------------
3738 DEFine FuNction TestQubideRestriction%(DirName$, panel%)
3740     LOCal i%, name$
3742 :
3744     name$ = DirName$
3746     IF name$(LEN(name$)) <> "_" THEN name$ = name$ & "_"
3748     IF panel% = 7
3750         FOR i% = LSizedir% + 1 TO LSizedir% + LSizeFile%
3752           IF name$ INSTR LeftFiles$(i%) = 1 THEN RETurn 1 : END IF
3754         END FOR i%
3756     ELSE
3758         FOR i% = RSizedir% + 1 TO RSizedir% + RSizeFile%
3760           IF name$ INSTR RightFiles$(i%) = 1 THEN RETurn 1 : END IF
3762         END FOR i%
3764     END IF
3766     RETurn 0
3768 END DEFine
3770 :
3772 :
3774 REMark ''----------------------------------------------------------
3776 DEFine FuNction IsQuillDoc%(a$)
3778     LOCal ch%, q$, i%, k%
3780 :
3782     ch% = FOPEN(a$)
3784     IF ch% <= 0 THEN RETurn 0 : END IF
3786     q$ = ""
3788     BGET #ch%\1, k%
3790     FOR i% = 1 TO 8
3792         BGET #ch%, k%
3794         q$ = q$ & CHR$(k%)
3796         NEXT i%
3798     END FOR i%
3800     CLOSE #ch%
3802     IF q$ = "vrm1qdf0" THEN RETurn 1 : ELSE RETurn 0: END IF
3804 END DEFine
3806 :
3808 :
3810 REMark ''-----------------------------------------------------------
3812 DEFine FuNction IsZipFile%(a$)
3814     LOCal ch%, q$, i%, k%
3816 :
3818     ch% = FOPEN(a$)
3820     IF ch% <= 0 THEN RETurn 0 : END IF
3822     q$ = ""
3824     FOR i% = 1 TO 4
3826         BGET #ch%, k%
3828         q$ = q$ & CHR$(k%)
3830         NEXT i%
3832     END FOR i%
3834     CLOSE #ch%
3836     IF q$ = "PK" & CHR$(3) & CHR$(4) THEN RETurn 1: ELSE RETurn 0: END IF
3838 END DEFine
3840 :
3842 :
3844 REMark ''----------------------------------------------------------
3846 DEFine PROCedure RenameFile
3848     LOCal NewFileName$, filename$, sourcepath$
3850     LOCal res%, i%, x%, filelen$, page%
3852 :
3854     IF crtPanel% = 7
3856         IF LIndex% > LSizeFile% + LSizedir% THEN RETurn : END IF
3858     ELSE
3860         IF RIndex% > RSizeFile% + RSizedir% THEN RETurn : END IF
3862     END IF
3864     IF crtPanel% = 7
3866         filename$ = GetFNam$(LeftFiles$, LIndex%)
3868         sourcepath$ = leftDir$
3870     ELSE
3872        filename$ = GetFNam$(RightFiles$, RIndex%)
3874        sourcepath$ = rightDir$
3876     END IF
3878     IF filename$ = ".." THEN RETurn : END IF
3880     IF IsDir% = 1
3882         MessageWnd 200, 60, 2, CHR$(10) & "   Cannot rename a Directory!"
3884         RETurn
3886     END IF
3888     res% = FTEST(sourcepath$ & filename$)
3890     IF res% = -9
3892         MessageWnd 200, 60, 2, CHR$(10) & "   File in Use! Cannot rename!"
3894         RETurn
3896     END IF
3898     IF res% = -20
3900         MessageWnd 200, 60, 2, CHR$(10) & "       File is Read Only! " & CHR$(10) & "          Cannot rename!"
3902         RETurn
3904     END IF
3906     NewFileName$ = InputWnd$(240, 60, " Rename File ", "Rename " & filename$ & " to:", filename$)
3908     IF NewFileName$ = "" THEN RETurn : END IF
3910     IF LEN(sourcepath$ & NewFileName$) > 36
3912         MessageWnd 200, 60, 2, CHR$(10) & "   Full file name is too long!"
3914         RETurn
3916     END IF
3918     IF FTEST(sourcepath$ & NewFileName$) <> -7 THEN
3920         MessageWnd 200, 60, 2, CHR$(10) & "      A file with this name" & CHR$(10) & "          already exists!"
3922         RETurn
3924     END IF
3926     RENAME sourcepath$ & filename$ TO sourcepath$ & NewFileName$
3928     IF crtPanel% = 7
3930         filelen$ = GetFLen(LeftFiles$, LIndex%)
3932         ShowHideCursor LIndex% - LStartPos%, LIndex%, LeftFiles$, 0
3934         FOR i% = LIndex% + 1 TO LSizedir% + LSizeFile%
3936           CopyRec LeftFiles$, i% TO LeftFiles$, i% - 1
3938         END FOR i%
3940         LSizeFile% = LSizeFile% - 1
3942         x% = Find%(NewFileName$, id%, LeftFiles$, LSizedir% + 1, LSizedir% + LSizeFile%)
3944         x% = Insert%(NewFileName$, id%, LeftFiles$, 0, LSizedir%, LSizeFile%, filelen$)
3946         LIndex% = id%
3948         x% = id% + (LMinPos% = 0)
3950         page% = x% DIV rowno%
3952         IF x% MOD rowno% > 0 THEN page% = page% + 1: END IF
3954         LStartPos% = (page% - 1) * rowno% + LMinPos%
3956         ListFiles LeftFiles$, LStartPos%, LIndex%, 7
3958     ELSE
3960         filelen$ = GetFLen(RightFiles$, RIndex%)
3962         ShowHideCursor RIndex% - RStartPos%, RIndex%, RightFiles$, 0
3964         FOR i% = RIndex% + 1 TO RSizedir% + RSizeFile%
3966           CopyRec RightFiles$, i% TO RightFiles$, i% - 1
3968         END FOR i%
3970         RSizeFile% = RSizeFile% - 1
3972         x% = Find%(NewFileName$, id%, RightFiles$, RSizedir% + 1, RSizedir% + RSizeFile%)
3974         x% = Insert%(NewFileName$, id%, RightFiles$, 0, RSizedir%, RSizeFile%, filelen$)
3976         RIndex% = id%
3978         x% = id% + (RMinPos% = 0)
3980         page% = x% DIV rowno%
3982         IF x% MOD rowno% > 0 THEN page% = page% + 1: END IF
3984         RStartPos% = (page% - 1) * rowno% + RMinPos%
3986         ListFiles RightFiles$, RStartPos%, RIndex%, 8
3988     END IF
3990 END DEFine RenameFile
3992 :
3994 :
3996 :
3998 REMark ''TODO mixworx
4000 :
4002 REMark ''-----------------------------------------------------------
4004 DEFine PROCedure ShowInfo
4006  LOCal filename$(36), path$(36), chf%, ch%,ch1%,ch2%,x%, k$(2),windef$, left%, top%
4008 :
4010   IF crtPanel%=7 THEN
4012     IF LIndex%>LSizeFile%+LSizedir% THEN RETurn : END IF
4014   ELSE
4016     IF RIndex%>RSizeFile%+RSizedir% THEN RETurn : END IF
4018   END IF
4020 :
4022   IF crtPanel%=7 THEN
4024     filename$=GetFNam$(LeftFiles$,LIndex%)
4026     path$=leftDir$
4028   ELSE
4030     filename$=GetFNam$(RightFiles$,RIndex%)
4032     path$=rightDir$
4034   END IF
4036 :
4038   IF filename$=".." THEN RETurn : END IF
4040   left%=(maxWinWid%-452) DIV 2
4042   IF maxWinHgt%>256 THEN top%=51: ELSE top%=14: END IF
4044   windef$="scr_452x230a"&left%&"x"&top%
4046   ch%=FOPEN(windef$)
4048   PAPER #ch%,0:INK #ch%,White%
4050   OUTLN #ch%,452,230,left%,top% : BORDER #ch%,1,2: CLS #ch%
4052   windef$="scr_452x12a"&left%&"x"&top%
4054   ch1%=FOPEN(windef$): BORDER #ch1%,1,2 : PAPER #ch1%,0,2,1 : CLS #ch1%
4056   PAPER #ch1%,0 : INK #ch1%,White% : AT #ch1%,0,34 : PRINT#ch1%, " Info "
4058   windef$="scr_448x204a"&(left%+2)&"x"&(top%+12)
4060   ch2%=FOPEN(windef$):PAPER#ch2%,0:INK#ch2%,Green%
4062   PRINT #ch2%, "Full name: ";path$&filename$;CHR$(10);
4064 :
4066   chf%=FOPEN(path$&filename$)
4068   IF chf%<0 THEN
4070     INK#ch2%, 2
4072     SELect ON chf%
4074       =-7: PRINT#ch2%, "File Not Found !"
4076       =-9: PRINT#ch2%, "File in use"
4078       = REMAINDER : PRINT#ch2%, "Error ";chf%
4080     END SELect
4082     INK 4
4084   ELSE
4086     GetHEAD #chf%,headBuff
4088     PRINT#ch2%, "File Length:"; : PRINT_USING#ch2%, "##,###,###. bytes\", PEEK_L(headBuff)
4090     x%=PEEK(headBuff+5)
4092     PRINT#ch2%, "File Type:   ";x%;" - ";
4094     SELect ON x%
4096       =0  : PRINT#ch2%, "BASIC, CALLable machine code, extensions or DATA file"
4098       =1  : PRINT#ch2%, "EXECable file"
4100       =2  : PRINT#ch2%, "SROFF file used by linkers etc, a C68 Library file etc"
4102       =3  : PRINT#ch2%, "THOR hard disc directory file. (I think!)"
4104       =4  : PRINT#ch2%, "A font file for The Painter"
4106       =5  : PRINT#ch2%, "A pattern file for The Painter"
4108       =6  : PRINT#ch2%, "A compressed mode 4 screen in The Painter"
4110       =11 : PRINT#ch2%, "A compressed mode 8 screen in The Painter"
4112       =255: PRINT#ch2%, "Level 2 driver directory or sub-directory file"
4114       =REMAINDER : PRINT#ch2%," "
4116     END SELect
4118     PRINT#ch2%, "Data-space: ";
4120     IF x%=1 THEN PRINT_USING#ch2%, "##,###,###. bytes\", PEEK_L(headBuff+6) : ELSE : PRINT#ch2%, "   n/a"
4122     PRINT#ch2%, "File Version:  ";PEEK_W(headBuff+56)
4124     PRINT#ch2%, "Last modified: ";
4126     d=PEEK_L(headBuff+52) : IF d THEN PRINT#ch2%, DATE$(d) : ELSE : PRINT#ch2%, "<not-set>"
4128     PRINT#ch2%, "Backup date:   ";
4130     d=PEEK_L(headBuff+60) : IF d THEN PRINT#ch2%, DATE$(d) : ELSE : PRINT#ch2%, "<not-set>"
4132     CLOSE #chf%
4134   END IF
4136 :
4138   PRINT#ch2%, CHR$(10);"------------------------------------------------------------------------";CHR$(10)
4140   PRINT#ch2%, "ROM Version:  "; VER$
4142   PRINT#ch2%, "QDOS Version: "; VER$(1)
4144   PRINT#ch2%, "Current RAMTOP: "; : PRINT_USING#ch2%, "##,###.#",RESPR(0)/1024-128 : PRINT#ch2%, " Kb"
4146   PRINT#ch2%, "Free memory:    "; : PRINT_USING#ch2%, "##,###.#",FREE_MEM/1024     : PRINT#ch2%, " Kb"
4148   PRINT#ch2%
4150   PRINT#ch2%, "DataD$: ";DATAD$
4152   PRINT#ch2%, "ProgD$: ";PROGD$
4154   PRINT#ch2%, "DestD$: ";DESTD$
4156 :
4158   k$=INKEY$(-1)
4160   CLS #ch1% : CLS #ch2% : CLOSE #ch2% : CLOSE #ch1%
4162   OUTLN #ch%,452,230,left%,top%
4164   CLOSE #ch%
4166 :
4168 END DEFine ShowInfo
4170 :
4172 :
4174 REMark ''----------------------------------------------------------
4176 DEFine PROCedure WriteCommands(ch%)
4178  LOCal lat, px%, px1%, i%, x%, lat%(9)
4180   lat=(comWinWid% - 4) DIV 9: rest=(comWinWid% - 4) MOD 9:FOR i%=1 TO 9:lat%(i%)=lat:NEXT i%
4182   IF rest>=0 THEN lat%(4)=lat+1
4184   IF rest>=1 THEN lat%(3)=lat+1
4186   IF rest>=2 THEN lat%(5)=lat+1
4188   IF rest>=3 THEN lat%(1)=lat+1
4190   IF rest>=4 THEN lat%(2)=lat+1
4192   IF rest>=5 THEN lat%(6)=lat+1
4194   IF rest>=6 THEN lat%(7)=lat+1
4196   IF rest>=7 THEN lat%(8)=lat+1
4198   IF rest>=8 THEN lat%(9)=lat+1
4200   px%=0
4202   PAPER#ch%, PPR9a%,ppr9b%,3
4204 :
4206   FOR i%=1 TO 9
4208     BLOCK#ch%, lat%(i%)-1,mainFountHeight%, px%,0, PPR9a%,ppr9b%,3
4210     x%=px% + (lat%(i%) - 1 - LEN(cmdText$(i%)) * comFountWid%) DIV 2
4212     CURSOR#ch%, x%,0 : PRINT#ch%, cmdText$(i%);
4214     px%=px%+lat%(i%)
4216   END FOR i%
4218 END DEFine WriteCommands
4220 :
4222 :
4224 REMark ''----------------------------------------------------------
4226 DEFine FuNction IsReadOnly% (a$)
4228 LOCal res%
4230 res%=FOPEN(a$&CHR$(0))
4232 IF res%=-20 THEN RETurn 1: END IF
4234 IF res%>0 THEN DELETE a$&CHR$(0): END IF
4236 RETurn 0
4238 END DEFine IsReadOnly%
4240 :
4242 :
4244 REMark ''----------------------------------------------------------
4246 DEFine PROCedure CopyFiles
4248 LOCal k%, x%, name$, source$, dest$, filelen$, panel%
4250 x%=CountSelected%
4252 IF crtPanel%=7 THEN
4254   source$=leftDir$ : dest$=rightDir$
4256   name$=GetFNam$(LeftFiles$,LIndex%)
4258   filelen$=GetFLen(LeftFiles$,LIndex%)
4260   panel%=8
4262 ELSE
4264   dest$=leftDir$ : source$=rightDir$
4266   name$=GetFNam$(RightFiles$,RIndex%)
4268   filelen$=GetFLen(RightFiles$,RIndex%)
4270   panel%=7
4272 END IF
4274 IF IsReadOnly%(dest$) THEN
4276  MessageWnd 200,60,2, CHR$(10)&"    Destination is Read Only! "&CHR$(10)&"           Cannot copy!"
4278  RETurn
4280 END IF
4282 IF x%>0 THEN
4284  k%=DlgWnd%(240,60," Copy Files ", "    Are you sure you want to copy"&CHR$(10)&"     "&x%&" files and directories ?")
4286  IF k%=1 THEN CopyMultipleFiles x%
4288 ELSE
4290  IF IsDir%=1 THEN
4292      CopySingleDir name$, source$, dest$, panel%
4294  ELSE
4296    IF LEN(dest$&name$)>41 THEN
4298      MessageWnd 200,60,2, CHR$(10)&"        Cannot copy file"&CHR$(10)&"          Name too long !"
4300      RETurn
4302    END IF
4304    k%=FTEST(dest$&name$)
4306    IF k%=-7 THEN
4308     IF crtPanel%=7 THEN
4310       IF RSizedir%+RSizeFile%+1>=MaxFiles% THEN
4312         MessageWnd 200,60,2, CHR$(10)&"        Cannot copy file"&CHR$(10)&"      maximum number reached !"
4314         RETurn
4316       END IF
4318      ELSE
4320       IF LSizedir%+LSizeFile%+1>=MaxFiles% THEN
4322         MessageWnd 200,60,2, CHR$(10)&"        Cannot copy file"&CHR$(10)&"      maximum number reached !"
4324         RETurn
4326       END IF
4328      END IF
4330      Copy1File name$, source$, dest$, filelen$, 1: RETurn
4332    ELSE
4334      IF k%=0 THEN
4336        x%=DlgWnd%(240,60," Copy Files ", "   Destination file already exists"&CHR$(10)&"              Overwrite ?")
4338        IF x%=1 THEN Copy1File name$, source$, dest$, filelen$, 1: RETurn :END IF
4340      ELSE
4342        SELect ON k%
4344          =-9: MessageWnd 200,60,2, CHR$(10)&"      Destination is in use "&CHR$(10)&"           Cannot copy!":RETurn
4346          =-11:MessageWnd 200,60,2, CHR$(10)&"    Destination drive is full"&CHR$(10)&"           Cannot copy!":RETurn
4348          =-16:MessageWnd 200,60,2, CHR$(10)&"      Bad or Changed Medium"&CHR$(10)&"           Cannot copy!":RETurn
4350          =-20:MessageWnd 200,60,2, CHR$(10)&"    Destination is Read Only! "&CHR$(10)&"           Cannot copy!": RETurn
4352          =REMAINDER : MessageWnd 200,60,2, CHR$(10)&"     Error copying file : "&k%:RETurn
4354        END SELect
4356      END IF
4358    END IF
4360  END IF
4362  IF crtPanel%=7 THEN
4364    id%=RIndex%+(RMinPos%=0)
4366    page%=id% DIV rowno%
4368    IF id% MOD rowno% >0 THEN page%=page%+1: END IF
4370    RStartPos%=(page%-1)*rowno% +RMinPos%
4372    ListFiles RightFiles$, RStartPos%, RIndex%, 8
4374  ELSE
4376    id%=LIndex%+(LMinPos%=0)
4378    page%=id% DIV rowno%
4380    IF id% MOD rowno% >0 THEN page%=page%+1: END IF
4382    LStartPos%=(page%-1)*rowno% +LMinPos%
4384    ListFiles LeftFiles$, LStartPos%, LIndex%, 7
4386  END IF
4388 END IF
4390 END DEFine CopyFiles
4392 :
4394 :
4396 REMark ''-----------------------------------------------------------
4398 DEFine PROCedure Copy1File (name$, source$, dest$, filelen$, UpdateList%)
4400 LOCal x%, page%
4402 COPY_O source$&name$ TO dest$&name$
4404 IF crtPanel%=8 THEN
4406   x%=Find%(name$,id%, LeftFiles$,LSizedir%+1,LSizedir%+LSizeFile%)
4408   IF x%=0 THEN
4410     x%=Insert%(name$,id%,LeftFiles$,0, LSizedir%, LSizeFile%, filelen$)
4412   ELSE
4414     PutFLen LeftFiles$,id%,filelen$
4416   END IF
4418   LIndex%=id%
4420   IF UpdateList%=1 THEN
4422     id%=id%+(LMinPos%=0)
4424     page%=id% DIV rowno%
4426     IF id% MOD rowno% >0 THEN page%=page%+1: END IF
4428     LStartPos%=(page%-1)*rowno% +LMinPos%
4430     ListFiles LeftFiles$, LStartPos%, LIndex%, 7
4432   END IF
4434 ELSE
4436   x%=Find%(name$,id%, RightFiles$,RSizedir%+1,RSizedir%+RSizeFile%)
4438   IF x%=0 THEN
4440     x%=Insert%(name$,id%,RightFiles$,0, RSizedir%, RSizeFile%, filelen$):
4442   ELSE
4444     PutFLen RightFiles$,id%,filelen$
4446   END IF
4448   RIndex%=id%
4450   IF UpdateList%=1 THEN
4452     id%=id%+(RMinPos%=0)
4454     page%=id% DIV rowno%
4456     IF id% MOD rowno% >0 THEN page%=page%+1: END IF
4458     RStartPos%=(page%-1)*rowno% +RMinPos%
4460     ListFiles RightFiles$, RStartPos%, RIndex%, 8
4462   END IF
4464 END IF
4466 END DEFine Copy1File
4468 :
4470 :
4472 REMark ''----------------------------------------------------------
4474 DEFine PROCedure CopyDirFiles(name$, source$, dest$, CreateWnd%)
4476 LOCal ch%, ch1%
4478 IF CreateWnd%=1 THEN
4480   ch%=FOPEN("scr_400x156a56x50")
4482   PAPER #ch%,0:INK #ch%,7
4484   OUTLN #ch%,400,156,56,50:BORDER#ch%,1,2:CLS#ch%
4486   ch1%=FOPEN("scr_398x12a57x51"): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
4488   PAPER#ch1%,0: INK#ch1%,7: AT#ch1%,0,25: PRINT#ch1%, " Copy Directory "
4490   WINDOW#0,396, 140, 58, 63:PAPER#0,0: INK#0,White%:CLS#0
4492 END IF
4494 PRINT#0, "Copy "&source$&name$&" to "&dest$&name$
4496 WCOPY source$&name$ TO dest$&name$
4498 IF CreateWnd%=1 THEN
4500   INK#0,Green%:PRINT#0, "Copy process ended - press any key to close window":INK#0,White%
4502   x%=KEYROW(0):a$=INKEY$(-1)
4504   WINDOW#0,448,12,32,231:
4506   CLOSE#ch1%
4508   OUTLN #ch%,400,156,56,50
4510   CLOSE#ch%
4512 END IF
4514 END DEFine CopyDirFiles
4516 :
4518 :
4520 REMark ''----------------------------------------------------------
4522 DEFine PROCedure CopyMultipleFiles(k%)
4524 LOCal ch%, ch1%, i%, x%, a$, Index%, panel%, page%, id%, left%,windef$, hgt%, wid%
4526 IF panelWinWid%*2>602 THEN wid%=600: ELSE wid%=400:END IF
4528 hgt%=panelWinHeight%*8 DIV  10
4530 left%=(maxWinWid%-wid%) DIV 2
4532 windef$="scr_"&wid%&"x"&hgt%&"a"&left%&"x50"
4534 ch%=FOPEN(windef$)
4536 PAPER #ch%,0:INK #ch%,White%
4538 OUTLN #ch%,wid%,hgt%,left%,50:BORDER#ch%,1,2:CLS#ch%
4540 left%=left%+1
4542 windef$="scr_"&(wid%-2)&"x12a"&left%&"x51"
4544 ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
4546 PAPER#ch1%,0: INK#ch1%,White%: CURSOR#ch1%,(wid%-90) DIV 2,0: PRINT#ch1%, " Copy Selected "
4548 WINDOW#0,wid%-4, hgt%-16, left%+1, 63:PAPER#0,0: INK#0,White%:CLS#0
4550 PRINT#0, "Copy Selected list: "&k%&" files and/or directories"
4552 IF crtPanel%=7 THEN
4554  source$=leftDir$:dest$=rightDir$: Index%=LIndex%: panel%=8
4556  FOR i%=1 TO LSizedir%+LSizeFile%
4558    LIndex%=i%
4560    IF GetFFlg%(LeftFiles$,i%) > 1 THEN
4562      IF GetFFlg%(LeftFiles$,i%) = 2 THEN
4564        PRINT#0, "Copying file "&GetFNam$(LeftFiles$,i%)&" ..."
4566        x%=CopyAListFile%(GetFNam$(LeftFiles$,i%), source$, dest$, GetFLen(LeftFiles$,i%), 8)
4568      ELSE
4570        PRINT#0, "Copying directory "&GetFNam$(LeftFiles$,i%)&" ..."
4572        x%=CopyFullDir%(GetFNam$(LeftFiles$,i%), source$, dest$, 8, 0, 1, 1)
4574      END IF
4576      IF x%=-1 THEN EXIT i%
4578      PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
4580    END IF
4582  NEXT i%: END FOR i%
4584  LIndex%=Index%
4586 ELSE
4588  source$=rightDir$:dest$=leftDir$:Index%=RIndex%
4590  FOR i%=1 TO RSizedir%+RSizeFile%
4592    RIndex%=i%
4594    IF GetFFlg%(RightFiles$,i%) > 1 THEN
4596      IF GetFFlg%(RightFiles$,i%)=2 THEN
4598        PRINT#0, "Copying file "&GetFNam$(RightFiles$,i%)&" ..."
4600        x%=CopyAListFile%(GetFNam$(RightFiles$,i%), source$, dest$, GetFLen(RightFiles$,i%), 7)
4602      ELSE
4604        PRINT#0, "Copying directory "&GetFNam$(RightFiles$,i%)&" ..."
4606        x%=CopyFullDir% (GetFNam$(RightFiles$,i%), source$, dest$, 7, 0, 1, 1)
4608      END IF
4610      IF x%=-1 THEN EXIT i%
4612      PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
4614    END IF
4616  NEXT i%: END FOR i%
4618  RIndex%=Index%
4620 END IF
4622 INK#0,Green%:PRINT#0, "Copy process ended - press any key to close window":INK#0,White%
4624 x%=KEYROW(0):a$=INKEY$(-1)
4626 WINDOW#0,448,12,32,231:
4628 CLOSE#ch1%
4630 OUTLN #ch%,wid%,hgt%,left%-1,50
4632 CLOSE#ch%
4634 id%=RIndex%+(RMinPos%=0)
4636 page%=id% DIV rowno%
4638 IF id% MOD rowno% >0 THEN page%=page%+1: END IF
4640 RStartPos%=(page%-1)*rowno% +RMinPos%
4642 ListFiles RightFiles$, RStartPos%, RIndex%, 8
4644 id%=LIndex%+(LMinPos%=0)
4646 page%=id% DIV rowno%
4648 IF id% MOD rowno% >0 THEN page%=page%+1: END IF
4650 LStartPos%=(page%-1)*rowno% +LMinPos%
4652 ListFiles LeftFiles$, LStartPos%, LIndex%, 7
4654 END DEFine CopyMultipleFiles
4656 :
4658 :
4660 REMark ''----------------------------------------------------------
4662 DEFine FuNction CopyAListFile%(name$, source$, dest$, filelen$, panel%)
4664 LOCal k%
4666  IF LEN(dest$&name$)>41 THEN
4668    INK#0,2: PRINT#0,name$&" not copied. Name too long":INK#0,White%
4670    RETurn 0
4672  END IF
4674  k%=FTEST(dest$&name$)
4676  IF k%=-7 THEN
4678   IF panel%=8 THEN
4680     IF RSizedir%+RSizeFile%+1>=MaxFiles% THEN
4682       INK#0,2: PRINT#0,"Maximum number reached on destination directory!":INK#0,White%
4684       RETurn -1
4686     END IF
4688   ELSE
4690     IF LSizedir%+LSizeFile%+1>=MaxFiles% THEN
4692       INK#0,2: PRINT#0,"Maximum number reached on destination directory!":INK#0,White%
4694       RETurn -1
4696     END IF
4698   END IF
4700   Copy1File name$, source$, dest$, filelen$, 0: RETurn 1
4702  ELSE
4704    IF k%=0 THEN
4706      PRINT#0,"File already exists Overwrite (Y/N) ?"
4708      REPeat loopa
4710        a$=INKEY$(-1)
4712        IF a$ INSTR "yYnN" THEN EXIT loopa: END IF
4714      END REPeat loopa
4716      IF a$="y" OR a$="Y" THEN
4718        Copy1File name$, source$, dest$, filelen$, 0: RETurn 1
4720      ELSE
4722        RETurn 0
4724      END IF
4726    ELSE
4728      SELect ON k%
4730        =-9: INK#0,2: PRINT#0,name$&"not copied. Destination is in use":INK#0,White%:RETurn 0
4732        =-11:INK#0,2: PRINT#0,name$&"not copied. Destination drive is full":INK#0,White%:RETurn -1
4734        =-16:INK#0,2: PRINT#0,name$&"not copied. Destination Bad or Changed Medium":INK#0,White%:RETurn -1
4736        =-20:INK#0,2: PRINT#0,name$&"not copied. Destination is Read Only! ":INK#0,White%: RETurn 0
4738        =REMAINDER : INK#0,2: PRINT#0,name$&"not copied. Error "&k%:INK#0,White%:RETurn 0
4740      END SELect
4742    END IF
4744  END IF
4746 END DEFine CopyAListFile%
4748 :
4750 :
4752 REMark ''-----------------------------------------------------------
4754 DEFine PROCedure DeleteFiles
4756 LOCal source$, name$, panel%, x%, k%, a$, ch%,ch1%, Index%,left%,windef$,hgt%, wid%
4758 IF crtPanel%=7 THEN
4760  source$=leftDir$: name$=GetFNam$(LeftFiles$,LIndex%):panel%=7: Index%=LIndex%
4762 ELSE
4764  source$=rightDir$: name$=GetFNam$(RightFiles$,RIndex%):panel%=8: Index%=RIndex%
4766 END IF
4768 IF IsReadOnly%(source$) THEN
4770  MessageWnd 200,60,2, CHR$(10)&"       Drive is Read Only! "
4772  RETurn
4774 END IF
4776 x%=CountSelected%
4778 IF x%>0 THEN
4780  k%=DlgWnd%(240,60," Delete Files ", "   Are you sure you want to delete"&CHR$(10)&"     "&x%&" files and directories ?")
4782 ELSE
4784  IF IsDir%=1 THEN
4786    a$="directory "&name$
4788  ELSE
4790    a$="file "&name$
4792  END IF
4794  k%=(39-LEN(a$)) DIV 2: IF k%<0 THEN k%=0
4796  a$="   Are you sure you want to delete"&CHR$(10)&FILL$(" ",k%)&a$
4798  k%=DlgWnd%(240,60," Delete File ",a$)
4800 END IF
4802 IF k%=0 THEN RETurn
4804 IF panelWinWid%*2>602 THEN wid%=600: ELSE wid%=400:END IF
4806 hgt%=panelWinHeight%*8 DIV  10
4808 left%=(maxWinWid%-wid%) DIV 2
4810 windef$="scr_"&wid%&"x"&hgt%&"a"&left%&"x50"
4812 ch%=FOPEN(windef$)
4814 PAPER #ch%,0:INK #ch%,White%
4816 OUTLN #ch%,wid%,hgt%,left%,50:BORDER#ch%,1,2:CLS#ch%
4818 left%=left%+1
4820 windef$="scr_"&(wid%-2)&"x12a"&left%&"x51"
4822 ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
4824 PAPER#ch1%,0: INK#ch1%,White%: CURSOR#ch1%,(wid%-84) DIV 2,0: PRINT#ch1%, " Delete Files "
4826 WINDOW#0,wid%-4, hgt%-16, left%+1, 63:PAPER#0,0: INK#0,White%:CLS#0
4828 IF x%=0 THEN
4830   IF IsDir%=0
4832     PRINT#0, "Deleting file "&source$&name$
4834     DELETE source$&name$
4836   ELSE
4838     IF DeleteDirectory (source$, name$)=0 THEN INK#0,2:PRINT#0, "Could not delete all of "&source$&name$&"_": INK#0,White%
4840   END IF
4842 ELSE
4844   PRINT#0, "Delete Selected list: "&x%&" files and/or directories"
4846   IF crtPanel%=7 THEN
4848     FOR k%=1 TO LSizedir%+LSizeFile%
4850       IF GetFFlg%(LeftFiles$,k%) > 1 THEN
4852         IF GetFFlg%(LeftFiles$,k%)=2 THEN
4854           PRINT#0, "Deleting file "&GetFNam$(LeftFiles$,k%)&" ..."
4856           DELETE source$&GetFNam$(LeftFiles$,k%)
4858         ELSE
4860           IF DeleteDirectory (source$, GetFNam$(LeftFiles$,k%)) =0 THEN INK#0,2:PRINT#0, "Could not delete all of "&source$&GetFNam$(LeftFiles$,k%)&"_": INK#0,White%
4862         END IF
4864       END IF
4866     NEXT k%: END FOR k%
4868   ELSE
4870     FOR k%=1 TO RSizedir%+RSizeFile%
4872       IF GetFFlg%(RightFiles$,k%) > 1 THEN
4874         IF GetFFlg%(RightFiles$,k%)=2 THEN
4876           PRINT#0, "Deleting file "&GetFNam$(RightFiles$,k%)&" ..."
4878           DELETE source$&GetFNam$(RightFiles$,k%)
4880         ELSE
4882           IF DeleteDirectory (source$, GetFNam$(RightFiles$,k%)) THEN INK#0,2:PRINT#0, "Could not delete all of "&source$&GetFNam$(RightFiles$,k%)&"_": INK#0,White%
4884         END IF
4886       END IF
4888     NEXT k%: END FOR k%
4890   END IF
4892 END IF
4894 INK#0,Green%:PRINT#0, "Delete process ended - press any key to close window":INK#0,White%
4896 x%=KEYROW(0):a$=INKEY$(-1)
4898 WINDOW#0,448,12,32,231:
4900 CLOSE#ch1%
4902 OUTLN #ch%,wid%,hgt%,left%-1,50
4904 CLOSE#ch%
4906 IF crtPanel%=7 THEN
4908   ReloadPanel 7, Index%
4910 ELSE
4912   ReloadPanel 8, Index%
4914 END IF
4916 END DEFine DeleteFiles
4918 :
4920 :
4922 REMark ''-----------------------------------------------------------
4924 DEFine PROCedure EXecFile
4926 LOCal filename$, path$, chf%, x%
4928 IF crtPanel%=7 THEN
4930  IF LIndex%>LSizeFile%+LSizedir% THEN RETurn : END IF
4932  filename$=GetFNam$(LeftFiles$,LIndex%)
4934  path$=leftDir$
4936 ELSE
4938  IF RIndex%>RSizeFile%+RSizedir% THEN RETurn : END IF
4940  filename$=GetFNam$(RightFiles$,RIndex%)
4942  path$=rightDir$
4944 END IF
4946 chf%=FOPEN(path$&filename$)
4948 IF chf%<0 THEN
4950   SELect ON chf%
4952    =-7:  MessageWnd 200,60,2, CHR$(10)&"         File Not Found !"
4954    =-9:  MessageWnd 200,60,2, CHR$(10)&"           File in use"
4956    = REMAINDER :  MessageWnd 200,60,2, CHR$(10)& "             Error "&chf%
4958  END SELect
4960  ELSE
4962   CLOSE#chf%
4964   x%=FTYP(\path$&filename$)
4966   IF x%<>1 THEN
4968     MessageWnd 200,60,2, CHR$(10)&"   This is not a EXECable file"
4970   ELSE
4972     EX path$&filename$
4974   END IF
4976 END IF
4978 END DEFine EXecFile
4980 :
4982 :
4984 REMark ''----------------------------------------------------------
4986 DEFine FuNction getKey$(c%)
4988  LOCal k$(2)
4990   CURSEN #c%
4992   k$=INKEY$(c%,-1)
4994   CURDIS #c%
4996   RETurn k$
4998 END DEFine getKey$
5000 :
5002 :
5004 REMark ''----------------------------------------------------------
5006 DEFine PROCedure OnEnter
5008   LOCal ext$(10), path$, a$, x%, i%
5010 :
5012   IF crtPanel%=7 THEN
5014     IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
5016     a$=GetFNam$(LeftFiles$,LIndex%)
5018     path$=leftDir$
5020   ELSE
5022     IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
5024     a$=GetFNam$(RightFiles$,RIndex%)
5026     path$=rightDir$
5028   END IF
5030   IF a$==".." OR IsDir%=1 THEN
5032     IF crtPanel%=7 THEN
5034       OpenSubDir LeftFiles$, LIndex%, 7
5036     ELSE
5038       OpenSubDir RightFiles$, RIndex%, 8
5040     END IF
5042     RETurn
5044   END IF
5046 :
5048   IF FTYP(\path$&a$) =1 THEN
5050     EXecFile
5052     RETurn
5054   END IF
5056 :
5058   REMark ''now get file extension
5060   x% = LEN(a$)
5062   FOR i% = 0 TO x% - 1
5064     IF a$(x% - i%) == "_" THEN EXIT i%
5066   NEXT i%: END FOR i%
5068   IF i%>0 THEN
5070     ext$ = a$(x% - i% TO x%)
5072   ELSE
5074     ext$=""
5076   END IF
5078   ext$ = LOWER$(ext$) : x% = 0
5080 :
5082   IF ext$ = "_bas" THEN x% = 1
5084   IF ext$ = "_cde" OR ext$ = "_code" OR ext$ = "_rext" THEN x% = 2
5086   IF ext$ = "_zip" THEN x% = 3
5088   IF ext$ = "_doc" THEN x% = 4
5090   IF ext$ = "_aba" THEN x% = 5
5092   IF ext$ = "_grf" THEN x% = 6
5094   IF ext$ = "_dbf" THEN x% = 7
5096   IF ext$ = "_ssb" THEN x% = 9
5098   IF a$ = "boot" THEN x% = 1
5100 :
5102   SELect ON x%
5104     = 1:
5106         dbg(path$ & a$) : LoadBasFile(path$ & a$)
5108     = 2:
5110         DoLrespr path$ & a$
5112     = 3:
5114         IF IsZipFile%(path$ & a$) = 1 THEN UnzipFile path$ & a$
5116     = 4:
5118         IF IsQuillDoc%(path$ & a$) = 1 THEN
5120           IF Xchangeprog$ <> ""
5122             ExecXchange path$, path$ & a$
5124           END IF
5126         END IF
5128     = 5:
5130         IF IsAbacusDoc%(path$ & a$) = 1
5132           IF Xchangeprog$ <> ""
5134             ExecXchange path$, path$ & a$
5136           END IF
5138         END IF
5140     = 6:
5142         IF Xchangeprog$ <> ""
5144           ExecXchange path$, path$ & a$
5146         END IF
5148     = 7:
5150         IF IsArchiveDoc%(path$ & a$) = 1
5152           IF Xchangeprog$ <> ""
5154             ExecXchange path$, path$ & a$
5156           END IF
5158         END IF
5160     = 8:
5162         x% = DlgWnd%(240,60," Archive Prg ", "     "&a$&CHR$(10)&"      Open with Xchange Archive ?")
5164         IF x% = 0 THEN RETurn
5166         ExecXchange path$, path$ & a$
5168     = 9:
5170         dbg(path$ & a$) : LoadSsbFile(path$ & a$)
5172   END SELect
5174 END DEFine OnEnter
5176 :
5178 :
5180 REMark ''----------------------------------------------------------
5182 DEFine PROCedure UnzipFile (filename$)
5184 LOCal path$, ch%, ch1%, ch2%
5186 IF crtPanel%=7 THEN
5188   IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
5190   path$=rightDir$
5192 ELSE
5194   IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
5196   path$=leftDir$
5198 END IF
5200 ch%=DlgWnd%(240,60," Unzip File ", "    Are you sure you want to unzip"&CHR$(10)&"     "&filename$&" ?")
5202 IF ch%=0 THEN RETurn
5204 ch%=FOPEN("scr_452x230a30x14")
5206 PAPER #ch%,0:INK #ch%,7
5208 OUTLN #ch%,452,230,30,14:BORDER#ch%,1,2:CLS#ch%
5210 ch1%=FOPEN("scr_452x12a31x14"): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
5212 PAPER#ch1%,0: INK#ch1%,7: AT#ch1%,0,37-(LEN(a$)+5)/2: PRINT#ch1%, "Unzip"&a$
5214 ch2%=FOPEN("scr_448x204a32x26"):PAPER#ch2%,0:INK#ch2%,4
5216 EW ConfigDrv$&"unzip", #ch2%;"-D"&path$&" -o "&filename$
5218 PRINT #ch2%, "Press any key ..."
5220 path$=INKEY$(-1)
5222 CLS#ch1%: CLS#ch2%: CLOSE#ch2%:CLOSE#ch1%
5224 WINDOW#0,488,23,12,233:PAPER#0,0:INK#0,White%
5226 OUTLN #ch%,452,230,30,14
5228 CLOSE#ch%
5230  IF crtPanel%=7 THEN
5232     ReloadPanel 8,RIndex%
5234  ELSE
5236     ReloadPanel 7,LIndex%
5238  END IF
5240 END DEFine UnzipFile
5242 :
5244 :
5246 REMark ''----------------------------------------------------------
5248 DEFine PROCedure ExecXchange(path$, filename$)
5250  LOCal savedDATAD$(36), savedPROGD$(36)
5252   savedDATAD$=DATAD$ : savedPROGD$=PROGD$
5254   DATA_USE path$
5256   PROG_USE Xchangepath$
5258   EX Xchangepath$&Xchangeprog$; filename$
5260   DATA_USE savedDATAD$
5262   PROG_USE savedPROGD$
5264 END DEFine ExecXchange
5266 :
5268 :
5270 REMark ''-----------------------------------------------------------
5272 DEFine PROCedure EditFile(path$, filename$)
5274   LOCal savedDATAD$(36), savedPROGD$(36)
5276   savedDATAD$=DATAD$ : savedPROGD$=PROGD$
5278   DATA_USE path$
5280   PROG_USE EditPath$
5282   EX EditPath$&Editprog$; path$&filename$
5284   DATA_USE savedDATAD$
5286   PROG_USE savedPROGD$
5288 END DEFine EditFile
5290 :
5292 :
5294 REMark ''-----------------------------------------------------------
5296 DEFine PROCedure AttachBasFileShell(filename$)
5298   TYPE_IN "merge " & "dos1_qlc_cmd_bas" & CHR$(10)
5300   TYPE_IN "32604   QLC_GlobalFilename$ = '" & filename$ & "'" & CHR$(10) : REMark '' odd '
5302 END DEFine
5304 :
5306 :
5308 REMark ''-----------------------------------------------------------
5310 DEFine PROCedure LoadBasFile(filename$)
5312   LOCal x%
5314   REMark ''QLC_GlobalFilename$ = filename$
5316   SBASIC
5318   COMMAND_LINE
5320   PAUSE 5
5322   TYPE_IN "load " & filename$ & CHR$(10)
5324   REMark ''type_in "dline 32600 to" & chr$(10)
5326 :
5328   AttachBasFileShell filename$
5330 :
5332   TYPE_IN "QLC_INIT" & CHR$(10)
5334   REMark ''type_in "SAVE_O " & filename$ & chr$(10)
5336   TYPE_IN "wtv" & CHR$(10)
5338   AT 2,0 : TYPE_IN "rem CMD: h/W/r/e/x/q/s/l/u" & CHR$(10)
5340   TYPE_IN "ED" & CHR$(10)
5342 END DEFine
5344 :
5346 :
5348 REMark ''-----------------------------------------------------------
5350 REMark ''simplified SSB to BAS conversion
5352 REMark ''- missing support for @Lables and #include, now !!!
5354 DEFine PROCedure CompileSsb2Bas(ssb_filename$, bas_filename$)
5356   LOCal i, x$
5358 :
5360   ierr = FOP_IN(#10, ssb_filename$)
5362   oerr = FOP_OVER(#11, bas_filename$)
5364   PRINT #11, "1 rem &&SSBGEN"
5366   linenum = 10
5368   REPeat linenum
5370     INPUT #10, in$
5372     IF EOF(#10) THEN EXIT
5374     IF (CHR$(38) & CHR$(38) & "QLCGEN") INSTR in$ THEN EXIT
5376     out$ = in$
5378     IF in$ = "" THEN out$ = ":"
5380     pos = (CHR$(39) & CHR$(39) INSTR in$) : REMark ''or ("##" instr in$) or ("//" instr in$) + odd '
5382     IF pos > 0
5384       IF pos > 1
5386         FOR i = 1 TO pos : IF in$(i) <> " " THEN EXIT : NEXT i
5388         IF i < pos THEN comment$ = ": rem" : ELSE comment$ = "rem " : END IF
5390         out$ = in$(1 TO pos - 1) & comment$
5392       ELSE out$ = "rem "
5394       END IF
5396       out$ = out$ & in$(pos TO)
5398     END IF
5400     PRINT #11, linenum & " " & out$
5402     linenum = linenum + 2
5404   END REPeat
5406   CLOSE #10
5408   CLOSE #11
5410 END DEFine
5412 :
5414 :
5416 REMark ''-----------------------------------------------------------
5418 DEFine PROCedure LoadSsbFile(filename$)
5420   LOCal ssb_filename$, bas_filename$, i, x$
5422 :
5424   ssb_filename$ = filename$
5426   bas_filename$ = ssb_filename$(1 TO LEN(ssb_filename$) - 4) & "_bas"
5428 :
5430   CompileSsb2Bas ssb_filename$, bas_filename$
5432   LoadBasFile bas_filename$
5434 END DEFine
5436 :
5438 :
5440 REMark ''----------------------------------------------------------
5442 DEFine PROCedure DoEdit
5444 LOCal path$, a$
5446 IF crtPanel%=7 THEN
5448   IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
5450   a$=GetFNam$(LeftFiles$,LIndex%)
5452   path$=leftDir$
5454 ELSE
5456   IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
5458   a$=GetFNam$(RightFiles$,RIndex%)
5460   path$=rightDir$
5462 END IF
5464 IF IsDir%(path$&a$)=1 THEN RETurn
5466 IF IsQuillDoc%(path$&a$)=1 THEN
5468   IF Xchangeprog$<>"" THEN
5470     ExecXchange path$, path$&a$
5472     RETurn
5474   END IF
5476 ELSE
5478   EditFile path$, a$
5480 END IF
5482 END DEFine DoEdit
5484 :
5486 :
5488 REMark ''-----------------------------------------------------------
5490 DEFine PROCedure DoLrespr (filename$)
5492 LOCal x%
5494 x%=DlgWnd%(240,60," lrespr File ", "    Are you sure you want to lrespr"&CHR$(10)&"     "&filename$&" ?")
5496 IF x%=0 THEN RETurn
5498 COMMAND_LINE
5500 PAUSE 5
5502 TYPE_IN "lrespr "&filename$&CHR$(10)
5504 END DEFine DoLrespr
5506 :
5508 :
5510 REMark ''----------------------------------------------------------
5512 DEFine FuNction IsAbacusDoc%(a$)
5514 LOCal ch%, q$, i%, k%
5516 ch% = FOPEN(a$)
5518 IF ch% <= 0 THEN RETurn 0: END IF
5520 q$=""
5522 FOR i%=1 TO 4
5524  BGET #ch%,k%
5526  q$=q$&CHR$(k%)
5528 NEXT i%: END FOR i%
5530 CLOSE #ch%
5532 IF q$="ABM1" THEN RETurn 1: ELSE RETurn 0: END IF
5534 END DEFine IsAbacusDoc%
5536 :
5538 :
5540 REMark ''-----------------------------------------------------------
5542 DEFine FuNction IsArchiveDoc%(a$)
5544 LOCal ch%, q$, i%, k%
5546 ch% = FOPEN(a$)
5548 IF ch% <= 0 THEN RETurn 0: END IF
5550 q$=""
5552 BGET #ch%\1,k%
5554 FOR i%=1 TO 8
5556  BGET #ch%,k%
5558  q$=q$&CHR$(k%)
5560 NEXT i%: END FOR i%
5562 CLOSE #ch%
5564 IF q$="vrm1dbf0" THEN RETurn 1: ELSE RETurn 0: END IF
5566 END DEFine IsArchiveDoc%
5568 :
5570 :
5572 REMark ''-----------------------------------------------------------
5574 DEFine PROCedure ReloadPanel(panel%, Index%)
5576 LOCal page%, x%
5578 IF panel%=7 THEN
5580   DIM LeftFiles$(MaxFiles%,_fMax%)
5582   LoadDir leftDir$, LeftFiles$,7,LSizedir%, LSizeFile%
5584   IF LEN(leftDir$)=5 THEN
5586     LMinPos%=1
5588   ELSE
5590     LMinPos%=0
5592   END IF
5594   IF Index%<LMinPos% THEN Index%=LMinPos%
5596   IF Index%>LSizedir%+LSizeFile% THEN Index%=LMinPos%
5598   LIndex%=Index%
5600   x%=Index%+(LMinPos%=0)
5602   page%=x% DIV rowno%
5604   IF x% MOD rowno% >0 THEN page%=page%+1: END IF
5606   LStartPos%=(page%-1)*rowno% +LMinPos%
5608   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
5610 ELSE
5612   DIM RightFiles$(MaxFiles%,_fMax%)
5614   LoadDir rightDir$, RightFiles$,8,RSizedir%, RSizeFile%
5616   IF LEN(rightDir$)=5 THEN
5618     RMinPos%=1
5620   ELSE
5622     RMinPos%=0
5624   END IF
5626   IF Index%<RMinPos% THEN Index%=RMinPos%
5628   IF Index%>RSizedir%+RSizeFile% THEN Index%=RMinPos%
5630   RIndex%=Index%
5632   x%=Index%+(RMinPos%=0)
5634   page%=x% DIV rowno%
5636   IF x% MOD rowno% >0 THEN page%=page%+1: END IF
5638   RStartPos%=(page%-1)*rowno% +RMinPos%
5640   ListFiles RightFiles$, RStartPos%, RIndex%, 8
5642 END IF
5644 END DEFine ReloadPanel
5646 :
5648 :
5650 REMark ''-----------------------------------------------------------
5652 DEFine PROCedure SelectAll
5654 LOCal i%
5656 IF crtPanel%=7 THEN
5658   FOR i%=1 TO LSizedir%+LSizeFile%
5660     IF GetFFlg%(LeftFiles$,i%) < 2 THEN PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
5662   END FOR i%
5664   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
5666 ELSE
5668   FOR i%=1 TO RSizedir%+RSizeFile%
5670     IF GetFFlg%(RightFiles$,i%) < 2 THEN PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
5672   END FOR i%
5674   ListFiles RightFiles$, RStartPos%, RIndex%, 8
5676 END IF
5678 END DEFine SelectAll
5680 :
5682 :
5684 REMark ''-----------------------------------------------------------
5686 DEFine PROCedure UnSelectAll
5688 LOCal i%
5690 IF crtPanel%=7 THEN
5692   FOR i%=1 TO LSizedir%+LSizeFile%
5694     IF GetFFlg%(LeftFiles$,i%) > 1 THEN PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
5696   END FOR i%
5698   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
5700 ELSE
5702   FOR i%=1 TO RSizedir%+RSizeFile%
5704     IF GetFFlg%(RightFiles$,i%) > 1 THEN PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
5706   END FOR i%
5708   ListFiles RightFiles$, RStartPos%, RIndex%, 8
5710 END IF
5712 END DEFine UnSelectAll
5714 :
5716 :
5718 REMark ''-----------------------------------------------------------
5720 DEFine PROCedure Set78CharSet
5722 REMark ''On QPC2 the char width gets reset so we have to set it again
5724 IF mainFountBase>0 THEN
5726   IF ClassicFont%=0 THEN
5728     CHAR_USE #leftPanelWin%,mainFountBase,0
5730     CHAR_INC #leftPanelWin%,5,10
5732     CHAR_USE #rightPanelWin%,mainFountBase,0
5734     CHAR_INC #rightPanelWin%,5,10
5736   END IF
5738 END IF
5740 END DEFine Set78CharSet
5742 :
5744 :
5746 REMark ''----------------------------------------------------------
5748 DEFine FuNction TestFount%(fountBase)
5750  LOCal fountMask%,fountMax%,char%,row%
5752   fountMask%=3 : REMark ''*** ------XX
5754   fountMax%=PEEK(fountBase+1)
5756   FOR char%=0 TO fountMax%
5758     FOR row%=0 TO 8
5760       IF PEEK(fountBase+2 + char%*9 + row%) && fountMask% THEN RETurn 2 : REMark ''*** appears to be a FAT fount
5762     END FOR row%
5764   END FOR char%
5766 :
5768   RETurn 1 : REMark ''*** Does not appear to be a FAT fount
5770 :
5772 END DEFine TestFount%
5774 :
5776 :
5778 REMark ''----------------------------------------------------------
5780 REFERENCE fList$(0,0)
5782 DEFine FuNction GetFNam$(fList$,fIndex%)
5784   RETurn fList$(fIndex%,3 TO 2 + STRING%(fList$(fIndex%,1 TO 2)))
5786 END DEFine GetFNam$
5788 :
5790 :
5792 REMark ''----------------------------------------------------------
5794 REFERENCE fList$(0,0)
5796 DEFine FuNction GetFLen(fList$,fIndex%)
5798   RETurn LONGINTEGER(fList$(fIndex%,_fLen% TO _fTyp%-1))
5800 END DEFine GetFLen
5802 :
5804 :
5806 REMark ''-----------------------------------------------------------
5808 REFERENCE fList$(0,0)
5810 DEFine FuNction GetFTyp%(fList$)
5812   RETurn STRING%(fList$(fIndex%,_fTyp% TO _fDat%-1))
5814 END DEFine GetFTyp%
5816 :
5818 :
5820 REMark ''-----------------------------------------------------------
5822 REFERENCE fList$(0,0)
5824 DEFine FuNction GetFDat(fList$,fIndex%)
5826   RETurn LONGINTEGER(fList$(fIndex%,_fDat% TO _fPar%-1))
5828 END DEFine GetFDat
5830 :
5832 :
5834 REMark ''-----------------------------------------------------------
5836 REFERENCE fList$(0,0)
5838 DEFine FuNction GetFPar%(fList$,fIndex%)
5840   RETurn STRING%(fList$(fIndex%,_fPar% TO _fFlg%-1))
5842 END DEFine GetFPar%
5844 :
5846 :
5848 REMark ''-----------------------------------------------------------
5850 REFERENCE fList$(0,0)
5852 DEFine FuNction GetFFlg%(fList$,fIndex%)
5854   RETurn STRING%(fList$(fIndex%,_fFlg% TO _fMax%))
5856 END DEFine GetFFlg%
5858 :
5860 :
5862 REMark ''-----------------------------------------------------------
5864 REFERENCE fList$(0,0)
5866 DEFine PROCedure PutFNam(fList$,fIndex%,newVal$)
5868  LOCal nVLen%
5870   nVLen%=LEN(newVal$)
5872   IF nVLen%>maxFNLen% THEN nVLen%=maxFNLen%
5874   fList$(fIndex%,1 TO 2+nVLen%)=STRING$(newVal$(1 TO nVLen%))
5876 END DEFine PutFNam
5878 :
5880 :
5882 REMark ''-----------------------------------------------------------
5884 REFERENCE fList$(0,0)
5886 DEFine PROCedure PutFLen(fList$,fIndex%,newVal)
5888   fList$(fIndex%,_fLen% TO _fTyp%-1)=LONGINTEGER$(newVal)
5890 END DEFine PutFLen
5892 :
5894 :
5896 REMark ''-----------------------------------------------------------
5898 REFERENCE fList$(0,0)
5900 DEFine PROCedure PutFTyp(fList$,fIndex%,newVal%)
5902   fList$(fIndex%,_fTyp% TO _fDat%-1)=INTEGER$(newVal%)
5904 END DEFine PutFTyp
5906 :
5908 :
5910 REMark ''-----------------------------------------------------------
5912 REFERENCE fList$(0,0)
5914 DEFine PROCedure PutFDat(fList$,fIndex%,newVal)
5916   fList$(fIndex%,_fDat% TO _fPar%-1)=LONGINTEGER$(newVal)
5918 END DEFine PutFDat
5920 :
5922 :
5924 REMark ''-----------------------------------------------------------
5926 REFERENCE fList$(0,0)
5928 DEFine PROCedure PutFPar(fList$,fIndex%,newVal%)
5930   fList$(fIndex%,_fPar% TO _fFlg%-1)=INTEGER$(newVal%)
5932 END DEFine PutFPar
5934 :
5936 :
5938 REMark ''-----------------------------------------------------------
5940 REFERENCE fList$(0,0)
5942 DEFine PROCedure PutFFlg(fList$,fIndex%,newVal%)
5944   fList$(fIndex%,_fFlg% TO _fMax%)=INTEGER$(newVal%)
5946 END DEFine PutFFlg
5948 :
5950 :
5952 REMark ''-----------------------------------------------------------
5954 REFERENCE fList$(0,0),fListDest$(0,0)
5956 DEFine PROCedure CopyRec(fList$,fIndex%,fListDest$,fDestIndex%)
5958   fListDest$(fDestIndex%, 1 TO _fMax%)=fList$(fIndex%, 1 TO _fMax%)
5960 END DEFine CopyRec
5962 :
5964 :
5966 REMark ''-----------------------------------------------------------
5968 DEFine FuNction isBasicRunning
5970   IF BASIC_B%(111)<> 0 THEN
5972     RETurn 0
5974   ELSE
5976     IF BASIC_B%(143) = 0 : RETurn 0 : REMark ''break - Ctrl-Space pressed
5978     IF BASIC_W%(104) = BASIC_W%(146) : RETurn 0 : REMark ''stop occurred
5980     RETurn 1 : REMark ''Program is running
5982   END IF
5984 END DEFine isBasicRunning
5986 :
5988 :
5990 REMark ''-----------------------------------------------------------
5992 DEFine FuNction isBasicProgramLoaded
5994 RETurn BASIC_W%(BASIC_L(16))
5996 END DEFine isBasicProgramLoaded
5998 :
6000 :
6002 REMark ''-----------------------------------------------------------
6004 REFERENCE fList$(0,0),r_StartPos%,r_Index%
6006 DEFine PROCedure MoveTop(fList$, r_StartPos%, r_Index%, ch%)
6008 LOCal top%, x%, size%
6010 IF ch%=7 THEN
6012   r_StartPos%= LMinPos%
6014 ELSE
6016   r_StartPos%=RMinPos%
6018 END IF
6020 r_Index%=r_StartPos%
6022 ListFiles fList$, r_StartPos%, r_Index%, ch%
6024 END DEFine MovePageUp
6026 :
6028 :
6030 REMark ''----------------------------------------------------------
6032 REFERENCE fList$(0,0),r_StartPos%,r_Index%
6034 DEFine PROCedure MoveLast(fList$, r_StartPos%, r_Index%, ch%)
6036 LOCal top%
6038 IF ch%=7 THEN
6040   top%= LMinPos%
6042   r_Index%=LSizeFile%+LSizedir%
6044 ELSE
6046   top%=RMinPos%
6048   r_Index%=RSizeFile%+RSizedir%
6050 END IF
6052 r_StartPos%=r_Index%-19
6054 IF r_StartPos%<top% THEN r_StartPos%=top%
6056 ListFiles fList$, r_StartPos%, r_Index%, ch%
6058 END DEFine MoveLast
6060 :
6062 :
6064 REMark ''-----------------------------------------------------------
6066 DEFine PROCedure LRUNBasic
6068 LOCal i%, a$, path$, ext$
6070 IF crtPanel%=7 THEN
6072   IF LIndex%>LSizedir%+LSizeFile% THEN RETurn : END IF
6074   a$=GetFNam$(LeftFiles$,LIndex%)
6076   path$=leftDir$
6078 ELSE
6080   IF RIndex%>RSizedir%+RSizeFile% THEN RETurn : END IF
6082   a$=GetFNam$(RightFiles$,RIndex%)
6084   path$=rightDir$
6086 END IF
6088 IF a$==".." OR IsDir%=1 THEN RETurn
6090 REMark ''now get file extension
6092 x%=LEN(a$)
6094 FOR i%=0 TO x%-1
6096 IF a$(x%-i%)=="_" THEN EXIT i%
6098 NEXT i%: END FOR i%
6100 IF i%>0 THEN
6102   ext$=a$(x%-i% TO x%)
6104 ELSE
6106   ext$=""
6108 END IF
6110 ext$=LOWER$(ext$)
6112 IF ext$<>"_bas" AND a$<>"boot" THEN RETurn
6114 IF isBasicRunning=1 THEN
6116   MessageWnd 200,60,2, CHR$(10)&"        BASIC is running"&CHR$(10)&"       Cannot run _bas now!"
6118   RETurn
6120 END IF
6122 IF (isBasicProgramLoaded>0) AND (isBasicProgramEdited=1) THEN
6124   i%=DlgWnd%(240,60," Basic program loaded ", "       A Basic program is loaded"&CHR$(10)&"         Loose any changes made?")
6126   IF i%=0 THEN RETurn
6128 END IF
6130 COMMAND_LINE
6132 PAUSE 5
6134 TYPE_IN CHR$(27)&CHR$(27)&CHR$(27):PAUSE 5
6136 TYPE_IN "LRUN "&path$&a$ & CHR$(10)
6138 END DEFine LRUNBasic
6140 :
6142 :
6144 REMark ''-----------------------------------------------------------
6146 DEFine PROCedure SetPalletteQL
6148 PALETTE_QL 0,0,0,255*256*256,255*256*256,255*256,255*256,255*256*256+255*256+255,255*256*256+255*256+255
6150 END DEFine SetPalletteQL
6152 :
6154 :
6156 REMark ''-----------------------------------------------------------
6158 DEFine FuNction isBasicProgramEdited
6160 IF BASIC_B%(142)=255 THEN
6162    RETurn 1
6164 ELSE
6166    RETurn 0
6168 END IF
6170 END DEFine isBasicProgramEdited
6172 :
6174 :
6176 REMark ''-----------------------------------------------------------
6178 DEFine FuNction CopyFullDir%(name$, source$, dest$, panel%, UpdateWnd%, CheckNoQ%, UpdateList%)
6180 LOCal x%, ch%, loop, d$, fp, newname$, newsource$, newdest$, totrim
6182 IF DirExists%(dest$&name$)=0 THEN
6184   x%=Create1Dir%(name$, dest$&name$,panel%,0,CheckNoQ%, UpdateList%)
6186   IF x%=0 THEN RETurn 0
6188 END IF
6190 PRINT#0, "Copy "&source$&name$&" to "&dest$&name$
6192 WCOPY source$&name$ TO dest$&name$
6194 ch% = FOP_DIR (source$&name$) : REMark ''open channel to directory
6196 IF ch% < 0 THEN RETurn : REMark ''unable to open directory
6198 fp = 14 : REMark ''file position in directory for filename
6200 newsource$=source$&name$: IF newsource$(LEN(newsource$))<>"_" THEN newsource$=newsource$&"_"
6202 newdest$=dest$&name$: IF newdest$(LEN(newdest$))<>"_" THEN newdest$=newdest$&"_"
6204 REPeat loop
6206   BGET #ch%\fp : IF EOF(#ch%) THEN CLOSE #ch% : EXIT loop
6208   GET #ch%,d$ : REMark ''get a directory entry name
6210   IF LEN(d$) > 0 THEN
6212     REMark ''a directory length of 0 may be a deleted file
6214     BGET #ch%\fp-9 : REMark ''file type byte
6216     IF CODE(INKEY$(#ch%)) = 255 THEN
6218       REMark ''this is a subdirectory, so we need to copy this
6220       REMark ''Extract file name and check length
6222       totrim=LEN(newsource$)-4
6224       newname$=d$(totrim TO)
6226       IF LEN(newdest$&newname$)>36 THEN
6228         INK#0,2:PRINT#0,"Directory "&newdest$&newname$&" not created  Name too long":INK#0,White%
6230       ELSE
6232         x%=CopyFullDir%(newname$, newsource$, newdest$, panel%, 0,0,0)
6234       END IF
6236     END IF
6238   END IF
6240   fp = fp + 64
6242 END REPeat loop
6244 RETurn 1
6246 END DEFine CopyFullDir%
6248 :
6250 :
6252 REMark ''-----------------------------------------------------------
6254 DEFine PROCedure CopySingleDir(name$, source$, dest$, panel%)
6256 LOCal ch%, ch1%, i%, x%, a$, Index%,page%, id%, left%,windef$, hgt%, wid%
6258 IF panelWinWid%*2>602 THEN wid%=600: ELSE wid%=400:END IF
6260 hgt%=panelWinHeight%*8 DIV  10
6262 left%=(maxWinWid%-wid%) DIV 2
6264 windef$="scr_"&wid%&"x"&hgt%&"a"&left%&"x50"
6266 ch%=FOPEN(windef$)
6268 PAPER #ch%,0:INK #ch%,White%
6270 OUTLN #ch%,wid%,hgt%,left%,50:BORDER#ch%,1,2:CLS#ch%
6272 left%=left%+1
6274 windef$="scr_"&(wid%-2)&"x12a"&left%&"x51"
6276 ch1%=FOPEN(windef$): BORDER#ch1%,1,2: PAPER#ch1%,0,2,1: CLS#ch1%
6278 PAPER#ch1%,0: INK#ch1%,White%: CURSOR#ch1%,(wid%-90) DIV 2,0: PRINT#ch1%, " Copy Directory "
6280 WINDOW#0,wid%-4, hgt%-16, left%+1, 63:PAPER#0,0: INK#0,White%:CLS#0
6282 PRINT#0, "Copy Directory "&source$&name$&" to "&dest$
6284 res%=CopyFullDir% (name$, source$, dest$, panel%,0,1,0)
6286 INK#0,Green%:PRINT#0, "Copy process ended - press any key to close window":INK#0,White%
6288 x%=KEYROW(0):a$=INKEY$(-1)
6290 WINDOW#0,448,12,32,231:
6292 CLOSE#ch1%
6294 OUTLN #ch%,wid%,hgt%,left%-1,50
6296 CLOSE#ch%
6298 REMark ''if copy OK then Add the dir name to the list in the destination panel and refresh screen
6300 IF res%=1 THEN
6302   IF panel%=8 THEN
6304     res%=Find% (name$,id%,RightFiles$,1,RSizedir%)
6306     IF res%=0 THEN
6308       res%=Insert% (name$,id%, RightFiles$, 1, RSizedir%, RSizeFile%, "0")
6310       RIndex%=id%
6312       id%=id%+(RMinPos%=0)
6314       page%=id% DIV rowno%
6316       IF id% MOD rowno% >0 THEN page%=page%+1: END IF
6318       RStartPos%=(page%-1)*rowno% +RMinPos%
6320       ListFiles RightFiles$, RStartPos%, RIndex%, 8
6322     END IF
6324   ELSE
6326     res%=Find% (name$,id%,LeftFiles$,1,LSizedir%)
6328     IF res%=0 THEN
6330       res%=Insert% (name$,id%, LeftFiles$, 1, LSizedir%, LSizeFile%, "0")
6332       LIndex%=id%
6334       id%=id%+(LMinPos%=0)
6336       page%=id% DIV rowno%
6338       IF id% MOD rowno% >0 THEN page%=page%+1: END IF
6340       LStartPos%=(page%-1)*rowno% +LMinPos%
6342       ListFiles LeftFiles$, LStartPos%, LIndex%, 7
6344     END IF
6346   END IF
6348 END IF
6350 END DEFine CopySingleDir
6352 :
6354 :
6356 REMark ''----------------------------------------------------------
6358 DEFine FuNction DeleteDirectory(source$, name$)
6360 LOCal ch%, loop, d$, newsource$, newname$, fp, totrim, x%
6362 IF name$(LEN(name$))<>"_" THEN name$=name$&"_"
6364 PRINT#0, "Deleting directory "&source$&name$&"..."
6366 WDEL source$&name$
6368 ch% = FOP_DIR (source$&name$) : REMark ''open channel to directory
6370 IF ch% < 0 THEN RETurn : REMark ''unable to open directory
6372 fp = 14 : REMark ''file position in directory for filename
6374 newsource$=source$&name$: IF newsource$(LEN(newsource$))<>"_" THEN newsource$=newsource$&"_"
6376 REPeat loop
6378   BGET #ch%\fp : IF EOF(#ch%) THEN CLOSE #ch% : EXIT loop
6380   GET #ch%,d$ : REMark ''get a directory entry name
6382   IF LEN(d$) > 0 THEN
6384     REMark ''a directory length of 0 may be a deleted file
6386     BGET #ch%\fp-9 : REMark ''file type byte
6388     IF CODE(INKEY$(#ch%)) = 255 THEN
6390       REMark ''this is a subdirectory, so we need to delete this
6392       REMark ''Extract file name and check length
6394       totrim=LEN(newsource$)-4
6396       newname$=d$(totrimto)
6398       x%=DeleteDirectory (newsource$, newname$)
6400     END IF
6402   END IF
6404   fp = fp + 64
6406 END REPeat loop
6408 REMark ''Now check that directory is empty
6410 IF isDirEmpty(source$&name$)=1 THEN
6412   DELETE source$&name$
6414   RETurn 1
6416 ELSE
6418   RETurn 0
6420 END IF
6422 END DEFine DeleteDirectory
6424 :
6426 :
6428 REMark ''----------------------------------------------------------
6430 DEFine FuNction isDirEmpty(DirName$)
6432 LOCal ch%, fp, d$, loop, res%
6434 ch% = FOP_DIR (DirName$) : REMark ''open channel to directory
6436 IF ch% < 0 THEN RETurn 0: REMark ''unable to open directory
6438 res%=1
6440 fp = 14 : REMark ''file position in directory for filename
6442 REPeat loop
6444   BGET #ch%\fp : IF EOF(#ch%) THEN : EXIT loop
6446   GET #ch%,d$ : REMark ''get a directory entry name
6448   IF LEN(d$) > 0 THEN res%=0: EXIT loop: REMark ''if file name >0 then we found a file and we set result to 1
6450   fp = fp + 64
6452 END REPeat loop
6454 CLOSE#ch%
6456 RETurn res%
6458 END DEFine isDirEmpty
6460 :
6462 :
6464 REMark ''----------------------------------------------------------
6466 DEFine PROCedure CompareDirs
6468 LOCal i%, res%
6470 REMark ''Unselect all left files
6472 FOR i%=1 TO LSizedir%+LSizeFile%
6474   IF GetFFlg%(LeftFiles$,i%) > 1 THEN PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
6476 END FOR i%
6478 REMark ''Select all right files
6480 FOR i%=1 TO RSizedir%+RSizeFile%
6482   IF GetFFlg%(RightFiles$,i%) < 2 THEN PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
6484 END FOR i%
6486 REMark ''Parse left directory list and compare it to right
6488 FOR i%= 1 TO LSizedir%
6490   res%=Find% (GetFNam$(LeftFiles$,i%),id%,RightFiles$,1,RSizedir%)
6492   IF res%=0 THEN
6494     PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
6496   ELSE
6498     PutFFlg RightFiles$,id%, GetFFlg%(RightFiles$,id%) ^^2
6500   END IF
6502 NEXT i%: END FOR i%
6504 REMark ''Parse left file list and compare it to right
6506 FOR i%= LSizedir%+1 TO LSizedir%+LSizeFile%
6508   res%=Find% (GetFNam$(LeftFiles$,i%),id%,RightFiles$,RSizedir%+1,RSizedir%+RSizeFile%)
6510   IF res%=0 THEN
6512     PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
6514   ELSE
6516     IF GetFLen(LeftFiles$,i%)=GetFLen(RightFiles$,id%) THEN
6518       PutFFlg RightFiles$,id%, GetFFlg%(RightFiles$,id%) ^^2
6520     ELSE
6522       PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
6524     END IF
6526   END IF
6528 NEXT i%: END FOR i%
6530 REMark ''refresh screen
6532 ListFiles LeftFiles$, LStartPos%, LIndex%, 7
6534 ListFiles RightFiles$, RStartPos%, RIndex%, 8
6536 END DEFine CompareDirs
6538 :
6540 :
6542 REMark ''----------------------------------------------------------
6544 DEFine PROCedure InvertSelection
6546 LOCal i%
6548 IF crtPanel%=7 THEN
6550   FOR i%=1 TO LSizedir%+LSizeFile%
6552     PutFFlg LeftFiles$,i%, GetFFlg%(LeftFiles$,i%) ^^2
6554   END FOR i%
6556   ListFiles LeftFiles$, LStartPos%, LIndex%, 7
6558 ELSE
6560   FOR i%=1 TO RSizedir%+RSizeFile%
6562     PutFFlg RightFiles$,i%, GetFFlg%(RightFiles$,i%) ^^2
6564   END FOR i%
6566   ListFiles RightFiles$, RStartPos%, RIndex%, 8
6568 END IF
6570 END DEFine InvertSelection
6572 :
6574 :
6576 :
6578 :
32600 REMark &&QLCGEN ShellCommands
32602 DEFine PROCedure QLC_INIT
32604   QLC_GlobalFilename$ = 'dos1_QLC_qlc20x_bas'
32616   XX=RESPR(1024) : LBYTES "dos1_tk_MORE_CODE", XX : CALL XX
32618   XX=RESPR(1538) : LBYTES "dos1_qlc_QLC_CODE", XX : CALL XX
32620   LRESPR "dos1_tk_TURBO_SMS_CODE"
32622 END DEFine
32624 :
32626 DEFine PROCedure r
32628   RUN
32630 END DEFine
32632 DEFine PROCedure e
32634   WTV
32636   PAPER #2,0 : INK #2,4
32638 END DEFine
32640 DEFine PROCedure x
32642   s : QUIT
32644 END DEFine
32646 DEFine PROCedure q
32648   s : QUIT
32650 END DEFine
32652 DEFine PROCedure s
32653   TYPE_IN "1 REMark &&SSBGEN &&SAVE" & CHR$(10)
32654   SAVE QLC_GlobalFilename$
32656   PRINT #2, QLC_GlobalFilename$ & " SAVED"
32658 END DEFine
32660 DEFine PROCedure l
32662   LOAD QLC_GlobalFilename$
32664   PRINT #2, QLC_GlobalFilename$ & " LOADED"
32666 END DEFine
32668 DEFine PROCedure w
32670   WMOV
32672 END DEFine
32674 DEFine PROCedure u
32676   REMark DLINE 32600 TO
32678   TYPE_IN "MERGE dos1_qlc_cmd_bas" & CHR$(10)
32680 END DEFine
32682 DEFine PROCedure h
32684   PRINT #0, "CMD: h/W/n/r/e/x/q/s/l/u"
32686 END DEFine
32688 DEFine PROCedure n(i)
32690   IF i = 0 THEN i = 1
32692   TYPE_IN "RENUM 10 TO 32599; 1000, " & i & CHR$(10)
32694 END DEFine
32696 DEFine PROCedure dbginit
32698   OPEN #99, "scr_"
32700   WINDOW #99, 120,16,0,0 : PAPER #99,0 : INK #99,7
32702 END DEFine
32704 DEFine PROCedure dbg(s$)
32706   PAPER #99,7 : INK #99,2 : PRINT #99, s$
32708 END DEFine
32710 DEFine PROCedure dbgstop
32712   STOP
32714 END DEFine
